searchNodes=[{"doc":"Compiles Phoenix source files that support code reloading.","ref":"Mix.Tasks.Compile.Phoenix.html","title":"Mix.Tasks.Compile.Phoenix","type":"task"},{"doc":"Updates the Phoenix project generator locally.mix local.phxAccepts the same command line options as archive.install hex phx_new.","ref":"Mix.Tasks.Local.Phx.html","title":"Mix.Tasks.Local.Phx","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Local.Phx.html#run/1","title":"Mix.Tasks.Local.Phx.run/1","type":"function"},{"doc":"Prints Phoenix tasks and their information.mix phx","ref":"Mix.Tasks.Phx.html","title":"Mix.Tasks.Phx","type":"task"},{"doc":"Digests and compresses static files.mix phx.digest mix phx.digest priv/static -o /www/publicThe first argument is the path where the static files are located. The -o option indicates the path that will be used to save the digested and compressed files.If no path is given, it will use priv/static as the input and output path.The output folder will contain:the original filethe file compressed with gzipa file containing the original file name and its digesta compressed file containing the file name and its digesta cache manifest fileExample of generated files:app.jsapp.js.gzapp-eb0a5b9302e8d32828d8a73f137cc8f0.jsapp-eb0a5b9302e8d32828d8a73f137cc8f0.js.gzcache_manifest.json","ref":"Mix.Tasks.Phx.Digest.html","title":"Mix.Tasks.Phx.Digest","type":"task"},{"doc":"Removes old versions of compiled assets.By default, it will keep the latest version and 2 previous versions as well as any digest created in the last hour.mix phx.digest.clean mix phx.digest.clean -o /www/public mix phx.digest.clean --age 600 --keep 3Options-o, --output - indicates the path to your compiled assets directory. Defaults to priv/static--age - specifies a maximum age (in seconds) for assets. Files older than age that are not in the last --keep versions will be removed. Defaults to 3600 (1 hour)--keep - specifies how many previous versions of assets to keep. Defaults to 2 previous versions","ref":"Mix.Tasks.Phx.Digest.Clean.html","title":"Mix.Tasks.Phx.Digest.Clean","type":"task"},{"doc":"Generates a self-signed certificate for HTTPS testing.mix phx.gen.cert mix phx.gen.cert my-app my-app.local my-app.internal.example.comCreates a private key and a self-signed certificate in PEM format. These files can be referenced in the certfile and keyfile parameters of an HTTPS Endpoint.WARNING: only use the generated certificate for testing in a closed network environment, such as running a development server on localhost. For production, staging, or testing servers on the public internet, obtain a proper certificate, for example from Let's Encrypt.NOTE: when using Google Chrome, open chrome://flags/#allow-insecure-localhost to enable the use of self-signed certificates on localhost.ArgumentsThe list of hostnames, if none are specified, defaults to:localhostOther (optional) arguments:--output (-o): the path and base filename for the certificate and key (default: priv/cert/selfsigned)--name (-n): the Common Name value in certificate's subject (default: &quot;Self-signed test certificate&quot;)Requires OTP 20 or later.","ref":"Mix.Tasks.Phx.Gen.Cert.html","title":"Mix.Tasks.Phx.Gen.Cert","type":"task"},{"doc":"Generates a Phoenix channel.mix phx.gen.channel RoomAccepts the module name for the channelThe generated files will contain:For a regular application:a channel in lib/my_app_web/channelsa channel test in test/my_app_web/channelsFor an umbrella application:a channel in apps/my_app_web/lib/app_name_web/channelsa channel test in apps/my_app_web/test/my_app_web/channels","ref":"Mix.Tasks.Phx.Gen.Channel.html","title":"Mix.Tasks.Phx.Gen.Channel","type":"task"},{"doc":"Generates a context with functions around an Ecto schema.mix phx.gen.context Accounts User users name:string age:integerThe first argument is the context module followed by the schema module and its plural name (used as the schema table name).The context is an Elixir module that serves as an API boundary for the given resource. A context often holds many related resources. Therefore, if the context already exists, it will be augmented with functions for the given resource.Note: A resource may also be split over distinct contexts (such as Accounts.User and Payments.User).The schema is responsible for mapping the database fields into an Elixir struct.Overall, this generator will add the following files to lib/your_app:a context module in accounts.ex, serving as the API boundarya schema in accounts/user.ex, with a users tableA migration file for the repository and test files for the context will also be generated.Generating without a schemaIn some cases, you may wish to bootstrap the context module and tests, but leave internal implementation of the context and schema to yourself. Use the --no-schema flags to accomplish this.tableBy default, the table name for the migration and schema will be the plural name provided for the resource. To customize this value, a --table option may be provided. For example:mix phx.gen.context Accounts User users --table cms_usersbinary_idGenerated migration can use binary_id for schema's primary key and its references with option --binary-id.Default optionsThis generator uses default options provided in the :generators configuration of your application. These are the defaults:config :your_app, :generators, migration: true, binary_id: false, sample_binary_id: &quot;11111111-1111-1111-1111-111111111111&quot;You can override those options per invocation by providing corresponding switches, e.g. --no-binary-id to use normal ids despite the default configuration or --migration to force generation of the migration.Read the documentation for phx.gen.schema for more information on attributes.","ref":"Mix.Tasks.Phx.Gen.Context.html","title":"Mix.Tasks.Phx.Gen.Context","type":"task"},{"doc":"","ref":"Mix.Tasks.Phx.Gen.Context.html#prompt_for_code_injection/1","title":"Mix.Tasks.Phx.Gen.Context.prompt_for_code_injection/1","type":"function"},{"doc":"Generates an embedded Ecto schema for casting/validating data outside the DB.mix phx.gen.embedded Blog.Post title:string views:integerThe first argument is the schema module followed by the schema attributes.The generated schema above will contain:an embedded schema file in lib/my_app/blog/post.exAttributesThe resource fields are given using name:type syntax where type are the types supported by Ecto. Omitting the type makes it default to :string:mix phx.gen.embedded Blog.Post title views:integerThe following types are supported::integer:float:decimal:boolean:map:string:array:references:text:date:time:time_usec:naive_datetime:naive_datetime_usec:utc_datetime:utc_datetime_usec:uuid:binary:datetime - An alias for :naive_datetime","ref":"Mix.Tasks.Phx.Gen.Embedded.html","title":"Mix.Tasks.Phx.Gen.Embedded","type":"task"},{"doc":"Generates controller, views, and context for an HTML resource.mix phx.gen.html Accounts User users name:string age:integerThe first argument is the context module followed by the schema module and its plural name (used as the schema table name).The context is an Elixir module that serves as an API boundary for the given resource. A context often holds many related resources. Therefore, if the context already exists, it will be augmented with functions for the given resource.Note: A resource may also be split over distinct contexts (such as Accounts.User and Payments.User).The schema is responsible for mapping the database fields into an Elixir struct. It is followed by an optional list of attributes, with their respective names and types. See mix phx.gen.schema for more information on attributes.Overall, this generator will add the following files to lib/:a context module in lib/app/accounts.ex for the accounts APIa schema in lib/app/accounts/user.ex, with an users tablea view in lib/app_web/views/user_view.exa controller in lib/app_web/controllers/user_controller.exdefault CRUD templates in lib/app_web/templates/userThe context appA migration file for the repository and test files for the context and controller features will also be generated.The location of the web files (controllers, views, templates, etc) in an umbrella application will vary based on the :context_app config located in your applications :generators configuration. When set, the Phoenix generators will generate web files directly in your lib and test folders since the application is assumed to be isolated to web specific functionality. If :context_app is not set, the generators will place web related lib and test files in a web/ directory since the application is assumed to be handling both web and domain specific functionality. Example configuration:config :my_app_web, :generators, context_app: :my_appAlternatively, the --context-app option may be supplied to the generator:mix phx.gen.html Sales User users --context-app warehouseWeb namespaceBy default, the controller and view will be namespaced by the schema name. You can customize the web module namespace by passing the --web flag with a module name, for example:mix phx.gen.html Sales User users --web SalesWhich would generate a lib/app_web/controllers/sales/user_controller.ex and lib/app_web/views/sales/user_view.ex.Customising the context, schema, tables and migrationsIn some cases, you may wish to bootstrap HTML templates, controllers, and controller tests, but leave internal implementation of the context or schema to yourself. You can use the --no-context and --no-schema flags for file generation control.You can also change the table name or configure the migrations to use binary ids for primary keys, see mix phx.gen.schema for more information.","ref":"Mix.Tasks.Phx.Gen.Html.html","title":"Mix.Tasks.Phx.Gen.Html","type":"task"},{"doc":"Generates controller, views, and context for a JSON resource.mix phx.gen.json Accounts User users name:string age:integerThe first argument is the context module followed by the schema module and its plural name (used as the schema table name).The context is an Elixir module that serves as an API boundary for the given resource. A context often holds many related resources. Therefore, if the context already exists, it will be augmented with functions for the given resource.Note: A resource may also be split over distinct contexts (such as Accounts.User and Payments.User).The schema is responsible for mapping the database fields into an Elixir struct. It is followed by an optional list of attributes, with their respective names and types. See mix phx.gen.schema for more information on attributes.Overall, this generator will add the following files to lib/:a context module in lib/app/accounts.ex for the accounts APIa schema in lib/app/accounts/user.ex, with an users tablea view in lib/app_web/views/user_view.exa controller in lib/app_web/controllers/user_controller.exA migration file for the repository and test files for the context and controller features will also be generated.The context appThe location of the web files (controllers, views, templates, etc) in an umbrella application will vary based on the :context_app config located in your applications :generators configuration. When set, the Phoenix generators will generate web files directly in your lib and test folders since the application is assumed to be isolated to web specific functionality. If :context_app is not set, the generators will place web related lib and test files in a web/ directory since the application is assumed to be handling both web and domain specific functionality. Example configuration:config :my_app_web, :generators, context_app: :my_appAlternatively, the --context-app option may be supplied to the generator:mix phx.gen.json Sales User users --context-app warehouseWeb namespaceBy default, the controller and view will be namespaced by the schema name. You can customize the web module namespace by passing the --web flag with a module name, for example:mix phx.gen.json Sales User users --web SalesWhich would generate a lib/app_web/controllers/sales/user_controller.ex and lib/app_web/views/sales/user_view.ex.Customising the context, schema, tables and migrationsIn some cases, you may wish to bootstrap JSON views, controllers, and controller tests, but leave internal implementation of the context or schema to yourself. You can use the --no-context and --no-schema flags for file generation control.You can also change the table name or configure the migrations to use binary ids for primary keys, see mix phx.gen.schema for more information.","ref":"Mix.Tasks.Phx.Gen.Json.html","title":"Mix.Tasks.Phx.Gen.Json","type":"task"},{"doc":"Generates LiveView, templates, and context for a resource.mix phx.gen.live Accounts User users name:string age:integerThe first argument is the context module followed by the schema module and its plural name (used as the schema table name).The context is an Elixir module that serves as an API boundary for the given resource. A context often holds many related resources. Therefore, if the context already exists, it will be augmented with functions for the given resource.When this command is run for the first time, a ModalComponent and LiveHelpers module will be created, along with the resource level LiveViews and components, including an IndexLive, ShowLive, FormComponent for the new resource.Note: A resource may also be split over distinct contexts (such as Accounts.User and Payments.User).The schema is responsible for mapping the database fields into an Elixir struct. It is followed by an optional list of attributes, with their respective names and types. See mix phx.gen.schema for more information on attributes.Overall, this generator will add the following files to lib/:a context module in lib/app/accounts.ex for the accounts APIa schema in lib/app/accounts/user.ex, with an users tablea view in lib/app_web/views/user_view.exa LiveView in lib/app_web/live/user_live/show_live.exa LiveView in lib/app_web/live/user_live/index_live.exa LiveComponent in lib/app_web/live/user_live/form_component.exa LiveComponent in lib/app_web/live/modal_component.exa helpers modules in lib/app_web/live/live_helpers.exThe context appA migration file for the repository and test files for the context and controller features will also be generated.The location of the web files (LiveView's, views, templates, etc) in an umbrella application will vary based on the :context_app config located in your applications :generators configuration. When set, the Phoenix generators will generate web files directly in your lib and test folders since the application is assumed to be isolated to web specific functionality. If :context_app is not set, the generators will place web related lib and test files in a web/ directory since the application is assumed to be handling both web and domain specific functionality. Example configuration:config :my_app_web, :generators, context_app: :my_appAlternatively, the --context-app option may be supplied to the generator:mix phx.gen.live Sales User users --context-app warehouseWeb namespaceBy default, the controller and view will be namespaced by the schema name. You can customize the web module namespace by passing the --web flag with a module name, for example:mix phx.gen.live Sales User users --web SalesWhich would generate a LiveViews inside lib/app_web/live/sales/user_live/ and a view at lib/app_web/views/sales/user_view.ex.Customising the context, schema, tables and migrationsIn some cases, you may wish to bootstrap HTML templates, LiveViews, and tests, but leave internal implementation of the context or schema to yourself. You can use the --no-context and --no-schema flags for file generation control.You can also change the table name or configure the migrations to use binary ids for primary keys, see mix phx.gen.schema for more information.","ref":"Mix.Tasks.Phx.Gen.Live.html","title":"Mix.Tasks.Phx.Gen.Live","type":"task"},{"doc":"Generates a Presence tracker.mix phx.gen.presence mix phx.gen.presence MyPresenceThe argument, which defaults to Presence, defines the module name of the Presence tracker.Generates a new file, lib/my_app_web/channels/my_presence.ex, where my_presence is the snake-cased version of the provided module name.","ref":"Mix.Tasks.Phx.Gen.Presence.html","title":"Mix.Tasks.Phx.Gen.Presence","type":"task"},{"doc":"Generates an Ecto schema and migration.mix phx.gen.schema Blog.Post blog_posts title:string views:integerThe first argument is the schema module followed by its plural name (used as the table name).The generated schema above will contain:a schema file in lib/my_app/blog/post.ex, with a blog_posts tablea migration file for the repositoryThe generated migration can be skipped with --no-migration.ContextsYour schemas can be generated and added to a separate OTP app. Make sure your configuration is properly setup or manually specify the context app with the --context-app option with the CLI.# Via config config :marketing_web, :generators, context_app: :marketing # Via CLI mix phx.gen.schema Blog.Post blog_posts title:string views:integer --context-app marketingAttributesThe resource fields are given using name:type syntax where type are the types supported by Ecto. Omitting the type makes it default to :string:mix phx.gen.schema Blog.Post blog_posts title views:integerThe following types are supported::integer:float:decimal:boolean:map:string:array:references:text:date:time:time_usec:naive_datetime:naive_datetime_usec:utc_datetime:utc_datetime_usec:uuid:binary:datetime - An alias for :naive_datetimeThe generator also supports references, which we will properly associate the given column to the primary key column of the referenced table:mix phx.gen.schema Blog.Post blog_posts title user_id:references:usersThis will result in a migration with an :integer column of :user_id and create an index.Furthermore an array type can also be given if it is supported by your database, although it requires the type of the underlying array element to be given too:mix phx.gen.schema Blog.Post blog_posts tags:array:stringUnique columns can be automatically generated by using:mix phx.gen.schema Blog.Post blog_posts title:unique unique_int:integer:uniqueIf no data type is given, it defaults to a string.tableBy default, the table name for the migration and schema will be the plural name provided for the resource. To customize this value, a --table option may be provided. For example:mix phx.gen.schema Blog.Post posts --table cms_postsbinary_idGenerated migration can use binary_id for schema's primary key and its references with option --binary-id.Default optionsThis generator uses default options provided in the :generators configuration of your application. These are the defaults:config :your_app, :generators, migration: true, binary_id: false, sample_binary_id: &quot;11111111-1111-1111-1111-111111111111&quot;You can override those options per invocation by providing corresponding switches, e.g. --no-binary-id to use normal ids despite the default configuration or --migration to force generation of the migration.","ref":"Mix.Tasks.Phx.Gen.Schema.html","title":"Mix.Tasks.Phx.Gen.Schema","type":"task"},{"doc":"Generates a secret and prints it to the terminal.mix phx.gen.secret [length]By default, mix phx.gen.secret generates a key 64 characters long.The minimum value for length is 32.","ref":"Mix.Tasks.Phx.Gen.Secret.html","title":"Mix.Tasks.Phx.Gen.Secret","type":"task"},{"doc":"Creates a new Phoenix project.It expects the path of the project as an argument.mix phx.new PATH [--module MODULE] [--app APP]A project at the given PATH will be created. The application name and module name will be retrieved from the path, unless --module or --app is given.Options--live - include Phoenix.LiveView to make it easier than ever to build interactive, real-time applications--umbrella - generate an umbrella project, with one application for your domain, and a second application for the web interface.--app - the name of the OTP application--module - the name of the base module in the generated skeleton--database - specify the database adapter for Ecto. One of:postgres - via https://github.com/elixir-ecto/postgrexmysql - via https://github.com/elixir-ecto/myxqlmssql - via https://github.com/livehelpnow/tds Please check the driver docs for more information and requirements. Defaults to &quot;postgres&quot;.--no-webpack - do not generate webpack files for static asset building. When choosing this option, you will need to manually handle JavaScript dependencies if building HTML apps--no-ecto - do not generate Ecto files.--no-html - do not generate HTML views.--no-gettext - do not generate gettext files.--no-dashboard - do not include Phoenix.LiveDashboard--binary-id - use binary_id as primary key type in Ecto schemas--verbose - use verbose outputWhen passing the --no-ecto flag, Phoenix generators such as phx.gen.html, phx.gen.json, phx.gen.live, and phx.gen.context may no longer work as expected as they generate context files that rely on Ecto for the database access. In those cases, you can pass the --no-context flag to generate most of the HTML and JSON files but skip the context, allowing you to fill in the blanks as desired.Similarly, if --no-html is given, the files generated by phx.gen.html will no longer work, as important HTML components will be missing.Installationmix phx.new by default prompts you to fetch and install your dependencies. You can enable this behaviour by passing the --install flag or disable it with the --no-install flag.Examplesmix phx.new hello_worldIs equivalent to:mix phx.new hello_world --module HelloWorldOr without the HTML and JS bits (useful for APIs):mix phx.new ~/Workspace/hello_world --no-html --no-webpackAs an umbrella:mix phx.new hello --umbrellaWould generate the following directory structure and modules:hello_umbrella/ Hello.Umbrella apps/ hello/ Hello hello_web/ HelloWebYou can read more about umbrella projects using the official Elixir guideTo print the Phoenix installer version, pass -v or --version, for example:mix phx.new -v","ref":"Mix.Tasks.Phx.New.html","title":"Mix.Tasks.Phx.New","type":"task"},{"doc":"","ref":"Mix.Tasks.Phx.New.html#generate/4","title":"Mix.Tasks.Phx.New.generate/4","type":"function"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Phx.New.html#run/1","title":"Mix.Tasks.Phx.New.run/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Phx.New.html#run/3","title":"Mix.Tasks.Phx.New.run/3","type":"function"},{"doc":"Creates a new Ecto project within an umbrella project.This task is intended to create a bare Ecto project without web integration, which serves as a core application of your domain for web applications and your greater umbrella platform to integrate with.It expects the name of the project as an argument.$ cd my_umbrella/apps $ mix phx.new.ecto APP [--module MODULE] [--app APP]A project at the given APP directory will be created. The application name and module name will be retrieved from the application name, unless --module or --app is given.Options--app - the name of the OTP application--module - the name of the base module in the generated skeleton--database - specify the database adapter for Ecto. One of:postgres - via https://github.com/elixir-ecto/postgrexmysql - via https://github.com/elixir-ecto/myxqlmssql - via https://github.com/livehelpnow/tds Please check the driver docs for more information and requirements. Defaults to &quot;postgres&quot;.--binary-id - use binary_id as primary key type in Ecto schemasExamplesmix phx.new.ecto hello_ectoIs equivalent to:mix phx.new.ecto hello_ecto --module HelloEcto","ref":"Mix.Tasks.Phx.New.Ecto.html","title":"Mix.Tasks.Phx.New.Ecto","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Phx.New.Ecto.html#run/1","title":"Mix.Tasks.Phx.New.Ecto.run/1","type":"function"},{"doc":"Creates a new Phoenix web project within an umbrella project.It expects the name of the otp app as the first argument and for the command to be run inside your umbrella application's apps directory:$ cd my_umbrella/apps $ mix phx.new.web APP [--module MODULE] [--app APP]This task is intended to create a bare Phoenix project without database integration, which interfaces with your greater umbrella application(s).Examplesmix phx.new.web hello_webIs equivalent to:mix phx.new.web hello_web --module HelloWebSupports the same options as the phx.new task. See Mix.Tasks.Phx.New for details.","ref":"Mix.Tasks.Phx.New.Web.html","title":"Mix.Tasks.Phx.New.Web","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Phx.New.Web.html#run/1","title":"Mix.Tasks.Phx.New.Web.run/1","type":"function"},{"doc":"Prints all routes for the default or a given router.$ mix phx.routes $ mix phx.routes MyApp.AnotherRouterThe default router is inflected from the application name unless a configuration named :namespace is set inside your application configuration. For example, the configuration:config :my_app, namespace: My.Appwill exhibit the routes for My.App.Router when this task is invoked without arguments.Umbrella projects do not have a default router and therefore always expect a router to be given.","ref":"Mix.Tasks.Phx.Routes.html","title":"Mix.Tasks.Phx.Routes","type":"task"},{"doc":"Starts the application by configuring all endpoints servers to run.Note: to start the endpoint without using this mix task you must set server: true in your Phoenix.Endpoint configuration.Command line optionsThis task accepts the same command-line arguments as run. For additional information, refer to the documentation for Mix.Tasks.Run.For example, to run phx.server without recompiling:mix phx.server --no-compileThe --no-halt flag is automatically added.Note that the --no-deps-check flag cannot be used this way, because Mix needs to check dependencies to find phx.server.To run phx.server without checking dependencies, you can run:mix do deps.loadpaths --no-deps-check, phx.server","ref":"Mix.Tasks.Phx.Server.html","title":"Mix.Tasks.Phx.Server","type":"task"},{"doc":"This is the documentation for the Phoenix project.By default, Phoenix applications depend on the following packages:Ecto - a language integrated query and database wrapperEEx - Elixir's built-in templating languageExUnit - Elixir's built-in test frameworkPhoenix - the Phoenix web framework (these docs)Phoenix PubSub - a distributed pub/sub system with presence supportPhoenix HTML - conveniences for working with HTML in PhoenixPlug - a specification and conveniences for composable modules in between web applicationsGettext - Internationalization and localization through gettextTo get started, see our overview guides.","ref":"Phoenix.html","title":"Phoenix","type":"module"},{"doc":"Returns the configured JSON encoding library for Phoenix.To customize the JSON library, including the following in your config/config.exs:config :phoenix, :json_library, Jason","ref":"Phoenix.html#json_library/0","title":"Phoenix.json_library/0","type":"function"},{"doc":"Returns the :plug_init_mode that controls when plugs are initialized.We recommend to set it to :runtime in development for compilation time improvements. It must be :compile in production (the default).This option is passed as the :init_mode to Plug.Builder.compile/3.","ref":"Phoenix.html#plug_init_mode/0","title":"Phoenix.plug_init_mode/0","type":"function"},{"doc":"Defines a Phoenix Channel.Channels provide a means for bidirectional communication from clients that integrate with the Phoenix.PubSub layer for soft-realtime functionality.Topics &amp; CallbacksEvery time you join a channel, you need to choose which particular topic you want to listen to. The topic is just an identifier, but by convention it is often made of two parts: &quot;topic:subtopic&quot;. Using the &quot;topic:subtopic&quot; approach pairs nicely with the Phoenix.Socket.channel/3 allowing you to match on all topics starting with a given prefix by using a splat (the * character) as the last character in the topic pattern:channel &quot;room:*&quot;, MyApp.RoomChannelAny topic coming into the router with the &quot;room:&quot; prefix would dispatch to MyApp.RoomChannel in the above example. Topics can also be pattern matched in your channels' join/3 callback to pluck out the scoped pattern:# handles the special `&quot;lobby&quot;` subtopic def join(&quot;room:lobby&quot;, _payload, socket) do {:ok, socket} end # handles any other subtopic as the room ID, for example `&quot;room:12&quot;`, `&quot;room:34&quot;` def join(&quot;room:&quot; &lt;&gt; room_id, _payload, socket) do {:ok, socket} endAuthorizationClients must join a channel to send and receive PubSub events on that channel. Your channels must implement a join/3 callback that authorizes the socket for the given topic. For example, you could check if the user is allowed to join that particular room.To authorize a socket in join/3, return {:ok, socket}. To refuse authorization in join/3, return {:error, reply}.Incoming EventsAfter a client has successfully joined a channel, incoming events from the client are routed through the channel's handle_in/3 callbacks. Within these callbacks, you can perform any action. Typically you'll either forward a message to all listeners with broadcast!/3, or push a message directly down the socket with push/3. Incoming callbacks must return the socket to maintain ephemeral state.Here's an example of receiving an incoming &quot;new_msg&quot; event from one client, and broadcasting the message to all topic subscribers for this socket.def handle_in(&quot;new_msg&quot;, %{&quot;uid&quot; =&gt; uid, &quot;body&quot; =&gt; body}, socket) do broadcast!(socket, &quot;new_msg&quot;, %{uid: uid, body: body}) {:noreply, socket} endYou can also push a message directly down the socket:# client asks for their current rank, push sent directly as a new event. def handle_in(&quot;current_rank&quot;, _, socket) do push(socket, &quot;current_rank&quot;, %{val: Game.get_rank(socket.assigns[:user])}) {:noreply, socket} endRepliesIn addition to pushing messages out when you receive a handle_in event, you can also reply directly to a client event for request/response style messaging. This is useful when a client must know the result of an operation or to simply ack messages.For example, imagine creating a resource and replying with the created record:def handle_in(&quot;create:post&quot;, attrs, socket) do changeset = Post.changeset(%Post{}, attrs) if changeset.valid? do post = Repo.insert!(changeset) response = MyApp.PostView.render(&quot;show.json&quot;, %{post: post}) {:reply, {:ok, response}, socket} else response = MyApp.ChangesetView.render(&quot;errors.json&quot;, %{changeset: changeset}) {:reply, {:error, response}, socket} end endAlternatively, you may just want to ack the status of the operation:def handle_in(&quot;create:post&quot;, attrs, socket) do changeset = Post.changeset(%Post{}, attrs) if changeset.valid? do Repo.insert!(changeset) {:reply, :ok, socket} else {:reply, :error, socket} end endIntercepting Outgoing EventsWhen an event is broadcasted with broadcast/3, each channel subscriber can choose to intercept the event and have their handle_out/3 callback triggered. This allows the event's payload to be customized on a socket by socket basis to append extra information, or conditionally filter the message from being delivered. If the event is not intercepted with Phoenix.Channel.intercept/1, then the message is pushed directly to the client:intercept [&quot;new_msg&quot;, &quot;user_joined&quot;] # for every socket subscribing to this topic, append an `is_editable` # value for client metadata. def handle_out(&quot;new_msg&quot;, msg, socket) do push(socket, &quot;new_msg&quot;, Map.merge(msg, %{is_editable: User.can_edit_message?(socket.assigns[:user], msg)} )) {:noreply, socket} end # do not send broadcasted `&quot;user_joined&quot;` events if this socket&#39;s user # is ignoring the user who joined. def handle_out(&quot;user_joined&quot;, msg, socket) do unless User.ignoring?(socket.assigns[:user], msg.user_id) do push(socket, &quot;user_joined&quot;, msg) end {:noreply, socket} endBroadcasting to an external topicIn some cases, you will want to broadcast messages without the context of a socket. This could be for broadcasting from within your channel to an external topic, or broadcasting from elsewhere in your application like a controller or another process. Such can be done via your endpoint:# within channel def handle_in(&quot;new_msg&quot;, %{&quot;uid&quot; =&gt; uid, &quot;body&quot; =&gt; body}, socket) do ... broadcast_from!(socket, &quot;new_msg&quot;, %{uid: uid, body: body}) MyApp.Endpoint.broadcast_from!(self(), &quot;room:superadmin&quot;, &quot;new_msg&quot;, %{uid: uid, body: body}) {:noreply, socket} end # within controller def create(conn, params) do ... MyApp.Endpoint.broadcast!(&quot;room:&quot; &lt;&gt; rid, &quot;new_msg&quot;, %{uid: uid, body: body}) MyApp.Endpoint.broadcast!(&quot;room:superadmin&quot;, &quot;new_msg&quot;, %{uid: uid, body: body}) redirect(conn, to: &quot;/&quot;) endTerminateOn termination, the channel callback terminate/2 will be invoked with the error reason and the socket.If we are terminating because the client left, the reason will be {:shutdown, :left}. Similarly, if we are terminating because the client connection was closed, the reason will be {:shutdown, :closed}.If any of the callbacks return a :stop tuple, it will also trigger terminate with the reason given in the tuple.terminate/2, however, won't be invoked in case of errors nor in case of exits. This is the same behaviour as you find in Elixir abstractions like GenServer and others. Typically speaking, if you want to clean something up, it is better to monitor your channel process and do the clean up from another process. Similar to GenServer, it would also be possible :trap_exit to guarantee that terminate/2 is invoked. This practice is not encouraged though.Exit reasons when stopping a channelWhen the channel callbacks return a :stop tuple, such as:{:stop, :shutdown, socket} {:stop, {:error, :enoent}, socket}the second argument is the exit reason, which follows the same behaviour as standard GenServer exits.You have three options to choose from when shutting down a channel::normal - in such cases, the exit won't be logged and linked processes do not exit:shutdown or {:shutdown, term} - in such cases, the exit won't be logged and linked processes exit with the same reason unless they're trapping exitsany other term - in such cases, the exit will be logged and linked processes exit with the same reason unless they're trapping exitsSubscribing to external topicsSometimes you may need to programmatically subscribe a socket to external topics in addition to the internal socket.topic. For example, imagine you have a bidding system where a remote client dynamically sets preferences on products they want to receive bidding notifications on. Instead of requiring a unique channel process and topic per preference, a more efficient and simple approach would be to subscribe a single channel to relevant notifications via your endpoint. For example:defmodule MyApp.Endpoint.NotificationChannel do use Phoenix.Channel def join(&quot;notification:&quot; &lt;&gt; user_id, %{&quot;ids&quot; =&gt; ids}, socket) do topics = for product_id &lt;- ids, do: &quot;product:\#{product_id}&quot; {:ok, socket |&gt; assign(:topics, []) |&gt; put_new_topics(topics)} end def handle_in(&quot;watch&quot;, %{&quot;product_id&quot; =&gt; id}, socket) do {:reply, :ok, put_new_topics(socket, [&quot;product:\#{id}&quot;])} end def handle_in(&quot;unwatch&quot;, %{&quot;product_id&quot; =&gt; id}, socket) do {:reply, :ok, MyApp.Endpoint.unsubscribe(&quot;product:\#{id}&quot;)} end defp put_new_topics(socket, topics) do Enum.reduce(topics, socket, fn topic, acc -&gt; topics = acc.assigns.topics if topic in topics do acc else :ok = MyApp.Endpoint.subscribe(topic) assign(acc, :topics, [topic | topics]) end end) end endNote: the caller must be responsible for preventing duplicate subscriptions. After calling subscribe/1 from your endpoint, the same flow applies to handling regular Elixir messages within your channel. Most often, you'll simply relay the %Phoenix.Socket.Broadcast{} event and payload:alias Phoenix.Socket.Broadcast def handle_info(%Broadcast{topic: _, event: event, payload: payload}, socket) do push(socket, event, payload) {:noreply, socket} endHibernationFrom Erlang/OTP 20, channels automatically hibernate to save memory after 15_000 milliseconds of inactivity. This can be customized by passing the :hibernate_after option to use Phoenix.Channel:use Phoenix.Channel, hibernate_after: 60_000You can also set it to :infinity to fully disable it.ShutdownYou can configure the shutdown of each channel used when your application is shutting down by setting the :shutdown value on use:use Phoenix.Channel, shutdown: 5_000It defaults to 5_000.LoggingBy default, channel &quot;join&quot; and &quot;handle_in&quot; events are logged, using the level :info and :debug, respectively. Logs can be customized per event type or disabled by setting the :log_join and :log_handle_in options when using Phoenix.Channel. For example, the following configuration logs join events as :info, but disables logging for incoming events:use Phoenix.Channel, log_join: :info, log_handle_in: false","ref":"Phoenix.Channel.html","title":"Phoenix.Channel","type":"behaviour"},{"doc":"Broadcast an event to all subscribers of the socket topic.The event's message must be a serializable map.Examplesiex&gt; broadcast(socket, &quot;new_message&quot;, %{id: 1, content: &quot;hello&quot;}) :ok","ref":"Phoenix.Channel.html#broadcast/3","title":"Phoenix.Channel.broadcast/3","type":"function"},{"doc":"Same as broadcast/3, but raises if broadcast fails.","ref":"Phoenix.Channel.html#broadcast!/3","title":"Phoenix.Channel.broadcast!/3","type":"function"},{"doc":"Broadcast event from pid to all subscribers of the socket topic.The channel that owns the socket will not receive the published message. The event's message must be a serializable map.Examplesiex&gt; broadcast_from(socket, &quot;new_message&quot;, %{id: 1, content: &quot;hello&quot;}) :ok","ref":"Phoenix.Channel.html#broadcast_from/3","title":"Phoenix.Channel.broadcast_from/3","type":"function"},{"doc":"Same as broadcast_from/3, but raises if broadcast fails.","ref":"Phoenix.Channel.html#broadcast_from!/3","title":"Phoenix.Channel.broadcast_from!/3","type":"function"},{"doc":"","ref":"Phoenix.Channel.html#c:code_change/3","title":"Phoenix.Channel.code_change/3","type":"callback"},{"doc":"Handle regular GenServer call messages.See GenServer.handle_call/3.","ref":"Phoenix.Channel.html#c:handle_call/3","title":"Phoenix.Channel.handle_call/3","type":"callback"},{"doc":"Handle regular GenServer cast messages.See GenServer.handle_cast/2.","ref":"Phoenix.Channel.html#c:handle_cast/2","title":"Phoenix.Channel.handle_cast/2","type":"callback"},{"doc":"Handle incoming events.Exampledef handle_in(&quot;ping&quot;, payload, socket) do {:reply, {:ok, payload}, socket} end","ref":"Phoenix.Channel.html#c:handle_in/3","title":"Phoenix.Channel.handle_in/3","type":"callback"},{"doc":"Handle regular Elixir process messages.See GenServer.handle_info/2.","ref":"Phoenix.Channel.html#c:handle_info/2","title":"Phoenix.Channel.handle_info/2","type":"callback"},{"doc":"Intercepts outgoing events.See intercept/1.","ref":"Phoenix.Channel.html#c:handle_out/3","title":"Phoenix.Channel.handle_out/3","type":"callback"},{"doc":"Defines which Channel events to intercept for handle_out/3 callbacks.By default, broadcasted events are pushed directly to the client, but intercepting events gives your channel a chance to customize the event for the client to append extra information or filter the message from being delivered.Note: intercepting events can introduce significantly more overhead if a large number of subscribers must customize a message since the broadcast will be encoded N times instead of a single shared encoding across all subscribers.Examplesintercept [&quot;new_msg&quot;] def handle_out(&quot;new_msg&quot;, payload, socket) do push(socket, &quot;new_msg&quot;, Map.merge(payload, is_editable: User.can_edit_message?(socket.assigns[:user], payload) )) {:noreply, socket} endhandle_out/3 callbacks must return one of:{:noreply, Socket.t} | {:noreply, Socket.t, timeout | :hibernate} | {:stop, reason :: term, Socket.t}","ref":"Phoenix.Channel.html#intercept/1","title":"Phoenix.Channel.intercept/1","type":"macro"},{"doc":"Handle channel joins by topic.To authorize a socket, return {:ok, socket} or {:ok, reply, socket}. To refuse authorization, return {:error, reason}.Exampledef join(&quot;room:lobby&quot;, payload, socket) do if authorized?(payload) do {:ok, socket} else {:error, %{reason: &quot;unauthorized&quot;}} end end","ref":"Phoenix.Channel.html#c:join/3","title":"Phoenix.Channel.join/3","type":"callback"},{"doc":"Sends event to the socket.The event's message must be a serializable map.Examplesiex&gt; push(socket, &quot;new_message&quot;, %{id: 1, content: &quot;hello&quot;}) :ok","ref":"Phoenix.Channel.html#push/3","title":"Phoenix.Channel.push/3","type":"function"},{"doc":"Replies asynchronously to a socket push.Useful when you need to reply to a push that can't otherwise be handled using the {:reply, {status, payload}, socket} return from your handle_in callbacks. reply/2 will be used in the rare cases you need to perform work in another process and reply when finished by generating a reference to the push with socket_ref/1.Note: In such cases, a socket_ref should be generated and passed to the external process, so the socket itself is not leaked outside the channel. The socket holds information such as assigns and transport configuration, so it's important to not copy this information outside of the channel that owns it.Examplesdef handle_in(&quot;work&quot;, payload, socket) do Worker.perform(payload, socket_ref(socket)) {:noreply, socket} end def handle_info({:work_complete, result, ref}, socket) do reply(ref, {:ok, result}) {:noreply, socket} end","ref":"Phoenix.Channel.html#reply/2","title":"Phoenix.Channel.reply/2","type":"function"},{"doc":"Generates a socket_ref for an async reply.See reply/2 for example usage.","ref":"Phoenix.Channel.html#socket_ref/1","title":"Phoenix.Channel.socket_ref/1","type":"function"},{"doc":"Invoked when the channel process is about to exit.See GenServer.terminate/2.","ref":"Phoenix.Channel.html#c:terminate/2","title":"Phoenix.Channel.terminate/2","type":"callback"},{"doc":"","ref":"Phoenix.Channel.html#t:reply/0","title":"Phoenix.Channel.reply/0","type":"type"},{"doc":"","ref":"Phoenix.Channel.html#t:socket_ref/0","title":"Phoenix.Channel.socket_ref/0","type":"type"},{"doc":"Controllers are used to group common functionality in the same (pluggable) module.For example, the route:get &quot;/users/:id&quot;, MyAppWeb.UserController, :showwill invoke the show/2 action in the MyAppWeb.UserController:defmodule MyAppWeb.UserController do use MyAppWeb, :controller def show(conn, %{&quot;id&quot; =&gt; id}) do user = Repo.get(User, id) render(conn, &quot;show.html&quot;, user: user) end endAn action is a regular function that receives the connection and the request parameters as arguments. The connection is a Plug.Conn struct, as specified by the Plug library.OptionsWhen used, the controller supports the following options::namespace - sets the namespace to properly inflect the layout view. By default it uses the base alias in your controller name:log - the level to log. When false, disables controller logging:put_default_views - controls whether the default view and layout should be set or notConnectionA controller by default provides many convenience functions for manipulating the connection, rendering templates, and more.Those functions are imported from two modules:Plug.Conn - a collection of low-level functions to work with the connectionPhoenix.Controller - functions provided by Phoenix to support rendering, and other Phoenix specific behaviourIf you want to have functions that manipulate the connection without fully implementing the controller, you can import both modules directly instead of use Phoenix.Controller.Plug pipelineAs with routers, controllers also have their own plug pipeline. However, different from routers, controllers have a single pipeline:defmodule MyAppWeb.UserController do use MyAppWeb, :controller plug :authenticate, usernames: [&quot;jose&quot;, &quot;eric&quot;, &quot;sonny&quot;] def show(conn, params) do # authenticated users only end defp authenticate(conn, options) do if get_session(conn, :username) in options[:usernames] do conn else conn |&gt; redirect(to: &quot;/&quot;) |&gt; halt() end end endThe :authenticate plug will be invoked before the action. If the plug calls Plug.Conn.halt/1 (which is by default imported into controllers), it will halt the pipeline and won't invoke the action.Guardsplug/2 in controllers supports guards, allowing a developer to configure a plug to only run in some particular action:plug :authenticate, [usernames: [&quot;jose&quot;, &quot;eric&quot;, &quot;sonny&quot;]] when action in [:show, :edit] plug :authenticate, [usernames: [&quot;admin&quot;]] when not action in [:index]The first plug will run only when action is show or edit. The second plug will always run, except for the index action.Those guards work like regular Elixir guards and the only variables accessible in the guard are conn, the action as an atom and the controller as an alias.Controllers are plugsLike routers, controllers are plugs, but they are wired to dispatch to a particular function which is called an action.For example, the route:get &quot;/users/:id&quot;, UserController, :showwill invoke UserController as a plug:UserController.call(conn, :show)which will trigger the plug pipeline and which will eventually invoke the inner action plug that dispatches to the show/2 function in the UserController.As controllers are plugs, they implement both init/1 and call/2, and it also provides a function named action/2 which is responsible for dispatching the appropriate action after the plug stack (and is also overridable).Overriding action/2 for custom argumentsPhoenix injects an action/2 plug in your controller which calls the function matched from the router. By default, it passes the conn and params. In some cases, overriding the action/2 plug in your controller is a useful way to inject arguments into your actions that you would otherwise need to repeatedly fetch off the connection. For example, imagine if you stored a conn.assigns.current_user in the connection and wanted quick access to the user for every action in your controller:def action(conn, _) do args = [conn, conn.params, conn.assigns.current_user] apply(__MODULE__, action_name(conn), args) end def index(conn, _params, user) do videos = Repo.all(user_videos(user)) # ... end def delete(conn, %{&quot;id&quot; =&gt; id}, user) do video = Repo.get!(user_videos(user), id) # ... endRendering and layoutsOne of the main features provided by controllers is the ability to perform content negotiation and render templates based on information sent by the client. Read render/3 to learn more.It is also important not to confuse Phoenix.Controller.render/3 with Phoenix.View.render/3. The former expects a connection and relies on content negotiation while the latter is connection-agnostic and typically invoked from your views.","ref":"Phoenix.Controller.html","title":"Phoenix.Controller","type":"module"},{"doc":"Performs content negotiation based on the available formats.It receives a connection, a list of formats that the server is capable of rendering and then proceeds to perform content negotiation based on the request information. If the client accepts any of the given formats, the request proceeds.If the request contains a &quot;_format&quot; parameter, it is considered to be the format desired by the client. If no &quot;_format&quot; parameter is available, this function will parse the &quot;accept&quot; header and find a matching format accordingly.This function is useful when you may want to serve different content-types (such as JSON and HTML) from the same routes. However, if you always have distinct routes, you can also disable content negotiation and simply hardcode your format of choice in your route pipelines:plug :put_format, &quot;html&quot;It is important to notice that browsers have historically sent bad accept headers. For this reason, this function will default to &quot;html&quot; format whenever:the accepted list of arguments contains the &quot;html&quot; formatthe accept header specified more than one media type preceded or followed by the wildcard media type &quot;*/*&quot;This function raises Phoenix.NotAcceptableError, which is rendered with status 406, whenever the server cannot serve a response in any of the formats expected by the client.Examplesaccepts/2 can be invoked as a function:iex&gt; accepts(conn, [&quot;html&quot;, &quot;json&quot;])or used as a plug:plug :accepts, [&quot;html&quot;, &quot;json&quot;] plug :accepts, ~w(html json)Custom media typesIt is possible to add custom media types to your Phoenix application. The first step is to teach Plug about those new media types in your config/config.exs file:config :mime, :types, %{ &quot;application/vnd.api+json&quot; =&gt; [&quot;json-api&quot;] }The key is the media type, the value is a list of formats the media type can be identified with. For example, by using &quot;json-api&quot;, you will be able to use templates with extension &quot;index.json-api&quot; or to force a particular format in a given URL by sending &quot;?_format=json-api&quot;.After this change, you must recompile plug:$ mix deps.clean mime --build $ mix deps.getAnd now you can use it in accepts too:plug :accepts, [&quot;html&quot;, &quot;json-api&quot;]","ref":"Phoenix.Controller.html#accepts/2","title":"Phoenix.Controller.accepts/2","type":"function"},{"doc":"Registers the plug to call as a fallback to the controller action.A fallback plug is useful to translate common domain data structures into a valid %Plug.Conn{} response. If the controller action fails to return a %Plug.Conn{}, the provided plug will be called and receive the controller's %Plug.Conn{} as it was before the action was invoked along with the value returned from the controller action.Examplesdefmodule MyController do use Phoenix.Controller action_fallback MyFallbackController def show(conn, %{&quot;id&quot; =&gt; id}, current_user) do with {:ok, post} &lt;- Blog.fetch_post(id), :ok &lt;- Authorizer.authorize(current_user, :view, post) do render(conn, &quot;show.json&quot;, post: post) end end endIn the above example, with is used to match only a successful post fetch, followed by valid authorization for the current user. In the event either of those fail to match, with will not invoke the render block and instead return the unmatched value. In this case, imagine Blog.fetch_post/2 returned {:error, :not_found} or Authorizer.authorize/3 returned {:error, :unauthorized}. For cases where these data structures serve as return values across multiple boundaries in our domain, a single fallback module can be used to translate the value into a valid response. For example, you could write the following fallback controller to handle the above values:defmodule MyFallbackController do use Phoenix.Controller def call(conn, {:error, :not_found}) do conn |&gt; put_status(:not_found) |&gt; put_view(MyErrorView) |&gt; render(:&quot;404&quot;) end def call(conn, {:error, :unauthorized}) do conn |&gt; put_status(403) |&gt; put_view(MyErrorView) |&gt; render(:&quot;403&quot;) end end","ref":"Phoenix.Controller.html#action_fallback/1","title":"Phoenix.Controller.action_fallback/1","type":"macro"},{"doc":"Returns the action name as an atom, raises if unavailable.","ref":"Phoenix.Controller.html#action_name/1","title":"Phoenix.Controller.action_name/1","type":"function"},{"doc":"A plug that may convert a JSON response into a JSONP one.In case a JSON response is returned, it will be converted to a JSONP as long as the callback field is present in the query string. The callback field itself defaults to &quot;callback&quot;, but may be configured with the callback option.In case there is no callback or the response is not encoded in JSON format, it is a no-op.Only alphanumeric characters and underscore are allowed in the callback name. Otherwise an exception is raised.Examples# Will convert JSON to JSONP if callback=someFunction is given plug :allow_jsonp # Will convert JSON to JSONP if cb=someFunction is given plug :allow_jsonp, callback: &quot;cb&quot;","ref":"Phoenix.Controller.html#allow_jsonp/2","title":"Phoenix.Controller.allow_jsonp/2","type":"function"},{"doc":"Clears all flash messages.","ref":"Phoenix.Controller.html#clear_flash/1","title":"Phoenix.Controller.clear_flash/1","type":"function"},{"doc":"Returns the controller module as an atom, raises if unavailable.","ref":"Phoenix.Controller.html#controller_module/1","title":"Phoenix.Controller.controller_module/1","type":"function"},{"doc":"Returns the current request path with its default query parameters:iex&gt; current_path(conn) &quot;/users/123?existing=param&quot;See current_path/2 to override the default parameters.","ref":"Phoenix.Controller.html#current_path/1","title":"Phoenix.Controller.current_path/1","type":"function"},{"doc":"Returns the current path with the given query parameters.You may also retrieve only the request path by passing an empty map of params.Examplesiex&gt; current_path(conn) &quot;/users/123?existing=param&quot; iex&gt; current_path(conn, %{new: &quot;param&quot;}) &quot;/users/123?new=param&quot; iex&gt; current_path(conn, %{filter: %{status: [&quot;draft&quot;, &quot;published&quot;}) &quot;/users/123?filter[status][]=draft&amp;filter[status][]=published&quot; iex&gt; current_path(conn, %{}) &quot;/users/123&quot;","ref":"Phoenix.Controller.html#current_path/2","title":"Phoenix.Controller.current_path/2","type":"function"},{"doc":"Returns the current request url with its default query parameters:iex&gt; current_url(conn) &quot;https://www.example.com/users/123?existing=param&quot;See current_url/2 to override the default parameters.","ref":"Phoenix.Controller.html#current_url/1","title":"Phoenix.Controller.current_url/1","type":"function"},{"doc":"Returns the current request URL with query params.The path will be retrieved from the currently requested path via current_path/1. The scheme, host and others will be received from the URL configuration in your Phoenix endpoint. The reason we don't use the host and scheme information in the request is because most applications are behind proxies and the host and scheme may not actually reflect the host and scheme accessed by the client. If you want to access the url precisely as requested by the client, see Plug.Conn.request_url/1.Examplesiex&gt; current_url(conn) &quot;https://www.example.com/users/123?existing=param&quot; iex&gt; current_url(conn, %{new: &quot;param&quot;}) &quot;https://www.example.com/users/123?new=param&quot; iex&gt; current_url(conn, %{}) &quot;https://www.example.com/users/123&quot;Custom URL GenerationIn some cases, you'll need to generate a request's URL, but using a different scheme, different host, etc. This can be accomplished in two ways.If you want to do so in a case-by-case basis, you can define a custom function that gets the endpoint URI configuration and changes it accordingly. For example, to get the current URL always in HTTPS format:def current_secure_url(conn, params \\\\ %{}) do cur_uri = MyAppWeb.Endpoint.struct_url() cur_path = Phoenix.Controller.current_path(conn, params) MyAppWeb.Router.Helpers.url(%URI{cur_uri | scheme: &quot;https&quot;}) &lt;&gt; cur_path endHowever, if you want all generated URLs to always have a certain schema, host, etc, you may use put_router_url/2.","ref":"Phoenix.Controller.html#current_url/2","title":"Phoenix.Controller.current_url/2","type":"function"},{"doc":"Deletes the CSRF token from the process dictionary.Note: The token is deleted only after a response has been sent.","ref":"Phoenix.Controller.html#delete_csrf_token/0","title":"Phoenix.Controller.delete_csrf_token/0","type":"function"},{"doc":"Returns the endpoint module as an atom, raises if unavailable.","ref":"Phoenix.Controller.html#endpoint_module/1","title":"Phoenix.Controller.endpoint_module/1","type":"function"},{"doc":"Fetches the flash storage.","ref":"Phoenix.Controller.html#fetch_flash/2","title":"Phoenix.Controller.fetch_flash/2","type":"function"},{"doc":"Gets or generates a CSRF token.If a token exists, it is returned, otherwise it is generated and stored in the process dictionary.","ref":"Phoenix.Controller.html#get_csrf_token/0","title":"Phoenix.Controller.get_csrf_token/0","type":"function"},{"doc":"Returns a map of previously set flash messages or an empty map.Examplesiex&gt; get_flash(conn) %{} iex&gt; conn = put_flash(conn, :info, &quot;Welcome Back!&quot;) iex&gt; get_flash(conn) %{&quot;info&quot; =&gt; &quot;Welcome Back!&quot;}","ref":"Phoenix.Controller.html#get_flash/1","title":"Phoenix.Controller.get_flash/1","type":"function"},{"doc":"Returns a message from flash by key (or nil if no message is available for key).Examplesiex&gt; conn = put_flash(conn, :info, &quot;Welcome Back!&quot;) iex&gt; get_flash(conn, :info) &quot;Welcome Back!&quot;","ref":"Phoenix.Controller.html#get_flash/2","title":"Phoenix.Controller.get_flash/2","type":"function"},{"doc":"Returns the request format, such as &quot;json&quot;, &quot;html&quot;.This format is used when rendering a template as an atom. For example, render(conn, :foo) will render &quot;foo.FORMAT&quot; where the format is the one set here. The default format is typically set from the negotiation done in accepts/2.","ref":"Phoenix.Controller.html#get_format/1","title":"Phoenix.Controller.get_format/1","type":"function"},{"doc":"Sends html response.Examplesiex&gt; html(conn, &quot;&lt;html&gt;&lt;head&gt;...&quot;)","ref":"Phoenix.Controller.html#html/2","title":"Phoenix.Controller.html/2","type":"function"},{"doc":"Sends JSON response.It uses the configured :json_library under the :phoenix application for :json to pick up the encoder module.Examplesiex&gt; json(conn, %{id: 123})","ref":"Phoenix.Controller.html#json/2","title":"Phoenix.Controller.json/2","type":"function"},{"doc":"Retrieves the current layout.","ref":"Phoenix.Controller.html#layout/1","title":"Phoenix.Controller.layout/1","type":"function"},{"doc":"Retrieves current layout formats.","ref":"Phoenix.Controller.html#layout_formats/1","title":"Phoenix.Controller.layout_formats/1","type":"function"},{"doc":"Merges a map into the flash.Returns the updated connection.Examplesiex&gt; conn = merge_flash(conn, info: &quot;Welcome Back!&quot;) iex&gt; get_flash(conn, :info) &quot;Welcome Back!&quot;","ref":"Phoenix.Controller.html#merge_flash/2","title":"Phoenix.Controller.merge_flash/2","type":"function"},{"doc":"Enables CSRF protection.Currently used as a wrapper function for Plug.CSRFProtection and mainly serves as a function plug in YourApp.Router.Check get_csrf_token/0 and delete_csrf_token/0 for retrieving and deleting CSRF tokens.","ref":"Phoenix.Controller.html#protect_from_forgery/2","title":"Phoenix.Controller.protect_from_forgery/2","type":"function"},{"doc":"Persists a value in flash.Returns the updated connection.Examplesiex&gt; conn = put_flash(conn, :info, &quot;Welcome Back!&quot;) iex&gt; get_flash(conn, :info) &quot;Welcome Back!&quot;","ref":"Phoenix.Controller.html#put_flash/3","title":"Phoenix.Controller.put_flash/3","type":"function"},{"doc":"Puts the format in the connection.This format is used when rendering a template as an atom. For example, render(conn, :foo) will render &quot;foo.FORMAT&quot; where the format is the one set here. The default format is typically set from the negotiation done in accepts/2.See get_format/1 for retrieval.","ref":"Phoenix.Controller.html#put_format/2","title":"Phoenix.Controller.put_format/2","type":"function"},{"doc":"Stores the layout for rendering.The layout must be a tuple, specifying the layout view and the layout name, or false. In case a previous layout is set, put_layout also accepts the layout name to be given as a string or as an atom. If a string, it must contain the format. Passing an atom means the layout format will be found at rendering time, similar to the template in render/3. It can also be set to false. In this case, no layout would be used.Examplesiex&gt; layout(conn) false iex&gt; conn = put_layout conn, {AppView, &quot;application.html&quot;} iex&gt; layout(conn) {AppView, &quot;application.html&quot;} iex&gt; conn = put_layout conn, &quot;print.html&quot; iex&gt; layout(conn) {AppView, &quot;print.html&quot;} iex&gt; conn = put_layout conn, :print iex&gt; layout(conn) {AppView, :print}Raises Plug.Conn.AlreadySentError if conn is already sent.","ref":"Phoenix.Controller.html#put_layout/2","title":"Phoenix.Controller.put_layout/2","type":"function"},{"doc":"Sets which formats have a layout when rendering.Examplesiex&gt; layout_formats(conn) [&quot;html&quot;] iex&gt; put_layout_formats(conn, [&quot;html&quot;, &quot;mobile&quot;]) iex&gt; layout_formats(conn) [&quot;html&quot;, &quot;mobile&quot;]Raises Plug.Conn.AlreadySentError if conn is already sent.","ref":"Phoenix.Controller.html#put_layout_formats/2","title":"Phoenix.Controller.put_layout_formats/2","type":"function"},{"doc":"Stores the layout for rendering if one was not stored yet.Raises Plug.Conn.AlreadySentError if conn is already sent.","ref":"Phoenix.Controller.html#put_new_layout/2","title":"Phoenix.Controller.put_new_layout/2","type":"function"},{"doc":"Stores the view for rendering if one was not stored yet.Raises Plug.Conn.AlreadySentError if conn is already sent.","ref":"Phoenix.Controller.html#put_new_view/2","title":"Phoenix.Controller.put_new_view/2","type":"function"},{"doc":"Stores the root layout for rendering.Like put_layout/2, the layout must be a tuple, specifying the layout view and the layout name, or false.In case a previous layout is set, put_root_layout also accepts the layout name to be given as a string or as an atom. If a string, it must contain the format. Passing an atom means the layout format will be found at rendering time, similar to the template in render/3. It can also be set to false. In this case, no layout would be used.Examplesiex&gt; root_layout(conn) false iex&gt; conn = put_root_layout conn, {AppView, &quot;root.html&quot;} iex&gt; root_layout(conn) {AppView, &quot;root.html&quot;} iex&gt; conn = put_root_layout conn, &quot;bare.html&quot; iex&gt; root_layout(conn) {AppView, &quot;bare.html&quot;} iex&gt; conn = put_root_layout conn, :bare iex&gt; root_layout(conn) {AppView, :bare}Raises Plug.Conn.AlreadySentError if conn is already sent.","ref":"Phoenix.Controller.html#put_root_layout/2","title":"Phoenix.Controller.put_root_layout/2","type":"function"},{"doc":"Puts the url string or %URI{} to be used for route generation.This function overrides the default URL generation pulled from the %Plug.Conn{}'s endpoint configuration.ExamplesImagine your application is configured to run on &quot;example.com&quot; but after the user signs in, you want all links to use &quot;some_user.example.com&quot;. You can do so by setting the proper router url configuration:def put_router_url_by_user(conn) do put_router_url(conn, get_user_from_conn(conn).account_name &lt;&gt; &quot;.example.com&quot;) endNow when you call Routes.some_route_url(conn, ...), it will use the router url set above. Keep in mind that, if you want to generate routes to the current domain, it is preferred to use Routes.some_route_path helpers, as those are always relative.","ref":"Phoenix.Controller.html#put_router_url/2","title":"Phoenix.Controller.put_router_url/2","type":"function"},{"doc":"Put headers that improve browser security.It sets the following headers:x-frame-options - set to SAMEORIGIN to avoid clickjacking through iframes unless in the same originx-content-type-options - set to nosniff. This requires script and style tags to be sent with proper content typex-xss-protection - set to &quot;1; mode=block&quot; to improve XSS protection on both Chrome and IEx-download-options - set to noopen to instruct the browser not to open a download directly in the browser, to avoid HTML files rendering inline and accessing the security context of the application (like critical domain cookies)x-permitted-cross-domain-policies - set to none to restrict Adobe Flash Player’s access to datacross-origin-window-policy - set to deny to avoid window control attacksA custom headers map may also be given to be merged with defaults. It is recommended for custom header keys to be in lowercase, to avoid sending duplicate keys in a request. Additionally, responses with mixed-case headers served over HTTP/2 are not considered valid by common clients, resulting in dropped responses.","ref":"Phoenix.Controller.html#put_secure_browser_headers/2","title":"Phoenix.Controller.put_secure_browser_headers/2","type":"function"},{"doc":"Puts the URL or %URI{} to be used for the static url generation.Using this function on a %Plug.Conn{} struct tells static_url/2 to use the given information for URL generation instead of the the %Plug.Conn{}'s endpoint configuration (much like put_router_url/2 but for static URLs).","ref":"Phoenix.Controller.html#put_static_url/2","title":"Phoenix.Controller.put_static_url/2","type":"function"},{"doc":"Stores the view for rendering.Raises Plug.Conn.AlreadySentError if conn is already sent.","ref":"Phoenix.Controller.html#put_view/2","title":"Phoenix.Controller.put_view/2","type":"function"},{"doc":"Sends redirect response to the given url.For security, :to only accepts paths. Use the :external option to redirect to any URL.The response will be sent with the status code defined within the connection, via Plug.Conn.put_status/2. If no status code is set, a 302 response is sent.Examplesiex&gt; redirect(conn, to: &quot;/login&quot;) iex&gt; redirect(conn, external: &quot;http://elixir-lang.org&quot;)","ref":"Phoenix.Controller.html#redirect/2","title":"Phoenix.Controller.redirect/2","type":"function"},{"doc":"Render the given template or the default template specified by the current action with the given assigns.See render/3 for more information.","ref":"Phoenix.Controller.html#render/2","title":"Phoenix.Controller.render/2","type":"function"},{"doc":"Renders the given template and assigns based on the conn information.Once the template is rendered, the template format is set as the response content type (for example, an HTML template will set &quot;text/html&quot; as response content type) and the data is sent to the client with default status of 200.Argumentsconn - the Plug.Conn structtemplate - which may be an atom or a string. If an atom, like :index, it will render a template with the same format as the one returned by get_format/1. For example, for an HTML request, it will render the &quot;index.html&quot; template. If the template is a string, it must contain the extension too, like &quot;index.json&quot;assigns - a dictionary with the assigns to be used in the view. Those assigns are merged and have higher precedence than the connection assigns (conn.assigns)Examplesdefmodule MyAppWeb.UserController do use Phoenix.Controller def show(conn, _params) do render(conn, &quot;show.html&quot;, message: &quot;Hello&quot;) end endThe example above renders a template &quot;show.html&quot; from the MyAppWeb.UserView and sets the response content type to &quot;text/html&quot;.In many cases, you may want the template format to be set dynamically based on the request. To do so, you can pass the template name as an atom (without the extension):def show(conn, _params) do render(conn, :show, message: &quot;Hello&quot;) endIn order for the example above to work, we need to do content negotiation with the accepts plug before rendering. You can do so by adding the following to your pipeline (in the router):plug :accepts, [&quot;html&quot;]ViewsBy default, Controllers render templates in a view with a similar name to the controller. For example, MyAppWeb.UserController will render templates inside the MyAppWeb.UserView. This information can be changed any time by using the put_view/2 function:def show(conn, _params) do conn |&gt; put_view(MyAppWeb.SpecialView) |&gt; render(:show, message: &quot;Hello&quot;) endput_view/2 can also be used as a plug:defmodule MyAppWeb.UserController do use Phoenix.Controller plug :put_view, MyAppWeb.SpecialView def show(conn, _params) do render(conn, :show, message: &quot;Hello&quot;) end endLayoutsTemplates are often rendered inside layouts. By default, Phoenix will render layouts for html requests. For example:defmodule MyAppWeb.UserController do use Phoenix.Controller def show(conn, _params) do render(conn, &quot;show.html&quot;, message: &quot;Hello&quot;) end endwill render the &quot;show.html&quot; template inside an &quot;app.html&quot; template specified in MyAppWeb.LayoutView. put_layout/2 can be used to change the layout, similar to how put_view/2 can be used to change the view.layout_formats/1 and put_layout_formats/2 can be used to configure which formats support/require layout rendering (defaults to &quot;html&quot; only).","ref":"Phoenix.Controller.html#render/3","title":"Phoenix.Controller.render/3","type":"function"},{"doc":"Retrieves the current root layout.","ref":"Phoenix.Controller.html#root_layout/1","title":"Phoenix.Controller.root_layout/1","type":"function"},{"doc":"Returns the router module as an atom, raises if unavailable.","ref":"Phoenix.Controller.html#router_module/1","title":"Phoenix.Controller.router_module/1","type":"function"},{"doc":"Scrubs the parameters from the request.This process is two-fold:Checks to see if the required_key is presentChanges empty parameters of required_key (recursively) to nilsThis function is useful for removing empty strings sent via HTML forms. If you are providing an API, there is likely no need to invoke scrub_params/2.If the required_key is not present, it will raise Phoenix.MissingParamError.Examplesiex&gt; scrub_params(conn, &quot;user&quot;)","ref":"Phoenix.Controller.html#scrub_params/2","title":"Phoenix.Controller.scrub_params/2","type":"function"},{"doc":"Sends the given file or binary as a download.The second argument must be {:binary, contents}, where contents will be sent as download, or{:file, path}, where path is the filesystem location of the file to be sent. Be careful to not interpolate the path from external parameters, as it could allow traversal of the filesystem.The download is achieved by setting &quot;content-disposition&quot; to attachment. The &quot;content-type&quot; will also be set based on the extension of the given filename but can be customized via the :content_type and :charset options.Options:filename - the filename to be presented to the user as download:content_type - the content type of the file or binary sent as download. It is automatically inferred from the filename extension:disposition - specifies dispositon type (:attachment or :inline). If :attachment was used, user will be prompted to save the file. If :inline was used, the browser will attempt to open the file. Defaults to :attachment.:charset - the charset of the file, such as &quot;utf-8&quot;. Defaults to none:offset - the bytes to offset when reading. Defaults to 0:length - the total bytes to read. Defaults to :all:encode - encodes the filename using URI.encode_www_form/1. Defaults to true. When false, disables encoding. If you disable encoding, you need to guarantee there are no special characters in the filename, such as quotes, newlines, etc. Otherwise you can expose your application to security attacksExamplesTo send a file that is stored inside your application priv directory:path = Application.app_dir(:my_app, &quot;priv/prospectus.pdf&quot;) send_download(conn, {:file, path})When using {:file, path}, the filename is inferred from the given path but may also be set explicitly.To allow the user to download contents that are in memory as a binary or string:send_download(conn, {:binary, &quot;world&quot;}, filename: &quot;hello.txt&quot;)See Plug.Conn.send_file/3 and Plug.Conn.send_resp/3 if you would like to access the low-level functions used to send files and responses via Plug.","ref":"Phoenix.Controller.html#send_download/3","title":"Phoenix.Controller.send_download/3","type":"function"},{"doc":"Generates a status message from the template name.Examplesiex&gt; status_message_from_template(&quot;404.html&quot;) &quot;Not Found&quot; iex&gt; status_message_from_template(&quot;whatever.html&quot;) &quot;Internal Server Error&quot;","ref":"Phoenix.Controller.html#status_message_from_template/1","title":"Phoenix.Controller.status_message_from_template/1","type":"function"},{"doc":"Sends text response.Examplesiex&gt; text(conn, &quot;hello&quot;) iex&gt; text(conn, :implements_to_string)","ref":"Phoenix.Controller.html#text/2","title":"Phoenix.Controller.text/2","type":"function"},{"doc":"Retrieves the current view.","ref":"Phoenix.Controller.html#view_module/1","title":"Phoenix.Controller.view_module/1","type":"function"},{"doc":"Returns the template name rendered in the view as a string (or nil if no template was rendered).","ref":"Phoenix.Controller.html#view_template/1","title":"Phoenix.Controller.view_template/1","type":"function"},{"doc":"Defines a Phoenix endpoint.The endpoint is the boundary where all requests to your web application start. It is also the interface your application provides to the underlying web servers.Overall, an endpoint has three responsibilities:to provide a wrapper for starting and stopping the endpoint as part of a supervision treeto define an initial plug pipeline for requests to pass throughto host web specific configuration for your applicationEndpointsAn endpoint is simply a module defined with the help of Phoenix.Endpoint. If you have used the mix phx.new generator, an endpoint was automatically generated as part of your application:defmodule YourApp.Endpoint do use Phoenix.Endpoint, otp_app: :your_app # plug ... # plug ... plug YourApp.Router endEndpoints must be explicitly started as part of your application supervision tree. Endpoints are added by default to the supervision tree in generated applications. Endpoints can be added to the supervision tree as follows:children = [ YourApp.Endpoint ]Endpoint configurationAll endpoints are configured in your application environment. For example:config :your_app, YourApp.Endpoint, secret_key_base: &quot;kjoy3o1zeidquwy1398juxzldjlksahdk3&quot;Endpoint configuration is split into two categories. Compile-time configuration means the configuration is read during compilation and changing it at runtime has no effect. The compile-time configuration is mostly related to error handling.Runtime configuration, instead, is accessed during or after your application is started and can be read through the config/2 function:YourApp.Endpoint.config(:port) YourApp.Endpoint.config(:some_config, :default_value)Dynamic configurationFor dynamically configuring the endpoint, such as loading data from environment variables or configuration files, Phoenix invokes the init/2 callback on the endpoint, passing the atom :supervisor as the first argument and the endpoint configuration as second.All of Phoenix configuration, except the Compile-time configuration below can be set dynamically from the init/2 callback.Compile-time configuration:code_reloader - when true, enables code reloading functionality. For the list of code reloader configuration options see Phoenix.CodeReloader.reload!/1:debug_errors - when true, uses Plug.Debugger functionality for debugging failures in the application. Recommended to be set to true only in development as it allows listing of the application source code during debugging. Defaults to false:force_ssl - ensures no data is ever sent via HTTP, always redirecting to HTTPS. It expects a list of options which are forwarded to Plug.SSL. By default it sets the &quot;strict-transport-security&quot; header in HTTPS requests, forcing browsers to always use HTTPS. If an unsafe request (HTTP) is sent, it redirects to the HTTPS version using the :host specified in the :url configuration. To dynamically redirect to the host of the current request, set :host in the :force_ssl configuration to nilRuntime configuration:adapter - which webserver adapter to use for serving web requests. See the &quot;Adapter configuration&quot; section below:cache_static_manifest - a path to a json manifest file that contains static files and their digested version. This is typically set to &quot;priv/static/cache_manifest.json&quot; which is the file automatically generated by mix phx.digest. It can be either: a string containing a file system path or a tuple containing the application name and the path within that application.:cache_static_manifest_latest - a map of the static files pointing to their digest version. This is automatically loaded from cache_static_manifest on boot. However, if you have your own static handling mechanism, you may want to set this value explicitly. This is used by projects such as LiveView to detect if the client is running on the latest version of all assets:check_origin - configure the default :check_origin setting for transports. See socket/3 for options. Defaults to true.:secret_key_base - a secret key used as a base to generate secrets for encrypting and signing data. For example, cookies and tokens are signed by default, but they may also be encrypted if desired. Defaults to nil as it must be set per application:server - when true, starts the web server when the endpoint supervision tree starts. Defaults to false. The mix phx.server task automatically sets this to true:url - configuration for generating URLs throughout the app. Accepts the :host, :scheme, :path and :port options. All keys except :path can be changed at runtime. Defaults to:[host: &quot;localhost&quot;, path: &quot;/&quot;]The :port option requires either an integer or string. The :host option requires a string. The :scheme option accepts &quot;http&quot; and &quot;https&quot; values. Default value is inferred from top level :http or :https option. It is useful when hosting Phoenix behind a load balancer or reverse proxy and terminating SSL there. The :path option can be used to override root path. Useful when hosting Phoenix behind a reverse proxy with URL rewrite rules:static_url - configuration for generating URLs for static files. It will fallback to url if no option is provided. Accepts the same options as url:watchers - a set of watchers to run alongside your server. It expects a list of tuples containing the executable and its arguments. Watchers are guaranteed to run in the application directory, but only when the server is enabled. For example, the watcher below will run the &quot;watch&quot; mode of the webpack build tool when the server starts. You can configure it to whatever build tool or command you want:[node: [&quot;node_modules/webpack/bin/webpack.js&quot;, &quot;--mode&quot;, &quot;development&quot;, &quot;--watch-stdin&quot;]]The :cd option can be used on a watcher to override the folder from which the watcher will run. By default this will be the project's root: File.cwd!()[node: [&quot;node_modules/webpack/bin/webpack.js&quot;, &quot;--mode&quot;, &quot;development&quot;, &quot;--watch-stdin&quot;, cd: &quot;my_frontend&quot;]]:live_reload - configuration for the live reload option. Configuration requires a :patterns option which should be a list of file patterns to watch. When these files change, it will trigger a reload. If you are using a tool like pow in development, you may need to set the :url option appropriately.live_reload: [ url: &quot;ws://localhost:4000&quot;, patterns: [ ~r{priv/static/.*(js|css|png|jpeg|jpg|gif)$}, ~r{web/views/.*(ex)$}, ~r{web/templates/.*(eex)$} ] ]:pubsub_server - the name of the pubsub server to use in channels and via the Endpoint broadcast functions. The PubSub server is typically started in your supervision tree.:render_errors - responsible for rendering templates whenever there is a failure in the application. For example, if the application crashes with a 500 error during a HTML request, render(&quot;500.html&quot;, assigns) will be called in the view given to :render_errors. Defaults to:[view: MyApp.ErrorView, accepts: ~w(html), layout: false, log: :debug]The default format is used when none is set in the connectionAdapter configurationPhoenix allows you to choose which webserver adapter to use. The default is Phoenix.Endpoint.Cowboy2Adapter which can be configured via the following options.:http - the configuration for the HTTP server. It accepts all options as defined by Plug.Cowboy. Defaults to false:https - the configuration for the HTTPS server. It accepts all options as defined by Plug.Cowboy. Defaults to false:drainer - a drainer process that triggers when your application is shutting to wait for any on-going request to finish. It accepts all options as defined by Plug.Cowboy. Defaults to [] and can be disabled by setting it to false.Endpoint APIIn the previous section, we have used the config/2 function that is automatically generated in your endpoint. Here's a list of all the functions that are automatically defined in your endpoint:for handling paths and URLs: struct_url/0, url/0, path/1, static_url/0,static_path/1, and static_integrity/1for broadcasting to channels: broadcast/3, broadcast!/3, broadcast_from/4, broadcast_from!/4, local_broadcast/3, and local_broadcast_from/4for configuration: start_link/0, config/2, and config_change/2as required by the Plug behaviour: Plug.init/1 and Plug.call/2","ref":"Phoenix.Endpoint.html","title":"Phoenix.Endpoint","type":"behaviour"},{"doc":"Broadcasts a msg as event in the given topic to all nodes.","ref":"Phoenix.Endpoint.html#c:broadcast/3","title":"Phoenix.Endpoint.broadcast/3","type":"callback"},{"doc":"Broadcasts a msg as event in the given topic to all nodes.Raises in case of failures.","ref":"Phoenix.Endpoint.html#c:broadcast!/3","title":"Phoenix.Endpoint.broadcast!/3","type":"callback"},{"doc":"Broadcasts a msg from the given from as event in the given topic to all nodes.","ref":"Phoenix.Endpoint.html#c:broadcast_from/4","title":"Phoenix.Endpoint.broadcast_from/4","type":"callback"},{"doc":"Broadcasts a msg from the given from as event in the given topic to all nodes.Raises in case of failures.","ref":"Phoenix.Endpoint.html#c:broadcast_from!/4","title":"Phoenix.Endpoint.broadcast_from!/4","type":"callback"},{"doc":"Access the endpoint configuration given by key.","ref":"Phoenix.Endpoint.html#c:config/2","title":"Phoenix.Endpoint.config/2","type":"callback"},{"doc":"Reload the endpoint configuration on application upgrades.","ref":"Phoenix.Endpoint.html#c:config_change/2","title":"Phoenix.Endpoint.config_change/2","type":"callback"},{"doc":"Returns the host from the :url configuration.","ref":"Phoenix.Endpoint.html#c:host/0","title":"Phoenix.Endpoint.host/0","type":"callback"},{"doc":"Initialize the endpoint configuration.Invoked when the endpoint supervisor starts, allows dynamically configuring the endpoint from system environment or other runtime sources.","ref":"Phoenix.Endpoint.html#c:init/2","title":"Phoenix.Endpoint.init/2","type":"callback"},{"doc":"Broadcasts a msg as event in the given topic within the current node.","ref":"Phoenix.Endpoint.html#c:local_broadcast/3","title":"Phoenix.Endpoint.local_broadcast/3","type":"callback"},{"doc":"Broadcasts a msg from the given from as event in the given topic within the current node.","ref":"Phoenix.Endpoint.html#c:local_broadcast_from/4","title":"Phoenix.Endpoint.local_broadcast_from/4","type":"callback"},{"doc":"Generates the path information when routing to this endpoint.","ref":"Phoenix.Endpoint.html#c:path/1","title":"Phoenix.Endpoint.path/1","type":"callback"},{"doc":"Returns the script name from the :url configuration.","ref":"Phoenix.Endpoint.html#c:script_name/0","title":"Phoenix.Endpoint.script_name/0","type":"callback"},{"doc":"Checks if Endpoint's web server has been configured to start.otp_app - The OTP app running the endpoint, for example :my_appendpoint - The endpoint module, for example MyApp.EndpointExamplesiex&gt; Phoenix.Endpoint.server?(:my_app, MyApp.Endpoint) true","ref":"Phoenix.Endpoint.html#server?/2","title":"Phoenix.Endpoint.server?/2","type":"function"},{"doc":"Defines a websocket/longpoll mount-point for a socket.Options:websocket - controls the websocket configuration. Defaults to true. May be false or a keyword list of options. See &quot;Shared configuration&quot; and &quot;WebSocket configuration&quot; for the whole list:longpoll - controls the longpoll configuration. Defaults to false. May be true or a keyword list of options. See &quot;Shared configuration&quot; and &quot;Longpoll configuration&quot; for the whole listIf your socket is implemented using Phoenix.Socket, you can also pass to each transport above all options accepted on use Phoenix.Socket. An option given here will override the value in use Phoenix.Socket.Examplessocket &quot;/ws&quot;, MyApp.UserSocket socket &quot;/ws/admin&quot;, MyApp.AdminUserSocket, longpoll: true, websocket: [compress: true]Path paramsIt is possible to include variables in the path, these will be available in the params that are passed to the socket.socket &quot;/ws/:user_id&quot;, MyApp.UserSocket, websocket: [path: &quot;/project/:project_id&quot;]Note: This feature is not supported with the Cowboy 1 adapter.Common configurationThe configuration below can be given to both :websocket and :longpoll keys::path - the path to use for the transport. Will default to the transport name (&quot;/websocket&quot; or &quot;/longpoll&quot;):serializer - a list of serializers for messages. See Phoenix.Socket for more information:transport_log - if the transport layer itself should log and, if so, the level:check_origin - if the transport should check the origin of requests when the origin header is present. May be true, false, a list of hosts that are allowed, or a function provided as MFA tuple. Defaults to :check_origin setting at endpoint configuration.If true, the header is checked against :host in YourApp.Endpoint.config(:url)[:host]. If false, your app is vulnerable to Cross-Site WebSocket Hijacking (CSWSH) attacks. Only use in development, when the host is truly unknown or when serving clients that do not send the origin header, such as mobile apps. You can also specify a list of explicitly allowed origins. Wildcards are supported.check_origin: [ &quot;https://example.com&quot;, &quot;//another.com:888&quot;, &quot;//*.other.com&quot; ]Or a custom MFA function:check_origin: {MyAppWeb.Auth, :my_check_origin?, []}The MFA is invoked with the request %URI{} as the first argument, followed by arguments in the MFA list.:code_reloader - enable or disable the code reloader. Defaults to your endpoint configuration:connect_info - a list of keys that represent data to be copied from the transport to be made available in the user socket connect/3 callbackThe valid keys are::peer_data - the result of Plug.Conn.get_peer_data/1:trace_context_headers - a list of all trace context headers. Supported headers are defined by the W3C Trace Context Specification. These headers are necessary for libraries such as OpenTelemetry to extract trace propagation information to know this request is part of a larger trace in progress.:x_headers - all request headers that have an &quot;x-&quot; prefix:uri - a %URI{} with information from the conn:user_agent - the value of the &quot;user-agent&quot; request header{:session, session_config} - the session information from Plug.Conn. The session_config is an exact copy of the arguments given to Plug.Session. This requires the &quot;_csrf_token&quot; to be given as request parameter with the value of URI.encode_www_form(Plug.CSRFProtection.get_csrf_token()) when connecting to the socket. It can also be a MFA to allow loading config in runtime {MyAppWeb.Auth, :get_session_config, []}. Otherwise the session will be nil. Arbitrary keywords may also appear following the above valid keys, which is useful for passing custom connection information to the socket. For example: socket &quot;/socket&quot;, AppWeb.UserSocket, websocket: [connect_info: [:peer_data, :trace_context_headers, :x_headers, :uri, session: [store: :cookie]] ] With arbitrary keywords: socket &quot;/socket&quot;, AppWeb.UserSocket, websocket: [connect_info: [:uri, custom_value: &quot;abcdef&quot;] ]Websocket configurationThe following configuration applies only to :websocket.:timeout - the timeout for keeping websocket connections open after it last received data, defaults to 60_000ms:max_frame_size - the maximum allowed frame size in bytes. Supported from Cowboy 2.3 onwards, defaults to &quot;infinity&quot;:compress - whether to enable per message compression on all data frames, defaults to false:subprotocols - a list of supported websocket subprotocols. Used for handshake Sec-WebSocket-Protocol response header, defaults to nil.For example:subprotocols: [&quot;sip&quot;, &quot;mqtt&quot;]Longpoll configurationThe following configuration applies only to :longpoll::window_ms - how long the client can wait for new messages in its poll request:pubsub_timeout_ms - how long a request can wait for the pubsub layer to respond:crypto - options for verifying and signing the token, accepted by Phoenix.Token. By default tokens are valid for 2 weeks","ref":"Phoenix.Endpoint.html#socket/3","title":"Phoenix.Endpoint.socket/3","type":"macro"},{"doc":"Starts the endpoint supervision tree.Starts endpoint's configuration cache and possibly the servers for handling requests.","ref":"Phoenix.Endpoint.html#c:start_link/0","title":"Phoenix.Endpoint.start_link/0","type":"callback"},{"doc":"Generates an integrity hash to a static file in priv/static.","ref":"Phoenix.Endpoint.html#c:static_integrity/1","title":"Phoenix.Endpoint.static_integrity/1","type":"callback"},{"doc":"Generates a two item tuple containing the static_path and static_integrity.","ref":"Phoenix.Endpoint.html#c:static_lookup/1","title":"Phoenix.Endpoint.static_lookup/1","type":"callback"},{"doc":"Generates a route to a static file in priv/static.","ref":"Phoenix.Endpoint.html#c:static_path/1","title":"Phoenix.Endpoint.static_path/1","type":"callback"},{"doc":"Generates the static URL without any path information.","ref":"Phoenix.Endpoint.html#c:static_url/0","title":"Phoenix.Endpoint.static_url/0","type":"callback"},{"doc":"Generates the endpoint base URL, but as a URI struct.","ref":"Phoenix.Endpoint.html#c:struct_url/0","title":"Phoenix.Endpoint.struct_url/0","type":"callback"},{"doc":"Generates the endpoint base URL without any path information.","ref":"Phoenix.Endpoint.html#c:url/0","title":"Phoenix.Endpoint.url/0","type":"callback"},{"doc":"","ref":"Phoenix.Endpoint.html#t:event/0","title":"Phoenix.Endpoint.event/0","type":"type"},{"doc":"","ref":"Phoenix.Endpoint.html#t:msg/0","title":"Phoenix.Endpoint.msg/0","type":"type"},{"doc":"","ref":"Phoenix.Endpoint.html#t:topic/0","title":"Phoenix.Endpoint.topic/0","type":"type"},{"doc":"Instrumenter to handle logging of various instrumentation events.InstrumentationPhoenix uses the :telemetry library for instrumentation. The following events are published by Phoenix with the following measurements and metadata:[:phoenix, :endpoint, :start] - dispatched by Plug.Telemetry in your endpoint, usually after code reloadingMeasurement: %{system_time: system_time}Metadata: %{conn: Plug.Conn.t, options: Keyword.t}Options: %{log: Logger.level | false}Disable logging: In your endpoint plug Plug.Telemetry, ..., log: Logger.level | false[:phoenix, :endpoint, :stop] - dispatched by Plug.Telemetry in your endpoint whenever the response is sentMeasurement: %{duration: native_time}Metadata: %{conn: Plug.Conn.t, options: Keyword.t}Options: %{log: Logger.level | false}Disable logging: In your endpoint plug Plug.Telemetry, ..., log: Logger.level | false[:phoenix, :router_dispatch, :start] - dispatched by Phoenix.Router before dispatching to a matched routeMeasurement: %{system_time: System.system_time}Metadata: %{conn: Plug.Conn.t, route: binary, plug: module, plug_opts: term, path_params: map, pipe_through: [atom], log: Logger.level | false}Disable logging: Pass log: false to the router macro, for example: get(&quot;/page&quot;, PageController, :index, log: false)[:phoenix, :router_dispatch, :exception] - dispatched by Phoenix.Router after exceptions on dispatching a routeMeasurement: %{duration: native_time}Metadata: %{conn: Plug.Conn.t, kind: :throw | :error | :exit, reason: term(), stacktrace: Exception.stacktrace()}Disable logging: This event is not logged[:phoenix, :router_dispatch, :stop] - dispatched by Phoenix.Router after successfully dispatching a matched routeMeasurement: %{duration: native_time}Metadata: %{conn: Plug.Conn.t, route: binary, plug: module, plug_opts: term, path_params: map, pipe_through: [atom], log: Logger.level | false}Disable logging: This event is not logged[:phoenix, :error_rendered] - dispatched at the end of an error view being renderedMeasurement: %{duration: native_time}Metadata: %{conn: Plug.Conn.t, status: Plug.Conn.status, kind: Exception.kind, reason: term, stacktrace: Exception.stacktrace}Disable logging: Set render_errors: [log: false] on your endpoint configuration[:phoenix, :socket_connected] - dispatched by Phoenix.Socket, at the end of a socket connectionMeasurement: %{duration: native_time}Metadata: %{endpoint: atom, transport: atom, params: term, connect_info: map, vsn: binary, user_socket: atom, result: :ok | :error, serializer: atom, log: Logger.level | false}Disable logging: use Phoenix.Socket, log: false or socket &quot;/foo&quot;, MySocket, websocket: [log: false] in your endpoint[:phoenix, :channel_joined] - dispatched at the end of a channel joinMeasurement: %{duration: native_time}Metadata: %{result: :ok | :error, params: term, socket: Phoenix.Socket.t}Disable logging: This event cannot be disabled[:phoenix, :channel_handled_in] - dispatched at the end of a channel handle inMeasurement: %{duration: native_time}Metadata: %{event: binary, params: term, socket: Phoenix.Socket.t}Disable logging: This event cannot be disabledTo see an example of how Phoenix LiveDashboard uses these events to create metrics, visit https://hexdocs.pm/phoenix_live_dashboard/metrics.html.Parameter filteringWhen logging parameters, Phoenix can filter out sensitive parameters such as passwords and tokens. Parameters to be filtered can be added via the :filter_parameters option:config :phoenix, :filter_parameters, [&quot;password&quot;, &quot;secret&quot;]With the configuration above, Phoenix will filter any parameter that contains the terms password or secret. The match is case sensitive.Phoenix's default is [&quot;password&quot;].Phoenix can filter all parameters by default and selectively keep parameters. This can be configured like so:config :phoenix, :filter_parameters, {:keep, [&quot;id&quot;, &quot;order&quot;]}With the configuration above, Phoenix will filter all parameters, except those that match exactly id or order. If a kept parameter matches, all parameters nested under that one will also be kept.DisablingWhen you are using custom logging system it is not always desirable to enable Phoenix.Logger by default. You can always disable this in general by:config :phoenix, :logger, false","ref":"Phoenix.Logger.html","title":"Phoenix.Logger","type":"module"},{"doc":"Conveniences for inflecting and working with names in Phoenix.","ref":"Phoenix.Naming.html","title":"Phoenix.Naming","type":"module"},{"doc":"Converts a string to camel case.Takes an optional :lower flag to return lowerCamelCase.Examplesiex&gt; Phoenix.Naming.camelize(&quot;my_app&quot;) &quot;MyApp&quot; iex&gt; Phoenix.Naming.camelize(&quot;my_app&quot;, :lower) &quot;myApp&quot;In general, camelize can be thought of as the reverse of underscore, however, in some cases formatting may be lost:Phoenix.Naming.underscore &quot;SAPExample&quot; #=&gt; &quot;sap_example&quot; Phoenix.Naming.camelize &quot;sap_example&quot; #=&gt; &quot;SapExample&quot;","ref":"Phoenix.Naming.html#camelize/1","title":"Phoenix.Naming.camelize/1","type":"function"},{"doc":"","ref":"Phoenix.Naming.html#camelize/2","title":"Phoenix.Naming.camelize/2","type":"function"},{"doc":"Converts an attribute/form field into its humanize version.Examplesiex&gt; Phoenix.Naming.humanize(:username) &quot;Username&quot; iex&gt; Phoenix.Naming.humanize(:created_at) &quot;Created at&quot; iex&gt; Phoenix.Naming.humanize(&quot;user_id&quot;) &quot;User&quot;","ref":"Phoenix.Naming.html#humanize/1","title":"Phoenix.Naming.humanize/1","type":"function"},{"doc":"Extracts the resource name from an alias.Examplesiex&gt; Phoenix.Naming.resource_name(MyApp.User) &quot;user&quot; iex&gt; Phoenix.Naming.resource_name(MyApp.UserView, &quot;View&quot;) &quot;user&quot;","ref":"Phoenix.Naming.html#resource_name/2","title":"Phoenix.Naming.resource_name/2","type":"function"},{"doc":"Converts a string to underscore case.Examplesiex&gt; Phoenix.Naming.underscore(&quot;MyApp&quot;) &quot;my_app&quot;In general, underscore can be thought of as the reverse of camelize, however, in some cases formatting may be lost:Phoenix.Naming.underscore &quot;SAPExample&quot; #=&gt; &quot;sap_example&quot; Phoenix.Naming.camelize &quot;sap_example&quot; #=&gt; &quot;SapExample&quot;","ref":"Phoenix.Naming.html#underscore/1","title":"Phoenix.Naming.underscore/1","type":"function"},{"doc":"Removes the given suffix from the name if it exists.Examplesiex&gt; Phoenix.Naming.unsuffix(&quot;MyApp.User&quot;, &quot;View&quot;) &quot;MyApp.User&quot; iex&gt; Phoenix.Naming.unsuffix(&quot;MyApp.UserView&quot;, &quot;View&quot;) &quot;MyApp.User&quot;","ref":"Phoenix.Naming.html#unsuffix/2","title":"Phoenix.Naming.unsuffix/2","type":"function"},{"doc":"A protocol that converts data structures into URL parameters.This protocol is used by URL helpers and other parts of the Phoenix stack. For example, when you write:user_path(conn, :edit, @user)Phoenix knows how to extract the :id from @user thanks to this protocol.By default, Phoenix implements this protocol for integers, binaries, atoms, and structs. For structs, a key :id is assumed, but you may provide a specific implementation.Nil values cannot be converted to param.Custom parametersIn order to customize the parameter for any struct, one can simply implement this protocol.However, for convenience, this protocol can also be derivable. For example:defmodule User do @derive Phoenix.Param defstruct [:id, :username] endBy default, the derived implementation will also use the :id key. In case the user does not contain an :id key, the key can be specified with an option:defmodule User do @derive {Phoenix.Param, key: :username} defstruct [:username] endwill automatically use :username in URLs.When using Ecto, you must call @derive before your schema call:@derive {Phoenix.Param, key: :username} schema &quot;users&quot; do","ref":"Phoenix.Param.html","title":"Phoenix.Param","type":"protocol"},{"doc":"","ref":"Phoenix.Param.html#to_param/1","title":"Phoenix.Param.to_param/1","type":"function"},{"doc":"","ref":"Phoenix.Param.html#t:t/0","title":"Phoenix.Param.t/0","type":"type"},{"doc":"Provides Presence tracking to processes and channels.This behaviour provides presence features such as fetching presences for a given topic, as well as handling diffs of join and leave events as they occur in real-time. Using this module defines a supervisor and a module that implements the Phoenix.Tracker behaviour that uses Phoenix.PubSub to broadcast presence updates.In case you want to use only a subset of the functionality provided by Phoenix.Presence, such as tracking processes but without broadcasting updates, we recommend that you look at the Phoenix.Tracker functionality from the phoenix_pubsub project.Example UsageStart by defining a presence module within your application which uses Phoenix.Presence and provide the :otp_app which holds your configuration, as well as the :pubsub_server.defmodule MyAppWeb.Presence do use Phoenix.Presence, otp_app: :my_app, pubsub_server: MyApp.PubSub endThe :pubsub_server must point to an existing pubsub server running in your application, which is included by default as MyApp.PubSub for new applications.Next, add the new supervisor to your supervision tree in lib/my_app/application.ex. It must be after the PubSub child and before the endpoint:children = [ ... {Phoenix.PubSub, name: MyApp.PubSub}, MyAppWeb.Presence, MyAppWeb.Endpoint ]Once added, presences can be tracked in your channel after joining:defmodule MyAppWeb.MyChannel do use MyAppWeb, :channel alias MyAppWeb.Presence def join(&quot;some:topic&quot;, _params, socket) do send(self(), :after_join) {:ok, assign(socket, :user_id, ...)} end def handle_info(:after_join, socket) do {:ok, _} = Presence.track(socket, socket.assigns.user_id, %{ online_at: inspect(System.system_time(:second)) }) push(socket, &quot;presence_state&quot;, Presence.list(socket)) {:noreply, socket} end endIn the example above, the current presence information for the socket's topic is pushed to the client as a &quot;presence_state&quot; event. Next, Presence.track is used to register this channel's process as a presence for the socket's user ID, with a map of metadata.Finally, a diff of presence join and leave events will be sent to the client as they happen in real-time with the &quot;presence_diff&quot; event. The diff structure will be a map of :joins and :leaves of the form:%{ joins: %{&quot;123&quot; =&gt; %{metas: [%{status: &quot;away&quot;, phx_ref: ...}]}, leaves: %{&quot;456&quot; =&gt; %{metas: [%{status: &quot;online&quot;, phx_ref: ...}] },See c:list/2 for more information on the presence data structure.Fetching Presence InformationPresence metadata should be minimized and used to store small, ephemeral state, such as a user's &quot;online&quot; or &quot;away&quot; status. More detailed information, such as user details that need to be fetched from the database, can be achieved by overriding the fetch/2 function.The fetch/2 callback is triggered when using c:list/2 and on every update, and it serves as a mechanism to fetch presence information a single time, before broadcasting the information to all channel subscribers. This prevents N query problems and gives you a single place to group isolated data fetching to extend presence metadata.The function must return a map of data matching the outlined Presence data structure, including the :metas key, but can extend the map of information to include any additional information. For example:def fetch(_topic, presences) do users = presences |&gt; Map.keys() |&gt; Accounts.get_users_map() for {key, %{metas: metas}} &lt;- presences, into: %{} do {key, %{metas: metas, user: users[String.to_integer(key)]}} end endWhere Account.get_users_map/1 could be implemented like:def get_users_map(ids) do query = from u in User, where: u.id in ^ids, select: {u.id, u} query |&gt; Repo.all() |&gt; Enum.into(%{}) endThe fetch/2 function above fetches all users from the database who have registered presences for the given topic. The presences information is then extended with a :user key of the user's information, while maintaining the required :metas field from the original presence data.Testing with PresenceEvery time the fetch callback is invoked, it is done from a separate process. Given those processes run asynchronously, it is often necessary to guarantee they have been shutdown at the end of every test. This can be done by using ExUnit's on_exit hook plus fetchers_pids function:on_exit(fn -&gt; for pid &lt;- MyAppWeb.Presence.fetchers_pids() do ref = Process.monitor(pid) assert_receive {:DOWN, ^ref, _, _, _}, 1000 end end)","ref":"Phoenix.Presence.html","title":"Phoenix.Presence","type":"behaviour"},{"doc":"Extend presence information with additional data.When c:list/2 is used to list all presences of the given topic, this callback is triggered once to modify the result before it is broadcasted to all channel subscribers. This avoids N query problems and provides a single place to extend presence metadata. You must return a map of data matching the original result, including the :metas key, but can extend the map to include any additional information.The default implementation simply passes presences through unchanged.Exampledef fetch(_topic, presences) do query = from u in User, where: u.id in ^Map.keys(presences), select: {u.id, u} users = query |&gt; Repo.all() |&gt; Enum.into(%{}) for {key, %{metas: metas}} &lt;- presences, into: %{} do {key, %{metas: metas, user: users[key]}} end end","ref":"Phoenix.Presence.html#c:fetch/2","title":"Phoenix.Presence.fetch/2","type":"callback"},{"doc":"Returns the map of presence metadata for a socket/topic-key pair.ExamplesUses the same data format as c:list/2, but only returns metadata for the presences under a topic and key pair. For example, a user with key &quot;user1&quot;, connected to the same chat room &quot;room:1&quot; from two devices, could return:iex&gt; MyPresence.get_by_key(&quot;room:1&quot;, &quot;user1&quot;) [%{name: &quot;User 1&quot;, metas: [%{device: &quot;Desktop&quot;}, %{device: &quot;Mobile&quot;}]}]Like c:list/2, the presence metadata is passed to the fetch callback of your presence module to fetch any additional information.","ref":"Phoenix.Presence.html#c:get_by_key/2","title":"Phoenix.Presence.get_by_key/2","type":"callback"},{"doc":"Returns presences for a socket/topic.Presence data structureThe presence information is returned as a map with presences grouped by key, cast as a string, and accumulated metadata, with the following form:%{key =&gt; %{metas: [%{phx_ref: ..., ...}, ...]}}For example, imagine a user with id 123 online from two different devices, as well as a user with id 456 online from just one device. The following presence information might be returned:%{&quot;123&quot; =&gt; %{metas: [%{status: &quot;away&quot;, phx_ref: ...}, %{status: &quot;online&quot;, phx_ref: ...}]}, &quot;456&quot; =&gt; %{metas: [%{status: &quot;online&quot;, phx_ref: ...}]}}The keys of the map will usually point to a resource ID. The value will contain a map with a :metas key containing a list of metadata for each resource. Additionally, every metadata entry will contain a :phx_ref key which can be used to uniquely identify metadata for a given key. In the event that the metadata was previously updated, a :phx_ref_prev key will be present containing the previous :phx_ref value.","ref":"Phoenix.Presence.html#c:list/1","title":"Phoenix.Presence.list/1","type":"callback"},{"doc":"Track a channel's process as a presence.Tracked presences are grouped by key, cast as a string. For example, to group each user's channels together, use user IDs as keys. Each presence can be associated with a map of metadata to store small, emphemeral state, such as a user's online status. To store detailed information, see fetch/2.Examplealias MyApp.Presence def handle_info(:after_join, socket) do {:ok, _} = Presence.track(socket, socket.assigns.user_id, %{ online_at: inspect(System.system_time(:second)) }) {:noreply, socket} end","ref":"Phoenix.Presence.html#c:track/3","title":"Phoenix.Presence.track/3","type":"callback"},{"doc":"Track an arbitrary process as a presence.Same with track/3, except track any process by topic and key.","ref":"Phoenix.Presence.html#c:track/4","title":"Phoenix.Presence.track/4","type":"callback"},{"doc":"Stop tracking a channel's process.","ref":"Phoenix.Presence.html#c:untrack/2","title":"Phoenix.Presence.untrack/2","type":"callback"},{"doc":"Stop tracking a process.","ref":"Phoenix.Presence.html#c:untrack/3","title":"Phoenix.Presence.untrack/3","type":"callback"},{"doc":"Update a channel presence's metadata.Replace a presence's metadata by passing a new map or a function that takes the current map and returns a new one.","ref":"Phoenix.Presence.html#c:update/3","title":"Phoenix.Presence.update/3","type":"callback"},{"doc":"Update a process presence's metadata.Same as update/3, but with an arbitrary process.","ref":"Phoenix.Presence.html#c:update/4","title":"Phoenix.Presence.update/4","type":"callback"},{"doc":"","ref":"Phoenix.Presence.html#t:presence/0","title":"Phoenix.Presence.presence/0","type":"type"},{"doc":"","ref":"Phoenix.Presence.html#t:presences/0","title":"Phoenix.Presence.presences/0","type":"type"},{"doc":"","ref":"Phoenix.Presence.html#t:topic/0","title":"Phoenix.Presence.topic/0","type":"type"},{"doc":"Defines a Phoenix router.The router provides a set of macros for generating routes that dispatch to specific controllers and actions. Those macros are named after HTTP verbs. For example:defmodule MyAppWeb.Router do use Phoenix.Router get &quot;/pages/:page&quot;, PageController, :show endThe get/3 macro above accepts a request to /pages/hello and dispatches it to the PageController's show action with %{&quot;page&quot; =&gt; &quot;hello&quot;} in params.Phoenix's router is extremely efficient, as it relies on Elixir pattern matching for matching routes and serving requests.Routingget/3, post/3, put/3 and other macros named after HTTP verbs are used to create routes.The route:get &quot;/pages&quot;, PageController, :indexmatches a GET request to /pages and dispatches it to the index action in PageController.get &quot;/pages/:page&quot;, PageController, :showmatches /pages/hello and dispatches to the show action with %{&quot;page&quot; =&gt; &quot;hello&quot;} in params.defmodule PageController do def show(conn, params) do # %{&quot;page&quot; =&gt; &quot;hello&quot;} == params end endPartial and multiple segments can be matched. For example:get &quot;/api/v:version/pages/:id&quot;, PageController, :showmatches /api/v1/pages/2 and puts %{&quot;version&quot; =&gt; &quot;1&quot;, &quot;id&quot; =&gt; &quot;2&quot;} in params. Only the trailing part of a segment can be captured.Routes are matched from top to bottom. The second route here:get &quot;/pages/:page&quot;, PageController, :show get &quot;/pages/hello&quot;, PageController, :hellowill never match /pages/hello because /pages/:page matches that first.Routes can use glob-like patterns to match trailing segments.get &quot;/pages/*page&quot;, PageController, :showmatches /pages/hello/world and puts the globbed segments in params[&quot;page&quot;].GET /pages/hello/world %{&quot;page&quot; =&gt; [&quot;hello&quot;, &quot;world&quot;]} = paramsGlobs can match segments partially too. The difference is the whole segment is captured along with the trailing segments.get &quot;/pages/he*page&quot;, PageController, :showmatchesGET /pages/hello/world %{&quot;page&quot; =&gt; [&quot;hello&quot;, &quot;world&quot;]} = params GET /pages/hey/world %{&quot;page&quot; =&gt; [&quot;hey&quot;, &quot;world&quot;]} = paramsHelpersPhoenix automatically generates a module Helpers inside your router which contains named helpers to help developers generate and keep their routes up to date.Helpers are automatically generated based on the controller name. For example, the route:get &quot;/pages/:page&quot;, PageController, :showwill generate the following named helper:MyAppWeb.Router.Helpers.page_path(conn_or_endpoint, :show, &quot;hello&quot;) &quot;/pages/hello&quot; MyAppWeb.Router.Helpers.page_path(conn_or_endpoint, :show, &quot;hello&quot;, some: &quot;query&quot;) &quot;/pages/hello?some=query&quot; MyAppWeb.Router.Helpers.page_url(conn_or_endpoint, :show, &quot;hello&quot;) &quot;http://example.com/pages/hello&quot; MyAppWeb.Router.Helpers.page_url(conn_or_endpoint, :show, &quot;hello&quot;, some: &quot;query&quot;) &quot;http://example.com/pages/hello?some=query&quot;If the route contains glob-like patterns, parameters for those have to be given as list:MyAppWeb.Router.Helpers.pages_path(conn_or_endpoint, :show, [&quot;hello&quot;, &quot;world&quot;]) &quot;/pages/hello/world&quot;The URL generated in the named URL helpers is based on the configuration for :url, :http and :https. However, if for some reason you need to manually control the URL generation, the url helpers also allow you to pass in a URI struct:uri = %URI{scheme: &quot;https&quot;, host: &quot;other.example.com&quot;} MyAppWeb.Router.Helpers.page_url(uri, :show, &quot;hello&quot;) &quot;https://other.example.com/pages/hello&quot;The named helper can also be customized with the :as option. Given the route:get &quot;/pages/:page&quot;, PageController, :show, as: :special_pagethe named helper will be:MyAppWeb.Router.Helpers.special_page_path(conn, :show, &quot;hello&quot;) &quot;/pages/hello&quot;Scopes and ResourcesIt is very common in Phoenix applications to namespace all of your routes under the application scope:scope &quot;/&quot;, MyAppWeb do get &quot;/pages/:id&quot;, PageController, :show endThe route above will dispatch to MyAppWeb.PageController. This syntax is not only convenient for developers, since we don't have to repeat the MyAppWeb. prefix on all routes, but it also allows Phoenix to put less pressure on the Elixir compiler. If instead we had written:get &quot;/pages/:id&quot;, MyAppWeb.PageController, :showThe Elixir compiler would infer that the router depends directly on MyAppWeb.PageController, which is not true. By using scopes, Phoenix can properly hint to the Elixir compiler the controller is not an actual dependency of the router. This provides more efficient compilation times.Scopes allow us to scope on any path or even on the helper name:scope &quot;/api/v1&quot;, MyAppWeb, as: :api_v1 do get &quot;/pages/:id&quot;, PageController, :show endFor example, the route above will match on the path &quot;/api/v1/pages/:id&quot; and the named route will be api_v1_page_path, as expected from the values given to scope/2 option.Phoenix also provides a resources/4 macro that allows developers to generate &quot;RESTful&quot; routes to a given resource:defmodule MyAppWeb.Router do use Phoenix.Router resources &quot;/pages&quot;, PageController, only: [:show] resources &quot;/users&quot;, UserController, except: [:delete] endFinally, Phoenix ships with a mix phx.routes task that nicely formats all routes in a given router. We can use it to verify all routes included in the router above:$ mix phx.routes page_path GET /pages/:id PageController.show/2 user_path GET /users UserController.index/2 user_path GET /users/:id/edit UserController.edit/2 user_path GET /users/new UserController.new/2 user_path GET /users/:id UserController.show/2 user_path POST /users UserController.create/2 user_path PATCH /users/:id UserController.update/2 PUT /users/:id UserController.update/2One can also pass a router explicitly as an argument to the task:$ mix phx.routes MyAppWeb.RouterCheck scope/2 and resources/4 for more information.Pipelines and plugsOnce a request arrives at the Phoenix router, it performs a series of transformations through pipelines until the request is dispatched to a desired end-point.Such transformations are defined via plugs, as defined in the Plug specification. Once a pipeline is defined, it can be piped through per scope.For example:defmodule MyAppWeb.Router do use Phoenix.Router pipeline :browser do plug :fetch_session plug :accepts, [&quot;html&quot;] end scope &quot;/&quot; do pipe_through :browser # browser related routes and resources end endPhoenix.Router imports functions from both Plug.Conn and Phoenix.Controller to help define plugs. In the example above, fetch_session/2 comes from Plug.Conn while accepts/2 comes from Phoenix.Controller.Note that router pipelines are only invoked after a route is found. No plug is invoked in case no matches were found.","ref":"Phoenix.Router.html","title":"Phoenix.Router","type":"module"},{"doc":"Generates a route to handle a connect request to the given path.connect(&quot;/events/:id&quot;, EventController, :action)See match/5 for options.","ref":"Phoenix.Router.html#connect/4","title":"Phoenix.Router.connect/4","type":"macro"},{"doc":"Generates a route to handle a delete request to the given path.delete(&quot;/events/:id&quot;, EventController, :action)See match/5 for options.","ref":"Phoenix.Router.html#delete/4","title":"Phoenix.Router.delete/4","type":"macro"},{"doc":"Forwards a request at the given path to a plug.All paths that match the forwarded prefix will be sent to the forwarded plug. This is useful for sharing a router between applications or even breaking a big router into smaller ones. The router pipelines will be invoked prior to forwarding the connection.However, we don't advise forwarding to another endpoint. The reason is that plugs defined by your app and the forwarded endpoint would be invoked twice, which may lead to errors.Examplesscope &quot;/&quot;, MyApp do pipe_through [:browser, :admin] forward &quot;/admin&quot;, SomeLib.AdminDashboard forward &quot;/api&quot;, ApiRouter end","ref":"Phoenix.Router.html#forward/4","title":"Phoenix.Router.forward/4","type":"macro"},{"doc":"Generates a route to handle a get request to the given path.get(&quot;/events/:id&quot;, EventController, :action)See match/5 for options.","ref":"Phoenix.Router.html#get/4","title":"Phoenix.Router.get/4","type":"macro"},{"doc":"Generates a route to handle a head request to the given path.head(&quot;/events/:id&quot;, EventController, :action)See match/5 for options.","ref":"Phoenix.Router.html#head/4","title":"Phoenix.Router.head/4","type":"macro"},{"doc":"Generates a route match based on an arbitrary HTTP method.Useful for defining routes not included in the builtin macros.The catch-all verb, :*, may also be used to match all HTTP methods.Options:as - configures the named helper exclusively. If false, does not generate a helper.:alias - configure if the scope alias should be applied to the route. Defaults to true, disables scoping if false.:log - the level to log the route dispatching under, may be set to false. Defaults to :debug:host - a string containing the host scope, or prefix host scope, ie &quot;foo.bar.com&quot;, &quot;foo.&quot;:private - a map of private data to merge into the connection when a route matches:assigns - a map of data to merge into the connection when a route matches:metadata - a map of metadata used by the telemetry events and returned by route_info/4:trailing_slash - a boolean to flag whether or not the helper functions append a trailing slash. Defaults to false.Examplesmatch(:move, &quot;/events/:id&quot;, EventController, :move) match(:*, &quot;/any&quot;, SomeController, :any)","ref":"Phoenix.Router.html#match/5","title":"Phoenix.Router.match/5","type":"macro"},{"doc":"Generates a route to handle a options request to the given path.options(&quot;/events/:id&quot;, EventController, :action)See match/5 for options.","ref":"Phoenix.Router.html#options/4","title":"Phoenix.Router.options/4","type":"macro"},{"doc":"Generates a route to handle a patch request to the given path.patch(&quot;/events/:id&quot;, EventController, :action)See match/5 for options.","ref":"Phoenix.Router.html#patch/4","title":"Phoenix.Router.patch/4","type":"macro"},{"doc":"Defines a list of plugs (and pipelines) to send the connection through.See pipeline/2 for more information.","ref":"Phoenix.Router.html#pipe_through/1","title":"Phoenix.Router.pipe_through/1","type":"macro"},{"doc":"Defines a plug pipeline.Pipelines are defined at the router root and can be used from any scope.Examplespipeline :api do plug :token_authentication plug :dispatch endA scope may then use this pipeline as:scope &quot;/&quot; do pipe_through :api endEvery time pipe_through/1 is called, the new pipelines are appended to the ones previously given.","ref":"Phoenix.Router.html#pipeline/2","title":"Phoenix.Router.pipeline/2","type":"macro"},{"doc":"Defines a plug inside a pipeline.See pipeline/2 for more information.","ref":"Phoenix.Router.html#plug/2","title":"Phoenix.Router.plug/2","type":"macro"},{"doc":"Generates a route to handle a post request to the given path.post(&quot;/events/:id&quot;, EventController, :action)See match/5 for options.","ref":"Phoenix.Router.html#post/4","title":"Phoenix.Router.post/4","type":"macro"},{"doc":"Generates a route to handle a put request to the given path.put(&quot;/events/:id&quot;, EventController, :action)See match/5 for options.","ref":"Phoenix.Router.html#put/4","title":"Phoenix.Router.put/4","type":"macro"},{"doc":"See resources/4.","ref":"Phoenix.Router.html#resources/2","title":"Phoenix.Router.resources/2","type":"macro"},{"doc":"See resources/4.","ref":"Phoenix.Router.html#resources/3","title":"Phoenix.Router.resources/3","type":"macro"},{"doc":"Defines &quot;RESTful&quot; routes for a resource.The given definition:resources &quot;/users&quot;, UserControllerwill include routes to the following actions:GET /users =&gt; :indexGET /users/new =&gt; :newPOST /users =&gt; :createGET /users/:id =&gt; :showGET /users/:id/edit =&gt; :editPATCH /users/:id =&gt; :updatePUT /users/:id =&gt; :updateDELETE /users/:id =&gt; :deleteOptionsThis macro accepts a set of options::only - a list of actions to generate routes for, for example: [:show, :edit]:except - a list of actions to exclude generated routes from, for example: [:delete]:param - the name of the parameter for this resource, defaults to &quot;id&quot;:name - the prefix for this resource. This is used for the named helper and as the prefix for the parameter in nested resources. The default value is automatically derived from the controller name, i.e. UserController will have name &quot;user&quot;:as - configures the named helper exclusively:singleton - defines routes for a singleton resource that is looked up by the client without referencing an ID. Read below for more informationSingleton resourcesWhen a resource needs to be looked up without referencing an ID, because it contains only a single entry in the given context, the :singleton option can be used to generate a set of routes that are specific to such single resource:GET /user =&gt; :showGET /user/new =&gt; :newPOST /user =&gt; :createGET /user/edit =&gt; :editPATCH /user =&gt; :updatePUT /user =&gt; :updateDELETE /user =&gt; :deleteUsage example:resources &quot;/account&quot;, AccountController, only: [:show], singleton: trueNested ResourcesThis macro also supports passing a nested block of route definitions. This is helpful for nesting children resources within their parents to generate nested routes.The given definition:resources &quot;/users&quot;, UserController do resources &quot;/posts&quot;, PostController endwill include the following routes:user_post_path GET /users/:user_id/posts PostController :index user_post_path GET /users/:user_id/posts/:id/edit PostController :edit user_post_path GET /users/:user_id/posts/new PostController :new user_post_path GET /users/:user_id/posts/:id PostController :show user_post_path POST /users/:user_id/posts PostController :create user_post_path PATCH /users/:user_id/posts/:id PostController :update PUT /users/:user_id/posts/:id PostController :update user_post_path DELETE /users/:user_id/posts/:id PostController :delete","ref":"Phoenix.Router.html#resources/4","title":"Phoenix.Router.resources/4","type":"macro"},{"doc":"Returns the compile-time route info and runtime path params for a request.The path can be either a string or the path_info segments.A map of metadata is returned with the following keys::log - the configured log level. For example :debug:path_params - the map of runtime path params:pipe_through - the list of pipelines for the route's scope, for example [:browser]:plug - the plug to dipatch the route to, for example AppWeb.PostController:plug_opts - the options to pass when calling the plug, for example: :index:route - the string route pattern, such as &quot;/posts/:id&quot;Examplesiex&gt; Phoenix.Router.route_info(AppWeb.Router, &quot;GET&quot;, &quot;/posts/123&quot;, &quot;myhost&quot;) %{ log: :debug, path_params: %{&quot;id&quot; =&gt; &quot;123&quot;}, pipe_through: [:browser], plug: AppWeb.PostController, plug_opts: :show, route: &quot;/posts/:id&quot;, } iex&gt; Phoenix.Router.route_info(MyRouter, &quot;GET&quot;, &quot;/not-exists&quot;, &quot;myhost&quot;) :error","ref":"Phoenix.Router.html#route_info/4","title":"Phoenix.Router.route_info/4","type":"function"},{"doc":"Defines a scope in which routes can be nested.Examplesscope path: &quot;/api/v1&quot;, as: :api_v1, alias: API.V1 do get &quot;/pages/:id&quot;, PageController, :show endThe generated route above will match on the path &quot;/api/v1/pages/:id&quot; and will dispatch to :show action in API.V1.PageController. A named helper api_v1_page_path will also be generated.OptionsThe supported options are::path - a string containing the path scope.:as - a string or atom containing the named helper scope. When set to false, it resets the nested helper scopes.:alias - an alias (atom) containing the controller scope. When set to false, it resets all nested aliases.:host - a string containing the host scope, or prefix host scope, ie &quot;foo.bar.com&quot;, &quot;foo.&quot;:private - a map of private data to merge into the connection when a route matches:assigns - a map of data to merge into the connection when a route matches:log - the level to log the route dispatching under, may be set to false. Defaults to :debug:trailing_slash - whether or not the helper functions append a trailing slash. Defaults to false.","ref":"Phoenix.Router.html#scope/2","title":"Phoenix.Router.scope/2","type":"macro"},{"doc":"Define a scope with the given path.This function is a shortcut for:scope path: path do ... endExamplesscope &quot;/api/v1&quot;, as: :api_v1, alias: API.V1 do get &quot;/pages/:id&quot;, PageController, :show end","ref":"Phoenix.Router.html#scope/3","title":"Phoenix.Router.scope/3","type":"macro"},{"doc":"Defines a scope with the given path and alias.This function is a shortcut for:scope path: path, alias: alias do ... endExamplesscope &quot;/api/v1&quot;, API.V1, as: :api_v1 do get &quot;/pages/:id&quot;, PageController, :show end","ref":"Phoenix.Router.html#scope/4","title":"Phoenix.Router.scope/4","type":"macro"},{"doc":"Returns the full alias with the current scope's aliased prefix.Useful for applying the same short-hand alias handling to other values besides the second argument in route definitions.Examplesscope &quot;/&quot;, MyPrefix do get &quot;/&quot;, ProxyPlug, controller: scoped_alias(__MODULE__, MyController) end","ref":"Phoenix.Router.html#scoped_alias/2","title":"Phoenix.Router.scoped_alias/2","type":"function"},{"doc":"Generates a route to handle a trace request to the given path.trace(&quot;/events/:id&quot;, EventController, :action)See match/5 for options.","ref":"Phoenix.Router.html#trace/4","title":"Phoenix.Router.trace/4","type":"macro"},{"doc":"Tokens provide a way to generate and verify bearer tokens for use in Channels or API authentication.The data stored in the token is signed to prevent tampering but not encrypted. This means it is safe to store identification information (such as user IDs) but should not be used to store confidential information (such as credit card numbers).ExampleWhen generating a unique token for use in an API or Channel it is advised to use a unique identifier for the user, typically the id from a database. For example:iex&gt; user_id = 1 iex&gt; token = Phoenix.Token.sign(MyApp.Endpoint, &quot;user auth&quot;, user_id) iex&gt; Phoenix.Token.verify(MyApp.Endpoint, &quot;user auth&quot;, token, max_age: 86400) {:ok, 1}In that example we have a user's id, we generate a token and verify it using the secret key base configured in the given endpoint. We guarantee the token will only be valid for one day by setting a max age (recommended).The first argument to both sign/4 and verify/4 can be one of:the module name of a Phoenix endpoint (shown above) - where the secret key base is extracted from the endpointPlug.Conn - where the secret key base is extracted from the endpoint stored in the connectionPhoenix.Socket - where the secret key base is extracted from the endpoint stored in the socketa string, representing the secret key base itself. A key base with at least 20 randomly generated characters should be used to provide adequate entropyThe second argument is a cryptographic salt which must be the same in both calls to sign/4 and verify/4. For instance, it may be called &quot;user auth&quot; and treated as namespace when generating a token that will be used to authenticate users on channels or on your APIs.The third argument can be any term (string, int, list, etc.) that you wish to codify into the token. Upon valid verification, this same term will be extracted from the token.UsageOnce a token is signed, we can send it to the client in multiple ways.One is via the meta tag:&lt;%= tag :meta, name: &quot;channel_token&quot;, content: Phoenix.Token.sign(@conn, &quot;user auth&quot;, @current_user.id) %&gt;Or an endpoint that returns it:def create(conn, params) do user = User.create(params) render(conn, &quot;user.json&quot;, %{token: Phoenix.Token.sign(conn, &quot;user auth&quot;, user.id), user: user}) endOnce the token is sent, the client may now send it back to the server as an authentication mechanism. For example, we can use it to authenticate a user on a Phoenix channel:defmodule MyApp.UserSocket do use Phoenix.Socket def connect(%{&quot;token&quot; =&gt; token}, socket, _connect_info) do case Phoenix.Token.verify(socket, &quot;user auth&quot;, token, max_age: 86400) do {:ok, user_id} -&gt; socket = assign(socket, :user, Repo.get!(User, user_id)) {:ok, socket} {:error, _} -&gt; :error end end def connect(_params, _socket, _connect_info), do: :error endIn this example, the phoenix.js client will send the token in the connect command which is then validated by the server.Phoenix.Token can also be used for validating APIs, handling password resets, e-mail confirmation and more.","ref":"Phoenix.Token.html","title":"Phoenix.Token","type":"module"},{"doc":"Decrypts the original data from the token and verifies its integrity.Options:max_age - verifies the token only if it has been generated &quot;max age&quot; ago in seconds. A reasonable value is 1 day (86400 seconds):key_iterations - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to 1000:key_length - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to 32:key_digest - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to :sha256","ref":"Phoenix.Token.html#decrypt/4","title":"Phoenix.Token.decrypt/4","type":"function"},{"doc":"Encodes, encrypts, and signs data into a token you can send to clients.Options:key_iterations - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to 1000:key_length - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to 32:key_digest - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to :sha256:signed_at - set the timestamp of the token in seconds. Defaults to System.system_time(:second)","ref":"Phoenix.Token.html#encrypt/4","title":"Phoenix.Token.encrypt/4","type":"function"},{"doc":"Encodes and signs data into a token you can send to clients.Options:key_iterations - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to 1000:key_length - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to 32:key_digest - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to :sha256:signed_at - set the timestamp of the token in seconds. Defaults to System.system_time(:second)","ref":"Phoenix.Token.html#sign/4","title":"Phoenix.Token.sign/4","type":"function"},{"doc":"Decodes the original data from the token and verifies its integrity.ExamplesIn this scenario we will create a token, sign it, then provide it to a client application. The client will then use this token to authenticate requests for resources from the server. See Phoenix.Token summary for more info about creating tokens.iex&gt; user_id = 99 iex&gt; secret = &quot;kjoy3o1zeidquwy1398juxzldjlksahdk3&quot; iex&gt; namespace = &quot;user auth&quot; iex&gt; token = Phoenix.Token.sign(secret, namespace, user_id)The mechanism for passing the token to the client is typically through a cookie, a JSON response body, or HTTP header. For now, assume the client has received a token it can use to validate requests for protected resources.When the server receives a request, it can use verify/4 to determine if it should provide the requested resources to the client:iex&gt; Phoenix.Token.verify(secret, namespace, token, max_age: 86400) {:ok, 99}In this example, we know the client sent a valid token because verify/4 returned a tuple of type {:ok, user_id}. The server can now proceed with the request.However, if the client had sent an expired or otherwise invalid token verify/4 would have returned an error instead:iex&gt; Phoenix.Token.verify(secret, namespace, expired, max_age: 86400) {:error, :expired} iex&gt; Phoenix.Token.verify(secret, namespace, invalid, max_age: 86400) {:error, :invalid}Options:max_age - verifies the token only if it has been generated &quot;max age&quot; ago in seconds. A reasonable value is 1 day (86400 seconds):key_iterations - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to 1000:key_length - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to 32:key_digest - option passed to Plug.Crypto.KeyGenerator when generating the encryption and signing keys. Defaults to :sha256","ref":"Phoenix.Token.html#verify/4","title":"Phoenix.Token.verify/4","type":"function"},{"doc":"Defines the view layer of a Phoenix application.This module is used to define the application's main view, which serves as the base for all other views and templates.The view layer also contains conveniences for rendering templates, including support for layouts and encoders per format.ExamplesPhoenix defines the view template at lib/your_app_web.ex:defmodule YourAppWeb do # ... def view do quote do use Phoenix.View, root: &quot;lib/your_app_web/templates&quot;, namespace: &quot;web&quot; # Import convenience functions from controllers import Phoenix.Controller, only: [get_flash: 1, get_flash: 2, view_module: 1, view_template: 1] # Use all HTML functionality (forms, tags, etc) use Phoenix.HTML import YourAppWeb.ErrorHelpers import YourAppWeb.Gettext # Alias the Helpers module as Routes alias YourAppWeb.Router.Helpers, as: Routes end end # ... endYou can use the definition above to define any view in your application:defmodule YourApp.UserView do use YourAppWeb, :view endBecause we have defined the template root to be &quot;lib/your_app_web/templates&quot;, Phoenix.View will automatically load all templates at &quot;your_app_web/templates/user&quot; and include them in the YourApp.UserView. For example, imagine we have the template:# your_app_web/templates/user/index.html.eex Hello &lt;%= @name %&gt;The .eex extension maps to a template engine which tells Phoenix how to compile the code in the file into Elixir source code. After it is compiled, the template can be rendered as:Phoenix.View.render(YourApp.UserView, &quot;index.html&quot;, name: &quot;John Doe&quot;) #=&gt; {:safe, &quot;Hello John Doe&quot;}RenderingThe main responsibility of a view is to render a template.A template has a name, which also contains a format. For example, in the previous section we have rendered the &quot;index.html&quot; template:Phoenix.View.render(YourApp.UserView, &quot;index.html&quot;, name: &quot;John Doe&quot;) #=&gt; {:safe, &quot;Hello John Doe&quot;}When a view renders a template, the result returned is an inner representation specific to the template format. In the example above, we got: {:safe, &quot;Hello John Doe&quot;}. The safe tuple annotates that our template is safe and that we don't need to escape its contents because all data has already been encoded. Let's try to inject custom code:Phoenix.View.render(YourApp.UserView, &quot;index.html&quot;, name: &quot;John&lt;br/&gt;Doe&quot;) #=&gt; {:safe, &quot;Hello John&amp;lt;br/&amp;gt;Doe&quot;}This inner representation allows us to render and compose templates easily. For example, if you want to render JSON data, we could do so by adding a &quot;show.json&quot; entry to render/2 in our view:defmodule YourApp.UserView do use YourApp.View def render(&quot;show.json&quot;, %{user: user}) do %{name: user.name, address: user.address} end endNotice that in order to render JSON data, we don't need to explicitly return a JSON string! Instead, we just return data that is encodable to JSON.Both JSON and HTML formats will be encoded only when passing the data to the controller via the render_to_iodata/3 function. The render_to_iodata/3 function uses the notion of format encoders to convert a particular format to its string/iodata representation.Phoenix ships with some template engines and format encoders, which can be further configured in the Phoenix application. You can read more about format encoders in Phoenix.Template documentation.","ref":"Phoenix.View.html","title":"Phoenix.View","type":"module"},{"doc":"When used, defines the current module as a main view module.Options:root - the template root to find templates:path - the optional path to search for templates within the :root. Defaults to the underscored view module name. A blank string may be provided to use the :root path directly as the template lookup path:namespace - the namespace to consider when calculating view paths:pattern - the wildcard pattern to apply to the root when finding templates. Default &quot;*&quot;The :root option is required while the :namespace defaults to the first nesting in the module name. For instance, both MyApp.UserView and MyApp.Admin.UserView have namespace MyApp.The :namespace and :path options are used to calculate template lookup paths. For example, if you are in MyApp.UserView and the namespace is MyApp, templates are expected at Path.join(root, &quot;user&quot;). On the other hand, if the view is MyApp.Admin.UserView, the path will be Path.join(root, &quot;admin/user&quot;) and so on. For explicit root path locations, the :path option can be provided instead. The :root and :path are joined to form the final lookup path. A blank string may be provided to use the :root path directly as the template lookup path.Setting the namespace to MyApp.Admin in the second example will force the template to also be looked up at Path.join(root, &quot;user&quot;).","ref":"Phoenix.View.html#__using__/1","title":"Phoenix.View.__using__/1","type":"macro"},{"doc":"Renders a template.It expects the view module, the template as a string, and a set of assigns.Notice that this function returns the inner representation of a template. If you want the encoded template as a result, use render_to_iodata/3 instead.ExamplesPhoenix.View.render(YourApp.UserView, &quot;index.html&quot;, name: &quot;John Doe&quot;) #=&gt; {:safe, &quot;Hello John Doe&quot;}AssignsAssigns are meant to be user data that will be available in templates. However, there are keys under assigns that are specially handled by Phoenix, they are::layout - tells Phoenix to wrap the rendered result in the given layout. See next sectionThe following assigns are reserved, and cannot be set directly:@view_module - The view module being rendered@view_template - The @view_module's template being renderedLayoutsTemplates can be rendered within other templates using the :layout option. :layout accepts a tuple of the form {LayoutModule, &quot;template.extension&quot;}.To template that goes inside the layout will be placed in the @inner_content assign:&lt;%= @inner_content %&gt;","ref":"Phoenix.View.html#render/3","title":"Phoenix.View.render/3","type":"function"},{"doc":"Renders a template only if it exists.Same as render/3, but returns nil instead of raising. This is often used with Phoenix.Controller.view_module/1 and Phoenix.Controller.view_template/1, which must be imported into your views. See the &quot;Examples&quot; section below.ExamplesConsider the case where the application layout allows views to dynamically render a section of script tags in the head of the document. Some views may wish to inject certain scripts, while others will not.&lt;head&gt; &lt;%= render_existing view_module(@conn), &quot;scripts.html&quot;, assigns %&gt; &lt;/head&gt;Then the module under view_module(@conn) can decide to provide scripts with either a precompiled template, or by implementing the function directly, ie:def render(&quot;scripts.html&quot;, _assigns) do ~E(&lt;script src=&quot;file.js&quot;&gt;&lt;/script&gt;) endTo use a precompiled template, create a scripts.html.eex file in the templates directory for the corresponding view you want it to render for. For example, for the UserView, create the scripts.html.eex file at your_app_web/templates/user/.Rendering based on controller templateIn some cases, you might need to render based on the template. For these cases, @view_template can pair with render_existing/3 for per-template based content, ie:&lt;head&gt; &lt;%= render_existing view_module(@conn), &quot;scripts.&quot; &lt;&gt; view_template(@conn), assigns %&gt; &lt;/head&gt; def render(&quot;scripts.show.html&quot;, _assigns) do ~E(&lt;script src=&quot;file.js&quot;&gt;&lt;/script&gt;) end def render(&quot;scripts.index.html&quot;, _assigns) do ~E(&lt;script src=&quot;file.js&quot;&gt;&lt;/script&gt;) end","ref":"Phoenix.View.html#render_existing/3","title":"Phoenix.View.render_existing/3","type":"function"},{"doc":"Renders the given layout passing the given do/end block as @inner_content.This can be useful to implement nested layouts. For example, imagine you have an application layout like this:# layout/app.html.eex &lt;html&gt; &lt;head&gt; &lt;title&gt;Title&lt;/title&gt; &lt;/head&gt; &lt;body&gt; &lt;div class=&quot;menu&quot;&gt;...&lt;/div&gt; &lt;%= @inner_content %&gt; &lt;/body&gt;This layout is used by many parts of your application. However, there is a subsection of your application that wants to also add a sidebar. Let's call it &quot;blog.html&quot;. You can build on top of the existing layout in two steps. First, define the blog layout:# layout/blog.html.eex &lt;%= render_layout LayoutView, &quot;app.html&quot;, assigns do %&gt; &lt;div class=&quot;sidebar&quot;&gt;...&lt;/div&gt; &lt;%= @inner_content %&gt; &lt;% end %&gt;And now you can simply use it from your controller:plug :put_layout, &quot;blog.html&quot;","ref":"Phoenix.View.html#render_layout/4","title":"Phoenix.View.render_layout/4","type":"function"},{"doc":"Renders a collection.A collection is any enumerable of structs. This function returns the rendered collection in a list:render_many users, UserView, &quot;show.html&quot;is roughly equivalent to:Enum.map(users, fn user -&gt; render(UserView, &quot;show.html&quot;, user: user) end)The underlying user is passed to the view and template as :user, which is inferred from the view name. The name of the key in assigns can be customized with the :as option:render_many users, UserView, &quot;show.html&quot;, as: :datais roughly equivalent to:Enum.map(users, fn user -&gt; render(UserView, &quot;show.html&quot;, data: user) end)","ref":"Phoenix.View.html#render_many/4","title":"Phoenix.View.render_many/4","type":"function"},{"doc":"Renders a single item if not nil.The following:render_one user, UserView, &quot;show.html&quot;is roughly equivalent to:if user != nil do render(UserView, &quot;show.html&quot;, user: user) endThe underlying user is passed to the view and template as :user, which is inflected from the view name. The name of the key in assigns can be customized with the :as option:render_one user, UserView, &quot;show.html&quot;, as: :datais roughly equivalent to:if user != nil do render(UserView, &quot;show.html&quot;, data: user) end","ref":"Phoenix.View.html#render_one/4","title":"Phoenix.View.render_one/4","type":"function"},{"doc":"Renders the template and returns iodata.","ref":"Phoenix.View.html#render_to_iodata/3","title":"Phoenix.View.render_to_iodata/3","type":"function"},{"doc":"Renders the template and returns a string.","ref":"Phoenix.View.html#render_to_string/3","title":"Phoenix.View.render_to_string/3","type":"function"},{"doc":"Conveniences for testing Phoenix channels.In channel tests, we interact with channels via process communication, sending and receiving messages. It is also common to subscribe to the same topic the channel subscribes to, allowing us to assert if a given message was broadcast or not.Channel testingTo get started, define the module attribute @endpoint in your test case pointing to your application endpoint.Then you can directly create a socket and subscribe_and_join/4 topics and channels:{:ok, _, socket} = socket(UserSocket, &quot;user:id&quot;, %{some_assigns: 1}) |&gt; subscribe_and_join(RoomChannel, &quot;room:lobby&quot;, %{&quot;id&quot; =&gt; 3})You usually want to set the same ID and assigns your UserSocket.connect/3 callback would set. Alternatively, you can use the connect/3 helper to call your UserSocket.connect/3 callback and initialize the socket with the socket id:{:ok, socket} = connect(UserSocket, %{&quot;some&quot; =&gt; &quot;params&quot;}, %{}) {:ok, _, socket} = subscribe_and_join(socket, &quot;room:lobby&quot;, %{&quot;id&quot; =&gt; 3})Once called, subscribe_and_join/4 will subscribe the current test process to the &quot;room:lobby&quot; topic and start a channel in another process. It returns {:ok, reply, socket} or {:error, reply}.Now, in the same way the channel has a socket representing communication it will push to the client. Our test has a socket representing communication to be pushed to the server.For example, we can use the push/3 function in the test to push messages to the channel (it will invoke handle_in/3):push(socket, &quot;my_event&quot;, %{&quot;some&quot; =&gt; &quot;data&quot;})Similarly, we can broadcast messages from the test itself on the topic that both test and channel are subscribed to, triggering handle_out/3 on the channel:broadcast_from(socket, &quot;my_event&quot;, %{&quot;some&quot; =&gt; &quot;data&quot;})Note only broadcast_from/3 and broadcast_from!/3 are available in tests to avoid broadcast messages to be resent to the test process.While the functions above are pushing data to the channel (server) we can use assert_push/3 to verify the channel pushed a message to the client:assert_push &quot;my_event&quot;, %{&quot;some&quot; =&gt; &quot;data&quot;}Or even assert something was broadcast into pubsub:assert_broadcast &quot;my_event&quot;, %{&quot;some&quot; =&gt; &quot;data&quot;}Finally, every time a message is pushed to the channel, a reference is returned. We can use this reference to assert a particular reply was sent from the server:ref = push(socket, &quot;counter&quot;, %{}) assert_reply ref, :ok, %{&quot;counter&quot; =&gt; 1}Checking side-effectsOften one may want to do side-effects inside channels, like writing to the database, and verify those side-effects during their tests.Imagine the following handle_in/3 inside a channel:def handle_in(&quot;publish&quot;, %{&quot;id&quot; =&gt; id}, socket) do Repo.get!(Post, id) |&gt; Post.publish() |&gt; Repo.update!() {:noreply, socket} endBecause the whole communication is asynchronous, the following test would be very brittle:push(socket, &quot;publish&quot;, %{&quot;id&quot; =&gt; 3}) assert Repo.get_by(Post, id: 3, published: true)The issue is that we have no guarantees the channel has done processing our message after calling push/3. The best solution is to assert the channel sent us a reply before doing any other assertion. First change the channel to send replies:def handle_in(&quot;publish&quot;, %{&quot;id&quot; =&gt; id}, socket) do Repo.get!(Post, id) |&gt; Post.publish() |&gt; Repo.update!() {:reply, :ok, socket} endThen expect them in the test:ref = push(socket, &quot;publish&quot;, %{&quot;id&quot; =&gt; 3}) assert_reply ref, :ok assert Repo.get_by(Post, id: 3, published: true)Leave and closeThis module also provides functions to simulate leaving and closing a channel. Once you leave or close a channel, because the channel is linked to the test process on join, it will crash the test process:leave(socket) ** (EXIT from #PID&lt;...&gt;) {:shutdown, :leave}You can avoid this by unlinking the channel process in the test:Process.unlink(socket.channel_pid)Notice leave/1 is async, so it will also return a reference which you can use to check for a reply:ref = leave(socket) assert_reply ref, :okOn the other hand, close is always sync and it will return only after the channel process is guaranteed to have been terminated::ok = close(socket)This mimics the behaviour existing in clients.To assert that your channel closes or errors asynchronously, you can monitor the channel process with the tools provided by Elixir, and wait for the :DOWN message. Imagine an implementation of the handle_info/2 function that closes the channel when it receives :some_message:def handle_info(:some_message, socket) do {:stop, :normal, socket} endIn your test, you can assert that the close happened by:Process.monitor(socket.channel_pid) send(socket.channel_pid, :some_message) assert_receive {:DOWN, _, _, _, :normal}","ref":"Phoenix.ChannelTest.html","title":"Phoenix.ChannelTest","type":"module"},{"doc":"Asserts the channel has broadcast a message within timeout.Before asserting anything was broadcast, we must first subscribe to the topic of the channel in the test process:@endpoint.subscribe(&quot;foo:ok&quot;)Now we can match on event and payload as patterns:assert_broadcast &quot;some_event&quot;, %{&quot;data&quot; =&gt; _}In the assertion above, we don't particularly care about the data being sent, as long as something was sent.The timeout is in milliseconds and defaults to the :assert_receive_timeout set on the :ex_unit application (which defaults to 100ms).","ref":"Phoenix.ChannelTest.html#assert_broadcast/3","title":"Phoenix.ChannelTest.assert_broadcast/3","type":"macro"},{"doc":"Asserts the channel has pushed a message back to the client with the given event and payload within timeout.Notice event and payload are patterns. This means one can write:assert_push &quot;some_event&quot;, %{&quot;data&quot; =&gt; _}In the assertion above, we don't particularly care about the data being sent, as long as something was sent.The timeout is in milliseconds and defaults to the :assert_receive_timeout set on the :ex_unit application (which defaults to 100ms).NOTE: Because event and payload are patterns, they will be matched. This means that if you wish to assert that the received payload is equivalent to an existing variable, you need to pin the variable in the assertion expression.Good:expected_payload = %{foo: &quot;bar&quot;} assert_push &quot;some_event&quot;, ^expected_payloadBad:expected_payload = %{foo: &quot;bar&quot;} assert_push &quot;some_event&quot;, expected_payload # The code above does not assert the payload matches the described map.","ref":"Phoenix.ChannelTest.html#assert_push/3","title":"Phoenix.ChannelTest.assert_push/3","type":"macro"},{"doc":"Asserts the channel has replied to the given message within timeout.Notice status and payload are patterns. This means one can write:ref = push(channel, &quot;some_event&quot;) assert_reply ref, :ok, %{&quot;data&quot; =&gt; _}In the assertion above, we don't particularly care about the data being sent, as long as something was replied.The timeout is in milliseconds and defaults to the :assert_receive_timeout set on the :ex_unit application (which defaults to 100ms).","ref":"Phoenix.ChannelTest.html#assert_reply/4","title":"Phoenix.ChannelTest.assert_reply/4","type":"macro"},{"doc":"Broadcast event from pid to all subscribers of the socket topic.The test process will not receive the published message. This triggers the handle_out/3 callback in the channel.Examplesiex&gt; broadcast_from(socket, &quot;new_message&quot;, %{id: 1, content: &quot;hello&quot;}) :ok","ref":"Phoenix.ChannelTest.html#broadcast_from/3","title":"Phoenix.ChannelTest.broadcast_from/3","type":"function"},{"doc":"Same as broadcast_from/3, but raises if broadcast fails.","ref":"Phoenix.ChannelTest.html#broadcast_from!/3","title":"Phoenix.ChannelTest.broadcast_from!/3","type":"function"},{"doc":"Emulates the client closing the socket.Closing socket is synchronous and has a default timeout of 5000 milliseconds.","ref":"Phoenix.ChannelTest.html#close/2","title":"Phoenix.ChannelTest.close/2","type":"function"},{"doc":"Initiates a transport connection for the socket handler.Useful for testing UserSocket authentication. Returns the result of the handler's connect/3 callback.","ref":"Phoenix.ChannelTest.html#connect/3","title":"Phoenix.ChannelTest.connect/3","type":"macro"},{"doc":"See join/4.","ref":"Phoenix.ChannelTest.html#join/2","title":"Phoenix.ChannelTest.join/2","type":"function"},{"doc":"See join/4.","ref":"Phoenix.ChannelTest.html#join/3","title":"Phoenix.ChannelTest.join/3","type":"function"},{"doc":"Joins the channel under the given topic and payload.The given channel is joined in a separate process which is linked to the test process.It returns {:ok, reply, socket} or {:error, reply}.","ref":"Phoenix.ChannelTest.html#join/4","title":"Phoenix.ChannelTest.join/4","type":"function"},{"doc":"Emulates the client leaving the channel.","ref":"Phoenix.ChannelTest.html#leave/1","title":"Phoenix.ChannelTest.leave/1","type":"function"},{"doc":"Pushes a message into the channel.The triggers the handle_in/3 callback in the channel.Examplesiex&gt; push(socket, &quot;new_message&quot;, %{id: 1, content: &quot;hello&quot;}) reference","ref":"Phoenix.ChannelTest.html#push/3","title":"Phoenix.ChannelTest.push/3","type":"function"},{"doc":"Asserts the channel has not broadcast a message within timeout.Like assert_broadcast, the event and payload are patterns.The timeout is in milliseconds and defaults to the :refute_receive_timeout set on the :ex_unit application (which defaults to 100ms). Keep in mind this macro will block the test by the timeout value, so use it only when necessary as overuse will certainly slow down your test suite.","ref":"Phoenix.ChannelTest.html#refute_broadcast/3","title":"Phoenix.ChannelTest.refute_broadcast/3","type":"macro"},{"doc":"Asserts the channel has not pushed a message to the client matching the given event and payload within timeout.Like assert_push, the event and payload are patterns.The timeout is in milliseconds and defaults to the :refute_receive_timeout set on the :ex_unit application (which defaults to 100ms). Keep in mind this macro will block the test by the timeout value, so use it only when necessary as overuse will certainly slow down your test suite.","ref":"Phoenix.ChannelTest.html#refute_push/3","title":"Phoenix.ChannelTest.refute_push/3","type":"macro"},{"doc":"Asserts the channel has not replied with a matching payload within timeout.Like assert_reply, the event and payload are patterns.The timeout is in milliseconds and defaults to the :refute_receive_timeout set on the :ex_unit application (which defaults to 100ms). Keep in mind this macro will block the test by the timeout value, so use it only when necessary as overuse will certainly slow down your test suite.","ref":"Phoenix.ChannelTest.html#refute_reply/4","title":"Phoenix.ChannelTest.refute_reply/4","type":"macro"},{"doc":"Builds a socket for the given socket_module.The socket is then used to subscribe and join channels. Use this function when you want to create a blank socket to pass to functions like UserSocket.connect/3.Otherwise, use socket/3 if you want to build a socket with existing id and assigns.Examplessocket(MyApp.UserSocket)","ref":"Phoenix.ChannelTest.html#socket/1","title":"Phoenix.ChannelTest.socket/1","type":"macro"},{"doc":"Builds a socket for the given socket_module with given id and assigns.Examplessocket(MyApp.UserSocket, &quot;user_id&quot;, %{some: :assign})","ref":"Phoenix.ChannelTest.html#socket/3","title":"Phoenix.ChannelTest.socket/3","type":"macro"},{"doc":"See subscribe_and_join/4.","ref":"Phoenix.ChannelTest.html#subscribe_and_join/2","title":"Phoenix.ChannelTest.subscribe_and_join/2","type":"function"},{"doc":"See subscribe_and_join/4.","ref":"Phoenix.ChannelTest.html#subscribe_and_join/3","title":"Phoenix.ChannelTest.subscribe_and_join/3","type":"function"},{"doc":"Subscribes to the given topic and joins the channel under the given topic and payload.By subscribing to the topic, we can use assert_broadcast/3 to verify a message has been sent through the pubsub layer.By joining the channel, we can interact with it directly. The given channel is joined in a separate process which is linked to the test process.If no channel module is provided, the socket's handler is used to lookup the matching channel for the given topic.It returns {:ok, reply, socket} or {:error, reply}.","ref":"Phoenix.ChannelTest.html#subscribe_and_join/4","title":"Phoenix.ChannelTest.subscribe_and_join/4","type":"function"},{"doc":"See subscribe_and_join!/4.","ref":"Phoenix.ChannelTest.html#subscribe_and_join!/2","title":"Phoenix.ChannelTest.subscribe_and_join!/2","type":"function"},{"doc":"See subscribe_and_join!/4.","ref":"Phoenix.ChannelTest.html#subscribe_and_join!/3","title":"Phoenix.ChannelTest.subscribe_and_join!/3","type":"function"},{"doc":"Same as subscribe_and_join/4, but returns either the socket or throws an error.This is helpful when you are not testing joining the channel and just need the socket.","ref":"Phoenix.ChannelTest.html#subscribe_and_join!/4","title":"Phoenix.ChannelTest.subscribe_and_join!/4","type":"function"},{"doc":"Conveniences for testing Phoenix endpoints and connection related helpers.You likely want to use this module or make it part of your ExUnit.CaseTemplate. Once used, this module automatically imports all functions defined here as well as the functions in Plug.Conn.Endpoint testingPhoenix.ConnTest typically works against endpoints. That's the preferred way to test anything that your router dispatches to:@endpoint MyAppWeb.Endpoint test &quot;says welcome on the home page&quot; do conn = get(build_conn(), &quot;/&quot;) assert conn.resp_body =~ &quot;Welcome!&quot; end test &quot;logs in&quot; do conn = post(build_conn(), &quot;/login&quot;, [username: &quot;john&quot;, password: &quot;doe&quot;]) assert conn.resp_body =~ &quot;Logged in!&quot; endThe @endpoint module attribute contains the endpoint under testing, most commonly your application endpoint itself. If you are using the MyApp.ConnCase generated by Phoenix, it is automatically set for you.As in your router and controllers, the connection is the main abstraction in testing. build_conn() returns a new connection and functions in this module can be used to manipulate the connection before dispatching to the endpoint.For example, one could set the accepts header for json requests as follows:build_conn() |&gt; put_req_header(&quot;accept&quot;, &quot;application/json&quot;) |&gt; get(&quot;/&quot;)You can also create your own helpers, such as json_conn() that uses build_conn/0 and put_req_header/3, so you avoid repeating the connection setup throughout your tests.Controller testingThe functions in this module can also be used for controller testing. While endpoint testing is preferred over controller testing, especially since the controller in Phoenix plays an integration role between your domain and your views, unit testing controllers may be helpful in some situations.For such cases, you need to set the @endpoint attribute to your controller and pass an atom representing the action to dispatch:@endpoint MyAppWeb.HomeController test &quot;says welcome on the home page&quot; do conn = get(build_conn(), :index) assert conn.resp_body =~ &quot;Welcome!&quot; endKeep in mind that, once the @endpoint variable is set, all tests after setting it will be affected.Views testingUnder other circumstances, you may be testing a view or another layer that requires a connection for processing. For such cases, a connection can be created using the build_conn/3 helper:MyApp.UserView.render(&quot;hello.html&quot;, conn: build_conn(:get, &quot;/&quot;))While build_conn/0 returns a connection with no request information to it, build_conn/3 returns a connection with the given request information already filled in.RecyclingBrowsers implement a storage by using cookies. When a cookie is set in the response, the browser stores it and sends it in the next request.To emulate this behaviour, this module provides the idea of recycling. The recycle/1 function receives a connection and returns a new connection, similar to the one returned by build_conn/0 with all the response cookies from the previous connection defined as request headers. This is useful when testing multiple routes that require cookies or session to work.Keep in mind Phoenix will automatically recycle the connection between dispatches. This usually works out well most times, but it may discard information if you are modifying the connection before the next dispatch:# No recycling as the connection is fresh conn = get(build_conn(), &quot;/&quot;) # The connection is recycled, creating a new one behind the scenes conn = post(conn, &quot;/login&quot;) # We can also recycle manually in case we want custom headers conn = conn |&gt; recycle() |&gt; put_req_header(&quot;x-special&quot;, &quot;nice&quot;) # No recycling as we did it explicitly conn = delete(conn, &quot;/logout&quot;)Recycling also recycles the &quot;accept&quot; and &quot;authorization&quot; headers, as well as peer data information.","ref":"Phoenix.ConnTest.html","title":"Phoenix.ConnTest","type":"module"},{"doc":"Asserts an error was wrapped and sent with the given status.Useful for testing actions that you expect raise an error and have the response wrapped in an HTTP status, with content usually rendered by your MyApp.ErrorView.The function accepts a status either as an integer HTTP status or atom, such as 404 or :not_found. The list of allowed atoms is available in Plug.Conn.Status. If an error is raised, a 3-tuple of the wrapped response is returned matching the status, headers, and body of the response:{404, [{&quot;content-type&quot;, &quot;text/html&quot;} | _], &quot;Page not found&quot;}Examplesassert_error_sent :not_found, fn -&gt; get(build_conn(), &quot;/users/not-found&quot;) end response = assert_error_sent 404, fn -&gt; get(build_conn(), &quot;/users/not-found&quot;) end assert {404, [_h | _t], &quot;Page not found&quot;} = response","ref":"Phoenix.ConnTest.html#assert_error_sent/2","title":"Phoenix.ConnTest.assert_error_sent/2","type":"function"},{"doc":"Creates a connection to be used in upcoming requests.","ref":"Phoenix.ConnTest.html#build_conn/0","title":"Phoenix.ConnTest.build_conn/0","type":"function"},{"doc":"Creates a connection to be used in upcoming requests with a preset method, path and body.This is useful when a specific connection is required for testing a plug or a particular function.","ref":"Phoenix.ConnTest.html#build_conn/3","title":"Phoenix.ConnTest.build_conn/3","type":"function"},{"doc":"Calls the Endpoint and Router pipelines.Useful for unit testing Plugs where Endpoint and/or router pipeline plugs are required for proper setup.Note the use of get(&quot;/&quot;) following bypass_through in the examples below. To execute the plug pipelines, you must issue a request against the router. Most often, you can simply send a GET request against the root path, but you may also specify a different method or path which your pipelines may operate against.ExamplesFor example, imagine you are testing an authentication plug in isolation, but you need to invoke the Endpoint plugs and router pipelines to set up session and flash related dependencies. One option is to invoke an existing route that uses the proper pipelines. You can do so by passing the connection and the router name to bypass_through:conn = conn |&gt; bypass_through(MyAppWeb.Router) |&gt; get(&quot;/some_url&quot;) |&gt; MyApp.RequireAuthentication.call([]) assert conn.haltedYou can also specify which pipelines you want to run:conn = conn |&gt; bypass_through(MyAppWeb.Router, [:browser]) |&gt; get(&quot;/&quot;) |&gt; MyApp.RequireAuthentication.call([]) assert conn.haltedAlternatively, you could only invoke the Endpoint's plugs:conn = conn |&gt; bypass_through() |&gt; get(&quot;/&quot;) |&gt; MyApp.RequireAuthentication.call([]) assert conn.halted","ref":"Phoenix.ConnTest.html#bypass_through/1","title":"Phoenix.ConnTest.bypass_through/1","type":"function"},{"doc":"Calls the Endpoint and Router pipelines for the current route.See bypass_through/1.","ref":"Phoenix.ConnTest.html#bypass_through/2","title":"Phoenix.ConnTest.bypass_through/2","type":"function"},{"doc":"Calls the Endpoint and the given Router pipelines.See bypass_through/1.","ref":"Phoenix.ConnTest.html#bypass_through/3","title":"Phoenix.ConnTest.bypass_through/3","type":"function"},{"doc":"Clears up the flash storage.","ref":"Phoenix.ConnTest.html#clear_flash/1","title":"Phoenix.ConnTest.clear_flash/1","type":"function"},{"doc":"Dispatches to the current endpoint.See dispatch/5 for more information.","ref":"Phoenix.ConnTest.html#connect/3","title":"Phoenix.ConnTest.connect/3","type":"macro"},{"doc":"Dispatches to the current endpoint.See dispatch/5 for more information.","ref":"Phoenix.ConnTest.html#delete/3","title":"Phoenix.ConnTest.delete/3","type":"macro"},{"doc":"Deletes a request cookie.","ref":"Phoenix.ConnTest.html#delete_req_cookie/2","title":"Phoenix.ConnTest.delete_req_cookie/2","type":"function"},{"doc":"Dispatches the connection to the given endpoint.When invoked via get/3, post/3 and friends, the endpoint is automatically retrieved from the @endpoint module attribute, otherwise it must be given as an argument.The connection will be configured with the given method, path_or_action and params_or_body.If path_or_action is a string, it is considered to be the request path and stored as so in the connection. If an atom, it is assumed to be an action and the connection is dispatched to the given action.Parameters and bodyThis function, as well as get/3, post/3 and friends, accepts the request body or parameters as last argument: get(build_conn(), &quot;/&quot;, some: &quot;param&quot;) get(build_conn(), &quot;/&quot;, &quot;some=param&amp;url=encoded&quot;)The allowed values are:nil - meaning there is no bodya binary - containing a request body. For such cases, :headers must be given as option with a content-typea map or list - containing the parameters which will automatically set the content-type to multipart. The map or list may contain other lists or maps and all entries will be normalized to string keysa struct - unlike other maps, a struct will be passed through as-is without normalizing its entries","ref":"Phoenix.ConnTest.html#dispatch/5","title":"Phoenix.ConnTest.dispatch/5","type":"function"},{"doc":"Ensures the connection is recycled if it wasn't already.See recycle/1 for more information.","ref":"Phoenix.ConnTest.html#ensure_recycled/1","title":"Phoenix.ConnTest.ensure_recycled/1","type":"function"},{"doc":"Fetches the flash storage.","ref":"Phoenix.ConnTest.html#fetch_flash/1","title":"Phoenix.ConnTest.fetch_flash/1","type":"function"},{"doc":"Dispatches to the current endpoint.See dispatch/5 for more information.","ref":"Phoenix.ConnTest.html#get/3","title":"Phoenix.ConnTest.get/3","type":"macro"},{"doc":"Gets the whole flash storage.","ref":"Phoenix.ConnTest.html#get_flash/1","title":"Phoenix.ConnTest.get_flash/1","type":"function"},{"doc":"Gets the given key from the flash storage.","ref":"Phoenix.ConnTest.html#get_flash/2","title":"Phoenix.ConnTest.get_flash/2","type":"function"},{"doc":"Dispatches to the current endpoint.See dispatch/5 for more information.","ref":"Phoenix.ConnTest.html#head/3","title":"Phoenix.ConnTest.head/3","type":"macro"},{"doc":"Asserts the given status code, that we have an html response and returns the response body if one was set or sent.Examplesassert html_response(conn, 200) =~ &quot;&lt;html&gt;&quot;","ref":"Phoenix.ConnTest.html#html_response/2","title":"Phoenix.ConnTest.html_response/2","type":"function"},{"doc":"Inits a session used exclusively for testing.","ref":"Phoenix.ConnTest.html#init_test_session/2","title":"Phoenix.ConnTest.init_test_session/2","type":"function"},{"doc":"Asserts the given status code, that we have a json response and returns the decoded JSON response if one was set or sent.Examplesbody = json_response(conn, 200) assert &quot;can&#39;t be blank&quot; in body[&quot;errors&quot;]","ref":"Phoenix.ConnTest.html#json_response/2","title":"Phoenix.ConnTest.json_response/2","type":"function"},{"doc":"Dispatches to the current endpoint.See dispatch/5 for more information.","ref":"Phoenix.ConnTest.html#options/3","title":"Phoenix.ConnTest.options/3","type":"macro"},{"doc":"Dispatches to the current endpoint.See dispatch/5 for more information.","ref":"Phoenix.ConnTest.html#patch/3","title":"Phoenix.ConnTest.patch/3","type":"macro"},{"doc":"Dispatches to the current endpoint.See dispatch/5 for more information.","ref":"Phoenix.ConnTest.html#post/3","title":"Phoenix.ConnTest.post/3","type":"macro"},{"doc":"Dispatches to the current endpoint.See dispatch/5 for more information.","ref":"Phoenix.ConnTest.html#put/3","title":"Phoenix.ConnTest.put/3","type":"macro"},{"doc":"Puts the given value under key in the flash storage.","ref":"Phoenix.ConnTest.html#put_flash/3","title":"Phoenix.ConnTest.put_flash/3","type":"function"},{"doc":"Puts a request cookie.","ref":"Phoenix.ConnTest.html#put_req_cookie/3","title":"Phoenix.ConnTest.put_req_cookie/3","type":"function"},{"doc":"Recycles the connection.Recycling receives a connection and returns a new connection, containing cookies and relevant information from the given one.This emulates behaviour performed by browsers where cookies returned in the response are available in following requests.By default, only the headers &quot;accept&quot;, &quot;accept-language&quot;, and &quot;authorization&quot; are recycled. However, a custom set of headers can be specified by passing a list of strings representing its names as the second argument of the function.Note recycle/1 is automatically invoked when dispatching to the endpoint, unless the connection has already been recycled.","ref":"Phoenix.ConnTest.html#recycle/2","title":"Phoenix.ConnTest.recycle/2","type":"function"},{"doc":"Returns the matched params from the URL the connection was redirected to.Uses the provided %Plug.Conn{}s router matched in the previous request. Raises if the response's location header is not set.Examplesassert redirected_to(conn) =~ &quot;/posts/123&quot; assert %{id: &quot;123&quot;} = redirected_params(conn)","ref":"Phoenix.ConnTest.html#redirected_params/1","title":"Phoenix.ConnTest.redirected_params/1","type":"function"},{"doc":"Returns the location header from the given redirect response.Raises if the response does not match the redirect status code (defaults to 302).Examplesassert redirected_to(conn) =~ &quot;/foo/bar&quot; assert redirected_to(conn, 301) =~ &quot;/foo/bar&quot; assert redirected_to(conn, :moved_permanently) =~ &quot;/foo/bar&quot;","ref":"Phoenix.ConnTest.html#redirected_to/2","title":"Phoenix.ConnTest.redirected_to/2","type":"function"},{"doc":"Asserts the given status code and returns the response body if one was set or sent.Examplesconn = get(build_conn(), &quot;/&quot;) assert response(conn, 200) =~ &quot;hello world&quot;","ref":"Phoenix.ConnTest.html#response/2","title":"Phoenix.ConnTest.response/2","type":"function"},{"doc":"Returns the content type as long as it matches the given format.Examples# Assert we have an html response with utf-8 charset assert response_content_type(conn, :html) =~ &quot;charset=utf-8&quot;","ref":"Phoenix.ConnTest.html#response_content_type/2","title":"Phoenix.ConnTest.response_content_type/2","type":"function"},{"doc":"Asserts the given status code, that we have a text response and returns the response body if one was set or sent.Examplesassert text_response(conn, 200) =~ &quot;hello&quot;","ref":"Phoenix.ConnTest.html#text_response/2","title":"Phoenix.ConnTest.text_response/2","type":"function"},{"doc":"Dispatches to the current endpoint.See dispatch/5 for more information.","ref":"Phoenix.ConnTest.html#trace/3","title":"Phoenix.ConnTest.trace/3","type":"macro"},{"doc":"A plug and module to handle automatic code reloading.For each request, Phoenix goes through all modules and checks if any of them implement a __phoenix_recompile__?/0 function. If they do and it returns true, the module source file is touched, forcing it to be recompiled. For this functionality to work, Phoenix requires you to add the :phoenix compiler to your list of compilers:compilers: [:phoenix] ++ Mix.compilers()This is useful, for example, to recompile modules that depend on external systems, such as directories, databases, etc. Note if you simply depend on external files, @external_resource annotation should be used.To avoid race conditions, all code reloads are funneled through a sequential call operation.","ref":"Phoenix.CodeReloader.html","title":"Phoenix.CodeReloader","type":"module"},{"doc":"API used by Plug to invoke the code reloader on every request.","ref":"Phoenix.CodeReloader.html#call/2","title":"Phoenix.CodeReloader.call/2","type":"function"},{"doc":"API used by Plug to start the code reloader.","ref":"Phoenix.CodeReloader.html#init/1","title":"Phoenix.CodeReloader.init/1","type":"function"},{"doc":"Reloads code for the current Mix project by invoking the :reloadable_compilers on the list of :reloadable_apps.This is configured in your application environment like:config :your_app, YourApp.Endpoint, reloadable_compilers: [:gettext, :phoenix, :elixir], reloadable_apps: [:ui, :backend]Keep in mind :reloadable_compilers must be a subset of the :compilers specified in project/0 in your mix.exs.The :reloadable_apps defaults to nil. In such case default behaviour is to reload current project if it consists of single app, or all applications within umbrella project. You can set :reloadable_apps to subset of default applications to reload only some of them, empty list - to effectively disable code reloader, or include external applications from library dependencies.","ref":"Phoenix.CodeReloader.html#reload!/1","title":"Phoenix.CodeReloader.reload!/1","type":"function"},{"doc":"The Cowboy2 adapter for Phoenix.Endpoint configurationThis adapter uses the following endpoint configuration::http - the configuration for the HTTP server. It accepts all options as defined by Plug.Cowboy. Defaults to false:https - the configuration for the HTTPS server. It accepts all options as defined by Plug.Cowboy. Defaults to false:drainer - a drainer process that triggers when your application is shutting to wait for any on-going request to finish. It accepts all options as defined by Plug.Cowboy. Defaults to [] and can be disabled by setting it to false.Custom dispatch optionsYou can provide custom dispatch options in order to use Phoenix's builtin Cowboy server with custom handlers. For example, to handle raw WebSockets as shown in Cowboy's docs).The options are passed to both :http and :https keys in the endpoint configuration. However, once you pass your custom dispatch options, you will need to manually wire the Phoenix endpoint by adding the following rule:{:_, Phoenix.Endpoint.Cowboy2Handler, {MyAppWeb.Endpoint, []}}For example:config :myapp, MyAppWeb.Endpoint, http: [dispatch: [ {:_, [ {&quot;/foo&quot;, MyAppWeb.CustomHandler, []}, {:_, Phoenix.Endpoint.Cowboy2Handler, {MyAppWeb.Endpoint, []}} ]}]]It is also important to specify your handlers first, otherwise Phoenix will intercept the requests before they get to your handler.","ref":"Phoenix.Endpoint.Cowboy2Adapter.html","title":"Phoenix.Endpoint.Cowboy2Adapter","type":"module"},{"doc":"The Cowboy adapter for Phoenix.It implements the required child_spec/3 function as well as the handler for the WebSocket transport.Custom dispatch optionsNOTE: This feature depends on the internals of Cowboy 1.0 API and how it integrates with Phoenix. Those may change at any time, without backwards compatibility.You can provide custom dispatch options in order to use Phoenix's builtin Cowboy server with custom handlers. For example, to handle raw WebSockets as shown in Cowboy's docs).The options are passed to both :http and :https keys in the endpoint configuration. However, once you pass your custom dispatch options, you will need to manually wire all Phoenix endpoints, including the socket transports.You will need the following rules:Per websocket transport:{&quot;/socket/websocket&quot;, Phoenix.Endpoint.CowboyWebSocket, {Phoenix.Transports.WebSocket, {MyAppWeb.Endpoint, MyAppWeb.UserSocket, websocket_config}}}Per longpoll transport:{&quot;/socket/long_poll&quot;, Plug.Adapters.Cowboy.Handler, {Phoenix.Transports.LongPoll, {MyAppWeb.Endpoint, MyAppWeb.UserSocket, longpoll_config}}}For the live-reload websocket:{&quot;/phoenix/live_reload/socket/websocket&quot;, Phoenix.Endpoint.CowboyWebSocket, {Phoenix.Transports.WebSocket, {MyAppWeb.Endpoint, Phoenix.LiveReloader.Socket, websocket_config}}}If you decide to include the live-reload websocket, you should disable it when building for production.For the endpoint:{:_, Plug.Adapters.Cowboy.Handler, {MyAppWeb.Endpoint, []}}For example:config :myapp, MyAppWeb.Endpoint, http: [dispatch: [ {:_, [ {&quot;/foo&quot;, MyAppWeb.CustomHandler, []}, {&quot;/bar&quot;, MyAppWeb.AnotherHandler, []}, {&quot;/phoenix/live_reload/socket/websocket&quot;, Phoenix.Endpoint.CowboyWebSocket, {Phoenix.Transports.WebSocket, {MyAppWeb.Endpoint, Phoenix.LiveReloader.Socket, websocket_config}}}, {:_, Plug.Adapters.Cowboy.Handler, {MyAppWeb.Endpoint, []}} ]}]]Note: if you reconfigure HTTP options in MyAppWeb.Endpoint.init/1, your dispatch options set in mix config will be overwritten.It is also important to specify your handlers first, otherwise Phoenix will intercept the requests before they get to your handler.","ref":"Phoenix.Endpoint.CowboyAdapter.html","title":"Phoenix.Endpoint.CowboyAdapter","type":"module"},{"doc":"A socket implementation that multiplexes messages over channels.Phoenix.Socket is used as a module for establishing and maintaining the socket state via the Phoenix.Socket struct.Once connected to a socket, incoming and outgoing events are routed to channels. The incoming client data is routed to channels via transports. It is the responsibility of the socket to tie transports and channels together.By default, Phoenix supports both websockets and longpoll when invoking Phoenix.Endpoint.socket/3 in your endpoint:socket &quot;/socket&quot;, MyAppWeb.Socket, websocket: true, longpoll: falseThe command above means incoming socket connections can be made via a WebSocket connection. Events are routed by topic to channels:channel &quot;room:lobby&quot;, MyAppWeb.LobbyChannelSee Phoenix.Channel for more information on channels.Socket BehaviourSocket handlers are mounted in Endpoints and must define two callbacks:connect/3 - receives the socket params, connection info if any, and authenticates the connection. Must return a Phoenix.Socket struct, often with custom assignsid/1 - receives the socket returned by connect/3 and returns the id of this connection as a string. The id is used to identify socket connections, often to a particular user, allowing us to force disconnections. For sockets requiring no authentication, nil can be returnedExamplesdefmodule MyAppWeb.UserSocket do use Phoenix.Socket channel &quot;room:*&quot;, MyAppWeb.RoomChannel def connect(params, socket, _connect_info) do {:ok, assign(socket, :user_id, params[&quot;user_id&quot;])} end def id(socket), do: &quot;users_socket:\#{socket.assigns.user_id}&quot; end # Disconnect all user&#39;s socket connections and their multiplexed channels MyAppWeb.Endpoint.broadcast(&quot;users_socket:&quot; &lt;&gt; user.id, &quot;disconnect&quot;, %{})Socket fields:id - The string id of the socket:assigns - The map of socket assigns, default: %{}:channel - The current channel module:channel_pid - The channel pid:endpoint - The endpoint module where this socket originated, for example: MyAppWeb.Endpoint:handler - The socket module where this socket originated, for example: MyAppWeb.UserSocket:joined - If the socket has effectively joined the channel:join_ref - The ref sent by the client when joining:ref - The latest ref sent by the client:pubsub_server - The registered name of the socket's pubsub server:topic - The string topic, for example &quot;room:123&quot;:transport - An identifier for the transport, used for logging:transport_pid - The pid of the socket's transport process:serializer - The serializer for socket messagesUsing optionsOn use Phoenix.Socket, the following options are accepted::log - the default level to log socket actions. Defaults to :info. May be set to false to disable it:partitions - each channel is spawned under a supervisor. This option controls how many supervisors will be spawned to handle channels. Defaults to the number of cores.Garbage collectionIt's possible to force garbage collection in the transport process after processing large messages. For example, to trigger such from your channels, run:send(socket.transport_pid, :garbage_collect)Client-server communicationThe encoding of server data and the decoding of client data is done according to a serializer, defined in Phoenix.Socket.Serializer. By default, JSON encoding is used to broker messages to and from clients with Phoenix.Socket.V2.JSONSerializer.The serializer decode! function must return a Phoenix.Socket.Message which is forwarded to channels except:&quot;heartbeat&quot; events in the &quot;phoenix&quot; topic - should just emit an OK reply&quot;phx_join&quot; on any topic - should join the topic&quot;phx_leave&quot; on any topic - should leave the topicEach message also has a ref field which is used to track responses.The server may send messages or replies back. For messages, the ref uniquely identifies the message. For replies, the ref matches the original message. Both data-types also include a join_ref that uniquely identifies the currently joined channel.The Phoenix.Socket implementation may also send special messages and replies:&quot;phx_error&quot; - in case of errors, such as a channel process crashing, or when attempting to join an already joined channel&quot;phx_close&quot; - the channel was gracefully closedPhoenix ships with a JavaScript implementation of both websocket and long polling that interacts with Phoenix.Socket and can be used as reference for those interested in implementing custom clients.Custom sockets and transportsSee the Phoenix.Socket.Transport documentation for more information on writing your own socket that does not leverage channels or for writing your own transports that interacts with other sockets.Custom channelsYou can list any module as a channel as long as it implements a child_spec/1 function. The child_spec/1 function receives the caller as argument and it must return a child spec that initializes a process.Once the process is initialized, it will receive the following message:{Phoenix.Channel, auth_payload, from, socket}A custom channel implementation MUST invoke GenServer.reply(from, {:ok | :error, reply_payload}) during its initialization with a custom reply_payload that will be sent as a reply to the client. Failing to do so will block the socket forever.A custom channel receives Phoenix.Socket.Message structs as regular messages from the transport. Replies to those messages and custom messages can be sent to the socket at any moment by building an appropriate Phoenix.Socket.Reply and Phoenix.Socket.Message structs, encoding them with the serializer and dispatching the serialized result to the transport.For example, to handle &quot;phx_leave&quot; messages, which is recommended to be handled by all channel implementations, one may do:def handle_info( %Message{topic: topic, event: &quot;phx_leave&quot;} = message, %{topic: topic, serializer: serializer, transport_pid: transport_pid} = socket ) do send transport_pid, serializer.encode!(build_leave_reply(message)) {:stop, {:shutdown, :left}, socket} endWe also recommend all channels to monitor the transport_pid on init and exit if the transport exits. We also advise to rewrite :normal exit reasons (usually due to the socket being closed) to the {:shutdown, :closed} to guarantee links are broken on the channel exit (as a :normal exit does not break links):def handle_info({:DOWN, _, _, transport_pid, reason}, %{transport_pid: transport_pid} = socket) do reason = if reason == :normal, do: {:shutdown, :closed}, else: reason {:stop, reason, socket} endAny process exit is treated as an error by the socket layer unless a {:socket_close, pid, reason} message is sent to the socket before shutdown.Custom channel implementations cannot be tested with Phoenix.ChannelTest and are currently considered experimental. The underlying API may be changed at any moment.","ref":"Phoenix.Socket.html","title":"Phoenix.Socket","type":"behaviour"},{"doc":"","ref":"Phoenix.Socket.html#assign/2","title":"Phoenix.Socket.assign/2","type":"function"},{"doc":"Adds key value pairs to socket assigns.A single key value pair may be passed, a keyword list or map of assigns may be provided to be merged into existing socket assigns.Examplesiex&gt; assign(socket, :name, &quot;Elixir&quot;) iex&gt; assign(socket, name: &quot;Elixir&quot;, logo: &quot;💧&quot;)","ref":"Phoenix.Socket.html#assign/3","title":"Phoenix.Socket.assign/3","type":"function"},{"doc":"Defines a channel matching the given topic and transports.topic_pattern - The string pattern, for example &quot;room:*&quot;, &quot;users:*&quot;, or &quot;system&quot;module - The channel module handler, for example MyAppWeb.RoomChannelopts - The optional list of options, see belowOptions:assigns - the map of socket assigns to merge into the socket on joinExampleschannel &quot;topic1:*&quot;, MyChannelTopic PatternsThe channel macro accepts topic patterns in two flavors. A splat (the * character) argument can be provided as the last character to indicate a &quot;topic:subtopic&quot; match. If a plain string is provided, only that topic will match the channel handler. Most use-cases will use the &quot;topic:*&quot; pattern to allow more versatile topic scoping.See Phoenix.Channel for more information","ref":"Phoenix.Socket.html#channel/3","title":"Phoenix.Socket.channel/3","type":"macro"},{"doc":"Receives the socket params and authenticates the connection.Socket params and assignsSocket params are passed from the client and can be used to verify and authenticate a user. After verification, you can put default assigns into the socket that will be set for all channels, ie{:ok, assign(socket, :user_id, verified_user_id)}To deny connection, return :error.See Phoenix.Token documentation for examples in performing token verification on connect.","ref":"Phoenix.Socket.html#c:connect/2","title":"Phoenix.Socket.connect/2","type":"callback"},{"doc":"","ref":"Phoenix.Socket.html#c:connect/3","title":"Phoenix.Socket.connect/3","type":"callback"},{"doc":"Identifies the socket connection.Socket IDs are topics that allow you to identify all sockets for a given user:def id(socket), do: &quot;users_socket:\#{socket.assigns.user_id}&quot;Would allow you to broadcast a &quot;disconnect&quot; event and terminate all active sockets and channels for a given user:MyAppWeb.Endpoint.broadcast(&quot;users_socket:&quot; &lt;&gt; user.id, &quot;disconnect&quot;, %{})Returning nil makes this socket anonymous.","ref":"Phoenix.Socket.html#c:id/1","title":"Phoenix.Socket.id/1","type":"callback"},{"doc":"","ref":"Phoenix.Socket.html#t:t/0","title":"Phoenix.Socket.t/0","type":"type"},{"doc":"Defines a message sent from pubsub to channels and vice-versa.The message format requires the following keys::topic - The string topic or topic:subtopic pair namespace, for example &quot;messages&quot;, &quot;messages:123&quot;:event- The string event name, for example &quot;phx_join&quot;:payload - The message payload","ref":"Phoenix.Socket.Broadcast.html","title":"Phoenix.Socket.Broadcast","type":"module"},{"doc":"","ref":"Phoenix.Socket.Broadcast.html#t:t/0","title":"Phoenix.Socket.Broadcast.t/0","type":"type"},{"doc":"Defines a message dispatched over transport to channels and vice-versa.The message format requires the following keys::topic - The string topic or topic:subtopic pair namespace, for example &quot;messages&quot;, &quot;messages:123&quot;:event- The string event name, for example &quot;phx_join&quot;:payload - The message payload:ref - The unique string ref:join_ref - The unique string ref when joining","ref":"Phoenix.Socket.Message.html","title":"Phoenix.Socket.Message","type":"module"},{"doc":"Converts a map with string keys into a message struct.Raises Phoenix.Socket.InvalidMessageError if not valid.","ref":"Phoenix.Socket.Message.html#from_map!/1","title":"Phoenix.Socket.Message.from_map!/1","type":"function"},{"doc":"","ref":"Phoenix.Socket.Message.html#t:t/0","title":"Phoenix.Socket.Message.t/0","type":"type"},{"doc":"Defines a reply sent from channels to transports.The message format requires the following keys::topic - The string topic or topic:subtopic pair namespace, for example &quot;messages&quot;, &quot;messages:123&quot;:status - The reply status as an atom:payload - The reply payload:ref - The unique string ref:join_ref - The unique string ref when joining","ref":"Phoenix.Socket.Reply.html","title":"Phoenix.Socket.Reply","type":"module"},{"doc":"","ref":"Phoenix.Socket.Reply.html#t:t/0","title":"Phoenix.Socket.Reply.t/0","type":"type"},{"doc":"A behaviour that serializes incoming and outgoing socket messages.By default Phoenix provides Phoenix.Socket.V2.JSONSerializer that encodes to JSON and decodes JSON messages.Custom serializers may be configured in the socket.","ref":"Phoenix.Socket.Serializer.html","title":"Phoenix.Socket.Serializer","type":"behaviour"},{"doc":"Decodes iodata into Phoenix.Socket.Message struct.","ref":"Phoenix.Socket.Serializer.html#c:decode!/2","title":"Phoenix.Socket.Serializer.decode!/2","type":"callback"},{"doc":"Encodes Phoenix.Socket.Message and Phoenix.Socket.Reply structs to push format.","ref":"Phoenix.Socket.Serializer.html#c:encode!/1","title":"Phoenix.Socket.Serializer.encode!/1","type":"callback"},{"doc":"Encodes a Phoenix.Socket.Broadcast struct to fastlane format.","ref":"Phoenix.Socket.Serializer.html#c:fastlane!/1","title":"Phoenix.Socket.Serializer.fastlane!/1","type":"callback"},{"doc":"Outlines the Socket &lt;-&gt; Transport communication.This module specifies a behaviour that all sockets must implement. Phoenix.Socket is just one possible implementation of a socket that multiplexes events over multiple channels. Developers can implement their own sockets as long as they implement the behaviour outlined here.Developers interested in implementing custom transports must invoke the socket API defined in this module. This module also provides many conveniences that invokes the underlying socket API to make it easier to build custom transports.Booting socketsWhenever your endpoint starts, it will automatically invoke the child_spec/1 on each listed socket and start that specification under the endpoint supervisor.Since the socket supervision tree is started by the endpoint, any custom transport must be started after the endpoint in a supervision tree.Operating socketsSockets are operated by a transport. When a transport is defined, it usually receives a socket module and the module will be invoked when certain events happen at the transport level.Whenever the transport receives a new connection, it should invoke the connect/1 callback with a map of metadata. Different sockets may require different metadatas.If the connection is accepted, the transport can move the connection to another process, if so desires, or keep using the same process. The process responsible for managing the socket should then call init/1.For each message received from the client, the transport must call handle_in/2 on the socket. For each informational message the transport receives, it should call handle_info/2 on the socket.Transports can optionally implement handle_control/2 for handling control frames such as :ping and :pong.On termination, terminate/2 must be called. A special atom with reason :closed can be used to specify that the client terminated the connection.ExampleHere is a simple echo socket implementation:defmodule EchoSocket do @behaviour Phoenix.Socket.Transport def child_spec(opts) do # We won&#39;t spawn any process, so let&#39;s return a dummy task %{id: Task, start: {Task, :start_link, [fn -&gt; :ok end]}, restart: :transient} end def connect(map) do # Callback to retrieve relevant data from the connection. # The map contains options, params, transport and endpoint keys. {:ok, state} end def init(state) do # Now we are effectively inside the process that maintains the socket. {:ok, state} end def handle_in({text, _opts}, state) do {:reply, :ok, {:text, text}, state} end def handle_info(_, state) do {:ok, state} end def terminate(_reason, _state) do :ok end endIt can be mounted in your endpoint like any other socket:socket &quot;/socket&quot;, EchoSocket, websocket: true, longpoll: trueYou can now interact with the socket under /socket/websocket and /socket/longpoll.SecurityThis module also provides functions to enable a secure environment on transports that, at some point, have access to a Plug.Conn.The functionality provided by this module helps in performing &quot;origin&quot; header checks and ensuring only SSL connections are allowed.","ref":"Phoenix.Socket.Transport.html","title":"Phoenix.Socket.Transport","type":"behaviour"},{"doc":"Checks the origin request header against the list of allowed origins.Should be called by transports before connecting when appropriate. If the origin header matches the allowed origins, no origin header was sent or no origin was configured, it will return the given connection.Otherwise a 403 Forbidden response will be sent and the connection halted. It is a noop if the connection has been halted.","ref":"Phoenix.Socket.Transport.html#check_origin/5","title":"Phoenix.Socket.Transport.check_origin/5","type":"function"},{"doc":"Checks the Websocket subprotocols request header against the allowed subprotocols.Should be called by transports before connecting when appropriate. If the sec-websocket-protocol header matches the allowed subprotocols, it will put sec-websocket-protocol response header and return the given connection. If no sec-websocket-protocol header was sent it will return the given connection.Otherwise a 403 Forbidden response will be sent and the connection halted. It is a noop if the connection has been halted.","ref":"Phoenix.Socket.Transport.html#check_subprotocols/2","title":"Phoenix.Socket.Transport.check_subprotocols/2","type":"function"},{"doc":"Returns a child specification for socket management.This is invoked only once per socket regardless of the number of transports and should be responsible for setting up any process structure used exclusively by the socket regardless of transports.Each socket connection is started by the transport and the process that controls the socket likely belongs to the transport. However, some sockets spawn new processes, such as Phoenix.Socket which spawns channels, and this gives the ability to start a supervision tree associated to the socket.It receives the socket options from the endpoint, for example:socket &quot;/my_app&quot;, MyApp.Socket, shutdown: 5000means child_spec([shutdown: 5000]) will be invoked.","ref":"Phoenix.Socket.Transport.html#c:child_spec/1","title":"Phoenix.Socket.Transport.child_spec/1","type":"callback"},{"doc":"Runs the code reloader if enabled.","ref":"Phoenix.Socket.Transport.html#code_reload/3","title":"Phoenix.Socket.Transport.code_reload/3","type":"function"},{"doc":"Connects to the socket.The transport passes a map of metadata and the socket returns {:ok, state} or :error. The state must be stored by the transport and returned in all future operations.This function is used for authorization purposes and it may be invoked outside of the process that effectively runs the socket.In the default Phoenix.Socket implementation, the metadata expects the following keys::endpoint - the application endpoint:transport - the transport name:params - the connection parameters:options - a keyword list of transport options, often given by developers when configuring the transport. It must include a :serializer field with the list of serializers and their requirements","ref":"Phoenix.Socket.Transport.html#c:connect/1","title":"Phoenix.Socket.Transport.connect/1","type":"callback"},{"doc":"Extracts connection information from conn and returns a map.Keys are retrieved from the optional transport option :connect_info. This functionality is transport specific. Please refer to your transports' documentation for more information.The supported keys are::peer_data - the result of Plug.Conn.get_peer_data/1:trace_context_headers - a list of all trace context headers:x_headers - a list of all request headers that have an &quot;x-&quot; prefix:uri - a %URI{} derived from the conn:user_agent - the value of the &quot;user-agent&quot; request header","ref":"Phoenix.Socket.Transport.html#connect_info/3","title":"Phoenix.Socket.Transport.connect_info/3","type":"function"},{"doc":"Forces SSL in the socket connection.Uses the endpoint configuration to decide so. It is a noop if the connection has been halted.","ref":"Phoenix.Socket.Transport.html#force_ssl/4","title":"Phoenix.Socket.Transport.force_ssl/4","type":"function"},{"doc":"Handles incoming control frames.The message is represented as {payload, options}. It must return one of:{:ok, state} - continues the socket with no reply{:reply, status, reply, state} - continues the socket with reply{:stop, reason, state} - stops the socketControl frames only supported when using websockets.The options contains an opcode key, this will be either :ping or :pong.If a control frame doesn't have a payload, then the payload value will be nil.","ref":"Phoenix.Socket.Transport.html#c:handle_control/2","title":"Phoenix.Socket.Transport.handle_control/2","type":"callback"},{"doc":"Handles incoming socket messages.The message is represented as {payload, options}. It must return one of:{:ok, state} - continues the socket with no reply{:reply, status, reply, state} - continues the socket with reply{:stop, reason, state} - stops the socketThe reply is a tuple contain an opcode atom and a message that can be any term. The built-in websocket transport supports both :text and :binary opcode and the message must be always iodata. Long polling only supports text opcode.","ref":"Phoenix.Socket.Transport.html#c:handle_in/2","title":"Phoenix.Socket.Transport.handle_in/2","type":"callback"},{"doc":"Handles info messages.The message is a term. It must return one of:{:ok, state} - continues the socket with no reply{:push, reply, state} - continues the socket with reply{:stop, reason, state} - stops the socketThe reply is a tuple contain an opcode atom and a message that can be any term. The built-in websocket transport supports both :text and :binary opcode and the message must be always iodata. Long polling only supports text opcode.","ref":"Phoenix.Socket.Transport.html#c:handle_info/2","title":"Phoenix.Socket.Transport.handle_info/2","type":"callback"},{"doc":"Initializes the socket state.This must be executed from the process that will effectively operate the socket.","ref":"Phoenix.Socket.Transport.html#c:init/1","title":"Phoenix.Socket.Transport.init/1","type":"callback"},{"doc":"Invoked on termination.If reason is :closed, it means the client closed the socket. This is considered a :normal exit signal, so linked process will not automatically exit. See Process.exit/2 for more details on exit signals.","ref":"Phoenix.Socket.Transport.html#c:terminate/2","title":"Phoenix.Socket.Transport.terminate/2","type":"callback"},{"doc":"Logs the transport request.Available for transports that generate a connection.","ref":"Phoenix.Socket.Transport.html#transport_log/2","title":"Phoenix.Socket.Transport.transport_log/2","type":"function"},{"doc":"","ref":"Phoenix.Socket.Transport.html#t:state/0","title":"Phoenix.Socket.Transport.state/0","type":"type"},{"doc":"Templates are used by Phoenix when rendering responses.Since many views render significant content, for example a whole HTML file, it is common to put these files into a particular directory, typically &quot;APP_web/templates&quot;.This module provides conveniences for reading all files from a particular directory and embedding them into a single module. Imagine you have a directory with templates:# templates/foo.html.eex Hello &lt;%= @name %&gt; # templates.ex defmodule Templates do use Phoenix.Template, root: &quot;templates&quot; def render(template, assigns) do render_template(template, assigns) end endPhoenix.Template will define a private function named render_template/2 with one clause per file system template. We expose this private function via render/2, which can be invoked as:Templates.render(&quot;foo.html&quot;, %{name: &quot;John Doe&quot;})In practice, developers rarely use Phoenix.Template directly. Instead they use Phoenix.View which wraps the template functionality and adds some extra conveniences.Options:root - the root template path to find templates:pattern - the wildcard pattern to apply to the root when finding templates. Default &quot;*&quot;:template_engines - a map of template engines extensions to template engine handlersTerminologyHere is a quick introduction into Phoenix templates terms:template name - is the name of the template as given by the user, without the template engine extension, for example: &quot;users.html&quot;template path - is the complete path of the template in the filesystem, for example, &quot;path/to/users.html.eex&quot;template root - the directory where templates are definedtemplate engine - a module that receives a template path and transforms its source code into Elixir quoted expressionsCustom Template EnginesPhoenix supports custom template engines. Engines tell Phoenix how to convert a template path into quoted expressions. See Phoenix.Template.Engine for more information on the API required to be implemented by custom engines.Once a template engine is defined, you can tell Phoenix about it via the template engines option:config :phoenix, :template_engines, eex: Phoenix.Template.EExEngine, exs: Phoenix.Template.ExsEngineIf you want to support a given engine only on a certain template, you can pass it as an option on use Phoenix.Template:use Phoenix.Template, template_engines: %{ foo: Phoenix.Template.FooEngine }Format encodersBesides template engines, Phoenix has the concept of format encoders. Format encoders work per format and are responsible for encoding a given format to string once the view layer finishes processing.A format encoder must export a function called encode_to_iodata!/1 which receives the rendering artifact and returns iodata.New encoders can be added via the format encoder option:config :phoenix, :format_encoders, html: Phoenix.HTML.Engine","ref":"Phoenix.Template.html","title":"Phoenix.Template","type":"module"},{"doc":"Returns a keyword list with all template engines extensions followed by their modules.","ref":"Phoenix.Template.html#engines/0","title":"Phoenix.Template.engines/0","type":"function"},{"doc":"Returns all template paths in a given template root.","ref":"Phoenix.Template.html#find_all/3","title":"Phoenix.Template.find_all/3","type":"function"},{"doc":"Returns the format encoder for the given template name.","ref":"Phoenix.Template.html#format_encoder/1","title":"Phoenix.Template.format_encoder/1","type":"function"},{"doc":"Returns the hash of all template paths in the given root.Used by Phoenix to check if a given root path requires recompilation.","ref":"Phoenix.Template.html#hash/3","title":"Phoenix.Template.hash/3","type":"function"},{"doc":"Converts a module, without the suffix, to a template root.Examplesiex&gt; Phoenix.Template.module_to_template_root(MyApp.UserView, MyApp, &quot;View&quot;) &quot;user&quot; iex&gt; Phoenix.Template.module_to_template_root(MyApp.Admin.User, MyApp, &quot;View&quot;) &quot;admin/user&quot; iex&gt; Phoenix.Template.module_to_template_root(MyApp.Admin.User, MyApp.Admin, &quot;View&quot;) &quot;user&quot; iex&gt; Phoenix.Template.module_to_template_root(MyApp.View, MyApp, &quot;View&quot;) &quot;&quot; iex&gt; Phoenix.Template.module_to_template_root(MyApp.View, MyApp.View, &quot;View&quot;) &quot;&quot;","ref":"Phoenix.Template.html#module_to_template_root/3","title":"Phoenix.Template.module_to_template_root/3","type":"function"},{"doc":"Converts the template path into the template name.Examplesiex&gt; Phoenix.Template.template_path_to_name( ...&gt; &quot;lib/templates/admin/users/show.html.eex&quot;, ...&gt; &quot;lib/templates&quot;) &quot;admin/users/show.html&quot;","ref":"Phoenix.Template.html#template_path_to_name/2","title":"Phoenix.Template.template_path_to_name/2","type":"function"},{"doc":"","ref":"Phoenix.Template.html#t:name/0","title":"Phoenix.Template.name/0","type":"type"},{"doc":"","ref":"Phoenix.Template.html#t:path/0","title":"Phoenix.Template.path/0","type":"type"},{"doc":"","ref":"Phoenix.Template.html#t:root/0","title":"Phoenix.Template.root/0","type":"type"},{"doc":"The Phoenix engine that handles the .eex extension.","ref":"Phoenix.Template.EExEngine.html","title":"Phoenix.Template.EExEngine","type":"module"},{"doc":"Callback implementation for Phoenix.Template.Engine.compile/2.","ref":"Phoenix.Template.EExEngine.html#compile/2","title":"Phoenix.Template.EExEngine.compile/2","type":"function"},{"doc":"Specifies the API for adding custom template engines into Phoenix.Engines must implement the compile/2 function, that receives the template file and the template name and outputs the template quoted expression:def compile(template_path, template_name)See Phoenix.Template.EExEngine for an example engine implementation.","ref":"Phoenix.Template.Engine.html","title":"Phoenix.Template.Engine","type":"behaviour"},{"doc":"","ref":"Phoenix.Template.Engine.html#c:compile/2","title":"Phoenix.Template.Engine.compile/2","type":"callback"},{"doc":"The Phoenix engine that handles the .exs extension.","ref":"Phoenix.Template.ExsEngine.html","title":"Phoenix.Template.ExsEngine","type":"module"},{"doc":"Callback implementation for Phoenix.Template.Engine.compile/2.","ref":"Phoenix.Template.ExsEngine.html#compile/2","title":"Phoenix.Template.ExsEngine.compile/2","type":"function"},{"doc":"","ref":"Phoenix.ActionClauseError.html","title":"Phoenix.ActionClauseError","type":"exception"},{"doc":"Callback implementation for Exception.blame/2.","ref":"Phoenix.ActionClauseError.html#blame/2","title":"Phoenix.ActionClauseError.blame/2","type":"function"},{"doc":"Callback implementation for Exception.message/1.","ref":"Phoenix.ActionClauseError.html#message/1","title":"Phoenix.ActionClauseError.message/1","type":"function"},{"doc":"Raised when a key is expected to be present in the request parameters, but is not.This exception is raised by Phoenix.Controller.scrub_params/2 which:Checks to see if the required_key is present (can be empty)Changes all empty parameters to nils (&quot;&quot; -&gt; nil)If you are seeing this error, you should handle the error and surface it to the end user. It means that there is a parameter missing from the request.","ref":"Phoenix.MissingParamError.html","title":"Phoenix.MissingParamError","type":"exception"},{"doc":"Raised when one of the accept* headers is not accepted by the server.This exception is commonly raised by Phoenix.Controller.accepts/2 which negotiates the media types the server is able to serve with the contents the client is able to render.If you are seeing this error, you should check if you are listing the desired formats in your :accepts plug or if you are setting the proper accept header in the client. The exception contains the acceptable mime types in the accepts field.","ref":"Phoenix.NotAcceptableError.html","title":"Phoenix.NotAcceptableError","type":"exception"},{"doc":"Exception raised when the URI is malformed on matching.","ref":"Phoenix.Router.MalformedURIError.html","title":"Phoenix.Router.MalformedURIError","type":"exception"},{"doc":"Exception raised when no route is found.","ref":"Phoenix.Router.NoRouteError.html","title":"Phoenix.Router.NoRouteError","type":"exception"},{"doc":"Raised when the socket message is invalid.","ref":"Phoenix.Socket.InvalidMessageError.html","title":"Phoenix.Socket.InvalidMessageError","type":"exception"},{"doc":"Exception raised when a template cannot be found.","ref":"Phoenix.Template.UndefinedError.html","title":"Phoenix.Template.UndefinedError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Phoenix.Template.UndefinedError.html#message/1","title":"Phoenix.Template.UndefinedError.message/1","type":"function"},{"doc":"OverviewPhoenix is a web development framework written in Elixir which implements the server-side Model View Controller (MVC) pattern. Many of its components and concepts will seem familiar to those of us with experience in other web frameworks like Ruby on Rails or Python's Django.Phoenix provides the best of both worlds - high developer productivity and high application performance. It also has some interesting new twists like channels for implementing realtime features and pre-compiled templates for blazing speed.If you are already familiar with Elixir, great! If not, there are a number of places to learn. The Elixir guides and the Elixir learning resources page are two great places to start.The guides that you are currently looking at provide an overview of all parts that make Phoenix. Here is a rundown of what they provide:Introduction - the guides you are currently reading. They will cover how to get your first application up and runningGuides - in-depth guides covering the main components in Phoenix and Phoenix applicationsReal-time components - in-depth guides covering Phoenix's built-in real-time componentsTesting - in-depth guides about testingDeployment - in-depth guides about deploymentHow-to's - a collection of articles on how to achieve certain things with PhoenixIf you would prefer to read these guides as an EPUB click here!Note these guides are not a step-by-step introduction to Phoenix. If you want a more structured approach to learning the framework, we have a large community and many books, courses, and screencasts available. See our community page for a complete list.Let's get Phoenix installed.","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"InstallationIn order to build a Phoenix application, we will need a few dependencies installed in our Operating System:the Erlang VM and the Elixir programming languagea database - Phoenix recommends PostgreSQL but you can pick others or not use a database at allNode.JS for assets - which can be opt-out, especially if you are building APIsand other optional packages.Please take a look at this list and make sure to install anything necessary for your system. Having dependencies installed in advance can prevent frustrating problems later on.","ref":"installation.html","title":"Installation","type":"extras"},{"doc":"Phoenix is written in Elixir, and our application code will also be written in Elixir. We won't get far in a Phoenix app without it! The Elixir site maintains a great Installation Page to help.If we have just installed Elixir for the first time, we will need to install the Hex package manager as well. Hex is necessary to get a Phoenix app running (by installing dependencies) and to install any extra dependencies we might need along the way.Here's the command to install Hex (If you have Hex already installed, it will upgrade Hex to the latest version):$ mix local.hex","ref":"installation.html#elixir-1-6-or-later","title":"Installation - Elixir 1.6 or later","type":"extras"},{"doc":"Elixir code compiles to Erlang byte code to run on the Erlang virtual machine. Without Erlang, Elixir code has no virtual machine to run on, so we need to install Erlang as well.When we install Elixir using instructions from the Elixir Installation Page, we will usually get Erlang too. If Erlang was not installed along with Elixir, please see the Erlang Instructions section of the Elixir Installation Page for instructions.A note about Erlang and Phoenix: while Phoenix itself only requires Erlang 20 or later, one of Phoenix's dependencies, cowboy, depends on Erlang 22 or later since cowboy 2.8.0. It is recommended to either install Erlang 22 or add {:cowboy, &quot;~&gt; 2.7.0&quot;} to your mix.exs once your app has been created.","ref":"installation.html#erlang-20-or-later","title":"Installation - Erlang 20 or later","type":"extras"},{"doc":"To check that we are on Elixir 1.6 and Erlang 20 or later, run:elixir -v Erlang/OTP 20 [erts-9.3] [source] [64-bit] [smp:8:8] [async-threads:10] [hipe] [kernel-poll:false] [dtrace] Elixir 1.6.3Once we have Elixir and Erlang, we are ready to install the Phoenix application generator:$ mix archive.install hex phx_new 1.5.6We will use this generator to generate new applications in the next guide, called Up and Running.","ref":"installation.html#phoenix","title":"Installation - Phoenix","type":"extras"},{"doc":"Node is an optional dependency. Phoenix will use webpack to compile static assets (JavaScript, CSS, etc), by default. Webpack uses the node package manager (npm) to install its dependencies, and npm requires node.js.If we don't have any static assets, or we want to use another build tool, we can pass the --no-webpack flag when creating a new application and node won't be required at all.We can get node.js from the download page. When selecting a package to download, it's important to note that Phoenix requires version 5.0.0 or greater.Mac OS X users can also install node.js via homebrew.","ref":"installation.html#node-js","title":"Installation - node.js","type":"extras"},{"doc":"PostgreSQL is a relational database server. Phoenix configures applications to use it by default, but we can switch to MySQL or MSSQL by passing the --database flag when creating a new application.In order to talk to databases, Phoenix applications use another Elixir package, called Ecto. If you don't plan to use databases in your application, you can pass the --no-ecto flag.However, if you are just getting started with Phoenix, we recommend you to install PostgreSQL and make sure it is running. The PostgreSQL wiki has installation guides for a number of different systems.","ref":"installation.html#postgresql","title":"Installation - PostgreSQL","type":"extras"},{"doc":"Phoenix provides a very handy feature called Live Reloading. As you change your views or your assets, it automatically reloads the page in the browser. In order for this functionality to work, you need a filesystem watcher.Mac OS X and Windows users already have a filesystem watcher but Linux users must install inotify-tools. Please consult the inotify-tools wiki for distribution-specific installation instructions.","ref":"installation.html#inotify-tools-for-linux-users","title":"Installation - inotify-tools (for linux users)","type":"extras"},{"doc":"At the end of this section, you must have installed Elixir, Hex, Phoenix, PostgreSQL and node.js. Now that we have everything installed, let's create our first Phoenix application and get up and running.","ref":"installation.html#summary","title":"Installation - Summary","type":"extras"},{"doc":"Up and RunningLet's get a Phoenix application up and running as quickly as possible.Before we begin, please take a minute to read the Installation Guide. By installing any necessary dependencies beforehand, we'll be able to get our application up and running smoothly.We can run mix phx.new from any directory in order to bootstrap our Phoenix application. Phoenix will accept either an absolute or relative path for the directory of our new project. Assuming that the name of our application is hello, let's run the following command:$ mix phx.new helloA note about webpack before we begin: Phoenix will use webpack for asset management by default. Webpack's dependencies are installed via the node package manager, not mix. Phoenix will prompt us to install them at the end of the mix phx.new task. If we say &quot;no&quot; at that point, and if we don't install those dependencies later with npm install, our application will raise errors when we try to start it, and our assets may not load properly. If we don't want to use webpack at all, we can simply pass --no-webpack to mix phx.new.A note about Ecto: Ecto allows our Phoenix application to communicate with a data store, such as PostgreSQL, MySQL, and others. If our application will not require this component we can skip this dependency by passing the --no-ecto flag to mix phx.new. This flag may also be combined with --no-webpack to create a skeleton application.To learn more about mix phx.new you can read the Mix Tasks Guide.mix phx.new hello * creating hello/config/config.exs * creating hello/config/dev.exs * creating hello/config/prod.exs ... * creating hello/assets/static/images/phoenix.png * creating hello/assets/static/favicon.ico Fetch and install dependencies? [Yn]Phoenix generates the directory structure and all the files we will need for our application. Phoenix promotes the usage of git as version control software: among the generated files we find a .gitignore. We can git init our repository, and immediately add and commit all that hasn't been marked ignored. When it's done, it will ask us if we want it to install our dependencies for us. Let's say yes to that.Fetch and install dependencies? [Yn] Y * running mix deps.get * running mix deps.compile * running cd assets &amp;&amp; npm install &amp;&amp; node node_modules/webpack/bin/webpack.js --mode development We are almost there! The following steps are missing: $ cd hello Then configure your database in config/dev.exs and run: $ mix ecto.create Start your Phoenix app with: $ mix phx.server You can also run your app inside IEx (Interactive Elixir) as: $ iex -S mix phx.serverOnce our dependencies are installed, the task will prompt us to change into our project directory and start our application.Phoenix assumes that our PostgreSQL database will have a postgres user account with the correct permissions and a password of &quot;postgres&quot;. If that isn't the case, please see the Mix Tasks Guide to learn more about the mix ecto.create task.Ok, let's give it a try. First, we'll cd into the hello/ directory we've just created:$ cd helloIf you followed the Installation Guide and opted to add {:cowboy, &quot;~&gt; 2.7.0&quot;} to your mix.exs, go ahead and do that now and run mix deps.get.Now we'll create our database:$ mix ecto.create Compiling 13 files (.ex) Generated hello app The database for Hello.Repo has been createdIn case the database could not be created, see the guides for the mix ecto.create for general trouble-shooting.Note: if this is the first time you are running this command, Phoenix may also ask to install Rebar. Go ahead with the installation as Rebar is used to build Erlang packages.And finally, we'll start the Phoenix server:$ mix phx.server [info] Running HelloWeb.Endpoint with cowboy 2.5.0 at http://localhost:4000 Webpack is watching the files… ...If we choose not to have Phoenix install our dependencies when we generate a new application, the mix phx.new task will prompt us to take the necessary steps when we do want to install them.Fetch and install dependencies? [Yn] n We are almost there! The following steps are missing: $ cd hello $ mix deps.get $ cd assets &amp;&amp; npm install &amp;&amp; node node_modules/webpack/bin/webpack.js --mode development Then configure your database in config/dev.exs and run: $ mix ecto.create Start your Phoenix app with: $ mix phx.server You can also run your app inside IEx (Interactive Elixir) as: $ iex -S mix phx.serverBy default Phoenix accepts requests on port 4000. If we point our favorite web browser at http://localhost:4000, we should see the Phoenix Framework welcome page.If your screen looks like the image above, congratulations! You now have a working Phoenix application. In case you can't see the page above, try accessing it via http://127.0.0.1:4000 and later make sure your OS has defined &quot;localhost&quot; as &quot;127.0.0.1&quot;.To stop it, we hit ctrl-c twice.Now you are ready to explore the world provided by Phoenix! See our community page for books, screencasts, courses, and more.Alternatively, you can continue reading these guides to have a quick introduction into all the parts that make your Phoenix application. If that's the case, you can read the guides in any order or start with our guide that explains the Phoenix directory structure.","ref":"up_and_running.html","title":"Up and Running","type":"extras"},{"doc":"CommunityThe Elixir and Phoenix communities are friendly and welcoming. All questions and comments are valuable, so please come join the discussion!There are a number of places to connect with community members at all experience levels.We're on Freenode IRC in the #elixir-lang channel.Request an invitation and join the #phoenix channel on Slack.Read about bug reports or open an issue in the Phoenix issue tracker.Ask or answer questions about Phoenix on Elixir Forum or Stack Overflow.To discuss new features in the framework, email the phoenix-core mailing list.Follow the Phoenix Framework on Twitter.The source for these guides is on GitHub. To help improve the guides, please report an issue or open a pull request.","ref":"community.html","title":"Community","type":"extras"},{"doc":"Real-Time Phoenix - Build Highly Scalable Systems with Channels (by Stephen Bussey - 2020)Programming Phoenix 1.4 (by Bruce Tate and Phoenix core team members Chris McCord and José Valim - 2019)Phoenix in Action (by Geoffrey Lessel - 2019)Phoenix Inside Out - Book Series (by Shankar Dhanasekaran - 2017)Functional Web Development with Elixir, OTP, and Phoenix Rethink the Modern Web App (by Lance Halvorsen - 2017)","ref":"community.html#books","title":"Community - Books","type":"extras"},{"doc":"Phoenix LiveView Free Course (by The Pragmatic Studio - 2020)Groxio LiveView: Self Study Program (by Bruce Tate - 2020)The Complete Elixir and Phoenix Bootcamp Master Functional Programming Techniques with Elixir and Phoenix while Learning to Build Compelling Web Applications (by Stephen Grider - 2017)[Discover Elixir &amp; Phoenix (by Tristan Edwards2017)](https://www.ludu.co/course/discover-elixir-phoenix)Phoenix Framework Tutorial (by Tensor Programming - 2017)Getting Started with Phoenix (by Pluralsight - 2017)LearnPhoenix.tv: Learn how to Build Fast, Dependable Web Apps with Phoenix (2017)LearnPhoenix.io: Build Scalable, Real-Time Apps with Phoenix, React, and React Native (2016)","ref":"community.html#screencasts-courses","title":"Community - Screencasts/Courses","type":"extras"},{"doc":"Directory structureRequirement: This guide expects that you have gone through the introductory guides and got a Phoenix application up and running.When we use mix phx.new to generates a new Phoenix application, it builds a top-level directory structure like this:├── _build ├── assets ├── config ├── deps ├── lib │ └── hello │ └── hello.ex │ └── hello_web │ └── hello_web.ex ├── priv └── testWe will go over those directories one by one:_build - a directory created by the mix command line tool that ships as part of Elixir that holds all compilation artefacts. As we have seen in &quot;Up and Running&quot;, mix is the main interface to your application. We use Mix to compile our code, create databases, run our server, and more. This directory must not be checked into version control and it can be removed at any time. Removing it will force Mix to rebuild your application from scratchassets - a directory that keeps everything related to front-end assets, such as JavaScript, CSS, static images and more. It is typically handled by the npm tool. Phoenix developers typically only need to run npm install inside the assets directory. Everything else is managed by Phoenixconfig - a directory that holds your project configuration. The config/config.exs file is the main entry point for your configuration. At the end of the config/config.exs, it imports environment specific configuration, which can be found in config/dev.exs, config/test.exs, and config/prod.exsdeps - a directory with all of our Mix dependencies. You can find all dependencies listed in the mix.exs file, inside the def deps do function definition. This directory must not be checked into version control and it can be removed at any time. Removing it will force Mix to download all deps from scratchlib - a directory that holds your application source code. This directory is broken into two subdirectories, lib/hello and lib/hello_web. The lib/hello directory will be responsible to host all of your business logic and business domain. It typically interacts directly with the database - it is the &quot;Model&quot; in Model-View-Controller (MVC) architecture. lib/hello_web is responsible for exposing your business domain to the world, in this case, through a web application. It holds both the View and Controller from MVC. We will discuss the contents of these directories with more detail in the next sectionspriv - a directory that keeps all assets that are necessary in production but are not directly part of your source code. You typically keep database scripts, translation files, and more in heretest - a directory with all of our application tests. It often mirrors the same structure found in lib","ref":"directory_structure.html","title":"Directory structure","type":"extras"},{"doc":"The lib/hello directory hosts all of your business domain. Since our project does not have any business logic yet, the directory is mostly empty. You will only find two files:lib/hello ├── application.ex └── repo.exThe lib/hello/application.ex file defines an Elixir application named Hello.Application. That's because at the end of the day Phoenix applications are simply Elixir applications. The Hello.Application module defines which services are part of our application:children = [ # Start the Ecto repository Hello.Repo, # Start the Telemetry supervisor HelloWeb.Telemetry, # Start the PubSub system {Phoenix.PubSub, name: Hello.PubSub}, # Start the Endpoint (http/https) HelloWeb.Endpoint # Start a worker by calling: Hello.Worker.start_link(arg) # {Hello.Worker, arg} ]If it is your first time with Phoenix, you don't need to worry about the details right now. For now, suffice it to say our application starts a database repository, a pubsub system for sharing messages across processes and nodes, and the application endpoint, which effectively serves HTTP requests. These services are started in the order they are defined and, whenever shutting down your application, they are stopped in the reverse order.You can learn more about applications in Elixir's official docs for Application.In the same lib/hello directory, we will find a lib/hello/repo.ex. It defines a Hello.Repo module which is our main interface to the database. If you are using Postgres (the default), you will see something like this:defmodule Hello.Repo do use Ecto.Repo, otp_app: :hello, adapter: Ecto.Adapters.Postgres endAnd that's it for now. As you work on your project, we will add files and modules to this directory.","ref":"directory_structure.html#the-lib-hello-directory","title":"Directory structure - The lib/hello directory","type":"extras"},{"doc":"The lib/hello_web directory holds the web-related parts of our application. It looks like this when expanded:lib/hello_web ├── channels │ └── user_socket.ex ├── controllers │ └── page_controller.ex ├── templates │ ├── layout │ │ └── app.html.eex │ └── page │ └── index.html.eex ├── views │ ├── error_helpers.ex │ ├── error_view.ex │ ├── layout_view.ex │ └── page_view.ex ├── endpoint.ex ├── gettext.ex ├── router.ex └── telemetry.exAll of the files which are currently in the controllers, templates, and views directories are there to create the &quot;Welcome to Phoenix!&quot; page we saw in the &quot;Up and running&quot; guide. The channels directory is where we will add code related to building real-time Phoenix applications.By looking at templates and views directories, we can see Phoenix provides features for handling layouts and error pages out of the box.Besides the directories mentioned, lib/hello_web has four files at its root. lib/hello_web/endpoint.ex is the entry-point for HTTP requests. Once the browser accesses http://localhost:4000, the endpoint starts processing the data, eventually leading to the router, which is defined in lib/hello_web/router.ex. The router defines the rules to dispatch requests to &quot;controllers&quot;, which then uses &quot;views&quot; and &quot;templates&quot; to render HTML pages back to clients. We explore these layers in length in other guides, starting with the &quot;Request life-cycle&quot; guide coming next.Through telemetry, Phoenix is able to collect metrics and send monitoring events of your application. The lib/hello_web/telemetry.ex file defines the supervisor responsible for managing the telemetry processes. You can find more information on this topic in the Telemetry guide.Finally, there is a lib/hello_web/gettext.ex file which provides internationalization through Gettext. If you are not worried about internationalization, you can safely skip this file and its contents.","ref":"directory_structure.html#the-lib-hello_web-directory","title":"Directory structure - The lib/hello_web directory","type":"extras"},{"doc":"Request life-cycleRequirement: This guide expects that you have gone through the introductory guides and got a Phoenix application up and running.The goal of this guide is to talk about Phoenix's request life-cycle. This guide will take a practical approach where we will learn by doing: we will add two new pages to our Phoenix project and comment on how the pieces fit together along the way.Let's get on with our first new Phoenix page!","ref":"request_lifecycle.html","title":"Request life-cycle","type":"extras"},{"doc":"When your browser accesses http://localhost:4000/, it sends a HTTP request to whatever service is running on that address, in this case our Phoenix application. The HTTP request is made of a verb and a path. For example, the following browser requests translate into:Browser address barVerbPathhttp://localhost:4000/GET/http://localhost:4000/helloGET/hellohttp://localhost:4000/hello/worldGET/hello/worldThere are other HTTP verbs. For example, submitting a form typically uses the POST verb.Web applications typically handle requests by mapping each verb/path pair into a specific part of your application. This matching in Phoenix is done by the router. For example, we may map &quot;/articles&quot; to a portion of our application that shows all articles. Therefore, to add a new page, our first task is to add new route.A new routeThe router maps unique HTTP verb/path pairs to controller/action pairs which will handle them. Controllers in Phoenix are simply Elixir modules. Actions are functions that are defined within these controllers.Phoenix generates a router file for us in new applications at lib/hello_web/router.ex. This is where we will be working for this section.The route for our &quot;Welcome to Phoenix!&quot; page from the previous Up And Running Guide looks like this.get &quot;/&quot;, PageController, :indexLet's digest what this route is telling us. Visiting http://localhost:4000/ issues an HTTP GET request to the root path. All requests like this will be handled by the index function in the HelloWeb.PageController module defined in lib/hello_web/controllers/page_controller.ex.The page we are going to build will simply say &quot;Hello World, from Phoenix!&quot; when we point our browser to http://localhost:4000/hello.The first thing we need to do to create that page is define a route for it. Let's open up lib/hello_web/router.ex in a text editor. For a brand new application, it looks like this:defmodule HelloWeb.Router do use HelloWeb, :router pipeline :browser do plug :accepts, [&quot;html&quot;] plug :fetch_session plug :fetch_flash plug :protect_from_forgery plug :put_secure_browser_headers end pipeline :api do plug :accepts, [&quot;json&quot;] end scope &quot;/&quot;, HelloWeb do pipe_through :browser get &quot;/&quot;, PageController, :index end # Other scopes may use custom stacks. # scope &quot;/api&quot;, HelloWeb do # pipe_through :api # end end For now, we'll ignore the pipelines and the use of scope here and just focus on adding a route. We will discuss those in the Routing guide.Let's add a new route to the router that maps a GET request for /hello to the index action of a soon-to-be-created HelloWeb.HelloController inside the scope &quot;/&quot; do block of the router:scope &quot;/&quot;, HelloWeb do pipe_through :browser get &quot;/&quot;, PageController, :index get &quot;/hello&quot;, HelloController, :index endA new ControllerControllers are Elixir modules, and actions are Elixir functions defined in them. The purpose of actions is to gather any data and perform any tasks needed for rendering. Our route specifies that we need a HelloWeb.HelloController module with an index/2 action.To make that happen, let's create a new lib/hello_web/controllers/hello_controller.ex file, and make it look like the following:defmodule HelloWeb.HelloController do use HelloWeb, :controller def index(conn, _params) do render(conn, &quot;index.html&quot;) end endWe'll save a discussion of use HelloWeb, :controller for the Controllers Guide. For now, let's focus on the index/2 action.All controller actions take two arguments. The first is conn, a struct which holds a ton of data about the request. The second is params, which are the request parameters. Here, we are not using params, and we avoid compiler warnings by adding the leading _.The core of this action is render(conn, &quot;index.html&quot;). It tells Phoenix to render &quot;index.html&quot;. The modules responsible for rendering are views. By default, Phoenix views are named after the controller, so Phoenix is expecting a HelloWeb.HelloView to exist and handle &quot;index.html&quot; for us.Note: Using an atom as the template name also works render(conn, :index). In these cases, the template will be chosen based off the Accept headers, e.g. &quot;index.html&quot; or &quot;index.json&quot;.A new ViewPhoenix views act as the presentation layer. For example, we expect the output of rendering &quot;index.html&quot; to be a complete HTML page. To make our lives easier, we often use templates for creating those HTML pages.Let's create a new view. Create lib/hello_web/views/hello_view.ex and make it look like this:defmodule HelloWeb.HelloView do use HelloWeb, :view endNow in order to add templates to this view, we simply need to add files to the lib/hello_web/templates/hello directory. Note the controller name (HelloController), the view name (HelloView), and the template directory (hello) all follow the same naming convention and are named after each other.A template file has the following structure: NAME.FORMAT.TEMPLATING_LANGUAGE. In our case, we will create a &quot;index.html.eex&quot; file at &quot;lib/hello_web/templates/hello/index.html.eex&quot;. &quot;.eex&quot; stands for EEx, which is a library for embedding Elixir that ships as part of Elixir itself. Phoenix enhances EEx to include automatic escaping of values. This protects you from security vulnerabilities like Cross-Site-Scripting with no extra work on your part.Create lib/hello_web/templates/hello/index.html.eex and make it look like this:&lt;div class=&quot;phx-hero&quot;&gt; &lt;h2&gt;Hello World, from Phoenix!&lt;/h2&gt; &lt;/div&gt;Now that we've got the route, controller, view, and template, we should be able to point our browsers at http://localhost:4000/hello and see our greeting from Phoenix! (In case you stopped the server along the way, the task to restart it is mix phx.server.)There are a couple of interesting things to notice about what we just did. We didn't need to stop and re-start the server while we made these changes. Yes, Phoenix has hot code reloading! Also, even though our index.html.eex file consisted of only a single div tag, the page we get is a full HTML document. Our index template is rendered into the application layout - lib/hello_web/templates/layout/app.html.eex. If you open it, you'll see a line that looks like this:&lt;%= @inner_content %&gt;which injects our template into the layout before the HTML is sent off to the browser.A note on hot code reloading: Some editors with their automatic linters may prevent hot code reloading from working. If it's not working for you, please see the discussion in this issue.","ref":"request_lifecycle.html#adding-a-new-page","title":"Request life-cycle - Adding a new page","type":"extras"},{"doc":"As we built our first page, we could start to understand how the request life-cycle is put together. Now let's take a more holistic look at it.All HTTP requests start in our application endpoint. You can find it as a module named HelloWeb.Endpoint in lib/hello_web/endpoint.ex. Once you open up the endpoint file, you will see that, similar to the router, the endpoint has many calls to plug. Plug is a library and specification for stitching web applications together. It is an essential part of how Phoenix handles requests and we will discuss it in detail in the Plug guide coming next.For now, it suffices to say that each Plug defines a slice of request processing. In the endpoint you will find a skeleton roughly like this:defmodule HelloWeb.Endpoint do use Phoenix.Endpoint, otp_app: :demo plug Plug.Static, ... plug Plug.RequestId plug Plug.Telemetry, ... plug Plug.Parsers, ... plug Plug.MethodOverride plug Plug.Head plug Plug.Session, ... plug HelloWeb.Router endEach of these plugs have a specific responsibility that we will learn later. The last plug is precisely the HelloWeb.Router module. This allows the endpoint to delegate all further request processing to the router. As we now know, its main responsibility is to map verb/path pairs to controllers. The controller then tells a view to render a template.At this moment, you may be thinking this can be a lot of steps to simply render a page. However, as our application grows in complexity, we will see that each layer serves a distinct purpose:endpoint (Phoenix.Endpoint) - the endpoint contains the common and initial path that all requests go through. If you want something to happen on all requests, it goes to the endpointrouter (Phoenix.Router) - the router is responsible for dispatching verb/path to controllers. The router also allows us to scope functionality. For example, some pages in your application may require user authentication, others may notcontroller (Phoenix.Controller) - the job of the controller is to retrieve request information, talk to your business domain, and prepare data for the presentation layerview (Phoenix.View) - the view handles the structured data from the controller and converts it to a presentation to be shown to usersLet's do a quick recap and how the last three components work together by adding another page.","ref":"request_lifecycle.html#from-endpoint-to-views","title":"Request life-cycle - From endpoint to views","type":"extras"},{"doc":"Let's add just a little complexity to our application. We're going to add a new page that will recognize a piece of the URL, label it as a &quot;messenger&quot; and pass it through the controller into the template so our messenger can say hello.As we did last time, the first thing we'll do is create a new route.Another new RouteFor this exercise, we're going to re-use the HelloController we just created and just add a new show action. We'll add a line just below our last route, like this:scope &quot;/&quot;, HelloWeb do pipe_through :browser get &quot;/&quot;, PageController, :index get &quot;/hello&quot;, HelloController, :index get &quot;/hello/:messenger&quot;, HelloController, :show endNotice that we use the :messenger syntax in the path. Phoenix will take whatever value that appears in that position in the URL and convert it into a parameter. For example, if we point the browser at: http://localhost:4000/hello/Frank, the value of &quot;messenger&quot; will be &quot;Frank&quot;.Another new ActionRequests to our new route will be handled by the HelloWeb.HelloController show action. We already have the controller at lib/hello_web/controllers/hello_controller.ex, so all we need to do is edit that file and add a show action to it. This time, we'll need to extract the messenger from the parameters so that we can pass it (the messenger) to the template. To do that, we add this show function to the controller:def show(conn, %{&quot;messenger&quot; =&gt; messenger}) do render(conn, &quot;show.html&quot;, messenger: messenger) endWithin the body of the show action, we also pass a third argument into the render function, a key/value pair where :messenger is the key, and the messenger variable is passed as the value.If the body of the action needs access to the full map of parameters bound to the params variable in addition to the bound messenger variable, we could define show/2 like this:def show(conn, %{&quot;messenger&quot; =&gt; messenger} = params) do ... endIt's good to remember that the keys to the params map will always be strings, and that the equals sign does not represent assignment, but is instead a pattern match assertion.Another new TemplateFor the last piece of this puzzle, we'll need a new template. Since it is for the show action of the HelloController, it will go into the lib/hello_web/templates/hello directory and be called show.html.eex. It will look surprisingly like our index.html.eex template, except that we will need to display the name of our messenger.To do that, we'll use the special EEx tags for executing Elixir expressions - &lt;%= %&gt;. Notice that the initial tag has an equals sign like this: &lt;%= . That means that any Elixir code that goes between those tags will be executed, and the resulting value will replace the tag. If the equals sign were missing, the code would still be executed, but the value would not appear on the page.And this is what the template should look like:&lt;div class=&quot;phx-hero&quot;&gt; &lt;h2&gt;Hello World, from &lt;%= @messenger %&gt;!&lt;/h2&gt; &lt;/div&gt;Our messenger appears as @messenger. We call &quot;assigns&quot; the values passed from the controller to views. It is a special bit of metaprogrammed syntax which stands in for assigns.messenger. The result is much nicer on the eyes and much easier to work with in a template.We're done. If you point your browser here: http://localhost:4000/hello/Frank, you should see a page that looks like this:Play around a bit. Whatever you put after /hello/ will appear on the page as your messenger.","ref":"request_lifecycle.html#another-new-page","title":"Request life-cycle - Another New Page","type":"extras"},{"doc":"PlugRequirement: This guide expects that you have gone through the introductory guides and got a Phoenix application up and running.Requirement: This guide expects that you have gone through the Request life-cycle guide.Plug lives at the heart of Phoenix's HTTP layer, and Phoenix puts Plug front and center. We interact with plugs at every step of the request life-cycle, and the core Phoenix components like Endpoints, Routers, and Controllers are all just Plugs internally. Let's jump in and find out just what makes Plug so special.Plug is a specification for composable modules in between web applications. It is also an abstraction layer for connection adapters of different web servers. The basic idea of Plug is to unify the concept of a &quot;connection&quot; that we operate on. This differs from other HTTP middleware layers such as Rack, where the request and response are separated in the middleware stack.At the simplest level, the Plug specification comes in two flavors: function plugs and module plugs.","ref":"plug.html","title":"Plug","type":"extras"},{"doc":"In order to act as a Plug, a function needs to accept a connection struct (%Plug.Conn{}) and options. It also needs to return a connection struct. Any function that meets those criteria will do. Here's an example.def introspect(conn, _opts) do IO.puts &quot;&quot;&quot; Verb: \#{inspect(conn.method)} Host: \#{inspect(conn.host)} Headers: \#{inspect(conn.req_headers)} &quot;&quot;&quot; conn endThis function does the following:It receives a connection and options (that we do not use)It prints some connection information to the terminalIt returns the connectionPretty simple, right? Let's see this function in action by adding it to our endpoint in lib/hello_web/endpoint.ex. We can plug it anywhere, so let's do it before we delegate the request to the router:defmodule HelloWeb.Endpoint do ... plug :introspect plug HelloWeb.Router def introspect(conn, _opts) do IO.puts &quot;&quot;&quot; Verb: \#{inspect(conn.method)} Host: \#{inspect(conn.host)} Headers: \#{inspect(conn.req_headers)} &quot;&quot;&quot; conn end endFunction plugs are plugged by passing the function name as an atom. To try the Plug out, go back to your browser and fetch &quot;http://localhost:4000&quot;. You should see something like this printed in your terminal:Verb: &quot;GET&quot; Host: &quot;localhost&quot; Headers: [...]Our Plug simply prints information from the connection. Although our initial Plug is very simple, you can virtually do anything you want inside of it. To learn about all fields available in the connection and all of the functionality associated to it, see the documentation for Plug.Conn.Now let's look at the other flavor plugs come in, module plugs.","ref":"plug.html#function-plugs","title":"Plug - Function Plugs","type":"extras"},{"doc":"Module plugs are another type of Plug that let us define a connection transformation in a module. The module only needs to implement two functions:init/1 which initializes any arguments or options to be passed to call/2call/2 which carries out the connection transformation. call/2 is just a function plug that we saw earlierTo see this in action, let's write a module plug that puts the :locale key and value into the connection assign for downstream use in other plugs, controller actions, and our views. Put the contents above to a file named &quot;lib/hello_web/plugs/locale.ex&quot;:defmodule HelloWeb.Plugs.Locale do import Plug.Conn @locales [&quot;en&quot;, &quot;fr&quot;, &quot;de&quot;] def init(default), do: default def call(%Plug.Conn{params: %{&quot;locale&quot; =&gt; loc}} = conn, _default) when loc in @locales do assign(conn, :locale, loc) end def call(conn, default) do assign(conn, :locale, default) end endTo give it a try, let's add this plug to our router:defmodule HelloWeb.Router do use HelloWeb, :router pipeline :browser do plug :accepts, [&quot;html&quot;] plug :fetch_session plug :fetch_flash plug :protect_from_forgery plug :put_secure_browser_headers plug HelloWeb.Plugs.Locale, &quot;en&quot; end ...We are able to add this module plug to our browser pipeline via plug HelloWeb.Plugs.Locale, &quot;en&quot;. In the init/1 callback, we pass a default locale to use if none is present in the params. We also use pattern matching to define multiple call/2 function heads to validate the locale in the params, and fall back to &quot;en&quot; if there is no match.To see the assign in action, go to the layout in &quot;lib/hello_web/templates/layout/app.html.eex&quot; and add the following close to the main container:&lt;main role=&quot;main&quot; class=&quot;container&quot;&gt; &lt;p&gt;Locale: &lt;%= @locale %&gt;&lt;/p&gt;Go to &quot;http://localhost:4000/&quot; and you should see the locale exhibited. Visit &quot;http://localhost:4000/?locale=fr&quot; and you should see the assign changed to &quot;fr&quot;. Someone can use this information alongside Gettext to provide a fully internationalized web application.That's all there is to Plug. Phoenix embraces the plug design of composable transformations all the way up and down the stack. Let's see some examples!","ref":"plug.html#module-plugs","title":"Plug - Module Plugs","type":"extras"},{"doc":"The endpoint, router, and controllers in Phoenix accept plugs.Endpoint plugsEndpoints organize all the plugs common to every request, and apply them before dispatching into the router with its custom pipelines. We added a plug to the endpoint like this:defmodule HelloWeb.Endpoint do ... plug :introspect plug HelloWeb.RouterThe default Endpoint plugs do quite a lot of work. Here they are in order:Plug.Static - serves static assets. Since this plug comes before the logger, serving of static assets is not loggedPhoenix.CodeReloader - a plug that enables code reloading for all entries in the web directory. It is configured directly in the Phoenix applicationPlug.RequestId - generates a unique request id for each request.Plug.Telemetry - adds instrumentation points so Phoenix can log the request path, status code and request time by default.Plug.Parsers - parses the request body when a known parser is available. By default parsers parse urlencoded, multipart and json (with jason). The request body is left untouched when the request content-type cannot be parsedPlug.MethodOverride - converts the request method to PUT, PATCH or DELETE for POST requests with a valid _method parameterPlug.Head - converts HEAD requests to GET requests and strips the response bodyPlug.Session - a plug that sets up session management. Note that fetch_session/2 must still be explicitly called before using the session as this Plug just sets up how the session is fetchedIn the middle of the endpoint, there is also a conditional block: if code_reloading? do socket &quot;/phoenix/live_reload/socket&quot;, Phoenix.LiveReloader.Socket plug Phoenix.LiveReloader plug Phoenix.CodeReloader plug Phoenix.Ecto.CheckRepoStatus, otp_app: :demo endThis block is only executed in development. It enables live reloading (if you change a CSS file, they are updated in-browser without refreshing the page), code reloading (so we can see changes to our application without restarting the server), and check repo status (which makes sure our database is up to date, raising readable and actionable error otherwise).Router plugsIn the router, we can declare plugs inside pipelines:defmodule HelloWeb.Router do use HelloWeb, :router pipeline :browser do plug :accepts, [&quot;html&quot;] plug :fetch_session plug :fetch_flash plug :protect_from_forgery plug :put_secure_browser_headers plug HelloWeb.Plugs.Locale, &quot;en&quot; end scope &quot;/&quot;, HelloWeb do pipe_through :browser get &quot;/&quot;, PageController, :index endRoutes are defined inside scopes and scopes may pipe through multiple pipelines. Once a route matches, Phoenix invokes all plugs defined in all pipelines associated to that route. For example, accessing &quot;/&quot; will pipe through the :browser pipeline, consequently invoking all of its plugs.As we will see in the Routing guide, the pipelines themselves are plugs. There we will also discuss all plugs in the :browser pipeline.Controller plugsFinally, controllers are plugs too, so we can do:defmodule HelloWeb.HelloController do use HelloWeb, :controller plug HelloWeb.Plugs.Locale, &quot;en&quot;In particular, controller plugs provide a feature that allows us to execute plugs only within certain actions. For example, you can do:defmodule HelloWeb.HelloController do use HelloWeb, :controller plug HelloWeb.Plugs.Locale, &quot;en&quot; when action in [:index]And the plug will only be executed for the index action.","ref":"plug.html#where-to-plug","title":"Plug - Where to plug","type":"extras"},{"doc":"By abiding by the plug contract, we turn an application request into a series of explicit transformations. It doesn't stop there. To really see how effective Plug's design is, let's imagine a scenario where we need to check a series of conditions and then either redirect or halt if a condition fails. Without plug, we would end up with something like this:defmodule HelloWeb.MessageController do use HelloWeb, :controller def show(conn, params) do case Authenticator.find_user(conn) do {:ok, user} -&gt; case find_message(params[&quot;id&quot;]) do nil -&gt; conn |&gt; put_flash(:info, &quot;That message wasn&#39;t found&quot;) |&gt; redirect(to: &quot;/&quot;) message -&gt; if Authorizer.can_access?(user, message) do render(conn, :show, page: message) else conn |&gt; put_flash(:info, &quot;You can&#39;t access that page&quot;) |&gt; redirect(to: &quot;/&quot;) end end :error -&gt; conn |&gt; put_flash(:info, &quot;You must be logged in&quot;) |&gt; redirect(to: &quot;/&quot;) end end endNotice how just a few steps of authentication and authorization require complicated nesting and duplication? Let's improve this with a couple of plugs.defmodule HelloWeb.MessageController do use HelloWeb, :controller plug :authenticate plug :fetch_message plug :authorize_message def show(conn, params) do render(conn, :show, page: conn.assigns[:message]) end defp authenticate(conn, _) do case Authenticator.find_user(conn) do {:ok, user} -&gt; assign(conn, :user, user) :error -&gt; conn |&gt; put_flash(:info, &quot;You must be logged in&quot;) |&gt; redirect(to: &quot;/&quot;) |&gt; halt() end end defp fetch_message(conn, _) do case find_message(conn.params[&quot;id&quot;]) do nil -&gt; conn |&gt; put_flash(:info, &quot;That message wasn&#39;t found&quot;) |&gt; redirect(to: &quot;/&quot;) |&gt; halt() message -&gt; assign(conn, :message, message) end end defp authorize_message(conn, _) do if Authorizer.can_access?(conn.assigns[:user], conn.assigns[:message]) do conn else conn |&gt; put_flash(:info, &quot;You can&#39;t access that page&quot;) |&gt; redirect(to: &quot;/&quot;) |&gt; halt() end end endTo make this all work, we converted the nested blocks of code and used halt(conn) whenever we reached a failure path. The halt(conn) functionality is essential here: it tells Plug that the next plug should not be invoked.At the end of the day, by replacing the nested blocks of code with a flattened series of plug transformations, we are able to achieve the same functionality in a much more composable, clear, and reusable way.To learn more about Plugs, see the documentation for the Plug project, which provides many built-in plugs and functionalities.","ref":"plug.html#plugs-as-composition","title":"Plug - Plugs as composition","type":"extras"},{"doc":"RoutingRequirement: This guide expects that you have gone through the introductory guides and got a Phoenix application up and running.Requirement: This guide expects that you have gone through the Request life-cycle guide.Routers are the main hubs of Phoenix applications. They match HTTP requests to controller actions, wire up real-time channel handlers, and define a series of pipeline transformations scoped to a set of routes.The router file that Phoenix generates, lib/hello_web/router.ex, will look something like this one:defmodule HelloWeb.Router do use HelloWeb, :router pipeline :browser do plug :accepts, [&quot;html&quot;] plug :fetch_session plug :fetch_flash plug :protect_from_forgery plug :put_secure_browser_headers end pipeline :api do plug :accepts, [&quot;json&quot;] end scope &quot;/&quot;, HelloWeb do pipe_through :browser get &quot;/&quot;, PageController, :index end # Other scopes may use custom stacks. # scope &quot;/api&quot;, HelloWeb do # pipe_through :api # end endBoth the router and controller module names will be prefixed with the name you gave your application instead of HelloWeb.The first line of this module, use HelloWeb, :router, simply makes Phoenix router functions available in our particular router.Scopes have their own section in this guide, so we won't spend time on the scope &quot;/&quot;, HelloWeb do block here. The pipe_through :browser line will get a full treatment in the Pipeline section of this guide. For now, you only need to know that pipelines allow a set of plugs to be applied to different sets of routes.Inside the scope block, however, we have our first actual route:get &quot;/&quot;, PageController, :indexget is a Phoenix macro that corresponds to the HTTP verb GET. Similar macros exist for other HTTP verbs including POST, PUT, PATCH, DELETE, OPTIONS, CONNECT, TRACE and HEAD.","ref":"routing.html","title":"Routing","type":"extras"},{"doc":"Phoenix provides a great tool for investigating routes in an application: mix phx.routes.Let's see how this works. Go to the root of a newly-generated Phoenix application and run mix phx.routes. You should see something like the following, generated with all routes you currently have:$ mix phx.routes page_path GET / HelloWeb.PageController :indexThe route above tells us that any HTTP GET request for the root of the application will be handled by the index action of the HelloWeb.PageController.page_path is an example of what Phoenix calls a path helper, and we'll talk about those very soon.","ref":"routing.html#examining-routes","title":"Routing - Examining Routes","type":"extras"},{"doc":"The router supports other macros besides those for HTTP verbs like get, post, and put. The most important among them is resources. Let's add a resource to our lib/hello_web/router.ex file like this:scope &quot;/&quot;, HelloWeb do pipe_through :browser get &quot;/&quot;, PageController, :index resources &quot;/users&quot;, UserController endFor now it doesn't matter that we don't actually have a HelloWeb.UserController.Run mix phx.routes once again at the root of your project. You should see something like the following:user_path GET /users HelloWeb.UserController :index user_path GET /users/:id/edit HelloWeb.UserController :edit user_path GET /users/new HelloWeb.UserController :new user_path GET /users/:id HelloWeb.UserController :show user_path POST /users HelloWeb.UserController :create user_path PATCH /users/:id HelloWeb.UserController :update PUT /users/:id HelloWeb.UserController :update user_path DELETE /users/:id HelloWeb.UserController :deleteThis is the standard matrix of HTTP verbs, paths, and controller actions. For a while, this was known as RESTful routes, but most consider this a misnomer nowadays. Let's look at them individually, in a slightly different order.A GET request to /users will invoke the index action to show all the users.A GET request to /users/new will invoke the new action to present a form for creating a new user.A GET request to /users/:id will invoke the show action with an id to show an individual user identified by that ID.A POST request to /users will invoke the create action to save a new user to the data store.A GET request to /users/:id/edit will invoke the edit action with an ID to retrieve an individual user from the data store and present the information in a form for editing.A PATCH request to /users/:id will invoke the update action with an ID to save the updated user to the data store.A PUT request to /users/:id will also invoke the update action with an ID to save the updated user to the data store.A DELETE request to /users/:id will invoke the delete action with an ID to remove the individual user from the data store.If we don't feel that we need all of these routes, we can be selective using the :only and :except options to filter certain actions.Let's say we have a read-only posts resource. We could define it like this:resources &quot;/posts&quot;, PostController, only: [:index, :show]Running mix phx.routes shows that we now only have the routes to the index and show actions defined.post_path GET /posts HelloWeb.PostController :index post_path GET /posts/:id HelloWeb.PostController :showSimilarly, if we have a comments resource, and we don't want to provide a route to delete one, we could define a route like this.resources &quot;/comments&quot;, CommentController, except: [:delete]Running mix phx.routes now shows that we have all the routes except the DELETE request to the delete action.comment_path GET /comments HelloWeb.CommentController :index comment_path GET /comments/:id/edit HelloWeb.CommentController :edit comment_path GET /comments/new HelloWeb.CommentController :new comment_path GET /comments/:id HelloWeb.CommentController :show comment_path POST /comments HelloWeb.CommentController :create comment_path PATCH /comments/:id HelloWeb.CommentController :update PUT /comments/:id HelloWeb.CommentController :updateThe Phoenix.Router.resources/4 macro describes additional options for customizing resource routes.","ref":"routing.html#resources","title":"Routing - Resources","type":"extras"},{"doc":"Path helpers are functions which are dynamically defined on the Router.Helpers module for an individual application. For us, that is HelloWeb.Router.Helpers. Their name of each path helper is derived from the name of the controller used in the route definition. Our controller is HelloWeb.PageController, and page_path is the function which will return the path to the root of our application.That's a mouthful. Let's see it in action. Run iex -S mix at the root of the project. When we call the page_path function on our router helpers with the Endpoint or connection and action as arguments, it returns the path to us.iex&gt; HelloWeb.Router.Helpers.page_path(HelloWeb.Endpoint, :index) &quot;/&quot;This is significant because we can use the page_path function in a template to link to the root of our application. We can then use this helper in our templates:&lt;%= link &quot;Welcome Page!&quot;, to: Routes.page_path(@conn, :index) %&gt;The reason we can use Routes.page_path instead of the full HelloWeb.Router.Helpers.page_path name is because HelloWeb.Router.Helpers is aliased as Routes by default in the view/0 block defined inside lib/hello_web.ex. This definition is made available to our templates through use HelloWeb, :view.We can, of course, use HelloWeb.Router.Helpers.page_path(@conn, :index) instead, but the convention is to use the aliased version for conciseness. Note that the alias is only set automatically for use in views, controllers and templates - outside these you need either the full name, or to alias it yourself inside the module definition with alias HelloWeb.Router.Helpers, as: Routes.Using path helpers makes it easy to ensure our controllers, views and templates are linking to pages our router can actually handle.More on Path HelpersWhen we ran mix phx.routes for our user resource, it listed the user_path as the path helper function for each line of output. Here is what that translates to for each action:iex&gt; alias HelloWeb.Router.Helpers, as: Routes iex&gt; alias HelloWeb.Endpoint iex&gt; Routes.user_path(Endpoint, :index) &quot;/users&quot; iex&gt; Routes.user_path(Endpoint, :show, 17) &quot;/users/17&quot; iex&gt; Routes.user_path(Endpoint, :new) &quot;/users/new&quot; iex&gt; Routes.user_path(Endpoint, :create) &quot;/users&quot; iex&gt; Routes.user_path(Endpoint, :edit, 37) &quot;/users/37/edit&quot; iex&gt; Routes.user_path(Endpoint, :update, 37) &quot;/users/37&quot; iex&gt; Routes.user_path(Endpoint, :delete, 17) &quot;/users/17&quot;What about paths with query strings? By adding an optional fourth argument of key value pairs, the path helpers will return those pairs in the query string.iex&gt; Routes.user_path(Endpoint, :show, 17, admin: true, active: false) &quot;/users/17?admin=true&amp;active=false&quot;What if we need a full url instead of a path? Just replace _path with _url:iex(3)&gt; Routes.user_url(Endpoint, :index) &quot;http://localhost:4000/users&quot;The _url functions will get the host, port, proxy port, and SSL information needed to construct the full URL from the configuration parameters set for each environment. We'll talk about configuration in more detail in its own guide. For now, you can take a look at config/dev.exs file in your own project to see those values.Whenever possible prefer to pass a conn (or @conn in your views) in place of an Endpoint.","ref":"routing.html#path-helpers","title":"Routing - Path Helpers","type":"extras"},{"doc":"It is also possible to nest resources in a Phoenix router. Let's say we also have a posts resource which has a many-to-one relationship with users. That is to say, a user can create many posts, and an individual post belongs to only one user. We can represent that by adding a nested route in lib/hello_web/router.ex like this:resources &quot;/users&quot;, UserController do resources &quot;/posts&quot;, PostController endWhen we run mix phx.routes now, in addition to the routes we saw for users above, we get the following set of routes:... user_post_path GET /users/:user_id/posts HelloWeb.PostController :index user_post_path GET /users/:user_id/posts/:id/edit HelloWeb.PostController :edit user_post_path GET /users/:user_id/posts/new HelloWeb.PostController :new user_post_path GET /users/:user_id/posts/:id HelloWeb.PostController :show user_post_path POST /users/:user_id/posts HelloWeb.PostController :create user_post_path PATCH /users/:user_id/posts/:id HelloWeb.PostController :update PUT /users/:user_id/posts/:id HelloWeb.PostController :update user_post_path DELETE /users/:user_id/posts/:id HelloWeb.PostController :deleteWe see that each of these routes scopes the posts to a user ID. For the first one, we will invoke the PostController index action, but we will pass in a user_id. This implies that we would display all the posts for that individual user only. The same scoping applies for all these routes.When calling path helper functions for nested routes, we will need to pass the IDs in the order they came in the route definition. For the following show route, 42 is the user_id, and 17 is the post_id. Let's remember to alias our HelloWeb.Endpoint before we begin.iex&gt; alias HelloWeb.Endpoint iex&gt; HelloWeb.Router.Helpers.user_post_path(Endpoint, :show, 42, 17) &quot;/users/42/posts/17&quot;Again, if we add a key/value pair to the end of the function call, it is added to the query string.iex&gt; HelloWeb.Router.Helpers.user_post_path(Endpoint, :index, 42, active: true) &quot;/users/42/posts?active=true&quot;If we had aliased the Helpers module as before (it is only automatically aliased for views, templates and controllers, in this case, since we're inside iex we need to do it ourselves), we could instead do:iex&gt; alias HelloWeb.Router.Helpers, as: Routes iex&gt; alias HelloWeb.Endpoint iex&gt; Routes.user_post_path(Endpoint, :index, 42, active: true) &quot;/users/42/posts?active=true&quot;","ref":"routing.html#nested-resources","title":"Routing - Nested Resources","type":"extras"},{"doc":"Scopes are a way to group routes under a common path prefix and scoped set of plugs. We might want to do this for admin functionality, APIs, and especially for versioned APIs. Let's say we have user generated reviews on a site, and that those reviews first need to be approved by an admin. The semantics of these resources are quite different, and they might not share the same controller. Scopes enable us to segregate these routes.The paths to the user facing reviews would look like a standard resource./reviews /reviews/1234 /reviews/1234/edit ...The admin review paths could be prefixed with /admin./admin/reviews /admin/reviews/1234 /admin/reviews/1234/edit ...We accomplish this with a scoped route that sets a path option to /admin like this one. We could nest this scope inside another scope, but instead let's set it by itself at the root:scope &quot;/admin&quot;, HelloWeb.Admin do pipe_through :browser resources &quot;/reviews&quot;, ReviewController endWe define a new scope where all routes are prefixed with &quot;/admin&quot; and all controllers are under the HelloWeb.Admin namespace.Running mix phx.routes again, in addition to the previous set of routes we get the following:... review_path GET /admin/reviews HelloWeb.Admin.ReviewController :index review_path GET /admin/reviews/:id/edit HelloWeb.Admin.ReviewController :edit review_path GET /admin/reviews/new HelloWeb.Admin.ReviewController :new review_path GET /admin/reviews/:id HelloWeb.Admin.ReviewController :show review_path POST /admin/reviews HelloWeb.Admin.ReviewController :create review_path PATCH /admin/reviews/:id HelloWeb.Admin.ReviewController :update PUT /admin/reviews/:id HelloWeb.Admin.ReviewController :update review_path DELETE /admin/reviews/:id HelloWeb.Admin.ReviewController :deleteThis looks good, but there is a problem here. Remember that we wanted both user facing reviews routes /reviews as well as the admin ones /admin/reviews. If we now include the user facing reviews in our router under the root scope like this:scope &quot;/&quot;, HelloWeb do pipe_through :browser ... resources &quot;/reviews&quot;, ReviewController end scope &quot;/admin&quot;, HelloWeb.Admin do pipe_through :browser resources &quot;/reviews&quot;, ReviewController endand we run mix phx.routes, we get this output:... review_path GET /reviews HelloWeb.ReviewController :index review_path GET /reviews/:id/edit HelloWeb.ReviewController :edit review_path GET /reviews/new HelloWeb.ReviewController :new review_path GET /reviews/:id HelloWeb.ReviewController :show review_path POST /reviews HelloWeb.ReviewController :create review_path PATCH /reviews/:id HelloWeb.ReviewController :update PUT /reviews/:id HelloWeb.ReviewController :update review_path DELETE /reviews/:id HelloWeb.ReviewController :delete ... review_path GET /admin/reviews HelloWeb.Admin.ReviewController :index review_path GET /admin/reviews/:id/edit HelloWeb.Admin.ReviewController :edit review_path GET /admin/reviews/new HelloWeb.Admin.ReviewController :new review_path GET /admin/reviews/:id HelloWeb.Admin.ReviewController :show review_path POST /admin/reviews HelloWeb.Admin.ReviewController :create review_path PATCH /admin/reviews/:id HelloWeb.Admin.ReviewController :update PUT /admin/reviews/:id HelloWeb.Admin.ReviewController :update review_path DELETE /admin/reviews/:id HelloWeb.Admin.ReviewController :deleteThe actual routes we get all look right, except for the path helper review_path at the beginning of each line. We are getting the same helper for both the user facing review routes and the admin ones, which is not correct.We can fix this problem by adding an as: :admin option to our admin scope: scope &quot;/admin&quot;, HelloWeb.Admin, as: :admin do pipe_through :browser resources &quot;/reviews&quot;, ReviewController endmix phx.routes now shows us we have what we are looking for.... review_path GET /reviews HelloWeb.ReviewController :index review_path GET /reviews/:id/edit HelloWeb.ReviewController :edit review_path GET /reviews/new HelloWeb.ReviewController :new review_path GET /reviews/:id HelloWeb.ReviewController :show review_path POST /reviews HelloWeb.ReviewController :create review_path PATCH /reviews/:id HelloWeb.ReviewController :update PUT /reviews/:id HelloWeb.ReviewController :update review_path DELETE /reviews/:id HelloWeb.ReviewController :delete ... admin_review_path GET /admin/reviews HelloWeb.Admin.ReviewController :index admin_review_path GET /admin/reviews/:id/edit HelloWeb.Admin.ReviewController :edit admin_review_path GET /admin/reviews/new HelloWeb.Admin.ReviewController :new admin_review_path GET /admin/reviews/:id HelloWeb.Admin.ReviewController :show admin_review_path POST /admin/reviews HelloWeb.Admin.ReviewController :create admin_review_path PATCH /admin/reviews/:id HelloWeb.Admin.ReviewController :update PUT /admin/reviews/:id HelloWeb.Admin.ReviewController :update admin_review_path DELETE /admin/reviews/:id HelloWeb.Admin.ReviewController :deleteThe path helpers now return what we want them to as well. Run iex -S mix and give it a try yourself.iex(1)&gt; HelloWeb.Router.Helpers.review_path(HelloWeb.Endpoint, :index) &quot;/reviews&quot; iex(2)&gt; HelloWeb.Router.Helpers.admin_review_path(HelloWeb.Endpoint, :show, 1234) &quot;/admin/reviews/1234&quot;What if we had a number of resources that were all handled by admins? We could put all of them inside the same scope like this:scope &quot;/admin&quot;, HelloWeb.Admin, as: :admin do pipe_through :browser resources &quot;/images&quot;, ImageController resources &quot;/reviews&quot;, ReviewController resources &quot;/users&quot;, UserController endHere's what mix phx.routes tells us:... admin_image_path GET /admin/images HelloWeb.Admin.ImageController :index admin_image_path GET /admin/images/:id/edit HelloWeb.Admin.ImageController :edit admin_image_path GET /admin/images/new HelloWeb.Admin.ImageController :new admin_image_path GET /admin/images/:id HelloWeb.Admin.ImageController :show admin_image_path POST /admin/images HelloWeb.Admin.ImageController :create admin_image_path PATCH /admin/images/:id HelloWeb.Admin.ImageController :update PUT /admin/images/:id HelloWeb.Admin.ImageController :update admin_image_path DELETE /admin/images/:id HelloWeb.Admin.ImageController :delete admin_review_path GET /admin/reviews HelloWeb.Admin.ReviewController :index admin_review_path GET /admin/reviews/:id/edit HelloWeb.Admin.ReviewController :edit admin_review_path GET /admin/reviews/new HelloWeb.Admin.ReviewController :new admin_review_path GET /admin/reviews/:id HelloWeb.Admin.ReviewController :show admin_review_path POST /admin/reviews HelloWeb.Admin.ReviewController :create admin_review_path PATCH /admin/reviews/:id HelloWeb.Admin.ReviewController :update PUT /admin/reviews/:id HelloWeb.Admin.ReviewController :update admin_review_path DELETE /admin/reviews/:id HelloWeb.Admin.ReviewController :delete admin_user_path GET /admin/users HelloWeb.Admin.UserController :index admin_user_path GET /admin/users/:id/edit HelloWeb.Admin.UserController :edit admin_user_path GET /admin/users/new HelloWeb.Admin.UserController :new admin_user_path GET /admin/users/:id HelloWeb.Admin.UserController :show admin_user_path POST /admin/users HelloWeb.Admin.UserController :create admin_user_path PATCH /admin/users/:id HelloWeb.Admin.UserController :update PUT /admin/users/:id HelloWeb.Admin.UserController :update admin_user_path DELETE /admin/users/:id HelloWeb.Admin.UserController :deleteThis is great, exactly what we want. Note how every route, path helper and controller is properly namespaced.Scopes can also be arbitrarily nested, but you should do it carefully as nesting can sometimes make our code confusing and less clear. With that said, suppose that we had a versioned API with resources defined for images, reviews and users. Then technically we could setup routes for the versioned API like this:scope &quot;/api&quot;, HelloWeb.Api, as: :api do pipe_through :api scope &quot;/v1&quot;, V1, as: :v1 do resources &quot;/images&quot;, ImageController resources &quot;/reviews&quot;, ReviewController resources &quot;/users&quot;, UserController end endYou can run mix phx.routes to see how these definitions will look like.Interestingly, we can use multiple scopes with the same path as long as we are careful not to duplicate routes. This router is perfectly fine with two scopes defined for the same path.defmodule HelloWeb.Router do use Phoenix.Router ... scope &quot;/&quot;, HelloWeb do pipe_through :browser resources &quot;/users&quot;, UserController end scope &quot;/&quot;, AnotherAppWeb do pipe_through :browser resources &quot;/posts&quot;, PostController end ... endIf we do duplicate a route, we'll get this familiar warning.warning: this clause cannot match because a previous clause at line 16 always matches","ref":"routing.html#scoped-routes","title":"Routing - Scoped Routes","type":"extras"},{"doc":"We have come quite a long way in this guide without talking about one of the first lines we saw in the router - pipe_through :browser. It's time to fix that.Pipelines are a series of plugs that can be attached to specific scopes. If you are not familiar with plugs, we have an in-depth guide about them.Routes are defined inside scopes and scopes may pipe through multiple pipelines. Once a route matches, Phoenix invokes all plugs defined in all pipelines associated to that route. For example, accessing &quot;/&quot; will pipe through the :browser pipeline, consequently invoking all of its plugs.Phoenix defines two pipelines by default, :browser and :api, which can be used for a number of common tasks. In turn we can customize them as well as create new pipelines to meet our needs.The :browser and :api PipelinesAs their names suggest, the :browser pipeline prepares for routes which render requests for a browser. The :api pipeline prepares for routes which produce data for an api.The :browser pipeline has five plugs: plug :accepts, [&quot;html&quot;] which defines the request format or formats which will be accepted, :fetch_session, which, naturally, fetches the session data and makes it available in the connection, :fetch_flash which retrieves any flash messages which may have been set, as well as :protect_from_forgery and :put_secure_browser_headers, which protects form posts from cross site forgery.Currently, the :api pipeline only defines plug :accepts, [&quot;json&quot;].The router invokes a pipeline on a route defined within a scope. Routes outside of a scope have no pipelines. Although the use of nested scopes is discouraged (see above), if we call pipe_through within a nested scope, the router will invoke all pipe_through's from parent scopes, followed by the nested one.Those are a lot of words bunched up together. Let's take a look at some examples to untangle their meaning.Here's another look at the router from a newly generated Phoenix application, this time with the api scope uncommented back in and a route added.defmodule HelloWeb.Router do use HelloWeb, :router pipeline :browser do plug :accepts, [&quot;html&quot;] plug :fetch_session plug :fetch_flash plug :protect_from_forgery plug :put_secure_browser_headers end pipeline :api do plug :accepts, [&quot;json&quot;] end scope &quot;/&quot;, HelloWeb do pipe_through :browser get &quot;/&quot;, PageController, :index end # Other scopes may use custom stacks. scope &quot;/api&quot;, HelloWeb do pipe_through :api resources &quot;/reviews&quot;, ReviewController end endWhen the server accepts a request, the request will always first pass through the plugs in our Endpoint, after which it will attempt to match on the path and HTTP verb.Let's say that the request matches our first route: a GET to /. The router will first pipe that request through the :browser pipeline - which will fetch the session data, fetch the flash, and execute forgery protection - before it dispatches the request to the PageController index action.Conversely, if the request matches any of the routes defined by the resources/2 macro, the router will pipe it through the :api pipeline - which currently does nothing - before it dispatches further to the correct action of the HelloWeb.ReviewController.If no route matches, no pipeline is invoked and a 404 error is raised.Let's stretch these ideas out a little bit more. What if we need to pipe requests through both :browser and one or more custom pipelines? We simply pipe_through a list of pipelines, and Phoenix will invoke them in order.defmodule HelloWeb.Router do use HelloWeb, :router pipeline :browser do plug :accepts, [&quot;html&quot;] plug :fetch_session plug :fetch_flash plug :protect_from_forgery plug :put_secure_browser_headers end ... scope &quot;/reviews&quot; do pipe_through [:browser, :review_checks, :other_great_stuff] resources &quot;/&quot;, HelloWeb.ReviewController end endHere's another example with two scopes that have different pipelines:defmodule HelloWeb.Router do use HelloWeb, :router pipeline :browser do plug :accepts, [&quot;html&quot;] plug :fetch_session plug :fetch_flash plug :protect_from_forgery plug :put_secure_browser_headers end ... scope &quot;/&quot;, HelloWeb do pipe_through :browser resources &quot;/posts&quot;, PostController end scope &quot;/reviews&quot;, HelloWeb do pipe_through [:browser, :review_checks] resources &quot;/&quot;, ReviewController end endIn general, the scoping rules for pipelines behave as you might expect. In this example, all routes will pipe through the :browser pipeline. However, only the reviews resources routes will pipe through the :review_checks pipeline. Since we declared both pipes pipe_through [:browser, :review_checks] in a list of pipelines, Phoenix will pipe_through each of them as it invokes them in order.Creating New PipelinesPhoenix allows us to create our own custom pipelines anywhere in the router. To do so, we call the pipeline/2 macro with these arguments: an atom for the name of our new pipeline and a block with all the plugs we want in it.defmodule HelloWeb.Router do use HelloWeb, :router pipeline :browser do plug :accepts, [&quot;html&quot;] plug :fetch_session plug :fetch_flash plug :protect_from_forgery plug :put_secure_browser_headers end pipeline :review_checks do plug :ensure_authenticated_user plug :ensure_user_owns_review end scope &quot;/reviews&quot;, HelloWeb do pipe_through [:browser, :review_checks] resources &quot;/&quot;, ReviewController end endNote that pipelines themselves are plugs, so we can plug a pipeline inside another pipeline. For example, we could rewrite the review_checks pipeline above to automatically invoke browser, simplifying the downstream pipeline call: pipeline :review_checks do plug :browser plug :ensure_authenticated_user plug :ensure_user_owns_review end scope &quot;/reviews&quot;, HelloWeb do pipe_through [:review_checks] resources &quot;/&quot;, ReviewController end","ref":"routing.html#pipelines","title":"Routing - Pipelines","type":"extras"},{"doc":"The Phoenix.Router.forward/4 macro can be used to send all requests that start with a particular path to a particular plug. Let's say we have a part of our system that is responsible (it could even be a separate application or library) for running jobs in the background, it could have its own web interface for checking the status of the jobs. We can forward to this admin interface using:defmodule HelloWeb.Router do use HelloWeb, :router ... scope &quot;/&quot;, HelloWeb do ... end forward &quot;/jobs&quot;, BackgroundJob.Plug endThis means that all routes starting with /jobs will be sent to the HelloWeb.BackgroundJob.Plug module. Inside the plug, you can match on subroutes, such as /pending and /active that shows the status of certain jobs.We can even mix the forward/4 macro with pipelines. If we wanted to ensure that the user was authenticated and an administrator in order to see the jobs page, we could use the following in our router.defmodule HelloWeb.Router do use HelloWeb, :router ... scope &quot;/&quot; do pipe_through [:authenticate_user, :ensure_admin] forward &quot;/jobs&quot;, BackgroundJob.Plug end endThis means the plugs in the authenticate_user and ensure_admin pipelines will be called before the BackgroundJob.Plug allowing them to send an appropriate response and halt the request accordingly.The opts that are received in the init/1 callback of the Module Plug can be passed as a 3rd argument. For example, maybe the background job lets you set the name of your application to be displayed on the page. This could be passed with:forward &quot;/jobs&quot;, BackgroundJob.Plug, name: &quot;Hello Phoenix&quot;There is a fourth router_opts argument that can be passed. These options are outlined in the Phoenix.Router.scope/2 documentation.BackgroundJob.Plug can be implemented as any Module Plug discussed in the Plug guide. Note though it is not advised to forward to another Phoenix endpoint. This is because plugs defined by your app and the forwarded endpoint would be invoked twice, which may lead to errors.","ref":"routing.html#forward","title":"Routing - Forward","type":"extras"},{"doc":"Routing is a big topic, and we have covered a lot of ground here. The important points to take away from this guide are:Routes which begin with an HTTP verb name expand to a single clause of the match function.Routes which begin with 'resources' expand to 8 clauses of the match function.Resources may restrict the number of match function clauses by using the only: or except: options.Any of these routes may be nested.Any of these routes may be scoped to a given path.Using the as: option in a scope can reduce duplication.Using the helper option for scoped routes eliminates unreachable paths.","ref":"routing.html#summary","title":"Routing - Summary","type":"extras"},{"doc":"ControllersRequirement: This guide expects that you have gone through the introductory guides and got a Phoenix application up and running.Requirement: This guide expects that you have gone through the Request life-cycle guide.Phoenix controllers act as intermediary modules. Their functions - called actions - are invoked from the router in response to HTTP requests. The actions, in turn, gather all the necessary data and perform all the necessary steps before invoking the view layer to render a template or returning a JSON response.Phoenix controllers also build on the Plug package, and are themselves plugs. Controllers provide the functions to do almost anything we need to in an action. If we do find ourselves looking for something that Phoenix controllers don't provide, we might find what we're looking for in Plug itself. Please see the Plug Guide or Plug Documentation for more information.A newly generated Phoenix app will have a single controller, the PageController, which can be found at lib/hello_web/controllers/page_controller.ex and looks like this.defmodule HelloWeb.PageController do use HelloWeb, :controller def index(conn, _params) do render(conn, &quot;index.html&quot;) end endThe first line below the module definition invokes the __using__/1 macro of the HelloWeb module, which imports some useful modules.The PageController gives us the index action to display the Phoenix welcome page associated with the default route Phoenix defines in the router.","ref":"controllers.html","title":"Controllers","type":"extras"},{"doc":"Controller actions are just functions. We can name them anything we like as long as they follow Elixir's naming rules. The only requirement we must fulfill is that the action name matches a route defined in the router.For example, in lib/hello_web/router.ex we could change the action name in the default route that Phoenix gives us in a new app from index:get &quot;/&quot;, PageController, :indexTo test:get &quot;/&quot;, PageController, :testAs long as we change the action name in the PageController to test as well, the welcome page will load as before.defmodule HelloWeb.PageController do ... def test(conn, _params) do render(conn, &quot;index.html&quot;) end endWhile we can name our actions whatever we like, there are conventions for action names which we should follow whenever possible. We went over these in the Routing Guide, but we'll take another quick look here.index - renders a list of all items of the given resource typeshow - renders an individual item by idnew - renders a form for creating a new itemcreate - receives params for one new item and saves it in a datastoreedit - retrieves an individual item by id and displays it in a form for editingupdate - receives params for one edited item and saves it to a datastoredelete - receives an id for an item to be deleted and deletes it from a datastoreEach of these actions takes two parameters, which will be provided by Phoenix behind the scenes.The first parameter is always conn, a struct which holds information about the request such as the host, path elements, port, query string, and much more. conn, comes to Phoenix via Elixir's Plug middleware framework. More detailed info about conn can be found in plug's documentation.The second parameter is params. Not surprisingly, this is a map which holds any parameters passed along in the HTTP request. It is a good practice to pattern match against params in the function signature to provide data in a simple package we can pass on to rendering. We saw this in the Request life-cycle guide when we added a messenger parameter to our show route in lib/hello_web/controllers/hello_controller.ex.defmodule HelloWeb.HelloController do ... def show(conn, %{&quot;messenger&quot; =&gt; messenger}) do render(conn, &quot;show.html&quot;, messenger: messenger) end endIn some cases - often in index actions, for instance - we don't care about parameters because our behavior doesn't depend on them. In those cases, we don't use the incoming params, and simply prepend the variable name with an underscore, _params. This will keep the compiler from complaining about the unused variable while still keeping the correct arity.","ref":"controllers.html#actions","title":"Controllers - Actions","type":"extras"},{"doc":"Controllers have several ways of rendering content. The simplest is to render some plain text using the text/2 function which Phoenix provides.For example, let's rewrite the show action from PageController to return text instead. For that, we could do the following.def show(conn, %{&quot;messenger&quot; =&gt; messenger}) do text(conn, &quot;From messenger \#{messenger}&quot;) endNow /hello/Frank in your browser should display From messenger Frank as plain text without any HTML.A step beyond this is rendering pure JSON with the json/2 function. We need to pass it something that the Jason library can decode into JSON, such as a map. (Jason is one of Phoenix's dependencies.)def show(conn, %{&quot;messenger&quot; =&gt; messenger}) do json(conn, %{id: messenger}) endIf we again visit /hello/Frank in the browser, we should see a block of JSON with the key id mapped to the string &quot;Frank&quot;.{&quot;id&quot;: &quot;Frank&quot;}Phoenix controllers can also render HTML without a view. As you may have already guessed, the html/2 function does just that. This time, we implement the show action like this.def show(conn, %{&quot;messenger&quot; =&gt; messenger}) do html(conn, &quot;&quot;&quot; &lt;html&gt; &lt;head&gt; &lt;title&gt;Passing a Messenger&lt;/title&gt; &lt;/head&gt; &lt;body&gt; &lt;p&gt;From messenger \#{Plug.HTML.html_escape(messenger)}&lt;/p&gt; &lt;/body&gt; &lt;/html&gt; &quot;&quot;&quot;) endHitting /hello/Frank now renders the HTML string we defined in the show action. Note that what we wrote in the action is not an eex template. It's a multi-line string, so we interpolate the messenger variable like this \#{Plug.HTML.html_escape(messenger)}, instead of this &lt;%= messenger %&gt;.It is worth noting that the text/2, json/2, and html/2 functions require neither a Phoenix view, nor a template to render.The json/2 function is obviously useful for writing APIs, and the other two may come in handy, but most of the times we use Phoenix views to build our responses. For this, Phoenix provides the render/3 function.Let's rollback our show action to what we originally wrote in the Request life-cycle guide:defmodule HelloWeb.HelloController do use HelloWeb, :controller def show(conn, %{&quot;messenger&quot; =&gt; messenger}) do render(conn, &quot;show.html&quot;, messenger: messenger) end endIn order for the render/3 function to work correctly, the controller and view must have the same root name, which must also have the same root name as the template directory where the show.html.eex template lives. In other words, the HelloController requires HelloView, and HelloView requires the existence of the lib/hello_web/templates/hello directory, which must contain the show.html.eex template.render/3 will also pass the value which the show action received for messenger from the params as an assign.If we need to pass values into the template when using render, that's easy. We can pass a keyword like we've seen with messenger: messenger, or we can use Plug.Conn.assign/3, which conveniently returns conn. def show(conn, %{&quot;messenger&quot; =&gt; messenger}) do conn |&gt; Plug.Conn.assign(:messenger, messenger) |&gt; render(&quot;show.html&quot;) endNote: Using Phoenix.Controller imports Plug.Conn, so shortening the call to assign/3 works just fine.Passing more than one value in to our template is as simple as connecting assign/3 functions together: def show(conn, %{&quot;messenger&quot; =&gt; messenger}) do conn |&gt; assign(:messenger, messenger) |&gt; assign(:receiver, &quot;Dweezil&quot;) |&gt; render(&quot;show.html&quot;) endGenerally speaking, once all assigns are configured, we invoke the View layer. The View layer then renders &quot;show.html&quot; alongside the layout and a response is sent back to the browser.Views and templates have their own guide, so we won't spend much time on them here. What we will look at is how to assign a different layout, or none at all, from inside a controller action.Assigning LayoutsLayouts are just a special subset of templates. They live in lib/hello_web/templates/layout. Phoenix created one for us when we generated our app. The default layout is called app.html.eex, and it is the layout into which all templates will be rendered by default.Since layouts are really just templates, they need a view to render them. This is the LayoutView module defined in lib/hello_web/views/layout_view.ex. Since Phoenix generated this view for us, we won't have to create a new one as long as we put the layouts we want to render inside the lib/hello_web/templates/layout directory.Before we create a new layout, though, let's do the simplest possible thing and render a template with no layout at all.The Phoenix.Controller module provides the put_layout/2 function for us to switch layouts. This takes conn as its first argument and a string for the basename of the layout we want to render. It also accepts false to disable the layout altogether.Edit the index action of the PageController module lib/hello_web/controllers/page_controller.ex to look like this.def index(conn, _params) do conn |&gt; put_layout(false) |&gt; render(&quot;index.html&quot;) endAfter reloading http://localhost:4000/, we should see a very different page, one with no title, logo image, or css styling at all.Now let's actually create another layout and render the index template into it. As an example, let's say we had a different layout for the admin section of our application which didn't have the logo image. To do this, let's copy the existing app.html.eex to a new file admin.html.eex in the same directory lib/hello_web/templates/layout. Then let's remove the line in admin.html.eex that displays the logo.&lt;span class=&quot;logo&quot;&gt;&lt;/span&gt; &lt;!-- remove this line --&gt;Then, pass the basename of the new layout into put_layout/2 in our index action in lib/hello_web/controllers/page_controller.ex.def index(conn, _params) do conn |&gt; put_layout(&quot;admin.html&quot;) |&gt; render(&quot;index.html&quot;) endWhen we load the page, we should be rendering the admin layout without a logo.Overriding Rendering FormatsRendering HTML through a template is fine, but what if we need to change the rendering format on the fly? Let's say that sometimes we need HTML, sometimes we need plain text, and sometimes we need JSON. Then what?Phoenix allows us to change formats on the fly with the _format query string parameter. To make this happen, Phoenix requires an appropriately named view and an appropriately named template in the correct directory.As an example, let's take the PageController index action from a newly generated app. Out of the box, this has the right view, PageView, the right templates directory, lib/hello_web/templates/page, and the right template for rendering HTML, index.html.eex.def index(conn, _params) do render(conn, &quot;index.html&quot;) endWhat it doesn't have is an alternative template for rendering text. Let's add one at lib/hello_web/templates/page/index.text.eex. Here is our example index.text.eex template.OMG, this is actually some text.There are just a few more things we need to do to make this work. We need to tell our router that it should accept the text format. We do that by adding text to the list of accepted formats in the :browser pipeline. Let's open up lib/hello_web/router.ex and change the plug :accepts to include text as well as html like this.defmodule HelloWeb.Router do use HelloWeb, :router pipeline :browser do plug :accepts, [&quot;html&quot;, &quot;text&quot;] plug :fetch_session plug :protect_from_forgery plug :put_secure_browser_headers end ...We also need to tell the controller to render a template with the same format as the one returned by Phoenix.Controller.get_format/1. We do that by substituting the name of the template &quot;index.html&quot; with the atom version :index.def index(conn, _params) do render(conn, :index) endIf we go to http://localhost:4000/?_format=text, we will see &quot;OMG, this is actually some text.&quot;.Sending responses directlyIf none of the rendering options above quite fits our needs, we can compose our own using some of the functions that Plug gives us. Let's say we want to send a response with a status of &quot;201&quot; and no body whatsoever. We can easily do that with the Plug.Conn.send_resp/3 function.Edit the index action of the PageController module lib/hello_web/controllers/page_controller.ex to look like this:def index(conn, _params) do conn |&gt; send_resp(201, &quot;&quot;) endReloading http://localhost:4000 should show us a completely blank page. The network tab of our browser's developer tools should show a response status of &quot;201&quot;.If we would like to be really specific about the content type, we can use put_resp_content_type/2 in conjunction with send_resp/3.def index(conn, _params) do conn |&gt; put_resp_content_type(&quot;text/plain&quot;) |&gt; send_resp(201, &quot;&quot;) endUsing Plug functions in this way, we can craft just the response we need.Setting the Content TypeAnalogous to the _format query string param, we can render any sort of format we want by modifying the HTTP Content-Type Header and providing the appropriate template.If we wanted to render an xml version of our index action, we might implement the action like this in lib/hello_web/page_controller.ex.def index(conn, _params) do conn |&gt; put_resp_content_type(&quot;text/xml&quot;) |&gt; render(&quot;index.xml&quot;, content: some_xml_content) endWe would then need to provide an index.xml.eex template which created valid xml, and we would be done.For a list of valid content mime-types, please see the mime.types documentation from the mime type library.Setting the HTTP StatusWe can also set the HTTP status code of a response similarly to the way we set the content type. The Plug.Conn module, imported into all controllers, has a put_status/2 function to do this.Plug.Conn.put_status/2 takes conn as the first parameter and as the second parameter either an integer or a &quot;friendly name&quot; used as an atom for the status code we want to set. The list of status code atom representations can be found in Plug.Conn.Status.code/1 documentation.Let's change the status in our PageController index action.def index(conn, _params) do conn |&gt; put_status(202) |&gt; render(&quot;index.html&quot;) endThe status code we provide must be a valid number.","ref":"controllers.html#rendering","title":"Controllers - Rendering","type":"extras"},{"doc":"Often, we need to redirect to a new url in the middle of a request. A successful create action, for instance, will usually redirect to the show action for the resource we just created. Alternately, it could redirect to the index action to show all the things of that same type. There are plenty of other cases where redirection is useful as well.Whatever the circumstance, Phoenix controllers provide the handy redirect/2 function to make redirection easy. Phoenix differentiates between redirecting to a path within the application and redirecting to a url - either within our application or external to it.In order to try out redirect/2, let's create a new route in lib/hello_web/router.ex.defmodule HelloWeb.Router do use HelloWeb, :router ... scope &quot;/&quot;, HelloWeb do ... get &quot;/&quot;, PageController, :index get &quot;/redirect_test&quot;, PageController, :redirect_test end endThen we'll change the index action to do nothing but redirect to our new route.def index(conn, _params) do redirect(conn, to: &quot;/redirect_test&quot;) endFinally, let's define in the same file the action we redirect to, which simply renders the index, but now under a new address:def redirect_test(conn, _params) do render(conn, &quot;index.html&quot;) endWhen we reload our Welcome Page, we see that we've been redirected to /redirect_test which shows the original welcome page. It works!If we care to, we can open up our developer tools, click on the network tab, and visit our root route again. We see two main requests for this page - a get to / with a status of 302, and a get to /redirect_test with a status of 200.Notice that the redirect function takes conn as well as a string representing a relative path within our application. For security reasons, the :to helper can only redirect for paths within your application. If you want to redirect to a fully-qualified path or an external URL, you should use :external instead:def index(conn, _params) do redirect(conn, external: &quot;https://elixir-lang.org/&quot;) endWe can also make use of the path helpers we learned about in the Routing Guide.defmodule HelloWeb.PageController do use HelloWeb, :controller def index(conn, _params) do redirect(conn, to: Routes.page_path(conn, :redirect_test)) end endUsing route helpers is actually the preferred approach to link to any page within our application.","ref":"controllers.html#redirection","title":"Controllers - Redirection","type":"extras"},{"doc":"There are times when we need to communicate with users during the course of an action. Maybe there was an error updating a schema. Maybe we just want to welcome them back to the application. For this, we have flash messages.The Phoenix.Controller module provides the put_flash/3 and get_flash/2 functions to help us set and retrieve flash messages as a key value pair. Let's set two flash messages in our HelloWeb.PageController to try this out.To do this we modify the index action as follows:defmodule HelloWeb.PageController do ... def index(conn, _params) do conn |&gt; put_flash(:info, &quot;Welcome to Phoenix, from flash info!&quot;) |&gt; put_flash(:error, &quot;Let&#39;s pretend we have an error.&quot;) |&gt; render(&quot;index.html&quot;) end endIn order to see our flash messages, we need to be able to retrieve them and display them in a template/layout. One way to do the first part is with get_flash/2 which takes conn and the key we care about. It then returns the value for that key.Fortunately, our application layout, lib/hello_web/templates/layout/app.html.eex, already has markup for displaying flash messages.&lt;p class=&quot;alert alert-info&quot; role=&quot;alert&quot;&gt;&lt;%= get_flash(@conn, :info) %&gt;&lt;/p&gt; &lt;p class=&quot;alert alert-danger&quot; role=&quot;alert&quot;&gt;&lt;%= get_flash(@conn, :error) %&gt;&lt;/p&gt;When we reload the Welcome Page, our messages should appear just above &quot;Welcome to Phoenix!&quot;The flash functionality is handy when mixed with redirects. Perhaps you want to redirect to a page with some extra information. If we re-use the redirect action from the previous section, we can do: def index(conn, _params) do conn |&gt; put_flash(:info, &quot;Welcome to Phoenix, from flash info!&quot;) |&gt; put_flash(:error, &quot;Let&#39;s pretend we have an error.&quot;) |&gt; redirect(to: Routes.page_path(conn, :redirect_test)) endNow if you reload the Welcome page, you will be redirect and the flash messages will be shown once more.Besides put_flash/3 and get_flash/2, the Phoenix.Controller module has another useful function worth knowing about. clear_flash/1 takes only conn and removes any flash messages which might be stored in the session.Phoenix does not enforce which keys are stored in the flash. As long as we are internally consistent, all will be well. :info and :error, however, are common and are handled by default in our templates.","ref":"controllers.html#flash-messages","title":"Controllers - Flash Messages","type":"extras"},{"doc":"Action Fallback allows us to centralize error handling code in plugs which are called when a controller action fails to return a %Plug.Conn{} struct. These plugs receive both the conn which was originally passed to the controller action along with the return value of the action.Let's say we have a show action which uses with to fetch a blog post and then authorize the current user to view that blog post. In this example we might expect fetch_post/1 to return {:error, :not_found} if the post is not found and authorize_user/3 might return {:error, :unauthorized} if the user is unauthorized. We could use the ErrorView Phoenix generates for every new application to handle these error paths accordingly:defmodule HelloWeb.MyController do use Phoenix.Controller def show(conn, %{&quot;id&quot; =&gt; id}, current_user) do with {:ok, post} &lt;- fetch_post(id), :ok &lt;- authorize_user(current_user, :view, post) do render(conn, &quot;show.json&quot;, post: post) else {:error, :not_found} -&gt; conn |&gt; put_status(:not_found) |&gt; put_view(HelloWeb.ErrorView) |&gt; render(:&quot;404&quot;) {:error, :unauthorized} -&gt; conn |&gt; put_status(403) |&gt; put_view(HelloWeb.ErrorView) |&gt; render(:&quot;403&quot;) end end endNow imagine you may need to implement similar logic for every controller and action handled by your API. This would result in a lot of repetition.Instead we can define a Module Plug which knows how to handle these error cases specifically. Since controllers are Module Plugs, let's define our Plug as a controller:defmodule HelloWeb.MyFallbackController do use Phoenix.Controller def call(conn, {:error, :not_found}) do conn |&gt; put_status(:not_found) |&gt; put_view(HelloWeb.ErrorView) |&gt; render(:&quot;404&quot;) end def call(conn, {:error, :unauthorized}) do conn |&gt; put_status(403) |&gt; put_view(HelloWeb.ErrorView) |&gt; render(:&quot;403&quot;) end endThen we can reference our new controller as the action_fallback and simply remove the else block from our with:defmodule HelloWeb.MyController do use Phoenix.Controller action_fallback HelloWeb.MyFallbackController def show(conn, %{&quot;id&quot; =&gt; id}, current_user) do with {:ok, post} &lt;- fetch_post(id), :ok &lt;- authorize_user(current_user, :view, post) do render(conn, &quot;show.json&quot;, post: post) end end endWhenever the with conditions do not match, HelloWeb.MyFallbackController will receive the original conn as well as the result of the action and respond appropriately.","ref":"controllers.html#action-fallback","title":"Controllers - Action Fallback","type":"extras"},{"doc":"Views and templatesRequirement: This guide expects that you have gone through the introductory guides and got a Phoenix application up and running.Requirement: This guide expects that you have gone through the Request life-cycle guide.Phoenix views main job is to render the body of the responses to be sent back to browsers and API clients. Most of the time, we use templates to build said responses, but we can also craft them by hand. We will learn how.","ref":"views.html","title":"Views and templates","type":"extras"},{"doc":"Phoenix assumes a strong naming convention from controllers to views to the templates they render. The PageController requires a PageView to render templates in the lib/hello_web/templates/page directory. While all of these can be customizable (see Phoenix.View and Phoenix.Template for more information), we recommend users stick with Phoenix' convention.A newly generated Phoenix application has three view modules - ErrorView, LayoutView, and PageView - which are all in the, lib/hello_web/views directory.Let's take a quick look at the LayoutView.defmodule HelloWeb.LayoutView do use HelloWeb, :view endThat's simple enough. There's only one line, use HelloWeb, :view. This line calls the view/0 function we just saw above. Besides allowing us to change our template root, view/0 exercises the __using__ macro in the Phoenix.View module. It also handles any module imports or aliases our application's view modules might need.All of the imports and aliases we make in our view will also be available in our templates. That's because templates are effectively compiled into functions inside their respective views. For example, if you define a function in your view, you will be able to invoke it directly from the template. Let's see this in practice.Open up our application layout template, lib/hello_web/templates/layout/app.html.eex, and change this line,&lt;title&gt;Hello · Phoenix Framework&lt;/title&gt;to call a title/0 function, like this.&lt;title&gt;&lt;%= title() %&gt;&lt;/title&gt;Now let's add a title/0 function to our LayoutView.defmodule HelloWeb.LayoutView do use HelloWeb, :view def title() do &quot;Awesome New Title!&quot; end endWhen we reload our home page, we should see our new title. Since templates are compiled inside the view, we could invoke the view function simply as title(), otherwise we would have to type HelloWeb.LayoutView.title().As you may recall, Elixir templates use Embedded Elixir, known as EEx. We use &lt;%= expression %&gt; to execute Elixir expressions. The result of the expression is interpolated into the template. You can use pretty much any Elixir expression. For example, in order to have conditionals:&lt;%= if some_condition? do %&gt; &lt;p&gt;Some condition is true for user: &lt;%= @user.name %&gt;&lt;/p&gt; &lt;% else %&gt; &lt;p&gt;Some condition is false for user: &lt;%= @user.name %&gt;&lt;/p&gt; &lt;% end %&gt;or even loops:&lt;table&gt; &lt;tr&gt; &lt;th&gt;Number&lt;/th&gt; &lt;th&gt;Power&lt;/th&gt; &lt;/tr&gt; &lt;%= for number &lt;- 1..10 do %&gt; &lt;tr&gt; &lt;td&gt;&lt;%= number %&gt;&lt;/td&gt; &lt;td&gt;&lt;%= number * number %&gt;&lt;/td&gt; &lt;/tr&gt; &lt;% end %&gt; &lt;/table&gt;At the end of the day, our templates are always compiled into Elixir code. Let's learn more about this.Understanding template compilationWhen a template is compiled into a view, it is simply compiled as a render function that expects two arguments: the template name and the assigns.You can prove this by temporarily adding this function clause to your PageView module in lib/hello_web/views/page_view.ex.defmodule HelloWeb.PageView do use HelloWeb, :view def render(&quot;index.html&quot;, assigns) do &quot;rendering with assigns \#{inspect Map.keys(assigns)}&quot; end endNow if you fire up the server with mix phx.server and visit http://localhost:4000, you should see the following text below your layout header instead of the main template page:rendering with assigns [:conn, :view_module, :view_template]By defining our own clause in render, it takes higher priority than the template, but the template is still there, which you can verify by simply removing the newly added clause.Pretty neat, right? At compile-time, Phoenix precompiles all *.html.eex templates and turns them into render/2 function clauses on their respective view modules. At runtime, all templates are already loaded in memory. There's no disk reads, complex file caching, or template engine computation involved.Manually rendering templatesSo far, Phoenix has taken care of putting everything in place and rendering views for us. However, we can also render views directly.Let's create a new template to play around with, lib/hello_web/templates/page/test.html.eex:This is the message: &lt;%= @message %&gt;This doesn't correspond to any action in our controller, which is fine. We'll exercise it in an iex session. At the root of our project, we can run iex -S mix, and then explicitly render our template.iex(1)&gt; Phoenix.View.render(HelloWeb.PageView, &quot;test.html&quot;, message: &quot;Hello from IEx!&quot;) {:safe, [&quot;This is the message: &quot;, &quot;Hello from IEx!&quot;]}As we can see, we're calling render/3 with the individual view responsible for our test template, the name of our test template, and an empty map representing any assigns we might have wanted to pass in. The return value is a tuple beginning with the atom :safe and the resultant io list of the interpolated template. &quot;Safe&quot; here means that Phoenix has escaped the contents of our rendered template to avoid XSS injection attacks.Let's test out the HTML escaping, just for fun:iex(2)&gt; Phoenix.View.render(HelloWeb.PageView, &quot;test.html&quot;, message: &quot;&lt;script&gt;badThings();&lt;/script&gt;&quot;) {:safe, [&quot;This is the message: &quot;, &quot;&amp;lt;script&amp;gt;badThings();&amp;lt;/script&amp;gt;&quot;]}If we need only the rendered string, without the whole tuple, we can use render_to_string/3.iex(5)&gt; Phoenix.View.render_to_string(HelloWeb.PageView, &quot;test.html&quot;, message: &quot;Hello from IEx!&quot;) &quot;This is the message: Hello from IEx!&quot;","ref":"views.html#rendering-templates","title":"Views and templates - Rendering Templates","type":"extras"},{"doc":"Now that we have acquainted ourselves with Phoenix.View.render/3, we are ready to share views and templates from inside other views and templates.For example, if you want to render the &quot;test.html&quot; template from inside our layout, you can invoke render/3 directly from the layout:&lt;%= Phoenix.View.render(HelloWeb.PageView, &quot;test.html&quot;, message: &quot;Hello from layout!&quot;) %&gt;If you visit the Welcome page, you should see the message from the layout.Since Phoenix.View is automatically imported into our templates, we could even skip the Phoenix.View module name and simply invoke render(...) directly:&lt;%= render(HelloWeb.PageView, &quot;test.html&quot;, message: &quot;Hello from layout!&quot;) %&gt;If you want to render a template within the same view, you can skip the view name, and simply call render(&quot;test.html&quot;, message: &quot;Hello from sibling template!&quot;) instead. For example, open up lib/hello_web/templates/page/index.html.eex and add this at the top:&lt;%= render(&quot;test.html&quot;, message: &quot;Hello from sibling template!&quot;) %&gt;Now if you visit the Welcome page, you see the template results also shown.","ref":"views.html#sharing-views-and-templates","title":"Views and templates - Sharing views and templates","type":"extras"},{"doc":"Layouts are just templates. They have a view, just like other templates. In a newly generated app, this is lib/hello_web/views/layout_view.ex. You may be wondering how the string resulting from a rendered view ends up inside a layout. That's a great question! If we look at lib/hello_web/templates/layout/app.html.eex, just about in the middle of the &lt;body&gt;, we will see this.&lt;%= @inner_content %&gt;In other words, the inner template is placed in the @inner_content assign. You can also find which module and template where used to render the inner content by introspecting the @view_module and @view_template assigns.","ref":"views.html#layouts","title":"Views and templates - Layouts","type":"extras"},{"doc":"The view's job is not only to render HTML templates. Views are about data presentation. Given a bag of data, the view's purpose is to present that in a meaningful way given some format, be it HTML, JSON, CSV, or others. Many web apps today return JSON to remote clients, and Phoenix Views are great for JSON rendering.Phoenix uses Jason to encode JSON, so all we need to do in our views is format the data we'd like to respond with as a list or a map, and Phoenix will do the rest.While it is possible to respond with JSON back directly from the controller and skip the view, Phoenix Views provide a much more structured approach for doing so. Let's take our PageController, and see what it might look like when we respond with some static page maps as JSON, instead of HTML.defmodule HelloWeb.PageController do use HelloWeb, :controller def show(conn, _params) do page = %{title: &quot;foo&quot;} render(conn, &quot;show.json&quot;, page: page) end def index(conn, _params) do pages = [%{title: &quot;foo&quot;}, %{title: &quot;bar&quot;}] render(conn, &quot;index.json&quot;, pages: pages) end endHere, we have our show/2 and index/2 actions returning static page data. Instead of passing in &quot;show.html&quot; to render/3 as the template name, we pass &quot;show.json&quot;. This way, we can have views that are responsible for rendering HTML as well as JSON by pattern matching on different file types.defmodule HelloWeb.PageView do use HelloWeb, :view def render(&quot;index.json&quot;, %{pages: pages}) do %{data: render_many(pages, HelloWeb.PageView, &quot;page.json&quot;)} end def render(&quot;show.json&quot;, %{page: page}) do %{data: render_one(page, HelloWeb.PageView, &quot;page.json&quot;)} end def render(&quot;page.json&quot;, %{page: page}) do %{title: page.title} end endIn the view we see our render/2 function pattern matching on &quot;index.json&quot;, &quot;show.json&quot;, and &quot;page.json&quot;. The &quot;index.json&quot; and &quot;show.json&quot; are the ones requested directly from the controller. They also match on the assigns sent by the controller. &quot;index.json&quot; will respond with JSON like this:{ &quot;data&quot;: [ { &quot;title&quot;: &quot;foo&quot; }, { &quot;title&quot;: &quot;bar&quot; }, ] }And the render/2 matching &quot;show.json&quot;:{ &quot;data&quot;: { &quot;title&quot;: &quot;foo&quot; } }This works because both &quot;index.json&quot; and &quot;show.json&quot; builds themselves on top of an internal &quot;page.json&quot; clause.The render_many/3 function takes the data we want to respond with (pages), a view, and a string to pattern match on the render/2 function defined on view. It will map over each item in pages, and call PageView.render(&quot;page.json&quot;, %{page: page}). render_one/3 follows, the same signature, ultimately using the render/2 matching page.json to specify what each page looks like. It's useful to build our views like this so they can be composable. Imagine a situation where our Page has a has_many relationship with Author, and depending on the request, we may want to send back author data with the page. We can easily accomplish this with a new render/2:defmodule HelloWeb.PageView do use HelloWeb, :view alias HelloWeb.AuthorView def render(&quot;page_with_authors.json&quot;, %{page: page}) do %{title: page.title, authors: render_many(page.authors, AuthorView, &quot;author.json&quot;)} end def render(&quot;page.json&quot;, %{page: page}) do %{title: page.title} end endThe name used in assigns is determined from the view. For example the PageView will use %{page: page} and the AuthorView will use %{author: author}. This can be overridden with the as option. Let's assume that the author view uses %{writer: writer} instead of %{author: author}:def render(&quot;page_with_authors.json&quot;, %{page: page}) do %{title: page.title, authors: render_many(page.authors, AuthorView, &quot;author.json&quot;, as: :writer)} end","ref":"views.html#rendering-json","title":"Views and templates - Rendering JSON","type":"extras"},{"doc":"Phoenix has a view called the ErrorView which lives in lib/hello_web/views/error_view.ex. The purpose of the ErrorView is to handle errors in a general way, from one centralized location. Similar to the views we built in this guide, error views can return both HTML and JSON responses. See the Custom Error Pages How-To for more information.","ref":"views.html#error-pages","title":"Views and templates - Error pages","type":"extras"},{"doc":"EctoRequirement: This guide expects that you have gone through the introductory guides and got a Phoenix application up and running.Most web applications today need some form of data validation and persistence. In the Elixir ecosystem, we have Ecto to enable this. Before we jump into building database-backed web features, we're going to focus on the finer details of Ecto to give a solid base to build our web features on top of. Let's get started!Phoenix uses Ecto to provide builtin support to the following databases:PostgreSQL (via postgrex)MySQL (via myxql)MSSQL (via tds)Newly generated Phoenix projects include Ecto with the PostgreSQL adapter by default. You can pass the --database option to change or --no-ecto flag to exclude this.Ecto also provides support for other databases and it has many learning resources available. Please check out Ecto's README for general information.This guide assumes that we have generated our new application with Ecto integration and that we will be using PostgreSQL. The introductory guides cover how to get your first application up and running. For instructions on switching to MySQL, please see the Using MySQL section.","ref":"ecto.html","title":"Ecto","type":"extras"},{"doc":"Now that we have Ecto and Postgres installed and configured, the easiest way to use Ecto is to generate an Ecto schema through the phx.gen.schema task. Ecto schemas are a way for us to specify how Elixir data types map to and from external sources, such as database tables. Let's generate a User schema with name, email, bio, and number_of_pets fields.$ mix phx.gen.schema User users name:string email:string \\ bio:string number_of_pets:integer * creating ./lib/hello/user.ex * creating priv/repo/migrations/20170523151118_create_users.exs Remember to update your repository by running migrations: $ mix ecto.migrateA couple of files were generated with this task. First, we have a user.ex file, containing our Ecto schema with our schema definition of the fields we passed to the task. Next, a migration file was generated inside priv/repo/migrations which will create our database table that our schema maps to.With our files in place, let's follow the instructions and run our migration:$ mix ecto.migrate Compiling 1 file (.ex) Generated hello app [info] == Running Hello.Repo.Migrations.CreateUsers.change/0 forward [info] create table users [info] == Migrated in 0.0sMix assumes that we are in the development environment unless we tell it otherwise with MIX_ENV=prod mix ecto.migrate.If we log in to our database server, and connect to our hello_dev database, we should see our users table. Ecto assumes that we want an integer column called id as our primary key, so we should see a sequence generated for that as well.$ psql -U postgres Type &quot;help&quot; for help. postgres=# \\connect hello_dev You are now connected to database &quot;hello_dev&quot; as user &quot;postgres&quot;. hello_dev=# \\d List of relations Schema | Name | Type | Owner --------+-------------------+----------+---------- public | schema_migrations | table | postgres public | users | table | postgres public | users_id_seq | sequence | postgres (3 rows) hello_dev=# \\qIf we take a look at the migration generated by phx.gen.schema in priv/repo/migrations, we'll see that it will add the columns we specified. It will also add timestamp columns for inserted_at and updated_at which come from the timestamps/0 function.defmodule Hello.Repo.Migrations.CreateUsers do use Ecto.Migration def change do create table(:users) do add :name, :string add :email, :string add :bio, :string add :number_of_pets, :integer timestamps() end end endAnd here's what that translates to in the actual users table.hello_dev=# \\d users Table &quot;public.users&quot; Column | Type | Modifiers ---------------+-----------------------------+---------------------------------------------------- id | integer | not null default nextval('users_id_seq'::regclass) name | character varying(255) | email | character varying(255) | bio | character varying(255) | number_of_pets | integer | inserted_at | timestamp without time zone | not null updated_at | timestamp without time zone | not null Indexes: &quot;users_pkey&quot; PRIMARY KEY, btree (id)Notice that we do get an id column as our primary key by default, even though it isn't listed as a field in our migration.","ref":"ecto.html#using-the-schema-and-migration-generator","title":"Ecto - Using the schema and migration generator","type":"extras"},{"doc":"Our Hello.Repo module is the foundation we need to work with databases in a Phoenix application. Phoenix generated it for us in lib/hello/repo.ex, and this is what it looks like.defmodule Hello.Repo do use Ecto.Repo, otp_app: :hello, adapter: Ecto.Adapters.Postgres endIt begins by configuring our otp_app name and repo module. Then it sets the adapter – Postgres, in our case. It also sets our login credentials. Of course, you can change these to match your actual credentials if they are different.Our repo has three main tasks - to bring in all the common query functions from Ecto.Repo, to set the otp_app name equal to our application name, and to configure our database adapter. We'll talk more about how to use the Repo in a bit.When phx.new generated our application, it included some basic repo configuration as well. Let's look at config/dev.exs.... # Configure your database config :hello, Hello.Repo, username: &quot;postgres&quot;, password: &quot;postgres&quot;, database: &quot;hello_dev&quot;, hostname: &quot;localhost&quot;, pool_size: 10 ...We also have similar configuration in config/test.exs and config/prod.secret.exs which can also be changed to match your actual credentials.","ref":"ecto.html#repo-configuration","title":"Ecto - Repo configuration","type":"extras"},{"doc":"Ecto schemas are responsible for mapping Elixir values to external data sources, as well as mapping external data back into Elixir data-structures. We can also define relationships to other schemas in our applications. For example, our User schema might have many Post's, and each Post would belong to a User. Ecto also handles data validation and type casting with changesets, which we'll discuss in a moment.Here's the User schema that Phoenix generated for us.defmodule Hello.User do use Ecto.Schema import Ecto.Changeset alias Hello.User schema &quot;users&quot; do field :bio, :string field :email, :string field :name, :string field :number_of_pets, :integer timestamps() end @doc false def changeset(%User{} = user, attrs) do user |&gt; cast(attrs, [:name, :email, :bio, :number_of_pets]) |&gt; validate_required([:name, :email, :bio, :number_of_pets]) end endEcto schemas at their core are simply Elixir structs. Our schema block is what tells Ecto how to cast our %User{} struct fields to and from the external users table. Often, the ability to simply cast data to and from the database isn't enough and extra data validation is required. This is where Ecto Changesets come in. Let's dive in!","ref":"ecto.html#the-schema","title":"Ecto - The Schema","type":"extras"},{"doc":"Changesets define a pipeline of transformations our data needs to undergo before it will be ready for our application to use. These transformations might include type-casting, user input validation, and filtering out any extraneous parameters. Often we'll use changesets to validate user input before writing it to the database. Ecto Repos are also changeset-aware, which allows them not only to refuse invalid data, but also perform the minimal database updates possible by inspecting the changeset to know which fields have changed.Let's take a closer look at our default changeset function.def changeset(%User{} = user, attrs) do user |&gt; cast(attrs, [:name, :email, :bio, :number_of_pets]) |&gt; validate_required([:name, :email, :bio, :number_of_pets]) endRight now, we have two transformations in our pipeline. In the first call, we invoke Ecto.Changeset.cast/3, passing in our external parameters and marking which fields are required for validation.cast/3 first takes a struct, then the parameters (the proposed updates), and then the final field is the list of columns to be updated. cast/3 also will only take fields that exist in the schema.Next, validate_required/3 checks that this list of fields is present in the changeset that cast/3 returns. By default with the generator, all fields are required.We can verify this functionality in iex. Let's fire up our application inside iex by running iex -S mix. In order to minimize typing and make this easier to read, let's alias our Hello.User struct.$ iex -S mix iex&gt; alias Hello.User Hello.UserNext, let's build a changeset from our schema with an empty User struct, and an empty map of parameters.iex&gt; changeset = User.changeset(%User{}, %{}) #Ecto.Changeset&lt;action: nil, changes: %{}, errors: [name: {&quot;can&#39;t be blank&quot;, [validation: :required]}, email: {&quot;can&#39;t be blank&quot;, [validation: :required]}, bio: {&quot;can&#39;t be blank&quot;, [validation: :required]}, number_of_pets: {&quot;can&#39;t be blank&quot;, [validation: :required]}], data: #Hello.User&lt;&gt;, valid?: false&gt;Once we have a changeset, we can check it if it is valid.iex&gt; changeset.valid? falseSince this one is not valid, we can ask it what the errors are.iex&gt; changeset.errors [name: {&quot;can&#39;t be blank&quot;, [validation: :required]}, email: {&quot;can&#39;t be blank&quot;, [validation: :required]}, bio: {&quot;can&#39;t be blank&quot;, [validation: :required]}, number_of_pets: {&quot;can&#39;t be blank&quot;, [validation: :required]}]Now, let's make number_of_pets optional. In order to do this, we simply remove it from the list. |&gt; validate_required([:name, :email, :bio])Now casting the changeset should tell us that only name, email, and bio can't be blank. We can test that by running recompile() inside iex and then rebuilding our changeset.iex&gt; recompile() Compiling 1 file (.ex) :ok iex&gt; changeset = User.changeset(%User{}, %{}) #Ecto.Changeset&lt;action: nil, changes: %{}, errors: [name: {&quot;can&#39;t be blank&quot;, [validation: :required]}, email: {&quot;can&#39;t be blank&quot;, [validation: :required]}, bio: {&quot;can&#39;t be blank&quot;, [validation: :required]}], data: #Hello.User&lt;&gt;, valid?: false&gt; iex&gt; changeset.errors [name: {&quot;can&#39;t be blank&quot;, [validation: :required]}, email: {&quot;can&#39;t be blank&quot;, [validation: :required]}, bio: {&quot;can&#39;t be blank&quot;, [validation: :required]}]What happens if we pass a key/value pair that is neither defined in the schema nor required?Inside our existing IEx shell, let's create a params map with valid values plus an extra random_key: &quot;random value&quot;.iex&gt; params = %{name: &quot;Joe Example&quot;, email: &quot;joe@example.com&quot;, bio: &quot;An example to all&quot;, number_of_pets: 5, random_key: &quot;random value&quot;} %{email: &quot;joe@example.com&quot;, name: &quot;Joe Example&quot;, bio: &quot;An example to all&quot;, number_of_pets: 5, random_key: &quot;random value&quot;}Next, let's use our new params map to create another changeset.iex&gt; changeset = User.changeset(%User{}, params) #Ecto.Changeset&lt;action: nil, changes: %{bio: &quot;An example to all&quot;, email: &quot;joe@example.com&quot;, name: &quot;Joe Example&quot;, number_of_pets: 5}, errors: [], data: #Hello.User&lt;&gt;, valid?: true&gt;Our new changeset is valid.iex&gt; changeset.valid? trueWe can also check the changeset's changes - the map we get after all of the transformations are complete.iex(9)&gt; changeset.changes %{bio: &quot;An example to all&quot;, email: &quot;joe@example.com&quot;, name: &quot;Joe Example&quot;, number_of_pets: 5}Notice that our random_key and random_value have been removed from the final changeset. Changesets allow us to cast external data, such as user input on a web form or data from a CSV file into valid data into our system. Invalid parameters will be stripped and bad data that is unable to be cast according to our schema will be highlighted in the changeset errors.We can validate more than just whether a field is required or not. Let's take a look at some finer-grained validations.What if we had a requirement that all biographies in our system must be at least two characters long? We can do this easily by adding another transformation to the pipeline in our changeset which validates the length of the bio field.def changeset(%User{} = user, attrs) do user |&gt; cast(attrs, [:name, :email, :bio, :number_of_pets]) |&gt; validate_required([:name, :email, :bio, :number_of_pets]) |&gt; validate_length(:bio, min: 2) endNow, if we try to cast data containing a value of &quot;A&quot; for our user's bio, we should see the failed validation in the changeset's errors.iex&gt; changeset = User.changeset(%User{}, %{bio: &quot;A&quot;}) iex&gt; changeset.errors[:bio] {&quot;should be at least %{count} character(s)&quot;, [count: 2, validation: :length, min: 2]}If we also have a requirement for the maximum length that a bio can have, we can simply add another validation.def changeset(%User{} = user, attrs) do user |&gt; cast(attrs, [:name, :email, :bio, :number_of_pets]) |&gt; validate_required([:name, :email, :bio, :number_of_pets]) |&gt; validate_length(:bio, min: 2) |&gt; validate_length(:bio, max: 140) endLet's say we want to perform at least some rudimentary format validation on the email field. All we want to check for is the presence of the &quot;@&quot;. The validate_format/3 function is just what we need.def changeset(%User{} = user, attrs) do user |&gt; cast(attrs, [:name, :email, :bio, :number_of_pets]) |&gt; validate_required([:name, :email, :bio, :number_of_pets]) |&gt; validate_length(:bio, min: 2) |&gt; validate_length(:bio, max: 140) |&gt; validate_format(:email, ~r/@/) endIf we try to cast a user with an email of &quot;example.com&quot;, we should see an error message like the following.iex&gt; changeset = User.changeset(%User{}, %{email: &quot;example.com&quot;}) iex&gt; changeset.errors[:email] {&quot;has invalid format&quot;, [validation: :format]}There are many more validations and transformations we can perform in a changeset. Please see the Ecto Changeset documentation for more information.","ref":"ecto.html#changesets-and-validations","title":"Ecto - Changesets and Validations","type":"extras"},{"doc":"We've explored migrations and schemas, but we haven't yet persisted any of our schemas or changesets. We briefly looked at our repo module in lib/hello/repo.ex earlier, now it's time to put it to use.Ecto Repos are the interface into a storage system, be it a Database like PostgreSQL or an external service like a RESTful API. The Repo module's purpose is to take care of the finer details of persistence and data querying for us. As the caller, we only care about fetching and persisting data. The Repo takes care of the underlying Database adapter communication, connection pooling, and error translation for database constraint violations.Let's head back over to IEx with iex -S mix, and insert a couple of users into the database.iex&gt; alias Hello.{Repo, User} [Hello.Repo, Hello.User] iex&gt; Repo.insert(%User{email: &quot;user1@example.com&quot;}) [debug] QUERY OK db=4.6ms INSERT INTO &quot;users&quot; (&quot;email&quot;,&quot;inserted_at&quot;,&quot;updated_at&quot;) VALUES ($1,$2,$3) RETURNING &quot;id&quot; [&quot;user1@example.com&quot;, {{2017, 5, 23}, {19, 6, 4, 822044}}, {{2017, 5, 23}, {19, 6, 4, 822055}}] {:ok, %Hello.User{__meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;users&quot;&gt;, bio: nil, email: &quot;user1@example.com&quot;, id: 3, inserted_at: ~N[2017-05-23 19:06:04.822044], name: nil, number_of_pets: nil, updated_at: ~N[2017-05-23 19:06:04.822055]}} iex&gt; Repo.insert(%User{email: &quot;user2@example.com&quot;}) [debug] QUERY OK db=5.1ms INSERT INTO &quot;users&quot; (&quot;email&quot;,&quot;inserted_at&quot;,&quot;updated_at&quot;) VALUES ($1,$2,$3) RETURNING &quot;id&quot; [&quot;user2@example.com&quot;, {{2017, 5, 23}, {19, 6, 8, 452545}}, {{2017, 5, 23}, {19, 6, 8, 452556}}] {:ok, %Hello.User{__meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;users&quot;&gt;, bio: nil, email: &quot;user2@example.com&quot;, id: 4, inserted_at: ~N[2017-05-23 19:06:08.452545], name: nil, number_of_pets: nil, updated_at: ~N[2017-05-23 19:06:08.452556]}}We started by aliasing our User and Repo modules for easy access. Next, we called Repo.insert/1 and passed a user struct. Since we're in the dev environment, we can see the debug logs for the query our Repo performed when inserting the underlying %User{} data. We received a 2-tuple back with {:ok, %User{}}, which lets us know the insertion was successful. With a couple of users inserted, let's fetch them back out of the repo.iex&gt; Repo.all(User) [debug] QUERY OK source=&quot;users&quot; db=2.7ms SELECT u0.&quot;id&quot;, u0.&quot;bio&quot;, u0.&quot;email&quot;, u0.&quot;name&quot;, u0.&quot;number_of_pets&quot;, u0.&quot;inserted_at&quot;, u0.&quot;updated_at&quot; FROM &quot;users&quot; AS u0 [] [%Hello.User{__meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;users&quot;&gt;, bio: nil, email: &quot;user1@example.com&quot;, id: 3, inserted_at: ~N[2017-05-23 19:06:04.822044], name: nil, number_of_pets: nil, updated_at: ~N[2017-05-23 19:06:04.822055]}, %Hello.User{__meta__: #Ecto.Schema.Metadata&lt;:loaded, &quot;users&quot;&gt;, bio: nil, email: &quot;user2@example.com&quot;, id: 4, inserted_at: ~N[2017-05-23 19:06:08.452545], name: nil, number_of_pets: nil, updated_at: ~N[2017-05-23 19:06:08.452556]}]That was easy! Repo.all/1 takes a data source, our User schema in this case, and translates that to an underlying SQL query against our database. After it fetches the data, the Repo then uses our Ecto schema to map the database values back into Elixir data-structures according to our User schema. We're not just limited to basic querying – Ecto includes a full-fledged query DSL for advanced SQL generation. In addition to a natural Elixir DSL, Ecto's query engine gives us multiple great features, such as SQL injection protection and compile-time optimization of queries. Let's try it out.iex&gt; import Ecto.Query Ecto.Query iex&gt; Repo.all(from u in User, select: u.email) [debug] QUERY OK source=&quot;users&quot; db=2.4ms SELECT u0.&quot;email&quot; FROM &quot;users&quot; AS u0 [] [&quot;user1@example.com&quot;, &quot;user2@example.com&quot;]First, we imported Ecto.Query, which imports the from macro of Ecto's Query DSL. Next, we built a query which selects all the email addresses in our users table. Let's try another example.iex)&gt; Repo.one(from u in User, where: ilike(u.email, &quot;%1%&quot;), select: count(u.id)) [debug] QUERY OK source=&quot;users&quot; db=1.6ms SELECT count(u0.&quot;id&quot;) FROM &quot;users&quot; AS u0 WHERE (u0.&quot;email&quot; ILIKE &#39;%1%&#39;) [] 1Now we're starting to get a taste of Ecto's rich querying capabilities. We used Repo.one/1 to fetch the count of all users with an email address containing &quot;1&quot;, and received the expected count in return. This just scratches the surface of Ecto's query interface, and much more is supported such as sub-querying, interval queries, and advanced select statements. For example, let's build a query to fetch a map of all user id's to their email addresses.iex&gt; Repo.all(from u in User, select: %{u.id =&gt; u.email}) [debug] QUERY OK source=&quot;users&quot; db=0.9ms SELECT u0.&quot;id&quot;, u0.&quot;email&quot; FROM &quot;users&quot; AS u0 [] [%{3 =&gt; &quot;user1@example.com&quot;}, %{4 =&gt; &quot;user2@example.com&quot;}]That little query packed a big punch. It both fetched all user emails from the database and efficiently built a map of the results in one go. You should browse the Ecto.Query documentation to see the breadth of supported query features.In addition to inserts, we can also perform updates and deletes with Repo.update/1 and Repo.delete/1 to update or delete a single schema. Ecto also supports bulk persistence with the Repo.insert_all, Repo.update_all, and Repo.delete_all functions.There is quite a bit more that Ecto can do and we've only barely scratched the surface. With a solid Ecto foundation in place, we're now ready to continue building our app and integrate the web facing application with our backend persistence. Along the way, we'll expand our Ecto knowledge and learn how to properly isolate our web interface from the underlying details of our system. Please take a look at the Ecto documentation for the rest of the story.In our context guide, we'll find out how to wrap up our Ecto access and business logic behind modules that group related functionality. We'll see how Phoenix helps us design maintainable applications, and we'll find out about other neat Ecto features along the way.","ref":"ecto.html#data-persistence","title":"Ecto - Data Persistence","type":"extras"},{"doc":"Phoenix applications are configured to use PostgreSQL by default, but what if we want to use MySQL instead? In this guide, we'll walk through changing that default whether we are about to create a new application, or whether we have an existing one configured for PostgreSQL.If we are about to create a new application, configuring our application to use MySQL is easy. We can simply pass the --database mysql flag to phx.new and everything will be configured correctly.$ mix phx.new hello_phoenix --database mysqlThis will set up all the correct dependencies and configuration for us automatically. Once we install those dependencies with mix deps.get, we'll be ready to begin working with Ecto in our application.If we have an existing application, all we need to do is switch adapters and make some small configuration changes.To switch adapters, we need to remove the Postgrex dependency and add a new one for Mariaex instead.Let's open up our mix.exs file and do that now.defmodule HelloPhoenix.MixProject do use Mix.Project . . . # Specifies your project dependencies. # # Type `mix help deps` for examples and options. defp deps do [ {:phoenix, &quot;~&gt; 1.4.0&quot;}, {:phoenix_ecto, &quot;~&gt; 4.0&quot;}, {:ecto_sql, &quot;~&gt; 3.4&quot;}, {:myxql, &quot;&gt;= 0.0.0&quot;}, {:phoenix_html, &quot;~&gt; 2.11&quot;}, {:phoenix_live_reload, &quot;~&gt; 1.2&quot;, only: :dev}, {:gettext, &quot;~&gt; 0.11&quot;}, {:plug_cowboy, &quot;~&gt; 2.0&quot;} ] end endNext, we need to configure our adapter to use the default MySQL credentials. Let's open up our config/dev.exs file and do that.config :hello_phoenix, HelloPhoenix.Repo, username: &quot;root&quot;, password: &quot;&quot;, database: &quot;hello_phoenix_dev&quot;If we have an existing configuration block for our HelloPhoenix.Repo, we can simply change the values to match our new ones. You also need to configure the correct values in the config/test.exs and config/prod.secret.exs files as well.The last change is to open up lib/hello_phoenix/repo.ex and make sure to set the :adapter to Ecto.Adapters.MyXQL.Now all we need to do is fetch our new dependency, and we'll be ready to go.$ mix do deps.get, compileWith our new adapter installed and configured, we're ready to create our database.$ mix ecto.createThe database for HelloPhoenix.repo has been created. We're also ready to run any migrations, or do anything else with Ecto that we might choose.$ mix ecto.migrate [info] == Running HelloPhoenix.Repo.Migrations.CreateUser.change/0 forward [info] create table users [info] == Migrated in 0.2s","ref":"ecto.html#using-mysql","title":"Ecto - Using MySQL","type":"extras"},{"doc":"While Phoenix uses the Ecto project to interact with the data access layer, there are many other data access options, some even built into the Erlang standard library. ETS and DETS are key value data stores built into OTP. OTP also provides a relational database called mnesia with its own query language called QLC. Both Elixir and Erlang also have a number of libraries for working with a wide range of popular data stores.The data world is your oyster, but we won't be covering these options in these guides.","ref":"ecto.html#other-options","title":"Ecto - Other options","type":"extras"},{"doc":"ContextsRequirement: This guide expects that you have gone through the introductory guides and got a Phoenix application up and running.Requirement: This guide expects that you have gone through the Request life-cycle guide.Requirement: This guide expects that you have gone through the Ecto guide.So far, we've built pages, wired up controller actions through our routers, and learned how Ecto allows data to be validated and persisted. Now it's time to tie it all together by writing web-facing features that interact with our greater Elixir application.When building a Phoenix project, we are first and foremost building an Elixir application. Phoenix's job is to provide a web interface into our Elixir application. Naturally, we compose our applications with modules and functions, but simply defining a module with a few functions isn't enough when designing an application. It's vital to think about your application design when writing code. Let's find out how.How to read this guide: Using the context generators is a great way for beginners and intermediate Elixir programmers alike to get up and running quickly while thoughtfully designing their applications. This guide focuses on those readers. On the other hand, experienced developers may get more mileage from nuanced discussions around application design. For those readers, we include a frequently asked questions (FAQ) section at the end of the guide which brings different perspectives to some design decisions made throughout the guide. Beginners can safely skip the FAQ sections and return later when they're ready to dig deeper.","ref":"contexts.html","title":"Contexts","type":"extras"},{"doc":"Contexts are dedicated modules that expose and group related functionality. For example, anytime you call Elixir's standard library, be it Logger.info/1 or Stream.map/2, you are accessing different contexts. Internally, Elixir's logger is made of multiple modules, but we never interact with those modules directly. We call the Logger module the context, exactly because it exposes and groups all of the logging functionality.Phoenix projects are structured like Elixir and any other Elixir project – we split our code into contexts. A context will group related functionality, such as posts and comments, often encapsulating patterns such as data access and data validation. By using contexts, we decouple and isolate our systems into manageable, independent parts.Let's use these ideas to build out our web application. Our goal is to build a user system as well as a basic content management system for adding and editing page content. Let's get started!Adding an Accounts ContextUser accounts are often wide-reaching across a platform so it's important to think upfront about writing a well-defined interface. With that in mind, our goal is to build an accounts API that handles creating, updating, and deleting user accounts, as well as authenticating user credentials. We'll start off with basic features, but as we add authentication later, we'll see how starting with a solid foundation allows us to grow our application naturally as we add functionality.Phoenix includes the mix phx.gen.html, mix phx.gen.json, mix phx.gen.live, and mix phx.gen.context generators that apply the ideas of isolating functionality in our applications into contexts. These generators are a great way to hit the ground running while Phoenix nudges you in the right direction to grow your application. Let's put these tools to use for our new user accounts context.In order to run the context generators, we need to come up with a module name that groups the related functionality that we're building. In the Ecto guide, we saw how we can use Changesets and Repos to validate and persist user schemas, but we didn't integrate this with our application at large. In fact, we didn't think about where a &quot;user&quot; in our application should live at all. Let's take a step back and think about the different parts of our system. We know that we'll have users of our product. Along with users comes things like account login credentials and user registration. An Accounts context in our system is a natural place for our user functionality to live.Naming things is hard. If you're stuck when trying to come up with a context name when the grouped functionality in your system isn't yet clear, you can simply use the plural form of the resource you're creating. For example, a Users context for managing users. As you grow your application and the parts of your system become clear, you can simply rename the context to a more refined name at a later time.Before we use the generators, we need to undo the changes we made in the Ecto guide, so we can give our user schema a proper home. Run these commands to undo our previous work:$ rm lib/hello/user.ex $ rm priv/repo/migrations/*_create_users.exsNext, let's reset our database so we also discard the table we have just removed:$ mix ecto.reset Generated hello app The database for Hello.Repo has been dropped The database for Hello.Repo has been created 14:38:37.418 [info] Migrations already upNow we're ready to create our accounts context. We'll use mix phx.gen.html which creates a context module that wraps up Ecto access for creating, updating, and deleting users, along with web files like controllers and templates for the web interface into our context. Run the following command at your project root:$ mix phx.gen.html Accounts User users name:string \\ username:string:unique * creating lib/hello_web/controllers/user_controller.ex * creating lib/hello_web/templates/user/edit.html.eex * creating lib/hello_web/templates/user/form.html.eex * creating lib/hello_web/templates/user/index.html.eex * creating lib/hello_web/templates/user/new.html.eex * creating lib/hello_web/templates/user/show.html.eex * creating lib/hello_web/views/user_view.ex * creating test/hello_web/controllers/user_controller_test.exs * creating lib/hello/accounts/user.ex * creating priv/repo/migrations/20170629175236_create_users.exs * creating lib/hello/accounts.ex * injecting lib/hello/accounts.ex * creating test/hello/accounts_test.exs * injecting test/hello/accounts_test.exs Add the resource to your browser scope in lib/hello_web/router.ex: resources &quot;/users&quot;, UserController Remember to update your repository by running migrations: $ mix ecto.migrate Phoenix generated the web files as expected in lib/hello_web/. We can also see our context files were generated inside a lib/hello/accounts.ex file and our user schema in the directory of the same name. Note the difference between lib/hello and lib/hello_web. We have an Accounts module to serve as the public API for account functionality, as well as an Accounts.User struct, which is an Ecto schema for casting and validating user account data. Phoenix also provided web and context tests for us, which we'll look at later. For now, let's follow the instructions and add the route according to the console instructions, in lib/hello_web/router.ex: scope &quot;/&quot;, HelloWeb do pipe_through :browser get &quot;/&quot;, PageController, :index + resources &quot;/users&quot;, UserController endWith the new route in place, Phoenix reminds us to update our repo by running mix ecto.migrate. Let's do that now:$ mix ecto.migrate [info] == Running Hello.Repo.Migrations.CreateUsers.change/0 forward [info] create table users [info] create index users_username_index [info] == Migrated in 0.0sBefore we jump into the generated code, let's start the server with mix phx.server and visit http://localhost:4000/users. Let's follow the &quot;New User&quot; link and click the &quot;Submit&quot; button without providing any input. We should be greeted with the following output:Oops, something went wrong! Please check the errors below.When we submit the form, we can see all the validation errors inline with the inputs. Nice! Out of the box, the context generator included the schema fields in our form template and we can see our default validations for required inputs are in effect. Let's enter some example user data and resubmit the form:User created successfully. Show User Name: Chris McCord Username: chrismccordIf we follow the &quot;Back&quot; link, we get a list of all users, which should contain the one we just created. Likewise, we can update this record or delete it. Now that we've seen how it works in the browser, it's time to take a look at the generated code.","ref":"contexts.html#thinking-about-design","title":"Contexts - Thinking about design","type":"extras"},{"doc":"That little mix phx.gen.html command packed a surprising punch. We got a lot of functionality out-of-the-box for creating, updating, and deleting users. This is far from a full-featured app, but remember, generators are first and foremost learning tools and a starting point for you to begin building real features. Code generation can't solve all your problems, but it will teach you the ins and outs of Phoenix and nudge you towards the proper mind-set when designing your application.Let's first check out the UserController that was generated in lib/hello_web/controllers/user_controller.ex:defmodule HelloWeb.UserController do use HelloWeb, :controller alias Hello.Accounts alias Hello.Accounts.User def index(conn, _params) do users = Accounts.list_users() render(conn, &quot;index.html&quot;, users: users) end def new(conn, _params) do changeset = Accounts.change_user(%User{}) render(conn, &quot;new.html&quot;, changeset: changeset) end def create(conn, %{&quot;user&quot; =&gt; user_params}) do case Accounts.create_user(user_params) do {:ok, user} -&gt; conn |&gt; put_flash(:info, &quot;User created successfully.&quot;) |&gt; redirect(to: Routes.user_path(conn, :show, user)) {:error, %Ecto.Changeset{} = changeset} -&gt; render(conn, &quot;new.html&quot;, changeset: changeset) end end ... endWe've seen how controllers work in our controller guide, so the code probably isn't too surprising. What is worth noticing is how our controller calls into the Accounts context. We can see that the index action fetches a list of users with Accounts.list_users/0, and how users are persisted in the create action with Accounts.create_user/1. We haven't yet looked at the accounts context, so we don't yet know how user fetching and creation is happening under the hood – but that's the point. Our Phoenix controller is the web interface into our greater application. It shouldn't be concerned with the details of how users are fetched from the database or persisted into storage. We only care about telling our application to perform some work for us. This is great because our business logic and storage details are decoupled from the web layer of our application. If we move to a full-text storage engine later for fetching users instead of a SQL query, our controller doesn't need to be changed. Likewise, we can reuse our context code from any other interface in our application, be it a channel, mix task, or long-running process importing CSV data.In the case of our create action, when we successfully create a user, we use Phoenix.Controller.put_flash/3 to show a success message, and then we redirect to the user_path's show page. Conversely, if Accounts.create_user/1 fails, we render our &quot;new.html&quot; template and pass along the Ecto changeset for the template to lift error messages from.Next, let's dig deeper and check out our Accounts context in lib/hello/accounts.ex:defmodule Hello.Accounts do @moduledoc &quot;&quot;&quot; The Accounts context. &quot;&quot;&quot; import Ecto.Query, warn: false alias Hello.Repo alias Hello.Accounts.User @doc &quot;&quot;&quot; Returns the list of users. ## Examples iex&gt; list_users() [%User{}, ...] &quot;&quot;&quot; def list_users do Repo.all(User) end ... endThis module will be the public API for all account functionality in our system. For example, in addition to user account management, we may also handle user login credentials, account preferences, and password reset generation. If we look at the list_users/0 function, we can see the private details of user fetching. And it's super simple. We have a call to Repo.all(User). We saw how Ecto repo queries worked in the Ecto guide, so this call should look familiar. Our list_users function is a generalized function specifying the intent of our code – namely to list users. The details of that intent where we use our Repo to fetch the users from our PostgreSQL database is hidden from our callers. This is a common theme we'll see re-iterated as we use the Phoenix generators. Phoenix will push us to think about where we have different responsibilities in our application, and then to wrap up those different areas behind well-named modules and functions that make the intent of our code clear, while encapsulating the details.Now we know how data is fetched, but how are users persisted? Let's take a look at the Accounts.create_user/1 function: @doc &quot;&quot;&quot; Creates a user. ## Examples iex&gt; create_user(%{field: value}) {:ok, %User{}} iex&gt; create_user(%{field: bad_value}) {:error, %Ecto.Changeset{}} &quot;&quot;&quot; def create_user(attrs \\\\ %{}) do %User{} |&gt; User.changeset(attrs) |&gt; Repo.insert() endThere's more documentation than code here, but a couple of things are important to highlight. First, we can see again that our Ecto Repo is used under the hood for database access. You probably also noticed the call to User.changeset/2. We talked about changesets before, and now we see them in action in our context.If we open up the User schema in lib/hello/accounts/user.ex, it will look immediately familiar:defmodule Hello.Accounts.User do use Ecto.Schema import Ecto.Changeset alias Hello.Accounts.User schema &quot;users&quot; do field :name, :string field :username, :string timestamps() end @doc false def changeset(%User{} = user, attrs) do user |&gt; cast(attrs, [:name, :username]) |&gt; validate_required([:name, :username]) |&gt; unique_constraint(:username) end endThis is just what we saw before when we ran mix phx.gen.schema, except here we see a @doc false above our changeset/2 function. This tells us that while this function is publicly callable, it's not part of the public context API. Callers that build changesets do so via the context API. For example, Accounts.create_user/1 calls into our User.changeset/2 to build the changeset from user input. Callers, such as our controller actions, do not access User.changeset/2 directly. All interaction with our user changesets is done through the public Accounts context.","ref":"contexts.html#starting-with-generators","title":"Contexts - Starting With Generators","type":"extras"},{"doc":"Our basic user account features are nice, but let's take it up a notch by supporting user login credentials. We won't implement a complete authentication system, but we'll give ourselves a good start to grow such a system from. Many authentication solutions couple the user credentials to an account in a one-to-one fashion, but this often causes issues. For example, supporting different login methods, such as social login or recovery email addresses, will cause major code changes. Let's set up a credentials association that will allow us to start off tracking a single credential per account, but easily support more features later.For now, user credentials will contain only email information. Our first order of business is to decide where credentials live in the application. We have our Accounts context, which manages user accounts. User credentials is a natural fit here. Phoenix is also smart enough to generate code inside an existing context, which makes adding new resources to a context a breeze. Run the following command at your project root:Sometimes it may be tricky to determine if two resources belong to the same context or not. In those cases, prefer distinct contexts per resource and refactor later if necessary. Otherwise you can easily end-up with large contexts of loosely related entities. Also keep in mind that the fact two resources are related does not necessarily mean they belong to the same context, otherwise you would quickly end-up with one large context, as the majority of resources in an application are connected to each other. To sum it up: if you are unsure, you should prefer explicit modules (contexts) between resources.$ mix phx.gen.context Accounts Credential credentials \\ email:string:unique user_id:references:users * creating lib/hello/accounts/credential.ex * creating priv/repo/migrations/20170629180555_create_credentials.exs * injecting lib/hello/accounts.ex * injecting test/hello/accounts_test.exs Remember to update your repository by running migrations: $ mix ecto.migrateThis time around, we used mix phx.gen.context, which is just like mix phx.gen.html, except it doesn't generate the web files for us. Since we already have controllers and templates for managing users, we can integrate the new credential features into our existing web form.We can see from the output that Phoenix generated an accounts/credential.ex file for our Accounts.Credential schema, as well as a migration. Notably, phoenix said it was * injecting code into the existing accounts.ex context file and test file. Since our Accounts module already exists, Phoenix knows to inject our code here.Before we run our migrations, we need to make one change to the generated migration to enforce data integrity of user account credentials. In our case, we want a user's credentials to be deleted when the parent user is removed. Make the following change to your *_create_credentials.exs migration file in priv/repo/migrations/: def change do create table(:credentials) do add :email, :string - add :user_id, references(:users, on_delete: :nothing) + add :user_id, references(:users, on_delete: :delete_all), + null: false timestamps() end create unique_index(:credentials, [:email]) create index(:credentials, [:user_id]) endWe changed the :on_delete option from :nothing to :delete_all, which will generate a foreign key constraint that will delete all credentials for a given user when the user is removed from the database. Likewise, we also passed null: false to disallow creating credentials without an existing user. By using a database constraint, we enforce data integrity at the database level, rather than relying on ad-hoc and error-prone application logic.Next, let's migrate up our database as Phoenix instructed:$ mix ecto.migrate mix ecto.migrate Compiling 2 files (.ex) Generated hello app [info] == Running Hello.Repo.Migrations.CreateCredentials.change/0 forward [info] create table credentials [info] create index credentials_email_index [info] create index credentials_user_id_index [info] == Migrated in 0.0sBefore we integrate credentials in the web layer, we need to let our context know how to associate users and credentials. First, open up lib/hello/accounts/user.ex and add the following association:+ alias Hello.Accounts.Credential schema &quot;users&quot; do field :name, :string field :username, :string + has_one :credential, Credential timestamps() end We used Ecto.Schema's has_one macro to let Ecto know how to associate our parent User to a child Credential. Next, let's add the relationships in the opposite direction in accounts/credential.ex:+ alias Hello.Accounts.User schema &quot;credentials&quot; do field :email, :string - field :user_id, :id + belongs_to :user, User timestamps() end We used the belongs_to macro to map our child relationship to the parent User. With our schema associations set up, let's open up accounts.ex and make the following changes to the generated list_users and get_user! functions: def list_users do User |&gt; Repo.all() |&gt; Repo.preload(:credential) end def get_user!(id) do User |&gt; Repo.get!(id) |&gt; Repo.preload(:credential) endWe rewrote the list_users/0 and get_user!/1 to preload the credential association whenever we fetch users. The Repo preload functionality fetches a schema's association data from the database, then places it inside the schema. When operating on a collection, such as our query in list_users, Ecto can efficiently preload the associations in a single query. This allows us to represent our %Accounts.User{} structs as always containing credentials without the caller having to worry about fetching the extra data.Next, let's expose our new feature to the web by adding the credentials input to our user form. Open up lib/hello_web/templates/user/form.html.eex and key in the new credential form group above the submit button: ... + &lt;div class=&quot;form-group&quot;&gt; + &lt;%= inputs_for f, :credential, fn cf -&gt; %&gt; + &lt;%= label cf, :email %&gt; + &lt;%= text_input cf, :email %&gt; + &lt;%= error_tag cf, :email %&gt; + &lt;% end %&gt; + &lt;/div&gt; &lt;%= submit &quot;Submit&quot; %&gt;We used Phoenix.HTML's inputs_for function to add an associations nested fields within the parent form. Within the nested inputs, we rendered our credential's email field and included the label and error_tag helpers just like our other inputs.Next, let's show the user's email address in the user show template. Add the following code to lib/hello_web/templates/user/show.html.eex: ... + &lt;li&gt; + &lt;strong&gt;Email:&lt;/strong&gt; + &lt;%= @user.credential.email %&gt; + &lt;/li&gt; &lt;/ul&gt; Now if we visit http://localhost:4000/users/new, we'll see the new email input, but if you try to save a user, you'll find that the email field is ignored. No validations are run telling you it was blank and the data was not saved, and at the end you'll get an exception (UndefinedFunctionError) function nil.email/0 is undefined or private. What gives?We used Ecto's belongs_to and has_one associations to wire-up how our data is related at the context level, but remember this is decoupled from our web-facing user input. To associate user input to our schema associations, we need to handle it the way we've handled other user input so far – in changesets. Remove the alias for Credential added by the generator and modify your alias Hello.Accounts.User, create_user/1 and update_user/2 functions in your Accounts context to build a changeset which knows how to cast user input with nested credential information:- alias Hello.Accounts.User + alias Hello.Accounts.{User, Credential} ... def update_user(%User{} = user, attrs) do user |&gt; User.changeset(attrs) + |&gt; Ecto.Changeset.cast_assoc(:credential, with: &amp;Credential.changeset/2) |&gt; Repo.update() end def create_user(attrs \\\\ %{}) do %User{} |&gt; User.changeset(attrs) + |&gt; Ecto.Changeset.cast_assoc(:credential, with: &amp;Credential.changeset/2) |&gt; Repo.insert() end ... - alias Hello.Accounts.CredentialWe updated the functions to pipe our user changeset into Ecto.Changeset.cast_assoc/3. Ecto's cast_assoc/3 allows us to tell the changeset how to cast user input to a schema relation. We also used the :with option to tell Ecto to use our Credential.changeset/2 function to cast the data. This way, any validations we perform in Credential.changeset/2 will be applied when saving the User changeset.Finally, if you visit http://localhost:4000/users/new and attempt to save an empty email address, you'll see the proper validation error message. If you enter valid information, the data will be casted and persisted properly.Show User Name: Chris McCord Username: chrismccord Email: chris@example.comIt's not much to look at yet, but it works! We added relationships within our context complete with data integrity enforced by the database. Not bad. Let's keep building!","ref":"contexts.html#in-context-relationships","title":"Contexts - In-context Relationships","type":"extras"},{"doc":"As we've seen, your context modules are dedicated modules that expose and group related functionality. Phoenix generates generic functions, such as list_users and update_user, but they only serve as a basis for you to grow your business logic and application from. To begin extending our Accounts context with real features, let's address an obvious issue of our application – we can create users with credentials in our system, but they have no way of signing in with those credentials. Building a complete user authentication system is beyond the scope of this guide, but let's get started with a basic email-only sign-in page that allows us to track a current user's session. This will let us focus on extending our Accounts context while giving you a good start to grow a complete authentication solution from.To start, let's think of a function name that describes what we want to accomplish. To authenticate a user by email address, we'll need a way to lookup that user and verify their entered credentials are valid. We can do this by exposing a single function on our Accounts context.&gt; user = Accounts.authenticate_by_email_password(email, password)That looks nice. A descriptive name that exposes the intent of our code is best. This function makes it crystal clear what purpose it serves, while allowing our caller to remain blissfully unaware of the internal details. Make the following additions to your lib/hello/accounts.ex file:def authenticate_by_email_password(email, _password) do query = from u in User, inner_join: c in assoc(u, :credential), where: c.email == ^email case Repo.one(query) do %User{} = user -&gt; {:ok, user} nil -&gt; {:error, :unauthorized} end endWe defined an authenticate_by_email_password/2 function, which discards the password field for now, but you could integrate tools like guardian or comeonin as you continue building your application. All we need to do in our function is find the user with matching credentials and return the %Accounts.User{} struct in a :ok tuple, or an {:error, :unauthorized} value to let the caller know their authentication attempt has failed.Now that we can authenticate a user from our context, let's add a login page to our web layer. First create a new controller in lib/hello_web/controllers/session_controller.ex:defmodule HelloWeb.SessionController do use HelloWeb, :controller alias Hello.Accounts def new(conn, _) do render(conn, &quot;new.html&quot;) end def create(conn, %{&quot;user&quot; =&gt; %{&quot;email&quot; =&gt; email, &quot;password&quot; =&gt; password}}) do case Accounts.authenticate_by_email_password(email, password) do {:ok, user} -&gt; conn |&gt; put_flash(:info, &quot;Welcome back!&quot;) |&gt; put_session(:user_id, user.id) |&gt; configure_session(renew: true) |&gt; redirect(to: &quot;/&quot;) {:error, :unauthorized} -&gt; conn |&gt; put_flash(:error, &quot;Bad email/password combination&quot;) |&gt; redirect(to: Routes.session_path(conn, :new)) end end def delete(conn, _) do conn |&gt; configure_session(drop: true) |&gt; redirect(to: &quot;/&quot;) end endWe defined a SessionController to handle users signing in and out of the application. Our new action is responsible for simply rendering a &quot;new session&quot; form, which posts out to the create action of our controller. In create, we pattern match the form fields and call into our Accounts.authenticate_by_email_password/2 that we just defined. If successful, we use Plug.Conn.put_session/3 to place the authenticated user's ID in the session, and redirect to the home page with a successful welcome message. We also called configure_session(conn, renew: true) before redirecting to avoid session fixation attacks. If authentication fails, we add a flash error message, and redirect to the sign-in page for the user to try again. To finish the controller, we support a delete action which simply calls Plug.Conn.configure_session/2 to drop the session and redirect to the home page.Next, let's wire up our session routes in lib/hello_web/router.ex: scope &quot;/&quot;, HelloWeb do pipe_through :browser get &quot;/&quot;, PageController, :index resources &quot;/users&quot;, UserController + resources &quot;/sessions&quot;, SessionController, only: [:new, :create, :delete], singleton: true endWe used resources to generate a set of routes under the &quot;/session&quot; path. This is what we've done for other routes, except this time we also passed the :only option to limit which routes are generated, since we only need to support :new, :create, and :delete actions. We also used the singleton: true option, which defines all the RESTful routes, but does not require a resource ID to be passed along in the URL. We don't need an ID in the URL because our actions are always scoped to the &quot;current&quot; user in the system. The ID is always in the session. Before we finish our router, let's add an authentication plug to the router that will allow us to lock down certain routes after a user has used our new session controller to sign-in. Add the following function to lib/hello_web/router.ex: defp authenticate_user(conn, _) do case get_session(conn, :user_id) do nil -&gt; conn |&gt; Phoenix.Controller.put_flash(:error, &quot;Login required&quot;) |&gt; Phoenix.Controller.redirect(to: &quot;/&quot;) |&gt; halt() user_id -&gt; assign(conn, :current_user, Hello.Accounts.get_user!(user_id)) end endWe defined an authenticate_user/2 plug in the router which simply uses Plug.Conn.get_session/2 to check for a :user_id in the session. If we find one, it means a user has previously authenticated, and we call into Hello.Accounts.get_user!/1 to place our :current_user into the connection assigns. If we don't have a session, we add a flash error message, redirect to the homepage, and we use Plug.Conn.halt/1 to halt further plugs downstream from being invoked. We won't use this new plug quite yet, but it will be ready and waiting as we add authenticated routes in just a moment.Lastly, we need SessionView to render a template for our login form. Create a new file in lib/hello_web/views/session_view.ex:defmodule HelloWeb.SessionView do use HelloWeb, :view endNext, add a new template in lib/hello_web/templates/session/new.html.eex:&lt;h1&gt;Sign in&lt;/h1&gt; &lt;%= form_for @conn, Routes.session_path(@conn, :create), [method: :post, as: :user], fn f -&gt; %&gt; &lt;div class=&quot;form-group&quot;&gt; &lt;%= text_input f, :email, placeholder: &quot;Email&quot; %&gt; &lt;/div&gt; &lt;div class=&quot;form-group&quot;&gt; &lt;%= password_input f, :password, placeholder: &quot;Password&quot; %&gt; &lt;/div&gt; &lt;div class=&quot;form-group&quot;&gt; &lt;%= submit &quot;Login&quot; %&gt; &lt;/div&gt; &lt;% end %&gt; &lt;%= form_for @conn, Routes.session_path(@conn, :delete), [method: :delete, as: :user], fn _ -&gt; %&gt; &lt;div class=&quot;form-group&quot;&gt; &lt;%= submit &quot;logout&quot; %&gt; &lt;/div&gt; &lt;% end %&gt;To keep things simple, we added both our sign-in and sign-out forms in this template. For our sign-in form, we pass the @conn directly to form_for, pointing our form action at session_path(@conn, :create). We also pass the as: :user option which tells Phoenix to wrap the form parameters inside a &quot;user&quot; key. Next, we used the text_input and password_input functions to send up an &quot;email&quot; and &quot;password&quot; parameter.For logging out, we simply defined a form that sends the DELETE HTTP method to server's session delete path. Now if you visit the sign-in page at http://localhost:4000/sessions/new and enter a bad email address, you should be greeted with your flash message. Entering a valid email address will redirect to the home page with a success flash notice.With authentication in place, we're in good shape to begin building out our next features.","ref":"contexts.html#adding-account-functions","title":"Contexts - Adding Account functions","type":"extras"},{"doc":"Now that we have the beginnings of user account and credential features, let's begin to work on the other main features of our application – managing page content. We want to support a content management system (CMS) where authors can create and edit pages of the site. While we could extend our Accounts context with CMS features, if we step back and think about the isolation of our application, we can see it doesn't fit. An accounts system shouldn't care at all about a CMS system. The responsibilities of our Accounts context is to manage users and their credentials, not handle page content changes. There's a clear need here for a separate context to handle these responsibilities. Let's call it CMS.Let's create a CMS context to handle basic CMS duties. Before we write code, let's imagine we have the following CMS feature requirements:Page creation and updatesPages belong to Authors who are responsible for publishing changesAuthor information should appear with the page, and include information such as author bio and role within the CMS, such as &quot;editor&quot;, &quot;writer&quot;, or &quot;intern&quot;.From the description, it's clear we need a Page resource for storing page information. What about our author information? While we could extend our existing Accounts.User schema to include information such as bio and role, that would violate the responsibilities we've set up for our contexts. Why should our Account system now be aware of author information? Worse, with a field like &quot;role&quot;, the CMS role in the system will likely conflict or be confused with other account roles for our application. There's a better way.Applications with &quot;users&quot; are naturally heavily user driven. After all, our software is typically designed to be used by human end-users one way or another. Instead of extending our Accounts.User struct to track every field and responsibility of our entire platform, it's better to keep those responsibilities with the modules who own that functionality. In our case, we can create a CMS.Author struct that holds author specific fields as it relates to a CMS. Now we can place fields like &quot;role&quot; and &quot;bio&quot; here, where they naturally live. Likewise, we also gain specialized datastructures in our application that are suited to the domain that we are operating in, rather than a single %User{} in the system that has to be everything to everyone.With our plan set, let's get to work. Run the following command to generate our new context:$ mix phx.gen.html CMS Page pages title:string body:text \\ views:integer --web CMS * creating lib/hello_web/controllers/cms/page_controller.ex * creating lib/hello_web/templates/cms/page/edit.html.eex * creating lib/hello_web/templates/cms/page/form.html.eex * creating lib/hello_web/templates/cms/page/index.html.eex * creating lib/hello_web/templates/cms/page/new.html.eex * creating lib/hello_web/templates/cms/page/show.html.eex * creating lib/hello_web/views/cms/page_view.ex * creating test/hello_web/controllers/cms/page_controller_test.exs * creating lib/hello/cms/page.ex * creating priv/repo/migrations/20170629195946_create_pages.exs * creating lib/hello/cms.ex * injecting lib/hello/cms.ex * creating test/hello/cms/cms_test.exs * injecting test/hello/cms/cms_test.exs Add the resource to your CMS :browser scope in lib/hello_web/router.ex: scope &quot;/cms&quot;, HelloWeb.CMS, as: :cms do pipe_through :browser ... resources &quot;/pages&quot;, PageController end Remember to update your repository by running migrations: $ mix ecto.migrate The views attribute on the pages will not be updated directly by the user, so let's remove it from the generated form. Open lib/hello_web/templates/cms/page/form.html.eex and remove this part:- &lt;%= label f, :views %&gt; - &lt;%= number_input f, :views %&gt; - &lt;%= error_tag f, :views %&gt;Also, change lib/hello/cms/page.ex to remove :views from the permitted params: def changeset(%Page{} = page, attrs) do page - |&gt; cast(attrs, [:title, :body, :views]) - |&gt; validate_required([:title, :body, :views]) + |&gt; cast(attrs, [:title, :body]) + |&gt; validate_required([:title, :body]) endFinally, open up the new file in priv/repo/migrations to ensure the views attribute will have a default value: create table(:pages) do add :title, :string add :body, :text - add :views, :integer + add :views, :integer, default: 0 timestamps() endThis time we passed the --web option to the generator. This tells Phoenix what namespace to use for the web modules, such as controllers and views. This is useful when you have conflicting resources in the system, such as our existing PageController, as well as a way to naturally namespace paths and functionality of different features, like a CMS system. Phoenix instructed us to add a new scope to the router for a &quot;/cms&quot; path prefix. Let's copy paste the following into our lib/hello_web/router.ex, but we'll make one modification to the pipe_through macro: scope &quot;/cms&quot;, HelloWeb.CMS, as: :cms do pipe_through [:browser, :authenticate_user] resources &quot;/pages&quot;, PageController end We added the :authenticate_user plug to require a signed-in user for all routes within this CMS scope. With our routes in place, we can migrate up the database:$ mix ecto.migrate Compiling 12 files (.ex) Generated hello app [info] == Running Hello.Repo.Migrations.CreatePages.change/0 forward [info] create table pages [info] == Migrated in 0.0sNow, let's fire up the server with mix phx.server and visit http://localhost:4000/cms/pages. If we haven't logged in yet, we'll be redirected to the home page with a flash error message telling us to sign in. Let's sign in at http://localhost:4000/sessions/new, then re-visit http://localhost:4000/cms/pages. Now that we're authenticated, we should see a familiar resource listing for pages, with a New Page link.Before we create any pages, we need page authors. Let's run the mix phx.gen.context generator to generate an Author schema along with injected context functions:$ mix phx.gen.context CMS Author authors bio:text role:string \\ genre:string user_id:references:users:unique * creating lib/hello/cms/author.ex * creating priv/repo/migrations/20170629200937_create_authors.exs * injecting lib/hello/cms.ex * injecting test/hello/cms/cms_test.exs Remember to update your repository by running migrations: $ mix ecto.migrate We used the context generator to inject code, just like when we generated our credentials code. We added fields for the author bio, their role in the content management system, the genre the author writes in, and lastly a foreign key to a user in our accounts system. Since our accounts context is still the authority on end-users in our application, we will depend on it for our CMS authors. That said, any information specific to authors will stay in the authors schema. We could also decorate our Author with user account information by using virtual fields and never expose the User structure. This would ensure consumers of the CMS API are protected from changes in the User context.Before we migrate our database, we need to handle data integrity once again in the newly generated *_create_authors.exs migration. Open up the new file in priv/repo/migrations and make the following change to the foreign key constraint: def change do create table(:authors) do add :bio, :text add :role, :string add :genre, :string - add :user_id, references(:users, on_delete: :nothing) + add :user_id, references(:users, on_delete: :delete_all), + null: false timestamps() end create unique_index(:authors, [:user_id]) endWe used the :delete_all strategy again to enforce data integrity. This way, when a user is deleted from the application through Accounts.delete_user/1), we don't have to rely on application code in our Accounts context to worry about cleaning up the CMS author records. This keeps our application code decoupled and the data integrity enforcement where it belongs – in the database.Before we continue, we have a final migration to generate. Now that we have an authors table, we can associate pages and authors. Let's add an author_id field to the pages table. Run the following command to generate a new migration:$ mix ecto.gen.migration add_author_id_to_pages * creating priv/repo/migrations * creating priv/repo/migrations/20170629202117_add_author_id_to_pages.exsNow open up the new *_add_author_id_to_pages.exs file in priv/repo/migrations and key this in: def change do alter table(:pages) do add :author_id, references(:authors, on_delete: :delete_all), null: false end create index(:pages, [:author_id]) endWe used the alter macro to add a new author_id field to the pages table, with a foreign key to our authors table. We also used the on_delete: :delete_all option again to prune any pages when a parent author is deleted from the application.Now let's migrate up:$ mix ecto.migrate [info] == Running Hello.Repo.Migrations.CreateAuthors.change/0 forward [info] create table authors [info] create index authors_user_id_index [info] == Migrated in 0.0s [info] == Running Hello.Repo.Migrations.AddAuthorIdToPages.change/0 forward [info] == Migrated in 0.0sWith our database ready, let's integrate authors and posts in the CMS system.","ref":"contexts.html#cross-context-dependencies","title":"Contexts - Cross-context dependencies","type":"extras"},{"doc":"Dependencies in your software are often unavoidable, but we can do our best to limit them where possible and lessen the maintenance burden when a dependency is necessary. So far, we've done a great job isolating the two main contexts of our application from each other, but now we have a necessary dependency to handle.Our Author resource serves to keep the responsibilities of representing an author inside the CMS, but ultimately for an author to exist at all, an end-user represented by an Accounts.User must be present. Given this, our CMS context will have a data dependency on the Accounts context. With that in mind, we have two options. One is to expose APIs on the Accounts contexts that allows us to efficiently fetch user data for use in the CMS system, or we can use database joins to fetch the dependent data. Both are valid options given your tradeoffs and application size, but joining data from the database when you have a hard data dependency is just fine for a large class of applications. If you decide to break out coupled contexts into entirely separate applications and databases at a later time, you still gain the benefits of isolation. This is because your public context APIs will likely remain unchanged.Now that we know where our data dependencies exist, let's add our schema associations so we can tie pages to authors and authors to users. Make the following changes to lib/hello/cms/page.ex:+ alias Hello.CMS.Author schema &quot;pages&quot; do field :body, :string field :title, :string field :views, :integer + belongs_to :author, Author timestamps() endWe added a belongs_to relationships between pages and their authors. Next, let's add the association in the other direction in lib/hello/cms/author.ex: + alias Hello.CMS.Page schema &quot;authors&quot; do field :bio, :string field :genre, :string field :role, :string - field :user_id, :id + has_many :pages, Page + belongs_to :user, Hello.Accounts.User timestamps() endWe added the has_many association for author pages, and then introduced our data dependency on the Accounts context by wiring up the belongs_to association to our Accounts.User schema.With our associations in place, let's update our CMS context to require an author when creating or updating a page. We'll start off with data fetching changes. Open up your CMS context in lib/hello/cms.ex and replace the list_pages/0, get_page!/1, and get_author!/1 functions with the following definitions: alias Hello.CMS.{Page, Author} alias Hello.Accounts def list_pages do Page |&gt; Repo.all() |&gt; Repo.preload(author: [user: :credential]) end def get_page!(id) do Page |&gt; Repo.get!(id) |&gt; Repo.preload(author: [user: :credential]) end def get_author!(id) do Author |&gt; Repo.get!(id) |&gt; Repo.preload(user: :credential) endWe started by rewriting the list_pages/0 function to preload the associated author, user, and credential data from the database. Next, we rewrote get_page!/1 and get_author!/1 to also preload the necessary data.With our data access functions in place, let's turn our focus towards persistence. We can fetch authors alongside pages, but we haven't yet allowed authors to be persisted when we create or edit pages. Let's fix that. Open up lib/hello/cms.ex and make the following changes:def create_page(%Author{} = author, attrs \\\\ %{}) do %Page{} |&gt; Page.changeset(attrs) |&gt; Ecto.Changeset.put_change(:author_id, author.id) |&gt; Repo.insert() end def ensure_author_exists(%Accounts.User{} = user) do %Author{user_id: user.id} |&gt; Ecto.Changeset.change() |&gt; Ecto.Changeset.unique_constraint(:user_id) |&gt; Repo.insert() |&gt; handle_existing_author() end defp handle_existing_author({:ok, author}), do: author defp handle_existing_author({:error, changeset}) do Repo.get_by!(Author, user_id: changeset.data.user_id) endThere's a bit of a code here, so let's break it down. First, we rewrote the create_page function to require a CMS.Author struct, which represents the author publishing the post. We then take our changeset and pass it to Ecto.Changeset.put_change/2 to place the author_id association in the changeset. Next, we use Repo.insert to insert the new page into the database, containing our associated author_id.Our CMS system requires an author to exist for any end-user before they publish posts, so we added an ensure_author_exists function to programmatically allow authors to be created. Our new function accepts an Accounts.User struct and either finds the existing author in the application with that user.id, or creates a new author for the user. Our authors table has a unique constraint on the user_id foreign key, so we are protected from a race condition allowing duplicate authors. That said, we still need to protect ourselves from racing the insert of another user. To accomplish this, we use a purpose-built changeset with Ecto.Changeset.change/1 which accepts a new Author struct with our user_id. The changeset's only purpose is to convert a unique constraint violation into an error we can handle. After attempting to insert the new author with Repo.insert/1, we pipe to handle_existing_author/1 which matches on the success and error cases. For the success case, we are done and simply return the created author, otherwise we use Repo.get_by! to fetch the author for the user_id that already exists.That wraps up our CMS changes. Now, let's update our web layer to support our additions. Before we update our individual CMS controller actions, we need to make a couple of additions to the CMS.PageController plug pipeline. First, we must ensure an author exists for end-users accessing the CMS, and we need to authorize access to page owners.Open up your generated lib/hello_web/controllers/cms/page_controller.ex and make the following additions: plug :require_existing_author plug :authorize_page when action in [:edit, :update, :delete] ... defp require_existing_author(conn, _) do author = CMS.ensure_author_exists(conn.assigns.current_user) assign(conn, :current_author, author) end defp authorize_page(conn, _) do page = CMS.get_page!(conn.params[&quot;id&quot;]) if conn.assigns.current_author.id == page.author_id do assign(conn, :page, page) else conn |&gt; put_flash(:error, &quot;You can&#39;t modify that page&quot;) |&gt; redirect(to: Routes.cms_page_path(conn, :index)) |&gt; halt() end endWe added two new plugs to our CMS.PageController. The first plug, :require_existing_author, runs for every action in this controller. The require_existing_author/2 plug calls into our CMS.ensure_author_exists/1 and passes in the current_user from the connection assigns. After finding or creating the author, we use Plug.Conn.assign/3 to place a :current_author key into the assigns for use downstream.Next, we added an :authorize_page plug that makes use of plug's guard clause feature where we can limit the plug to only certain actions. The definition for our authorize_page/2 plug first fetches the page from the connection params, then does an authorization check against the current_author. If our current author's ID matches the fetched page ID, we have verified the page's owner is accessing the page and we simply assign the page into the connection assigns to be used in the controller action. If our authorization fails, we add a flash error message, redirect to the page index screen, and then call Plug.Conn.halt/1 to prevent the plug pipeline from continuing and invoking the controller action.With our new plugs in place, we can now modify our create, edit, update, and delete actions to make use of the new values in the connection assigns:- def edit(conn, %{&quot;id&quot; =&gt; id}) do + def edit(conn, _) do - page = CMS.get_page!(id) - changeset = CMS.change_page(page) + changeset = CMS.change_page(conn.assigns.page) - render(conn, &quot;edit.html&quot;, page: page, changeset: changeset) + render(conn, &quot;edit.html&quot;, changeset: changeset) end def create(conn, %{&quot;page&quot; =&gt; page_params}) do - case CMS.create_page(page_params) do + case CMS.create_page(conn.assigns.current_author, page_params) do {:ok, page} -&gt; conn |&gt; put_flash(:info, &quot;Page created successfully.&quot;) |&gt; redirect(to: Routes.cms_page_path(conn, :show, page)) {:error, %Ecto.Changeset{} = changeset} -&gt; render(conn, &quot;new.html&quot;, changeset: changeset) end end - def update(conn, %{&quot;id&quot; =&gt; id, &quot;page&quot; =&gt; page_params}) do + def update(conn, %{&quot;page&quot; =&gt; page_params}) do - page = CMS.get_page!(id) - case CMS.update_page(page, page_params) do + case CMS.update_page(conn.assigns.page, page_params) do {:ok, page} -&gt; conn |&gt; put_flash(:info, &quot;Page updated successfully.&quot;) |&gt; redirect(to: Routes.cms_page_path(conn, :show, page)) {:error, %Ecto.Changeset{} = changeset} -&gt; - render(conn, &quot;edit.html&quot;, page: page, changeset: changeset) + render(conn, &quot;edit.html&quot;, changeset: changeset) end end - def delete(conn, %{&quot;id&quot; =&gt; id}) do + def delete(conn, _) do - page = CMS.get_page!(id) - {:ok, _page} = CMS.delete_page(page) + {:ok, _page} = CMS.delete_page(conn.assigns.page) conn |&gt; put_flash(:info, &quot;Page deleted successfully.&quot;) |&gt; redirect(to: Routes.cms_page_path(conn, :index)) endWe modified the create action to grab our current_author from the connection assigns, which was placed there by our require_existing_author plug. We then passed our current author into CMS.create_page where it will be used to associate the author to the new page. Next, we changed the update action to pass the conn.assigns.page into CMS.update_page/2, rather than fetching it directly in the action. Since our authorize_page plug already fetched the page and placed it into the assigns, we can simply reference it here in the action. Similarly, we updated the delete action to pass the conn.assigns.page into the CMS rather than fetching the page in the action.To complete the web changes, let's display the author when showing a page. First, open up lib/hello_web/views/cms/page_view.ex and add a helper function to handle formatting the author's name:defmodule HelloWeb.CMS.PageView do use HelloWeb, :view alias Hello.CMS def author_name(%CMS.Page{author: author}) do author.user.name end endNext, let's open up lib/hello_web/templates/cms/page/show.html.eex and make use of our new function:+ &lt;li&gt; + &lt;strong&gt;Author:&lt;/strong&gt; + &lt;%= author_name(@page) %&gt; + &lt;/li&gt; &lt;/ul&gt;Now, fire up your server with mix phx.server and try it out. Visit http://localhost:4000/cms/pages/new and save a new page.Page created successfully. Show Page Title: Home Body: Welcome to Phoenix! Views: 0 Author: ChrisAnd it works! We now have two isolated contexts responsible for user accounts and content management. We coupled the content management system to accounts where necessary, while keeping each system isolated wherever possible. This gives us a great base to grow our application from.","ref":"contexts.html#cross-context-data","title":"Contexts - Cross-context data","type":"extras"},{"doc":"Just like we extended our Accounts context with new application-specific functions like Accounts.authenticate_by_email_password/2, let's extend our generated CMS context with new functionality. For any CMS system, the ability to track how many times a page has been viewed is essential for popularity ranks. While we could try to use the existing CMS.update_page function, along the lines of CMS.update_page(user, page, %{views: page.views + 1}), this would not only be prone to race conditions, but it would also require the caller to know too much about our CMS system. To see why the race condition exists, let's walk through the possible execution of events:Intuitively, you would assume the following events:User 1 loads the page with count of 13User 1 saves the page with count of 14User 2 loads the page with count of 14User 2 loads the page with count of 15While in practice this would happen:User 1 loads the page with count of 13User 2 loads the page with count of 13User 1 saves the page with count of 14User 2 saves the page with count of 14The race conditions would make this an unreliable way to update the existing table since multiple callers may be updating out of date view values. There's a better way.Again, let's think of a function name that describes what we want to accomplish.&gt; page = CMS.inc_page_views(page)That looks great. Our callers will have no confusion over what this function does and we can wrap up the increment in an atomic operation to prevent race conditions.Open up your CMS context (lib/hello/cms.ex), and add this new function:def inc_page_views(%Page{} = page) do {1, [%Page{views: views}]} = from(p in Page, where: p.id == ^page.id, select: [:views]) |&gt; Repo.update_all(inc: [views: 1]) put_in(page.views, views) endWe built a query for fetching the current page given its ID which we pass to Repo.update_all. Ecto's Repo.update_all allows us to perform batch updates against the database, and is perfect for atomically updating values, such as incrementing our views count. The result of the repo operation returns the number of updated records, along with the selected schema values specified by the select option. When we receive the new page views, we use put_in(page.views, views) to place the new view count within the page.With our context function in place, let's make use of it in our CMS page controller. Update your show action in lib/hello_web/controllers/cms/page_controller.ex to call our new function:def show(conn, %{&quot;id&quot; =&gt; id}) do page = id |&gt; CMS.get_page!() |&gt; CMS.inc_page_views() render(conn, &quot;show.html&quot;, page: page) endWe modified our show action to pipe our fetched page into CMS.inc_page_views/1, which will return the updated page. Then we rendered our template just as before. Let's try it out. Refresh one of your pages a few times and watch the view count increase.We can also see our atomic update in action in the ecto debug logs:[debug] QUERY OK source=&quot;pages&quot; db=3.1ms UPDATE &quot;pages&quot; AS p0 SET &quot;views&quot; = p0.&quot;views&quot; + $1 WHERE (p0.&quot;id&quot; = $2) RETURNING p0.&quot;views&quot; [1, 3]Good work!As we've seen, designing with contexts gives you a solid foundation to grow your application from. Using discrete, well-defined APIs that expose the intent of your system allows you to write more maintainable applications with reusable code.","ref":"contexts.html#adding-cms-functions","title":"Contexts - Adding CMS functions","type":"extras"},{"doc":"Returning Ecto structures from context APIsAs we explored the context API, you might have wondered:If one of the goals of our context is to encapsulate Ecto Repo access, why does create_user/1 return an Ecto.Changeset struct when we fail to create a user?The answer is we've decided to expose %Ecto.Changeset{} as a public data-structure in our application. We saw before how changesets allow us to track field changes, perform validations, and generate error messages. Its use here is decoupled from the private Repo access and Ecto changeset API internals. We're exposing a data structure that the caller understands which contains the rich information like field errors. Conveniently for us, the phoenix_ecto project implements the necessary Phoenix.Param and Phoenix.HTML.FormData protocols which know how to handle %Ecto.Changeset{}'s for things like form generation and error messages. You can also think about it as being as if you had defined your own %Accounts.Changes{} struct for the same purpose and implemented the Phoenix protocols for the web-layer integration.Strategies for cross-context workflowsOur CMS context supports lazily creating authors in the system when a user decides to publish page content. This makes sense for our use case because not all users of our system will be CMS authors. But what if our use case were for when all users of our app are indeed authors?If we require a CMS.Author to exist every time an Accounts.User is created, we have to think carefully where to place this dependency. We know our CMS context depends on the Accounts context, but it's important to avoid cyclic dependencies across our contexts. For example, imagine we changed our Accounts.create_user function to:def create_user(attrs) do %User{} |&gt; User.changeset(attrs) |&gt; Ecto.Changeset.cast_assoc(:credential, with: &amp;Credential.changeset/2) |&gt; Ecto.Changeset.put_assoc(:author, %Author{...}) |&gt; Repo.insert() endThis may accomplish what we want, but now we need to wire up the schema relationships in the Accounts context to the CMS author. Worse, we have now taken our isolated Accounts context and required it to know about a content management system, which in turn knows about Accounts too. With time, cyclic dependencies would blurry the lines between contexts, which is not what we want for isolated responsibilities in our application. There's a better way to handle these requirements.If you find yourself in similar situations where you feel your use case is requiring you to create circular dependencies across contexts, it's a sign you need a new context in the system to handle these application requirements. In our case, what we really want is an interface that handles all requirements when a user is created or registers in our application. To handle this, we could create a UserRegistration context, which calls into both the Accounts and CMS APIs to create a user, then associate a CMS author. Not only would this allow our Accounts to remain as isolated as possible, it gives us a clear, obvious API to handle UserRegistration needs in the system. If you take this approach, you can also use tools like Ecto.Multi to handle transactions across different context operations without deeply coupling the internal database calls. Part of our UserRegistration API could look something like this:defmodule Hello.UserRegistration do alias Ecto.Multi alias Hello.{Accounts, CMS, Repo} def register_user(params) do Multi.new() |&gt; Multi.run(:user, fn _repo, _changes_so_far -&gt; Accounts.create_user(params) end) |&gt; Multi.run(:author, fn _repo, %{user: user} -&gt; {:ok, CMS.ensure_author_exists(user)} end) |&gt; Repo.transaction() end endWe can take advantage of Ecto.Multi to create a pipeline of operations that can be run inside a transaction of our Repo. If any given operation fails, the transaction will be rolled back and an error will be returned containing which operation failed, as well as the changes up to that point. In our register_user/1 example, we specified two operations, one that calls into Accounts.create_user/1 and another that passes the newly created user to CMS.ensure_author_exists/1. The final step of our function is to invoke the operations with Repo.transaction/1.The UserRegistration setup is likely simpler to implement than the dynamic author system we built – we decided to take the harder path exactly because those are decisions developers take on their applications every day.","ref":"contexts.html#faq","title":"Contexts - FAQ","type":"extras"},{"doc":"Mix TasksThere are currently a number of built-in Phoenix-specific and Ecto-specific mix tasks available to us within a newly-generated application. We can also create our own application specific tasks.Note to learn more about mix, you can read Elixir's official Introduction to Mix.","ref":"mix_tasks.html","title":"Mix Tasks","type":"extras"},{"doc":"➜ mix help --search &quot;phx&quot; mix local.phx # Updates the Phoenix project generator locally mix phx # Prints Phoenix help information mix phx.digest # Digests and compresses static files mix phx.digest.clean # Removes old versions of static assets. mix phx.gen.cert # Generates a self-signed certificate for HTTPS testing mix phx.gen.channel # Generates a Phoenix channel mix phx.gen.context # Generates a context with functions around an Ecto schema mix phx.gen.embedded # Generates an embedded Ecto schema file mix phx.gen.html # Generates controller, views, and context for an HTML resource mix phx.gen.json # Generates controller, views, and context for a JSON resource mix phx.gen.presence # Generates a Presence tracker mix phx.gen.schema # Generates an Ecto schema and migration file mix phx.gen.secret # Generates a secret mix phx.new # Creates a new Phoenix application mix phx.new.ecto # Creates a new Ecto project within an umbrella project mix phx.new.web # Creates a new Phoenix web project within an umbrella project mix phx.routes # Prints all routes mix phx.server # Starts applications and their serversWe have seen all of these at one point or another in the guides, but having all the information about them in one place seems like a good idea.We will cover all Phoenix Mix tasks, except phx.new, phx.new.ecto, and phx.new.web, which are part of the Phoenix installer. You can learn more about them or any other task by calling mix help TASK.mix phx.gen.htmlPhoenix offers the ability to generate all the code to stand up a complete HTML resource - ecto migration, ecto context, controller with all the necessary actions, view, and templates. This can be a tremendous timesaver. Let's take a look at how to make this happen.The mix phx.gen.html task takes a number of arguments, the module name of the context, the module name of the schema, the resource name, and a list of column_name:type attributes. The module name we pass in must conform to the Elixir rules of module naming, following proper capitalization.$ mix phx.gen.html Blog Post posts body:string word_count:integer * creating lib/hello_web/controllers/post_controller.ex * creating lib/hello_web/templates/post/edit.html.eex * creating lib/hello_web/templates/post/form.html.eex * creating lib/hello_web/templates/post/index.html.eex * creating lib/hello_web/templates/post/new.html.eex * creating lib/hello_web/templates/post/show.html.eex * creating lib/hello_web/views/post_view.ex * creating test/hello_web/controllers/post_controller_test.exs * creating lib/hello/blog/post.ex * creating priv/repo/migrations/20170906150129_create_posts.exs * creating lib/hello/blog.ex * injecting lib/hello/blog.ex * creating test/hello/blog/blog_test.exs * injecting test/hello/blog/blog_test.exsWhen mix phx.gen.html is done creating files, it helpfully tells us that we need to add a line to our router file as well as run our ecto migrations.Add the resource to your browser scope in lib/hello_web/router.ex: resources &quot;/posts&quot;, PostController Remember to update your repository by running migrations: $ mix ecto.migrateImportant: If we don't do this, we will see the following warnings in our logs, and our application will error when trying to execute the function.$ mix phx.server Compiling 17 files (.ex) warning: function HelloWeb.Router.Helpers.post_path/3 is undefined or private lib/hello_web/controllers/post_controller.ex:22:If we don't want to create a context or schema for our resource we can use the --no-context flag. Note that this still requires a context module name as a parameter.$ mix phx.gen.html Blog Post posts body:string word_count:integer --no-context * creating lib/hello_web/controllers/post_controller.ex * creating lib/hello_web/templates/post/edit.html.eex * creating lib/hello_web/templates/post/form.html.eex * creating lib/hello_web/templates/post/index.html.eex * creating lib/hello_web/templates/post/new.html.eex * creating lib/hello_web/templates/post/show.html.eex * creating lib/hello_web/views/post_view.ex * creating test/hello_web/controllers/post_controller_test.exsIt will tell us we need to add a line to our router file, but since we skipped the context, it won't mention anything about ecto.migrate.Add the resource to your browser scope in lib/hello_web/router.ex: resources &quot;/posts&quot;, PostControllerSimilarly - if we want a context created without a schema for our resource we can use the --no-schema flag.$ mix phx.gen.html Blog Post posts body:string word_count:integer --no-schema * creating lib/hello_web/controllers/post_controller.ex * creating lib/hello_web/templates/post/edit.html.eex * creating lib/hello_web/templates/post/form.html.eex * creating lib/hello_web/templates/post/index.html.eex * creating lib/hello_web/templates/post/new.html.eex * creating lib/hello_web/templates/post/show.html.eex * creating lib/hello_web/views/post_view.ex * creating test/hello_web/controllers/post_controller_test.exs * creating lib/hello/blog.ex * injecting lib/hello/blog.ex * creating test/hello/blog/blog_test.exs * injecting test/hello/blog/blog_test.exsIt will tell us we need to add a line to our router file, but since we skipped the schema, it won't mention anything about ecto.migrate.mix phx.gen.jsonPhoenix also offers the ability to generate all the code to stand up a complete JSON resource - ecto migration, ecto schema, controller with all the necessary actions and view. This command will not create any template for the app.The mix phx.gen.json task takes a number of arguments, the module name of the context, the module name of the schema, the resource name, and a list of column_name:type attributes. The module name we pass in must conform to the Elixir rules of module naming, following proper capitalization.$ mix phx.gen.json Blog Post posts title:string content:string * creating lib/hello_web/controllers/post_controller.ex * creating lib/hello_web/views/post_view.ex * creating test/hello_web/controllers/post_controller_test.exs * creating lib/hello_web/views/changeset_view.ex * creating lib/hello_web/controllers/fallback_controller.ex * creating lib/hello/blog/post.ex * creating priv/repo/migrations/20170906153323_create_posts.exs * creating lib/hello/blog.ex * injecting lib/hello/blog.ex * creating test/hello/blog/blog_test.exs * injecting test/hello/blog/blog_test.exsWhen mix phx.gen.json is done creating files, it helpfully tells us that we need to add a line to our router file as well as run our ecto migrations.Add the resource to your :api scope in lib/hello_web/router.ex: resources &quot;/posts&quot;, PostController, except: [:new, :edit] Remember to update your repository by running migrations: $ mix ecto.migrateImportant: If we don't do this, we'll get the following warning in our logs and the application will error when attempting to load the page:$ mix phx.server Compiling 19 files (.ex) warning: function HelloWeb.Router.Helpers.post_path/3 is undefined or private lib/hello_web/controllers/post_controller.ex:18mix phx.gen.json also supports --no-context, --no-schema, and others, as in mix phx.gen.html.mix phx.gen.contextIf we don't need a complete HTML/JSON resource and instead are only interested in a context, we can use the mix phx.gen.context task. It will generate a context, a schema, a migration and a test case.The mix phx.gen.context task takes a number of arguments, the module name of the context, the module name of the schema, the resource name, and a list of column_name:type attributes.$ mix phx.gen.context Accounts User users name:string age:integer * creating lib/hello/accounts/user.ex * creating priv/repo/migrations/20170906161158_create_users.exs * creating lib/hello/accounts.ex * injecting lib/hello/accounts.ex * creating test/hello/accounts/accounts_test.exs * injecting test/hello/accounts/accounts_test.exsNote: If we need to namespace our resource we can simply namespace the first argument of the generator.* creating lib/hello/admin/accounts/user.ex * creating priv/repo/migrations/20170906161246_create_users.exs * creating lib/hello/admin/accounts.ex * injecting lib/hello/admin/accounts.ex * creating test/hello/admin/accounts/accounts_test.exs * injecting test/hello/admin/accounts/accounts_test.exsmix phx.gen.schemaIf we don't need a complete HTML/JSON resource and are not interested in generating or altering a context we can use the mix phx.gen.schema task. It will generate a schema, and a migration.The mix phx.gen.schema task takes a number of arguments, the module name of the schema (which may be namespaced), the resource name, and a list of column_name:type attributes.$ mix phx.gen.schema Accounts.Credential credentials email:string:unique user_id:references:users * creating lib/hello/accounts/credential.ex * creating priv/repo/migrations/20170906162013_create_credentials.exsmix phx.gen.channelThis task will generate a basic Phoenix channel as well a test case for it. It takes the module name for the channel as argument:$ mix phx.gen.channel Room * creating lib/hello_web/channels/room_channel.ex * creating test/hello_web/channels/room_channel_test.exsWhen mix phx.gen.channel is done, it helpfully tells us that we need to add a channel route to our router file.Add the channel to your `lib/hello_web/channels/user_socket.ex` handler, for example: channel &quot;rooms:lobby&quot;, HelloWeb.RoomChannelmix phx.gen.presenceThis task will generate a Presence tracker. The module name can be passed as an argument, Presence is used if no module name is passed.$ mix phx.gen.presence Presence $ lib/hello_web/channels/presence.exmix phx.routesThis task has a single purpose, to show us all the routes defined for a given router. We saw it used extensively in the Routing Guide.If we don't specify a router for this task, it will default to the router Phoenix generated for us.$ mix phx.routes page_path GET / TaskTester.PageController.index/2We can also specify an individual router if we have more than one for our application.$ mix phx.routes TaskTesterWeb.Router page_path GET / TaskTesterWeb.PageController.index/2mix phx.serverThis is the task we use to get our application running. It takes no arguments at all. If we pass any in, they will be silently ignored.$ mix phx.server [info] Running TaskTesterWeb.Endpoint with Cowboy on port 4000 (http)It silently ignores our DoesNotExist argument.$ mix phx.server DoesNotExist [info] Running TaskTesterWeb.Endpoint with Cowboy on port 4000 (http)If we would like to start our application and also have an iex session open to it, we can run the mix task within iex like this, iex -S mix phx.server.$ iex -S mix phx.server Erlang/OTP 17 [erts-6.4] [source] [64-bit] [smp:8:8] [async-threads:10] [hipe] [kernel-poll:false] [dtrace] [info] Running TaskTesterWeb.Endpoint with Cowboy on port 4000 (http) Interactive Elixir (1.0.4) - press Ctrl+C to exit (type h() ENTER for help) iex(1)&gt;mix phx.digestThis task does two things, it creates a digest for our static assets and then compresses them.&quot;Digest&quot; here refers to an MD5 digest of the contents of an asset which gets added to the filename of that asset. This creates a sort of &quot;fingerprint&quot; for it. If the digest doesn't change, browsers and CDNs will use a cached version. If it does change, they will re-fetch the new version.Before we run this task let's inspect the contents of two directories in our hello application.First priv/static which should look similar to this:├── images │ └── phoenix.png ├── robots.txtAnd then assets/ which should look similar to this:├── css │ └── app.scss ├── js │ └── app.js ├── vendor │ └── phoenix.jsAll of these files are our static assets. Now let's run the mix phx.digest task.$ mix phx.digest Check your digested files at 'priv/static'.We can now do as the task suggests and inspect the contents of priv/static directory. We'll see that all files from assets/ have been copied over to priv/static and also each file now has a couple of versions. Those versions are:the original filea compressed file with gzipa file containing the original file name and its digesta compressed file containing the file name and its digestWe can optionally determine which files should be gzipped by using the :gzippable_exts option in the config file:config :phoenix, :gzippable_exts, ~w(.js .css)Note: We can specify a different output folder where mix phx.digest will put processed files. The first argument is the path where the static files are located.$ mix phx.digest priv/static -o www/public Check your digested files at 'www/public'.","ref":"mix_tasks.html#phoenix-tasks","title":"Mix Tasks - Phoenix tasks","type":"extras"},{"doc":"Newly generated Phoenix applications now include ecto and postgrex as dependencies by default (which is to say, unless we use mix phx.new with the --no-ecto flag). With those dependencies come mix tasks to take care of common ecto operations. Let's see which tasks we get out of the box.$ mix help --search &quot;ecto&quot; mix ecto # Prints Ecto help information mix ecto.create # Creates the repository storage mix ecto.drop # Drops the repository storage mix ecto.dump # Dumps the repository database structure mix ecto.gen.migration # Generates a new migration for the repo mix ecto.gen.repo # Generates a new repository mix ecto.load # Loads previously dumped database structure mix ecto.migrate # Runs the repository migrations mix ecto.migrations # Displays the repository migration status mix ecto.rollback # Rolls back the repository migrationsNote: We can run any of the tasks above with the --no-start flag to execute the task without starting the application.mix ecto.createThis task will create the database specified in our repo. By default it will look for the repo named after our application (the one generated with our app unless we opted out of ecto), but we can pass in another repo if we want.Here's what it looks like in action.$ mix ecto.create The database for Hello.Repo has been created.There are a few things that can go wrong with ecto.create. If our Postgres database doesn't have a &quot;postgres&quot; role (user), we'll get an error like this one.$ mix ecto.create ** (Mix) The database for Hello.Repo couldn't be created, reason given: psql: FATAL: role &quot;postgres&quot; does not existWe can fix this by creating the &quot;postgres&quot; role in the psql console with the permissions needed to log in and create a database.=# CREATE ROLE postgres LOGIN CREATEDB; CREATE ROLEIf the &quot;postgres&quot; role does not have permission to log in to the application, we'll get this error.$ mix ecto.create ** (Mix) The database for Hello.Repo couldn't be created, reason given: psql: FATAL: role &quot;postgres&quot; is not permitted to log inTo fix this, we need to change the permissions on our &quot;postgres&quot; user to allow login.=# ALTER ROLE postgres LOGIN; ALTER ROLEIf the &quot;postgres&quot; role does not have permission to create a database, we'll get this error.$ mix ecto.create ** (Mix) The database for Hello.Repo couldn't be created, reason given: ERROR: permission denied to create databaseTo fix this, we need to change the permissions on our &quot;postgres&quot; user in the psql console to allow database creation.=# ALTER ROLE postgres CREATEDB; ALTER ROLEIf the &quot;postgres&quot; role is using a password different from the default &quot;postgres&quot;, we'll get this error.$ mix ecto.create ** (Mix) The database for Hello.Repo couldn't be created, reason given: psql: FATAL: password authentication failed for user &quot;postgres&quot;To fix this, we can change the password in the environment specific configuration file. For the development environment the password used can be found at the bottom of the config/dev.exs file.Finally, if we happen to have another repo called OurCustom.Repo that we want to create the database for, we can run this.$ mix ecto.create -r OurCustom.Repo The database for OurCustom.Repo has been created.mix ecto.dropThis task will drop the database specified in our repo. By default it will look for the repo named after our application (the one generated with our app unless we opted out of ecto). It will not prompt us to check if we're sure we want to drop the db, so do exercise caution.$ mix ecto.drop The database for Hello.Repo has been dropped.If we happen to have another repo that we want to drop the database for, we can specify it with the -r flag.$ mix ecto.drop -r OurCustom.Repo The database for OurCustom.Repo has been dropped.mix ecto.gen.repoMany applications require more than one data store. For each data store, we'll need a new repo, and we can generate them automatically with ecto.gen.repo.If we name our repo OurCustom.Repo, this task will create it here lib/our_custom/repo.ex.$ mix ecto.gen.repo -r OurCustom.Repo * creating lib/our_custom * creating lib/our_custom/repo.ex * updating config/config.exs Don't forget to add your new repo to your supervision tree (typically in lib/hello.ex): children = [ ..., OurCustom.Repo, ... ]Notice that this task has updated config/config.exs. If we take a look, we'll see this extra configuration block for our new repo.. . . config :hello, OurCustom.Repo, database: &quot;hello_repo&quot;, username: &quot;user&quot;, password: &quot;pass&quot;, hostname: &quot;localhost&quot; . . .Of course, we'll need to change the login credentials to match what our database expects. We'll also need to change the config for other environments.We certainly should follow the instructions and add our new repo to our supervision tree. In our Hello application, we would open up lib/hello.ex, and add our repo as a worker to the children list.. . . children = [ # Start the Ecto repository Hello.Repo, # Our custom repo OurCustom.Repo, # Start the endpoint when the application starts HelloWeb.Endpoint, ] . . .mix ecto.gen.migrationMigrations are a programmatic, repeatable way to affect changes to a database schema. Migrations are also just modules, and we can create them with the ecto.gen.migration task. Let's walk through the steps to create a migration for a new comments table.We simply need to invoke the task with a snake_case version of the module name that we want. Preferably, the name will describe what we want the migration to do.mix ecto.gen.migration add_comments_table * creating priv/repo/migrations * creating priv/repo/migrations/20150318001628_add_comments_table.exsNotice that the migration's filename begins with a string representation of the date and time the file was created.Let's take a look at the file ecto.gen.migration has generated for us at priv/repo/migrations/20150318001628_add_comments_table.exs.defmodule Hello.Repo.Migrations.AddCommentsTable do use Ecto.Migration def change do end endNotice that there is a single function change/0 which will handle both forward migrations and rollbacks. We'll define the schema changes that we want using ecto's handy dsl, and ecto will figure out what to do depending on whether we are rolling forward or rolling back. Very nice indeed.What we want to do is create a comments table with a body column, a word_count column, and timestamp columns for inserted_at and updated_at.. . . def change do create table(:comments) do add :body, :string add :word_count, :integer timestamps() end end . . .Again, we can run this task with the -r flag and another repo if we need to.$ mix ecto.gen.migration -r OurCustom.Repo add_users * creating priv/repo/migrations * creating priv/repo/migrations/20150318172927_add_users.exsFor more information on how to modify your database schema please refer to the ecto's migration dsl ecto migration docs. For example, to alter an existing schema see the documentation on ecto’s alter/2 function.That's it! We're ready to run our migration.mix ecto.migrateOnce we have our migration module ready, we can simply run mix ecto.migrate to have our changes applied to the database.$ mix ecto.migrate [info] == Running Hello.Repo.Migrations.AddCommentsTable.change/0 forward [info] create table comments [info] == Migrated in 0.1sWhen we first run ecto.migrate, it will create a table for us called schema_migrations. This will keep track of all the migrations which we run by storing the timestamp portion of the migration's filename.Here's what the schema_migrations table looks like.hello_dev=# select * from schema_migrations; version | inserted_at ---------------+--------------------- 20150317170448 | 2015-03-17 21:07:26 20150318001628 | 2015-03-18 01:45:00 (2 rows)When we roll back a migration, ecto.rollback will remove the record representing this migration from schema_migrations.By default, ecto.migrate will execute all pending migrations. We can exercise more control over which migrations we run by specifying some options when we run the task.We can specify the number of pending migrations we would like to run with the -n or --step options.$ mix ecto.migrate -n 2 [info] == Running Hello.Repo.Migrations.CreatePost.change/0 forward [info] create table posts [info] == Migrated in 0.0s [info] == Running Hello.Repo.Migrations.AddCommentsTable.change/0 forward [info] create table comments [info] == Migrated in 0.0sThe --step option will behave the same way.mix ecto.migrate --step 2The --to option will run all migrations up to and including given version.mix ecto.migrate --to 20150317170448mix ecto.rollbackThe ecto.rollback task will reverse the last migration we have run, undoing the schema changes. ecto.migrate and ecto.rollback are mirror images of each other.$ mix ecto.rollback [info] == Running Hello.Repo.Migrations.AddCommentsTable.change/0 backward [info] drop table comments [info] == Migrated in 0.0secto.rollback will handle the same options as ecto.migrate, so -n, --step, -v, and --to will behave as they do for ecto.migrate.","ref":"mix_tasks.html#ecto-tasks","title":"Mix Tasks - Ecto tasks","type":"extras"},{"doc":"As we've seen throughout this guide, both mix itself and the dependencies we bring in to our application provide a number of really useful tasks for free. Since neither of these could possibly anticipate all our individual application's needs, mix allows us to create our own custom tasks. That's exactly what we are going to do now.The first thing we need to do is create a mix/tasks directory inside of lib. This is where any of our application specific mix tasks will go.$ mkdir -p lib/mix/tasksInside that directory, let's create a new file, hello.greeting.ex, that looks like this.defmodule Mix.Tasks.Hello.Greeting do use Mix.Task @shortdoc &quot;Sends a greeting to us from Hello Phoenix&quot; @moduledoc &quot;&quot;&quot; This is where we would put any long form documentation or doctests. &quot;&quot;&quot; def run(_args) do Mix.shell().info(&quot;Greetings from the Hello Phoenix Application!&quot;) end # We can define other functions as needed here. endLet's take a quick look at the moving parts involved in a working mix task.The first thing we need to do is name our module. All tasks must be defined in Mix.Tasks namespace. We'd like to invoke this as mix hello.greeting, so we complete the module name with Hello.Greeting.The use Mix.Task line brings in functionality from Mix that makes this module behave as a mix task.The @shortdoc module attribute holds a string which will describe our task when users invoke mix help.@moduledoc serves the same function that it does in any module. It's where we can put long-form documentation and doctests, if we have any.The run/1 function is the critical heart of any Mix task. It's the function that does all the work when users invoke our task. In ours, all we do is send a greeting from our app, but we can implement our run/1 function to do whatever we need it to. Note that Mix.shell().info/1 is the preferred way to print text back out to the user.Of course, our task is just a module, so we can define other private functions as needed to support our run/1 function.Now that we have our task module defined, our next step is to compile the application.$ mix compile Compiled lib/tasks/hello.greeting.ex Generated hello.appNow our new task should be visible to mix help.$ mix help --search hello mix hello.greeting # Sends a greeting to us from Hello PhoenixNotice that mix help displays the text we put into the @shortdoc along with the name of our task.So far, so good, but does it work?$ mix hello.greeting Greetings from the Hello Phoenix Application!Indeed it does.If you want to make your new mix task to use your application's infrastructure, you need to make sure the application is started when mix task is being executed. This is particularly useful if you need to access your database from within the mix task. Thankfully, mix makes it really easy for us: . . . def run(_args) do Mix.Task.run(&quot;app.start&quot;) Mix.shell().info(&quot;Now I have access to Repo and other goodies!&quot;) end . . .","ref":"mix_tasks.html#creating-our-own-mix-task","title":"Mix Tasks - Creating our own Mix task","type":"extras"},{"doc":"TelemetryIn this guide, we will show you how to instrument and report on :telemetry events in your Phoenix application.te·lem·e·try - the process of recording and transmitting the readings of an instrument.As you follow along with this guide, we will introduce you to the core concepts of Telemetry, you will initialize a reporter to capture your application's events as they occur, and we will guide you through the steps to properly instrument your own functions using :telemetry. Let's take a closer look at how Telemetry works in your application.","ref":"telemetry.html","title":"Telemetry","type":"extras"},{"doc":"The [:telemetry] library allows you to emit events at various stages of an application's lifecycle. You can then respond to these events by, among other things, aggregating them as metrics and sending the metrics data to a reporting destination.Telemetry stores events by their name in an ETS table, along with the handler for each event. Then, when a given event is executed, Telemetry looks up its handler and invokes it.Phoenix's Telemetry tooling provides you with a supervisor that uses Telemetry.Metrics to define the list of Telemetry events to handle and how to handle those events, i.e. how to structure them as a certain type of metric. This supervisor works together with Telemetry reporters to respond to the specified Telemetry events by aggregating them as the appropriate metric and sending them to the correct reporting destination.","ref":"telemetry.html#overview","title":"Telemetry - Overview","type":"extras"},{"doc":"Since v1.5, new Phoenix applications are generated with a Telemetry supervisor. This module is responsible for managing the lifecycle of your Telemetry processes. It also defines a metrics/0 function, which returns a list of Telemetry.Metrics that you define for your application.By default, the supervisor also starts :telemetry_poller. By simply adding :telemetry_poller as a dependency, you can receive VM-related events on a specified interval.If you are coming from an older version of Phoenix, install the :telemetry_metrics and :telemetry_poller packages:{:telemetry_metrics, &quot;~&gt; 0.4&quot;}, {:telemetry_poller, &quot;~&gt; 0.4&quot;}and create your Telemetry supervisor at lib/my_app_web/telemetry.ex:# lib/my_app_web/telemetry.ex defmodule MyAppWeb.Telemetry do use Supervisor import Telemetry.Metrics def start_link(arg) do Supervisor.start_link(__MODULE__, arg, name: __MODULE__) end def init(_arg) do children = [ {:telemetry_poller, measurements: periodic_measurements(), period: 10_000} # Add reporters as children of your supervision tree. # {Telemetry.Metrics.ConsoleReporter, metrics: metrics()} ] Supervisor.init(children, strategy: :one_for_one) end def metrics do [ # Phoenix Metrics summary(&quot;phoenix.endpoint.stop.duration&quot;, unit: {:native, :millisecond} ), summary(&quot;phoenix.router_dispatch.stop.duration&quot;, tags: [:route], unit: {:native, :millisecond} ), # VM Metrics summary(&quot;vm.memory.total&quot;, unit: {:byte, :kilobyte}), summary(&quot;vm.total_run_queue_lengths.total&quot;), summary(&quot;vm.total_run_queue_lengths.cpu&quot;), summary(&quot;vm.total_run_queue_lengths.io&quot;) ] end defp periodic_measurements do [ # A module, function and arguments to be invoked periodically. # This function must call :telemetry.execute/3 and a metric must be added above. # {MyApp, :count_users, []} ] end endMake sure to replace MyApp by your actual application name.Then add to your main application's supervision tree (usually in lib/my_app/application.ex):children = [ MyApp.Repo, MyAppWeb.Telemetry, MyAppWeb.Endpoint, ... ]","ref":"telemetry.html#the-telemetry-supervisor","title":"Telemetry - The Telemetry supervisor","type":"extras"},{"doc":"Many Elixir libraries (including Phoenix) are already using the :telemetry package as a way to give users more insight into the behavior of their applications, by emitting events at key moments in the application lifecycle.A Telemetry event is made up of the following:name - A string (e.g. &quot;my_app.worker.stop&quot;) or a list of atoms that uniquely identifies the event.measurements - A map of atom keys (e.g. :duration) and numeric values.metadata - A map of key/value pairs that can be used for tagging metrics.A Phoenix ExampleHere is an example of an event from your endpoint:[:phoenix, :endpoint, :stop] - dispatched by Plug.Telemetry, one of the default plugs in your endpoint, whenever the response is sentMeasurement: %{duration: native_time}Metadata: %{conn: Plug.Conn.t}This means that after each request, Plug, via :telemetry, will emit a &quot;stop&quot; event, with a measurement of how long it took to get the response::telemetry.execute([:phoenix, :endpoint, :stop], %{duration: duration}, %{conn: conn})Phoenix Telemetry EventsA full list of all Phoenix telemetry events can be found in Phoenix.Logger","ref":"telemetry.html#telemetry-events","title":"Telemetry - Telemetry Events","type":"extras"},{"doc":"Metrics are aggregations of Telemetry events with a specific name, providing a view of the system's behaviour over time.&amp;#x2015; Telemetry.MetricsThe Telemetry.Metrics package provides a common interface for defining metrics. It exposes a set of five metric type functions that are responsible for structuring a given Telemetry event as a particular measurement.The package does not perform any aggregation of the measurements itself. Instead, it provides a reporter with the Telemetry event-as-measurement definition and the reporter uses that definition to perform aggregations and report them.We will discuss reporters in the next section.Let's take a look at some examples.Using Telemetry.Metrics, you can define a counter metric, which counts how many HTTP requests were completed:Telemetry.Metrics.counter(&quot;phoenix.endpoint.stop.duration&quot;)or you could use a distribution metric to see how many requests were completed in particular time buckets:Telemetry.Metrics.distribution(&quot;phoenix.endpoint.stop.duration&quot;, buckets: [100, 200, 300])This ability to introspect HTTP requests is really powerful -- and this is but one of many telemetry events emitted by the Phoenix framework! We'll discuss more of these events, as well as specific patterns for extracting valuable data from Phoenix/Plug events in the Phoenix Metrics section later in this guide.The full list of :telemetry events emitted from Phoenix, along with their measurements and metadata, is available in the &quot;Instrumentation&quot; section of the Phoenix.Logger module documentation.An Ecto ExampleLike Phoenix, Ecto ships with built-in Telemetry events. This means that you can gain introspection into your web and database layers using the same tools.Here is an example of a Telemetry event executed by Ecto when an Ecto repository starts:[:ecto, :repo, :init] - dispatched by Ecto.Repo.SupervisorMeasurement: %{system_time: native_time}Metadata: %{repo: Ecto.Repo, opts: Keyword.t()}This means that whenever the Ecto.Repo.Supervisor starts, it will emit an event, via :telemetry, with a measurement of the time at start-up.:telemetry.execute([:ecto, :repo, :init], %{system_time: System.system_time()}, %{repo: repo, opts: opts})Additional Telemetry events are executed by Ecto adapters.One such adapter-specific event is the [:my_app, :repo, :query] event. For instance, if you want to graph query execution time, you can use the Telemetry.Metrics.summary/2 function to instruct your reporter to calculate statistics of the [:my_app, :repo, :query] event, like maximum, mean, percentiles etc.:Telemetry.Metrics.summary(&quot;my_app.repo.query.query_time&quot;, unit: {:native, :millisecond} )Or you could use the Telemetry.Metrics.distribution/2 function to define a histogram for another adapter-specific event: [:my_app, :repo, :query, :queue_time], thus visualizing how long queries spend queued:Telemetry.Metrics.distribution(&quot;my_app.repo.query.queue_time&quot;, unit: {:native, :millisecond}, buckets: [10, 50, 100] )You can learn more about Ecto Telemetry in the &quot;Telemetry Events&quot; section of the Ecto.Repo module documentation.So far we have seen some of the Telemetry events common to Phoenix applications, along with some examples of their various measurements and metadata. With all of this data just waiting to be consumed, let's talk about reporters.","ref":"telemetry.html#metrics","title":"Telemetry - Metrics","type":"extras"},{"doc":"Reporters subscribe to Telemetry events using the common interface provided by Telemetry.Metrics. They then aggregate the measurements (data) into metrics to provide meaningful information about your application.For example, if the following Telemetry.Metrics.summary/2 call is added to the metrics/0 function of your Telemetry supervisor:summary(&quot;phoenix.endpoint.stop.duration&quot;, unit: {:native, :millisecond} )Then the reporter will attach a listener for the &quot;phoenix.endpoint.stop.duration&quot; event and will respond to this event by calculating a summary metric with the given event metadata and reporting on that metric to the appropriate source.Phoenix.LiveDashboardFor developers interested in real-time visualizations for their Telemetry metrics, you may be interested in installing LiveDashboard. LiveDashboard acts as a Telemetry.Metrics reporter to render your data as beautiful, real-time charts on the dashboard.Telemetry.Metrics.ConsoleReporterTelemetry.Metrics ships with a ConsoleReporter that can be used to print events and metrics to the terminal. You can use this reporter to experiment with the metrics discussed in this guide.Uncomment or add the following to this list of children in your Telemetry supervision tree (usually in lib/my_app_web/telemetry.ex):{Telemetry.Metrics.ConsoleReporter, metrics: metrics()}There are numerous reporters available, for services like StatsD, Prometheus, and more. You can find them by searching for &quot;telemetry_metrics&quot; on hex.pm.","ref":"telemetry.html#reporters","title":"Telemetry - Reporters","type":"extras"},{"doc":"Earlier we looked at the &quot;stop&quot; event emitted by Plug.Telemetry, and used it to count the number of HTTP requests. In reality, it's only somewhat helpful to be able to see just the total number of requests. What if you wanted to see the number of requests per route, or per route and method?Let's take a look at another event emitted during the HTTP request lifecycle, this time from Phoenix.Router:[:phoenix, :router_dispatch, :stop] - dispatched by Phoenix.Router after successfully dispatching to a matched routeMeasurement: %{duration: native_time}Metadata: %{conn: Plug.Conn.t, route: binary, plug: module, plug_opts: term, path_params: map, pipe_through: [atom]}Let's start by grouping these events by route. Add the following (if it does not already exist) to the metrics/0 function of your Telemetry supervisor (usually in lib/my_app_web/telemetry.ex):# lib/my_app_web/telemetry.ex def metrics do [ ...metrics... summary(&quot;phoenix.router_dispatch.stop.duration&quot;, tags: [:route], unit: {:native, :millisecond} ) ] endRestart your server, and then make requests to a page or two. In your terminal, you should see the ConsoleReporter print logs for the Telemetry events it received as a result of the metrics definitions you provided.The log line for each request contains the specific route for that request. This is due to specifying the :tags option for the summary metric, which takes care of our first requirement; we can use :tags to group metrics by route. Note that reporters will necessarily handle tags differently depending on the underlying service in use.Looking more closely at the Router &quot;stop&quot; event, you can see that the Plug.Conn struct representing the request is present in the metadata, but how do you access the properties in conn?Fortunately, Telemetry.Metrics provides the following options to help you classify your events::tags - A list of metadata keys for grouping;:tag_values - A function which transforms the metadata into the desired shape; Note that this function is called for each event, so it's important to keep it fast if the rate of events is high.Learn about all the available metrics options in the Telemetry.Metrics module documentation.Let's find out how to extract more tags from events that include a conn in their metadata.Extracting tag values from Plug.ConnLet's add another metric for the route event, this time to group by route and method:summary(&quot;phoenix.router_dispatch.stop.duration&quot;, tags: [:method, :route], tag_values: &amp;get_and_put_http_method/1, unit: {:native, :millisecond} )We've introduced the :tag_values option here, because we need to perform a transformation on the event metadata in order to get to the values we need.Add the following private function to your Telemetry module to lift the :method value from the Plug.Conn struct:# lib/my_app_web/telemetry.ex defp get_and_put_http_method(%{conn: %{method: method}} = metadata) do Map.put(metadata, :method, method) endRestart your server and make some more requests. You should begin to see logs with tags for both the HTTP method and the route.Note the :tags and :tag_values options can be applied to all Telemetry.Metrics types.Renaming value labels using tag valuesSometimes when displaying a metric, the value label may need to be transformed to improve readability. Take for example the following metric that displays the duration of the each LiveView's mount/3 callback by connected? status.summary(&quot;phoenix.live_view.mount.stop.duration&quot;, unit: {:native, :millisecond}, tags: [:view, :connected?], tag_values: &amp;live_view_metric_tag_values/1 )The following function lifts metadata.socket.view and metadata.socket.connected? to be top-level keys on metadata, as we did in the previous example.# lib/my_app_web/telemetry.ex defp live_view_metric_tag_values(metadata) do metadata |&gt; Map.put(:view, metadata.socket.view) |&gt; Map.put(:connected?, metadata.socket.connected?) endHowever, when rendering these metrics in LiveDashboard, the value label is output as &quot;Elixir.Phoenix.LiveDashboard.MetricsLive true&quot;.To make the value label easier to read, we can update our private function to generate more user friendly names. We'll run the value of the :view through inspect/1 to remove the Elixir. prefix and call another private function to convert the connected? boolean into human readable text.# lib/my_app_web/telemetry.ex defp live_view_metric_tag_values(metadata) do metadata |&gt; Map.put(:view, inspect(metadata.socket.view)) |&gt; Map.put(:connected?, get_connection_status(metadata.socket)) end defp get_connection_status(%{connected?: true}), do: &quot;Connected&quot; defp get_connection_status(%{connected?: false}), do: &quot;Disconnected&quot;Now the value label will be rendered like &quot;Phoenix.LiveDashboard.MetricsLive Connected&quot;.Hopefully, this gives you some inspiration on how to use the :tag_values option. Just remember to keep this function fast since it is called on every event.","ref":"telemetry.html#phoenix-metrics","title":"Telemetry - Phoenix Metrics","type":"extras"},{"doc":"You might want to periodically measure key values within your application. Fortunately the :telemetry_poller package provides a mechanism for custom measurements, which is useful for retrieving process information or for performing custom measurements periodically.Add the following to the list in your Telemetry supervisor's periodic_measurements/0 function, which is a private function that returns a list of measurements to take on a specified interval.# lib/my_app_web/telemetry.ex defp periodic_measurements do [ {MyApp, :measure_users, []}, {:process_info, event: [:my_app, :my_server], name: MyApp.MyServer, keys: [:message_queue_len, :memory]} ] endwhere MyApp.measure_users/0 could be written like this:# lib/my_app.ex defmodule MyApp do def measure_users do :telemetry.execute([:my_app, :users], %{total: MyApp.users_count()}, %{}) end endNow with measurements in place, you can define the metrics for the events above:# lib/my_app_web/telemetry.ex def metrics do [ ...metrics... # MyApp Metrics last_value(&quot;my_app.users.total&quot;), last_value(&quot;my_app.my_server.memory&quot;, unit: :byte), last_value(&quot;my_app.my_server.message_queue_len&quot;) summary(&quot;my_app.my_server.call.stop.duration&quot;), counter(&quot;my_app.my_server.call.exception&quot;) ] endYou will implement MyApp.MyServer in the Custom Events section.","ref":"telemetry.html#periodic-measurements","title":"Telemetry - Periodic measurements","type":"extras"},{"doc":"Telemetry is quickly becoming the de-facto standard for package instrumentation in Elixir. Here is a list of libraries currently emitting :telemetry events.Library authors are actively encouraged to send a PR adding their own (in alphabetical order, please):Absinthe - Coming Soon!Broadway - EventsEcto - EventsOban - EventsPhoenix - EventsPlug - EventsTesla - Events","ref":"telemetry.html#libraries-using-telemetry","title":"Telemetry - Libraries using Telemetry","type":"extras"},{"doc":"If you need custom metrics and instrumentation in your application, you can utilize the :telemetry package (https://hexdocs.pm/telemetry) just like your favorite frameworks and libraries.Here is an example of a simple GenServer that emits telemetry events. Create this file in your app at lib/my_app/my_server.ex:# lib/my_app/my_server.ex defmodule MyApp.MyServer do @moduledoc &quot;&quot;&quot; An example GenServer that runs arbitrary functions and emits telemetry events when called. &quot;&quot;&quot; use GenServer # A common prefix for :telemetry events @prefix [:my_app, :my_server, :call] def start_link(fun) do GenServer.start_link(__MODULE__, fun, name: __MODULE__) end @doc &quot;&quot;&quot; Runs the function contained within this server. ## Events The following events may be emitted: * `[:my_app, :my_server, :call, :start]` - Dispatched immediately before invoking the function. This event is always emitted. * Measurement: `%{system_time: system_time}` * Metadata: `%{}` * `[:my_app, :my_server, :call, :stop]` - Dispatched immediately after successfully invoking the function. * Measurement: `%{duration: native_time}` * Metadata: `%{}` * `[:my_app, :my_server, :call, :exception]` - Dispatched immediately after invoking the function, in the event the function throws or raises. * Measurement: `%{duration: native_time}` * Metadata: `%{kind: kind, reason: reason, stacktrace: stacktrace}` &quot;&quot;&quot; def call!, do: GenServer.call(__MODULE__, :called) @impl true def init(fun) when is_function(fun, 0), do: {:ok, fun} @impl true def handle_call(:called, _from, fun) do # Wrap the function invocation in a &quot;span&quot; result = telemetry_span(fun) {:reply, result, fun} end # Emits telemetry events related to invoking the function defp telemetry_span(fun) do start_time = emit_start() try do fun.() catch kind, reason -&gt; stacktrace = System.stacktrace() duration = System.monotonic_time() - start_time emit_exception(duration, kind, reason, stacktrace) :erlang.raise(kind, reason, stacktrace) else result -&gt; duration = System.monotonic_time() - start_time emit_stop(duration) result end end defp emit_start do start_time_mono = System.monotonic_time() :telemetry.execute( @prefix ++ [:start], %{system_time: System.system_time()}, %{} ) start_time_mono end defp emit_stop(duration) do :telemetry.execute( @prefix ++ [:stop], %{duration: duration}, %{} ) end defp emit_exception(duration, kind, reason, stacktrace) do :telemetry.execute( @prefix ++ [:exception], %{duration: duration}, %{ kind: kind, reason: reason, stacktrace: stacktrace } ) end endand add it to your application's supervisor tree (usually in lib/my_app/application.ex), giving it a function to invoke when called:# lib/my_app/application.ex children = [ # Start a server that greets the world {MyApp.MyServer, fn -&gt; &quot;Hello, world!&quot; end}, ]Now start an IEx session and call the server:iex(1)&gt; MyApp.MyServer.call!and you should see something like the following output:[Telemetry.Metrics.ConsoleReporter] Got new event! Event name: my_app.my_server.call.stop All measurements: %{duration: 4000} All metadata: %{} Metric measurement: #Function&lt;2.111777250/1 in Telemetry.Metrics.maybe_convert_measurement/2&gt; (summary) With value: 0.004 millisecond Tag values: %{} &quot;Hello, world!&quot;","ref":"telemetry.html#custom-events","title":"Telemetry - Custom Events","type":"extras"},{"doc":"ChannelsRequirement: This guide expects that you have gone through the introductory guides and got a Phoenix application up and running.Channels are an exciting part of Phoenix that enable soft real-time communication with and between millions of connected clients.Some possible use cases include:Chat rooms and APIs for messaging appsBreaking news, like &quot;a goal was scored&quot; or &quot;an earthquake is coming&quot;Tracking trains, trucks, or race participants on a mapEvents in multiplayer gamesMonitoring sensors and controlling lightsNotifying a browser that a page's CSS or JavaScript has changed (this is handy in development)Conceptually, Channels are pretty simple.First, clients connect to the server using some transport, like WebSocket. Once connected, they join one or more topics. For example, to interact with a public chat room clients may join a topic called public_chat, and to receive updates from a product with ID 7, they may need to join a topic called product_updates:7.Clients can push messages to the topics they've joined, and can also receive messages from them. The other way around, Channel servers receive messages from their connected clients, and can push messages to them too.Servers are able to broadcast messages to all clients subscribed to a certain topic. This is illustrated in the following diagram: +----------------+ +--Topic X--&gt;| Mobile Client | | +----------------+ +-------------------+ | +----------------+ | | | +----------------+ | Browser Client |--Topic X--&gt;| Phoenix Server(s) |--+--Topic X--&gt;| Desktop Client | +----------------+ | | | +----------------+ +-------------------+ | | +----------------+ +--Topic X--&gt;| IoT Client | +----------------+Broadcasts work even if the application runs on several nodes/computers. That is, if two clients have their socket connected to different application nodes and are subscribed to the same topic T, both of them will receive messages broadcasted to T. That is possible thanks to an internal PubSub mechanism.Channels can support any kind of client: a browser, native app, smart watch, embedded device, or anything else that can connect to a network. All the client needs is a suitable library; see the Client Libraries section below. Each client library communicates using one of the &quot;transports&quot; that Channels understand. Currently, that's either Websockets or long polling, but other transports may be added in the future.Unlike stateless HTTP connections, Channels support long-lived connections, each backed by a lightweight BEAM process, working in parallel and maintaining its own state.This architecture scales well; Phoenix Channels can support millions of subscribers with reasonable latency on a single box, passing hundreds of thousands of messages per second. And that capacity can be multiplied by adding more nodes to the cluster.","ref":"channels.html","title":"Channels","type":"extras"},{"doc":"Although Channels are simple to use from a client perspective, there are a number of components involved in routing messages to clients across a cluster of servers. Let's take a look at them.OverviewTo start communicating, a client connects to a node (a Phoenix server) using a transport (eg, Websockets or long polling) and joins one or more channels using that single network connection. One channel server process is created per client, per topic. The appropriate socket handler initializes a %Phoenix.Socket for the channel server (possibly after authenticating the client). The channel server then holds onto the %Phoenix.Socket{} and can maintain any state it needs within its socket.assigns.Once the connection is established, each incoming message from a client is routed, based on its topic, to the correct channel server. If the channel server asks to broadcast a message, that message is sent to the local PubSub, which sends it out to any clients connected to the same server and subscribed to that topic.If there are other nodes in the cluster, the local PubSub also forwards the message to their PubSubs, which send it out to their own subscribers. Because only one message has to be sent per additional node, the performance cost of adding nodes is negligible, while each new node supports many more subscribers.The message flow looks something like this: Channel +-------------------------+ +--------+ route | Sending Client, Topic 1 | | Local | +-----------&gt;| Channel.Server |-----&gt;| PubSub |--+ +----------------+ | +-------------------------+ +--------+ | | Sending Client |-Transport--+ | | +----------------+ +-------------------------+ | | | Sending Client, Topic 2 | | | | Channel.Server | | | +-------------------------+ | | | | +-------------------------+ | | +----------------+ | Browser Client, Topic 1 | | | | Browser Client |&lt;-------Transport--------| Channel.Server |&lt;----------+ | +----------------+ +-------------------------+ | | | | +-------------------------+ | +----------------+ | Phone Client, Topic 1 | | | Phone Client |&lt;-------Transport--------| Channel.Server |&lt;-+ | +----------------+ +-------------------------+ | +--------+ | | | Remote | | +-------------------------+ +---| PubSub |&lt;-+ +----------------+ | Watch Client, Topic 1 | | +--------+ | | Watch Client |&lt;-------Transport--------| Channel.Server |&lt;-+ | +----------------+ +-------------------------+ | | | +-------------------------+ +--------+ | +----------------+ | IoT Client, Topic 1 | | Remote | | | IoT Client |&lt;-------Transport--------| Channel.Server |&lt;-----| PubSub |&lt;-+ +----------------+ +-------------------------+ +--------+EndpointIn your Phoenix app's Endpoint module, a socket declaration specifies which socket handler will receive connections on a given URL.socket &quot;/socket&quot;, HelloWeb.UserSocket, websocket: true, longpoll: falsePhoenix comes with two default transports: websocket and longpoll. You can configure them directly via the socket declaration.Socket HandlersSocket handlers, such as HelloWeb.UserSocket in the example above, are called when Phoenix is setting up a channel connection. Connections to a given URL will all use the same socket handler, based on your endpoint configuration. But that handler can be used for setting up connections on any number of topics.Within the handler, you can authenticate and identify a socket connection and set default socket assigns.Channel RoutesChannel routes are defined in socket handlers, such as HelloWeb.UserSocket in the example above. They match on the topic string and dispatch matching requests to the given Channel module.The star character * acts as a wildcard matcher, so in the following example route, requests for room:lobby and room:123 would both be dispatched to the RoomChannel.channel &quot;room:*&quot;, HelloWeb.RoomChannelChannelsChannels handle events from clients, so they are similar to Controllers, but there are two key differences. Channel events can go both directions - incoming and outgoing. Channel connections also persist beyond a single request/response cycle. Channels are the highest level abstraction for realtime communication components in Phoenix.Each Channel will implement one or more clauses of each of these four callback functions - join/3, terminate/2, handle_in/3, and handle_out/3.TopicsTopics are string identifiers - names that the various layers use in order to make sure messages end up in the right place. As we saw above, topics can use wildcards. This allows for a useful &quot;topic:subtopic&quot; convention. Often, you'll compose topics using record IDs from your application layer, such as &quot;users:123&quot;.MessagesThe Phoenix.Socket.Message module defines a struct with the following keys which denotes a valid message. From the Phoenix.Socket.Message docs.topic - The string topic or &quot;topic:subtopic&quot; pair namespace, such as &quot;messages&quot; or &quot;messages:123&quot;event - The string event name, for example &quot;phx_join&quot;payload - The message payloadref - The unique string refPubSubPubSub consists of the Phoenix.PubSub module and a variety of modules for different adapters and their GenServers. These modules contain functions which are the nuts and bolts of organizing Channel communication - subscribing to topics, unsubscribing from topics, and broadcasting messages on a topic. PubSub is used internally by Phoenix. It's also useful in application development in any case where you want to notify interested processes of an event; for instance, letting all connected live views know that a new comment has been added to a post.The PubSub system takes care of getting messages from one node to another so that they can be sent to all subscribers across the cluster. By default, this is done using Phoenix.PubSub.PG2, which uses native BEAM messaging.If your deployment environment does not support distributed Elixir or direct communication between servers, Phoenix also ships with a Redis Adapter that uses Redis to exchange PubSub data. Please see the Phoenix.PubSub docs for more information.Client LibrariesAny networked device can connect to Phoenix Channels as long as it has a client library. The following libraries exist today, and new ones are always welcome.OfficialPhoenix ships with a JavaScript client that is available when generating a new Phoenix project. The documentation for the JavaScript module is available at https://hexdocs.pm/phoenix/js/; the code is in phoenix.js.3rd PartySwift (iOS)SwiftPhoenixJava (Android)JavaPhoenixChannelsKotlin (Android)JavaPhoenixClientC#PhoenixSharpElixirphoenix_gen_socket_clientGDScript (Godot Game Engine)GodotPhoenixChannels","ref":"channels.html#the-moving-parts","title":"Channels - The Moving Parts","type":"extras"},{"doc":"Let's tie all these ideas together by building a simple chat application. After generating a new Phoenix application we'll see that the endpoint is already set up for us in lib/hello_web/endpoint.ex:defmodule HelloWeb.Endpoint do use Phoenix.Endpoint, otp_app: :hello socket &quot;/socket&quot;, HelloWeb.UserSocket ... endIn lib/hello_web/channels/user_socket.ex, the HelloWeb.UserSocket we pointed to in our endpoint has already been created when we generated our application. We need to make sure messages get routed to the correct channel. To do that, we'll uncomment the &quot;room:*&quot; channel definition:defmodule HelloWeb.UserSocket do use Phoenix.Socket ## Channels channel &quot;room:*&quot;, HelloWeb.RoomChannel ...Now, whenever a client sends a message whose topic starts with &quot;room:&quot;, it will be routed to our RoomChannel. Next, we'll define a HelloWeb.RoomChannel module to manage our chat room messages.Joining ChannelsThe first priority of your channels is to authorize clients to join a given topic. For authorization, we must implement join/3 in lib/hello_web/channels/room_channel.ex.defmodule HelloWeb.RoomChannel do use Phoenix.Channel def join(&quot;room:lobby&quot;, _message, socket) do {:ok, socket} end def join(&quot;room:&quot; &lt;&gt; _private_room_id, _params, _socket) do {:error, %{reason: &quot;unauthorized&quot;}} end endFor our chat app, we'll allow anyone to join the &quot;room:lobby&quot; topic, but any other room will be considered private and special authorization, say from a database, will be required. (We won't worry about private chat rooms for this exercise, but feel free to explore after we finish.)To authorize the socket to join a topic, we return {:ok, socket} or {:ok, reply, socket}. To deny access, we return {:error, reply}. More information about authorization with tokens can be found in the Phoenix.Token documentation.With our channel in place, let's get the client and server talking.Phoenix projects come with webpack by default, unless disabled with the --no-webpack option when you run mix phx.new.The assets/js/socket.js defines a simple client based on the socket implementation that ships with Phoenix.We can use that library to connect to our socket and join our channel, we just need to set our room name to &quot;room:lobby&quot; in that file.// assets/js/socket.js // ... socket.connect() // Now that you are connected, you can join channels with a topic: let channel = socket.channel(&quot;room:lobby&quot;, {}) channel.join() .receive(&quot;ok&quot;, resp =&gt; { console.log(&quot;Joined successfully&quot;, resp) }) .receive(&quot;error&quot;, resp =&gt; { console.log(&quot;Unable to join&quot;, resp) }) export default socketAfter that, we need to make sure assets/js/socket.js gets imported into our application JavaScript file. To do that, uncomment the last line in assets/js/app.js.// ... import socket from &quot;./socket&quot;Save the file and your browser should auto refresh, thanks to the Phoenix live reloader. If everything worked, we should see &quot;Joined successfully&quot; in the browser's JavaScript console. Our client and server are now talking over a persistent connection. Now let's make it useful by enabling chat.In lib/hello_web/templates/page/index.html.eex, we'll replace the existing code with a container to hold our chat messages, and an input field to send them:&lt;div id=&quot;messages&quot; role=&quot;log&quot; aria-live=&quot;polite&quot;&gt;&lt;/div&gt; &lt;input id=&quot;chat-input&quot; type=&quot;text&quot;&gt;&lt;/input&gt;Now let's add a couple of event listeners to assets/js/socket.js:// ... let channel = socket.channel(&quot;room:lobby&quot;, {}) let chatInput = document.querySelector(&quot;#chat-input&quot;) let messagesContainer = document.querySelector(&quot;#messages&quot;) chatInput.addEventListener(&quot;keypress&quot;, event =&gt; { if(event.key === 'Enter'){ channel.push(&quot;new_msg&quot;, {body: chatInput.value}) chatInput.value = &quot;&quot; } }) channel.join() .receive(&quot;ok&quot;, resp =&gt; { console.log(&quot;Joined successfully&quot;, resp) }) .receive(&quot;error&quot;, resp =&gt; { console.log(&quot;Unable to join&quot;, resp) }) export default socketAll we had to do is detect that enter was pressed and then push an event over the channel with the message body. We named the event &quot;new_msg&quot;. With this in place, let's handle the other piece of a chat application where we listen for new messages and append them to our messages container.// ... let channel = socket.channel(&quot;room:lobby&quot;, {}) let chatInput = document.querySelector(&quot;#chat-input&quot;) let messagesContainer = document.querySelector(&quot;#messages&quot;) chatInput.addEventListener(&quot;keypress&quot;, event =&gt; { if(event.key === 'Enter'){ channel.push(&quot;new_msg&quot;, {body: chatInput.value}) chatInput.value = &quot;&quot; } }) channel.on(&quot;new_msg&quot;, payload =&gt; { let messageItem = document.createElement(&quot;p&quot;) messageItem.innerText = `[${Date()}] ${payload.body}` messagesContainer.appendChild(messageItem) }) channel.join() .receive(&quot;ok&quot;, resp =&gt; { console.log(&quot;Joined successfully&quot;, resp) }) .receive(&quot;error&quot;, resp =&gt; { console.log(&quot;Unable to join&quot;, resp) }) export default socketWe listen for the &quot;new_msg&quot; event using channel.on, and then append the message body to the DOM. Now let's handle the incoming and outgoing events on the server to complete the picture.Incoming EventsWe handle incoming events with handle_in/3. We can pattern match on the event names, like &quot;new_msg&quot;, and then grab the payload that the client passed over the channel. For our chat application, we simply need to notify all other room:lobby subscribers of the new message with broadcast!/3.defmodule HelloWeb.RoomChannel do use Phoenix.Channel def join(&quot;room:lobby&quot;, _message, socket) do {:ok, socket} end def join(&quot;room:&quot; &lt;&gt; _private_room_id, _params, _socket) do {:error, %{reason: &quot;unauthorized&quot;}} end def handle_in(&quot;new_msg&quot;, %{&quot;body&quot; =&gt; body}, socket) do broadcast!(socket, &quot;new_msg&quot;, %{body: body}) {:noreply, socket} end endbroadcast!/3 will notify all joined clients on this socket's topic and invoke their handle_out/3 callbacks. handle_out/3 isn't a required callback, but it allows us to customize and filter broadcasts before they reach each client. By default, handle_out/3 is implemented for us and simply pushes the message on to the client, just like our definition. We included it here because hooking into outgoing events allows for powerful message customization and filtering. Let's see how.Intercepting Outgoing EventsWe won't implement this for our application, but imagine our chat app allowed users to ignore messages about new users joining a room. We could implement that behavior like this where we explicitly tell Phoenix which outgoing event we want to intercept and then define a handle_out/3 callback for those events. (Of course, this assumes that we have a Accounts context with an ignoring_user?/2 function, and that we pass a user in via the assigns map). It is important to note that the handle_out/3 callback will be called for every recipient of a message, so more expensive operations like hitting the database should be considered carefully before being included in handle_out/3.intercept [&quot;user_joined&quot;] def handle_out(&quot;user_joined&quot;, msg, socket) do if Accounts.ignoring_user?(socket.assigns[:user], msg.user_id) do {:noreply, socket} else push(socket, &quot;user_joined&quot;, msg) {:noreply, socket} end endThat's all there is to our basic chat app. Fire up multiple browser tabs and you should see your messages being pushed and broadcasted to all windows!","ref":"channels.html#tying-it-all-together","title":"Channels - Tying it all together","type":"extras"},{"doc":"When we connect, we'll often need to authenticate the client. Fortunately, this is a 4-step process with Phoenix.Token.Step 1 - Assign a Token in the ConnectionLet's say we have an authentication plug in our app called OurAuth. When OurAuth authenticates a user, it sets a value for the :current_user key in conn.assigns. Since the current_user exists, we can simply assign the user's token in the connection for use in the layout. We can wrap that behavior up in a private function plug, put_user_token/2. This could also be put in its own module as well. To make this all work, we just add OurAuth and put_user_token/2 to the browser pipeline.pipeline :browser do ... plug OurAuth plug :put_user_token end defp put_user_token(conn, _) do if current_user = conn.assigns[:current_user] do token = Phoenix.Token.sign(conn, &quot;user socket&quot;, current_user.id) assign(conn, :user_token, token) else conn end endNow our conn.assigns contains the current_user and user_token.Step 2 - Pass the Token to the JavaScriptNext we need to pass this token to JavaScript. We can do so inside a script tag in web/templates/layout/app.html.eex right above the app.js script, as follows:&lt;script&gt;window.userToken = &quot;&lt;%= assigns[:user_token] %&gt;&quot;;&lt;/script&gt; &lt;script src=&quot;&lt;%= Routes.static_path(@conn, &quot;/js/app.js&quot;) %&gt;&quot;&gt;&lt;/script&gt;Step 3 - Pass the Token to the Socket Constructor and VerifyWe also need to pass the :params to the socket constructor and verify the user token in the connect/3 function. To do so, edit web/channels/user_socket.ex, as follows:def connect(%{&quot;token&quot; =&gt; token}, socket, _connect_info) do # max_age: 1209600 is equivalent to two weeks in seconds case Phoenix.Token.verify(socket, &quot;user socket&quot;, token, max_age: 1209600) do {:ok, user_id} -&gt; {:ok, assign(socket, :current_user, user_id)} {:error, reason} -&gt; :error end endIn our JavaScript, we can use the token set previously when to pass the token when constructing the Socket:let socket = new Socket(&quot;/socket&quot;, {params: {token: window.userToken}})We used Phoenix.Token.verify/4 to verify the user token provided by the client. Phoenix.Token.verify/4 returns either {:ok, user_id} or {:error, reason}. We can pattern match on that return in a case statement. With a verified token, we set the user's id as the value to :current_user in the socket. Otherwise, we return :error.Step 4 - Connect to the socket in JavaScriptWith authentication set up, we can connect to sockets and channels from JavaScript.let socket = new Socket(&quot;/socket&quot;, {params: {token: window.userToken}}) socket.connect()Now that we are connected, we can join channels with a topic:let channel = socket.channel(&quot;topic:subtopic&quot;, {}) channel.join() .receive(&quot;ok&quot;, resp =&gt; { console.log(&quot;Joined successfully&quot;, resp) }) .receive(&quot;error&quot;, resp =&gt; { console.log(&quot;Unable to join&quot;, resp) }) export default socketNote that token authentication is preferable since it's transport agnostic and well-suited for long running-connections like channels, as opposed to using sessions or authentication approaches.","ref":"channels.html#using-token-authentication","title":"Channels - Using Token Authentication","type":"extras"},{"doc":"Servers restart, networks split, and clients lose connectivity. In order to design robust systems, we need to understand how Phoenix responds to these events and what guarantees it offers.Handling ReconnectionClients subscribe to topics, and Phoenix stores those subscriptions in an in-memory ETS table. If a channel crashes, the clients will need to reconnect to the topics they had previously subscribed to. Fortunately, the Phoenix JavaScript client knows how to do this. The server will notify all the clients of the crash. This will trigger each client's Channel.onError callback. The clients will attempt to reconnect to the server using an exponential back off strategy. Once they reconnect, they'll attempt to rejoin the topics they had previously subscribed to. If they are successful, they'll start receiving messages from those topics as before.Resending Client MessagesChannel clients queue outgoing messages into a PushBuffer, and send them to the server when there is a connection. If no connection is available, the client holds on to the messages until it can establish a new connection. With no connection, the client will hold the messages in memory until it establishes a connection, or until it receives a timeout event. The default timeout is set to 5000 milliseconds. The client won't persist the messages in the browser's local storage, so if the browser tab closes, the messages will be gone.Resending Server MessagesPhoenix uses an at-most-once strategy when sending messages to clients. If the client is offline and misses the message, Phoenix won't resend it. Phoenix doesn't persist messages on the server. If the server restarts, unsent messages will be gone. If our application needs stronger guarantees around message delivery, we'll need to write that code ourselves. Common approaches involve persisting messages on the server and having clients request missing messages. For an example, see Chris McCord's Phoenix training: client code and server code.","ref":"channels.html#fault-tolerance-and-reliability-guarantees","title":"Channels - Fault Tolerance and Reliability Guarantees","type":"extras"},{"doc":"To see an example of the application we just built, checkout the project phoenix_chat_example.You can also see a live demo at http://phoenixchat.herokuapp.com/.","ref":"channels.html#example-application","title":"Channels - Example Application","type":"extras"},{"doc":"PresenceRequirement: This guide expects that you have gone through the introductory guides and got a Phoenix application up and running.Requirement: This guide expects that you have gone through the Channels guide.Phoenix Presence is a feature which allows you to register process information on a topic and replicate it transparently across a cluster. It's a combination of both a server-side and client-side library which makes it simple to implement. A simple use-case would be showing which users are currently online in an application.Phoenix Presence is special for a number of reasons. It has no single point of failure, no single source of truth, relies entirely on the standard library with no operational dependencies and self heals. This is all handled with a conflict-free replicated data type (CRDT) protocol.To get started with Presence we'll first need to generate a presence module. We can do this with the mix phx.gen.presence task:$ mix phx.gen.presence * creating lib/hello_web/channels/presence.ex Add your new module to your supervision tree, in lib/hello/application.ex: children = [ ... HelloWeb.Presence, ] You're all set! See the Phoenix.Presence docs for more details: http://hexdocs.pm/phoenix/Phoenix.Presence.htmlIf we open up the lib/hello_web/channels/presence.ex file, we will see the following line:use Phoenix.Presence, otp_app: :hello, pubsub_server: Hello.PubSubThis sets up the module for presence, defining the functions we require for tracking presences. As mentioned in the generator task, we should add this module to our supervision tree in application.ex:children = [ ... HelloWeb.Presence, ]Next we will create a channel that Presence can communicate on. For this example we will create a RoomChannel (see the channels guide for more details on this):$ mix phx.gen.channel Room * creating lib/hello_web/channels/room_channel.ex * creating test/hello_web/channels/room_channel_test.exs Add the channel to your `lib/hello_web/channels/user_socket.ex` handler, for example: channel &quot;room:lobby&quot;, HelloWeb.RoomChanneland register it in lib/hello_web/channels/user_socket.ex:defmodule HelloWeb.UserSocket do use Phoenix.Socket channel &quot;room:lobby&quot;, HelloWeb.RoomChannel endWe also need to change our connect function to take a user_id from the params and assign it on the socket. In production you may want to use Phoenix.Token if you have real users that are authenticated.def connect(params, socket, _connect_info) do {:ok, assign(socket, :user_id, params[&quot;user_id&quot;])} endNext, we will create the channel that we'll communicate presence over. After a user joins we can push the list of presences down the channel and then track the connection. We can also provide a map of additional information to track.Note that we provide the user_id from the connection in order to uniquely identify the client. You can use whatever identifier you like, but you'll see how this is provided to the socket in the client-side example below.To learn more about channels, read the channel documentation in the guide.defmodule HelloWeb.RoomChannel do use Phoenix.Channel alias HelloWeb.Presence def join(&quot;room:lobby&quot;, _params, socket) do send(self(), :after_join) {:ok, socket} end def handle_info(:after_join, socket) do {:ok, _} = Presence.track(socket, socket.assigns.user_id, %{ online_at: inspect(System.system_time(:second)) }) push(socket, &quot;presence_state&quot;, Presence.list(socket)) {:noreply, socket} end endFinally we can use the client-side Presence library included in phoenix.js to manage the state and presence diffs that come down the socket. It listens for the &quot;presence_state&quot; and &quot;presence_diff&quot; events and provides a simple callback for you to handle the events as they happen, with the onSync callback.The onSync callback allows you to easily react to presence state changes, which most often results in re-rendering an updated list of active users. You can use the list method to format and return each individual presence based on the needs of your application.To iterate users, we use the presences.list() function which accepts a callback. The callback will be called for each presence item with 2 arguments, the presence id and a list of metas (one for each presence for that presence id). We use this to display the users and the number of devices they are online with.We can see presence working by adding the following to assets/js/app.js:import {Socket, Presence} from &quot;phoenix&quot; let socket = new Socket(&quot;/socket&quot;, { params: {user_id: window.location.search.split(&quot;=&quot;)[1]} }) let channel = socket.channel(&quot;room:lobby&quot;, {}) let presence = new Presence(channel) function renderOnlineUsers(presence) { let response = &quot;&quot; presence.list((id, {metas: [first, ...rest]}) =&gt; { let count = rest.length + 1 response += `&lt;br&gt;${id} (count: ${count})&lt;/br&gt;` }) document.querySelector(&quot;main[role=main]&quot;).innerHTML = response } socket.connect() presence.onSync(() =&gt; renderOnlineUsers(presence)) channel.join()We can ensure this is working by opening 3 browser tabs. If we navigate to http://localhost:4000/?name=Alice on two browser tabs and http://localhost:4000/?name=Bob then we should see:Alice (count: 2) Bob (count: 1)If we close one of the Alice tabs, then the count should decrease to 1. If we close another tab, the user should disappear from the list entirely.","ref":"presence.html","title":"Presence","type":"extras"},{"doc":"Introduction to TestingRequirement: This guide expects that you have gone through the introductory guides and got a Phoenix application up and running.Testing has become integral to the software development process, and the ability to easily write meaningful tests is an indispensable feature for any modern web framework. Phoenix takes this seriously, providing support files to make all the major components of the framework easy to test. It also generates test modules with real-world examples alongside any generated modules to help get us going.Elixir ships with a built-in testing framework called ExUnit. ExUnit strives to be clear and explicit, keeping magic to a minimum. Phoenix uses ExUnit for all of its testing, and we will use it here as well.","ref":"testing.html","title":"Introduction to Testing","type":"extras"},{"doc":"When Phoenix generates a web application for us, it also includes tests. To run them, simply type mix test:$ mix test .... Finished in 0.09 seconds 3 tests, 0 failures Randomized with seed 652656We already have three tests!In fact, we already have a directory structure completely set up for testing, including a test helper and support files.test ├── hello_web │   ├── channels │   ├── controllers │   │   └── page_controller_test.exs │   └── views │   ├── error_view_test.exs │   ├── layout_view_test.exs │   └── page_view_test.exs ├── support │   ├── channel_case.ex │   ├── conn_case.ex │   └── data_case.ex └── test_helper.exsThe test cases we get for free include test/hello_web/controllers/page_controller_test.exs, test/hello_web/views/error_view_test.exs, and test/hello_web/views/page_view_test.exs. They are testing our controllers and views. If you haven't read the guides for controllers and views, now is a good time.","ref":"testing.html#running-tests","title":"Introduction to Testing - Running tests","type":"extras"},{"doc":"We are going to use the next sections to get acquainted with Phoenix testing structure. We will start with the three test files generated by Phoenix.The first test file we'll look at is test/hello_web/controllers/page_controller_test.exs.defmodule HelloWeb.PageControllerTest do use HelloWeb.ConnCase test &quot;GET /&quot;, %{conn: conn} do conn = get(conn, &quot;/&quot;) assert html_response(conn, 200) =~ &quot;Welcome to Phoenix!&quot; end endThere are a couple of interesting things happening here.Our test files simply define modules. At the top of each module, you will find a line such as:use HelloWeb.ConnCaseIf you were to write an Elixir library, outside of Phoenix, instead of use HelloWeb.ConnCase, you would write use ExUnit.Case instead. However, Phoenix already ships with a bunch of functionality for testing controllers and HelloWeb.ConnCase builds on top of ExUnit.Case to bring these functionalities in. We will the HelloWeb.ConnCase module soon.Then we define each test using the test/3 macro. The test/3 macro receives three arguments: the test name, the testing context that we are pattern matching on, and the contents of the test. In this test, we access the root page of our application by a &quot;GET&quot; HTTP request on the path &quot;/&quot; with the get/2 macro. Then we assert that the rendered page contains the string &quot;Welcome to Phoenix!&quot;.When writing tests in Elixir, we use assertions to check that something is true. In our case, assert html_response(conn, 200) =~ &quot;Welcome to Phoenix!&quot; is doing a couple things:It asserts that conn has rendered a responseIt asserts that the response has the 200 status code (which means OK in HTTP parlance)It asserts that the type of the response is HTMLIt asserts that the result of html_response(conn, 200), which is an HTML response, has the string &quot;Welcome to Phoenix!&quot; in itHowever, from where does the conn we use on get and html_response come from? To answer this question, let's take a look at HelloWeb.ConnCase.","ref":"testing.html#understanding-test-modules","title":"Introduction to Testing - Understanding test modules","type":"extras"},{"doc":"If you open up test/support/conn_case.ex, you will find this (with comments removed):defmodule HelloWeb.ConnCase do use ExUnit.CaseTemplate using do quote do # Import conveniences for testing with connections import Plug.Conn import Phoenix.ConnTest alias HelloWeb.Router.Helpers, as: Routes # The default endpoint for testing @endpoint HelloWeb.Endpoint end end setup tags do :ok = Ecto.Adapters.SQL.Sandbox.checkout(Demo.Repo) unless tags[:async] do Ecto.Adapters.SQL.Sandbox.mode(Demo.Repo, {:shared, self()}) end %{conn: Phoenix.ConnTest.build_conn()} end endThere is a lot to unpack here.The second line says this is a case template. This is a ExUnit feature that allows developers to replace the built-in use ExUnit.Case by their own case. This line is pretty much what allows us to write use HelloWeb.ConnCase at the top of our controller tests.Now that we have made this module a case template, when can define callbacks that are invoked on certain occasions. The using callback defines code to be injected on every module that calls use HelloWeb.ConnCase. In this case, we import Plug.Conn, so all of the connection helpers available in controllers are also available in tests, and then imports Phoenix.ConnTest. You can consult these modules to learn all functionality available.Then it aliases the module with all path helpers, so we can easily generate URLs in our tests. Finally, it sets the @endpoint module attribute with the name of our endpoint.Then our case template defines a setup block. The setup block will be called before test. Most of the setup block is on setting up the SQL Sandbox, which we will talk about it later. In the last line of the setup block, we will find this:%{conn: Phoenix.ConnTest.build_conn()}The last line of setup can return test metadata that will be available in each test. The metadata we are passing forward here is a newly built Plug.Conn. In our test, we extract the connection out of this metadata at the very beginning of our test:test &quot;GET /&quot;, %{conn: conn} doAnd that's where the connection comes from! At first, the testing structure does come with a bit of indirection, but this indirection pays off as our test suite grows, since it allows us to cut down the amount of boilerplate.","ref":"testing.html#the-conncase","title":"Introduction to Testing - The ConnCase","type":"extras"},{"doc":"The other test files in our application are responsible for testing our views.The error view test case, test/hello_web/views/error_view_test.exs, illustrates a few interesting things of its own.defmodule HelloWeb.ErrorViewTest do use HelloWeb.ConnCase, async: true # Bring render/3 and render_to_string/3 for testing custom views import Phoenix.View test &quot;renders 404.html&quot; do assert render_to_string(HelloWeb.ErrorView, &quot;404.html&quot;, []) == &quot;Not Found&quot; end test &quot;renders 500.html&quot; do assert render_to_string(HelloWeb.ErrorView, &quot;500.html&quot;, []) == &quot;Internal Server Error&quot; end endHelloWeb.ErrorViewTest sets async: true which means that this test case will be run in parallel with other test cases. While individual tests within the case still run serially, this can greatly increase overall test speeds.It also imports Phoenix.View in order to use the render_to_string/3 function. With that, all the assertions can be simple string equality tests.The page view case, test/hello_web/views/page_view_test.exs, does not contain any tests by default, but it is here for us when we need to add functions to our HelloWeb.PageView module.defmodule HelloWeb.PageViewTest do use HelloWeb.ConnCase, async: true end","ref":"testing.html#view-tests","title":"Introduction to Testing - View tests","type":"extras"},{"doc":"Now that we have an idea what our tests are doing, let's look at different ways to run them.As we saw near the beginning of this guide, we can run our entire suite of tests with mix test.$ mix test .... Finished in 0.2 seconds 3 tests, 0 failures Randomized with seed 540755If we would like to run all the tests in a given directory, test/hello_web/controllers for instance, we can pass the path to that directory to mix test.$ mix test test/hello_web/controllers/ . Finished in 0.2 seconds 1 tests, 0 failures Randomized with seed 652376In order to run all the tests in a specific file, we can pass the path to that file into mix test.$ mix test test/hello_web/views/error_view_test.exs ... Finished in 0.2 seconds 2 tests, 0 failures Randomized with seed 220535And we can run a single test in a file by appending a colon and a line number to the filename.Let's say we only wanted to run the test for the way HelloWeb.ErrorView renders 500.html. The test begins on line 11 of the file, so this is how we would do it.$ mix test test/hello_web/views/error_view_test.exs:11 Including tags: [line: &quot;11&quot;] Excluding tags: [:test] . Finished in 0.1 seconds 2 tests, 0 failures, 1 excluded Randomized with seed 288117We chose to run this specifying the first line of the test, but actually, any line of that test will do. These line numbers would all work - :11, :12, or :13.","ref":"testing.html#running-tests-per-directory-file","title":"Introduction to Testing - Running tests per directory/file","type":"extras"},{"doc":"ExUnit allows us to tag our tests individually or for the whole module. We can then choose to run only the tests with a specific tag, or we can exclude tests with that tag and run everything else.Let's experiment with how this works.First, we'll add a @moduletag to test/hello_web/views/error_view_test.exs.defmodule HelloWeb.ErrorViewTest do use HelloWeb.ConnCase, async: true @moduletag :error_view_case ... endIf we use only an atom for our module tag, ExUnit assumes that it has a value of true. We could also specify a different value if we wanted.defmodule HelloWeb.ErrorViewTest do use HelloWeb.ConnCase, async: true @moduletag error_view_case: &quot;some_interesting_value&quot; ... endFor now, let's leave it as a simple atom @moduletag :error_view_case.We can run only the tests from the error view case by passing --only error_view_case into mix test.$ mix test --only error_view_case Including tags: [:error_view_case] Excluding tags: [:test] ... Finished in 0.1 seconds 3 tests, 0 failures, 1 excluded Randomized with seed 125659Note: ExUnit tells us exactly which tags it is including and excluding for each test run. If we look back to the previous section on running tests, we'll see that line numbers specified for individual tests are actually treated as tags.$ mix test test/hello_web/views/error_view_test.exs:11 Including tags: [line: &quot;11&quot;] Excluding tags: [:test] . Finished in 0.2 seconds 2 tests, 0 failures, 1 excluded Randomized with seed 364723Specifying a value of true for error_view_case yields the same results.$ mix test --only error_view_case:true Including tags: [error_view_case: &quot;true&quot;] Excluding tags: [:test] ... Finished in 0.1 seconds 3 tests, 0 failures, 1 excluded Randomized with seed 833356Specifying false as the value for error_view_case, however, will not run any tests because no tags in our system match error_view_case: false.$ mix test --only error_view_case:false Including tags: [error_view_case: &quot;false&quot;] Excluding tags: [:test] Finished in 0.1 seconds 3 tests, 0 failures, 3 excluded Randomized with seed 622422 The --only option was given to &quot;mix test&quot; but no test executedWe can use the --exclude flag in a similar way. This will run all of the tests except those in the error view case.$ mix test --exclude error_view_case Excluding tags: [:error_view_case] . Finished in 0.2 seconds 3 tests, 0 failures, 2 excluded Randomized with seed 682868Specifying values for a tag works the same way for --exclude as it does for --only.We can tag individual tests as well as full test cases. Let's tag a few tests in the error view case to see how this works.defmodule HelloWeb.ErrorViewTest do use HelloWeb.ConnCase, async: true @moduletag :error_view_case # Bring render/3 and render_to_string/3 for testing custom views import Phoenix.View @tag individual_test: &quot;yup&quot; test &quot;renders 404.html&quot; do assert render_to_string(HelloWeb.ErrorView, &quot;404.html&quot;, []) == &quot;Not Found&quot; end @tag individual_test: &quot;nope&quot; test &quot;renders 500.html&quot; do assert render_to_string(HelloWeb.ErrorView, &quot;500.html&quot;, []) == &quot;Internal Server Error&quot; end endIf we would like to run only tests tagged as individual_test, regardless of their value, this will work.$ mix test --only individual_test Including tags: [:individual_test] Excluding tags: [:test] .. Finished in 0.1 seconds 3 tests, 0 failures, 1 excluded Randomized with seed 813729We can also specify a value and run only tests with that.$ mix test --only individual_test:yup Including tags: [individual_test: &quot;yup&quot;] Excluding tags: [:test] . Finished in 0.1 seconds 3 tests, 0 failures, 2 excluded Randomized with seed 770938Similarly, we can run all tests except for those tagged with a given value.$ mix test --exclude individual_test:nope Excluding tags: [individual_test: &quot;nope&quot;] ... Finished in 0.2 seconds 3 tests, 0 failures, 1 excluded Randomized with seed 539324We can be more specific and exclude all the tests from the error view case except the one tagged with individual_test that has the value &quot;yup&quot;.$ mix test --exclude error_view_case --include individual_test:yup Including tags: [individual_test: &quot;yup&quot;] Excluding tags: [:error_view_case] .. Finished in 0.2 seconds 3 tests, 0 failures, 1 excluded Randomized with seed 61472Finally, we can configure ExUnit to exclude tags by default. The default ExUnit configuration is done in the test/test_helper.exs file:ExUnit.start(exclude: [error_view_case: true]) Ecto.Adapters.SQL.Sandbox.mode(Hello.Repo, :manual)Now when we run mix test, it only runs one spec from our page_controller_test.exs.$ mix test Excluding tags: [error_view_case: true] . Finished in 0.2 seconds 3 tests, 0 failures, 2 excluded Randomized with seed 186055We can override this behavior with the --include flag, telling mix test to include tests tagged with error_view_case.$ mix test --include error_view_case Including tags: [:error_view_case] Excluding tags: [error_view_case: true] .... Finished in 0.2 seconds 3 tests, 0 failures Randomized with seed 748424This technique can be very useful to control very long running tests, which you may only want to run in CI or in specific scenarios.","ref":"testing.html#running-tests-using-tags","title":"Introduction to Testing - Running tests using tags","type":"extras"},{"doc":"Running tests in random order is a good way to ensure that our tests are truly isolated. If we notice that we get sporadic failures for a given test, it may be because a previous test changes the state of the system in ways that aren't cleaned up afterward, thereby affecting the tests which follow. Those failures might only present themselves if the tests are run in a specific order.ExUnit will randomize the order tests run in by default, using an integer to seed the randomization. If we notice that a specific random seed triggers our intermittent failure, we can re-run the tests with that same seed to reliably recreate that test sequence in order to help us figure out what the problem is.$ mix test --seed 401472 .... Finished in 0.2 seconds 3 tests, 0 failures Randomized with seed 401472","ref":"testing.html#randomization","title":"Introduction to Testing - Randomization","type":"extras"},{"doc":"As we have seen, ExUnit allows developers to run tests concurrently. This allows developers to use all of the power in their machine to run their test suites as fast as possible. Couple this with Phoenix performance, most test suites compile and run in a fraction of the time compared to other frameworks.While developers usually have powerful machines available to them during development, this may not always be the case in your Continuous Integration servers. For this reason, ExUnit also supports out of the box test partitioning in test environments. If you open up your config/test.exs, you will find the database name set to:database: &quot;hello_test\#{System.get_env(&quot;MIX_TEST_PARTITION&quot;)}&quot;,By default, the MIX_TEST_PARTITION environment variable has no value, and therefore it has no effect. But in your CI server, you can, for example, split your test suite across machines by using four distinct commands:MIX_TEST_PARTITION=1 mix test --partitions 4 MIX_TEST_PARTITION=2 mix test --partitions 4 MIX_TEST_PARTITION=3 mix test --partitions 4 MIX_TEST_PARTITION=4 mix test --partitions 4That's all you need to do and ExUnit and Phoenix will take care of all rest, including setting up the database for each distinct partition with a distinct name.","ref":"testing.html#concurrency-and-partitioning","title":"Introduction to Testing - Concurrency and partitioning","type":"extras"},{"doc":"While ExUnit is a simple test framework, it provides a really flexible and robust test runner through the mix test command. We recommend you to run mix help test or read the docs onlineWe've seen what Phoenix gives us with a newly generated app. Furthermore, whenever you generate a new resource, Phoenix will generate all appropariate tests for that resource too. For example, you can create a complete scaffold with schema, context, controllers, and views by running the following command at the root of your application:$ mix phx.gen.html Blog Post posts title body:text * creating lib/demo_web/controllers/post_controller.ex * creating lib/demo_web/templates/post/edit.html.eex * creating lib/demo_web/templates/post/form.html.eex * creating lib/demo_web/templates/post/index.html.eex * creating lib/demo_web/templates/post/new.html.eex * creating lib/demo_web/templates/post/show.html.eex * creating lib/demo_web/views/post_view.ex * creating test/demo_web/controllers/post_controller_test.exs * creating lib/demo/blog/post.ex * creating priv/repo/migrations/20200215122336_create_posts.exs * creating lib/demo/blog.ex * injecting lib/demo/blog.ex * creating test/demo/blog_test.exs * injecting test/demo/blog_test.exs Add the resource to your browser scope in lib/demo_web/router.ex: resources &quot;/posts&quot;, PostController Remember to update your repository by running migrations: $ mix ecto.migrate Now let's follow the directions and add the new resources route to our lib/hello_web/router.ex file and run the migrations.When we run mix test again, we see that we now have twenty tests!$ mix test ................ Finished in 0.1 seconds 19 tests, 0 failures Randomized with seed 537537At this point, we are at a great place to transition to the rest of the testing guides, in which we'll examine these tests in much more detail, and add some of our own.","ref":"testing.html#going-further","title":"Introduction to Testing - Going further","type":"extras"},{"doc":"Testing ContextsRequirement: This guide expects that you have gone through the introductory guides and got a Phoenix application up and running.Requirement: This guide expects that you have gone through the Introduction to Testing guide.Requirement: This guide expects that you have gone through the Contexts guide.At the end of the Introduction to Testing guide, we generated an HTML resource for posts using the following command:$ mix phx.gen.html Blog Post posts title body:textThis gave us a number of modules for free, including a Blog context and a Post schema, alongside their respective test files. As we have learned in the Context guide, the Blog context is simply a module with functions to a particular area of our business domain while Post schema maps to a particular table in our database.In this guide, we are going to explore the tests generated for our contexts and schemas. Before we do anything else, let's run mix test to make sure our test suite runs cleanly.$ mix test ................ Finished in 0.6 seconds 19 tests, 0 failures Randomized with seed 638414Great. We've got nineteen tests and they are all passing!","ref":"testing_contexts.html","title":"Testing Contexts","type":"extras"},{"doc":"If you open up test/hello/blog_test.exs, you will see a file with the following:defmodule Hello.BlogTest do use Hello.DataCase alias Hello.Blog describe &quot;posts&quot; do alias Hello.Blog.Post @valid_attrs %{body: &quot;some body&quot;, title: &quot;some title&quot;} @update_attrs %{body: &quot;some updated body&quot;, title: &quot;some updated title&quot;} @invalid_attrs %{body: nil, title: nil} def post_fixture(attrs \\\\ %{}) do {:ok, post} = attrs |&gt; Enum.into(@valid_attrs) |&gt; Blog.create_post() post end test &quot;list_posts/0 returns all posts&quot; do post = post_fixture() assert Blog.list_posts() == [post] end ...As the top of the file we import Hello.DataCase, which as we will see soon, it is similar to HelloWeb.ConnCase. While HelloWeb.ConnCase sets up helpers for working with connections, which is useful when testing controllers and views, Hello.DataCase provides functionality for working with contexts and schemas.Next we define an alias, so we can refer to Hello.Blog simply as Blog.Then we start a describe &quot;posts&quot; block. A describe block is a feature in ExUnit that allows us to group similar tests. The reason why we have grouped all post related tests together is because contexts in Phoenix are capable of grouping multiple schemas together. For example, if you ran this command:$ mix phx.gen.html Blog Comment comments post_id:references:posts body:textWe will would get a bunch of new functions in the Hello.Blog context plus a whole new describe &quot;comments&quot; block in our test file.The tests defined for our context are very straight-forward. They call the functions in our context and assert on their results. As you can see, some of those tests even create entries in the database:test &quot;create_post/1 with valid data creates a post&quot; do assert {:ok, %Post{} = post} = Blog.create_post(@valid_attrs) assert post.body == &quot;some body&quot; assert post.title == &quot;some title&quot; endAt this point, you may wonder: how can Phoenix make sure the data created in one of the tests do not affect other tests? We are glad you asked. To answer this question, let's talk about the DataCase.","ref":"testing_contexts.html#testing-posts","title":"Testing Contexts - Testing posts","type":"extras"},{"doc":"If you open up test/support/data_case.ex, you will find the following:defmodule Hello.DataCase do use ExUnit.CaseTemplate using do quote do alias Hello.Repo import Ecto import Ecto.Changeset import Ecto.Query import Hello.DataCase end end setup tags do :ok = Ecto.Adapters.SQL.Sandbox.checkout(Hello.Repo) unless tags[:async] do Ecto.Adapters.SQL.Sandbox.mode(Hello.Repo, {:shared, self()}) end :ok end def errors_on(changeset) do ... end endHello.DataCase is another ExUnit.CaseTemplate. In the using block, we can see all of the aliases and imports DataCase brings into our tests. The setup chunk for DataCase is very similar to the one from ConnCase. As we can see, most of the setup block revolves around setting up a SQL Sandbox.The SQL Sandbox is precisely what allows our tests to write to the database without affecting any of the other tests. In a nutshell, at the beginning of every test, we start a transaction in the database. When the test is over, we automatically rollback the transaction, effectively erasing all of the data created in the test.Furthermore, the SQL Sandbox allows multiple tests to run concurrently, even if they talk to the database. This feature is provided for PostgreSQL databases and it can be used to further speed up your contexts and controllers tests by adding a async: true flag when using them:use Hello.DataCase, async: trueThere are some considerations you need to have in mind when running asynchronous tests with the sandbox, so please refer to the Ecto.Adapters.SQL.Sandbox for more information.Finally at the end of the of the DataCase module we can find a function named errors_on with some examples of how to use it. This function is used for testing any validation we may want to add to our schemas. Let's give it a try by adding our own validations and then testing them.","ref":"testing_contexts.html#the-datacase","title":"Testing Contexts - The DataCase","type":"extras"},{"doc":"When we generate our HTML Post resource, Phoenix generated a Blog context and a Post schema. It generated a test file for the context but no test file for the schema. However, this doesn't mean we don't need to test the schema, it just means we did not have to test the schema so far.You may be wondering then: when do we test the context directly and when do we test the schema directly? The answer to this question is the same answer to the question of when do we add code to a context and when do we add it to the schema?The general guideline is to keep all side-effect free code in the schema. In other words, if you are simply working with data structures, schemas and changesets, put it in the schema. The context will typically have the code that creates and updates schemas and then write them to a database or an API.We'll be adding additional validations to the schema module, so that's a great opportunity to write some schema specific tests. Open up lib/hello/blog/post.ex and add the following validation to def changeset:def changeset(post, attrs) do post |&gt; cast(attrs, [:title, :body]) |&gt; validate_required([:title, :body]) |&gt; validate_length(:title, min: 2) endThe new validation says the title needs to have at least 2 characters. Let's write a test for this. Create a new file at test/hello/blog/post_test.exs with this:defmodule Hello.Blog.PostTest do use Hello.DataCase, async: true alias Hello.Blog.Post test &quot;title must be at least two characters long&quot; do changeset = Post.changeset(%User{}, %{title: &quot;I&quot;}) assert %{title: [&quot;should be at least 2 character(s)&quot;]} = errors_on(changeset) end endAnd that's it. As our business domain grows, we have well defined places to test our contexts and schemas.","ref":"testing_contexts.html#testing-schemas","title":"Testing Contexts - Testing schemas","type":"extras"},{"doc":"Testing ControllersRequirement: This guide expects that you have gone through the introductory guides and got a Phoenix application up and running.Requirement: This guide expects that you have gone through the Introduction to Testing guide.At the end of the Introduction to Testing guide, we generated an HTML resource for posts using the following command:$ mix phx.gen.html Blog Post posts title body:textThis gave us a number of modules for free, including a PostController and the associated tests. We are going to explore those tests to learn more about testing controllers in general. At the end of the guide, we will generate a JSON resource, and explore how our API tests look like.","ref":"testing_controllers.html","title":"Testing Controllers","type":"extras"},{"doc":"If you open up test/hello_web/controllers/post_controller_test.exs, you will find the following:defmodule HelloWeb.PostControllerTest do use HelloWeb.ConnCase alias Hello.Blog @create_attrs %{body: &quot;some body&quot;, title: &quot;some title&quot;} @update_attrs %{body: &quot;some updated body&quot;, title: &quot;some updated title&quot;} @invalid_attrs %{body: nil, title: nil} def fixture(:post) do {:ok, post} = Blog.create_post(@create_attrs) post end ...Similar to the PageControllerTest that ships with our application, this controller tests uses use HelloWeb.ConnCase to setup the testing structure. Then, as usual, it defines some aliases, some module attributes to use throughout testing, and then it starts a series of describe blocks, each of them to test a different controller action.The index actionThe first describe block is for the index action. The action itself is implemented like this in lib/hello_web/controllers/post_controller.ex:def index(conn, _params) do posts = Blog.list_posts() render(conn, &quot;index.html&quot;, posts: posts) endIt gets all posts and renders the &quot;index.html&quot; template. The template can be found in &quot;lib/hello_web/templates/page/index.html.eex&quot;.The test looks like this:describe &quot;index&quot; do test &quot;lists all posts&quot;, %{conn: conn} do conn = get(conn, Routes.post_path(conn, :index)) assert html_response(conn, 200) =~ &quot;Listing Posts&quot; end endThe test for the index page is quite straight-forward. It uses the get/2 helper to make a request to the &quot;/posts&quot; page, returned by Routes.post_path(conn, :index), then we assert we got a successful HTML response and match on its contents.The create actionThe next test we will look at is the one for the create action. The create action implementation is this:def create(conn, %{&quot;post&quot; =&gt; post_params}) do case Blog.create_post(post_params) do {:ok, post} -&gt; conn |&gt; put_flash(:info, &quot;Post created successfully.&quot;) |&gt; redirect(to: Routes.post_path(conn, :show, post)) {:error, %Ecto.Changeset{} = changeset} -&gt; render(conn, &quot;new.html&quot;, changeset: changeset) end endSince there are two possible outcomes for the create, we will have at least two tests:describe &quot;create post&quot; do test &quot;redirects to show when data is valid&quot;, %{conn: conn} do conn = post(conn, Routes.post_path(conn, :create), post: @create_attrs) assert %{id: id} = redirected_params(conn) assert redirected_to(conn) == Routes.post_path(conn, :show, id) conn = get(conn, Routes.post_path(conn, :show, id)) assert html_response(conn, 200) =~ &quot;Show Post&quot; end test &quot;renders errors when data is invalid&quot;, %{conn: conn} do conn = post(conn, Routes.post_path(conn, :create), post: @invalid_attrs) assert html_response(conn, 200) =~ &quot;New Post&quot; end endThe first test starts with a post/2 request. That's because once the form in the &quot;/posts/new&quot; page is submitted, it becomes a POST request to the create action. Because we have supplied valid attributes, the post should have been successfully created and we should have redirected to the show action of the new post. This new page will have an address like &quot;/posts/ID&quot;, where ID is the identifier of the post in the database.We then use redirected_params(conn) to get the ID of the post and then match that we indeed redirected to the show action. Finally, we do request a get request to the page we redirected to, allowing us to verify that the post was indeed created.For the second test, we simply test the failure scenario. If any invalid attribute is given, it should re-render the &quot;New Post&quot; page.One common question is: how many failure scenarios do you test at the controller level? For example, in the Testing Contexts guide, we introduced a validation to the title field of the post:def changeset(post, attrs) do post |&gt; cast(attrs, [:title, :body]) |&gt; validate_required([:title, :body]) |&gt; validate_length(:title, min: 2) endIn other words, creating a post can fail for the following reasons:the title is missingthe body is missingthe title is present but is less than 2 charactersShould we test all of these possible outcomes in our controller tests?The answer is no. All of the different rules and outcomes should be verified in your context and schema tests. The controller works as the integration layer. In the controller tests we simply want to verify, in broad strokes, that we handle both success and failure scenarios.The test for update follows a similar structure to the test on create, so we let's skip to the delete test.The delete actionThe delete action looks like this:def delete(conn, %{&quot;id&quot; =&gt; id}) do post = Blog.get_post!(id) {:ok, _post} = Blog.delete_post(post) conn |&gt; put_flash(:info, &quot;Post deleted successfully.&quot;) |&gt; redirect(to: Routes.post_path(conn, :index)) endThe test is written like this: describe &quot;delete post&quot; do setup [:create_post] test &quot;deletes chosen post&quot;, %{conn: conn, post: post} do conn = delete(conn, Routes.post_path(conn, :delete, post)) assert redirected_to(conn) == Routes.post_path(conn, :index) assert_error_sent 404, fn -&gt; get(conn, Routes.post_path(conn, :show, post)) end end end defp create_post(_) do post = fixture(:post) %{post: post} endFirst of all, setup is used to declare that the create_post function should run before every test in this describe block. The create_post function simply creates a post and stores it in the test metadata. This allows us to, in the first line of the test, match on both the post and the connection:test &quot;deletes chosen post&quot;, %{conn: conn, post: post} doThe test uses delete/2 to delete the post and then asserts that we redirected to the index page. Finally, we check that it is no longer possible to access the show page of the deleted post:assert_error_sent 404, fn -&gt; get(conn, Routes.post_path(conn, :show, post)) endassert_error_sent is a testing helper provided by Phoenix.ConnTest. In this case, it verifies that:An exception was raisedThe exception has a status code equivalent to 404 (which stands for Not Found)This pretty much mimics how Phoenix handles exceptions. For example, when we access &quot;/posts/12345&quot; where 12345 is an ID that does not exist, we will invoke our show action:def show(conn, %{&quot;id&quot; =&gt; id}) do post = Blog.get_post!(id) render(conn, &quot;show.html&quot;, post: post) endWhen an unknown post ID is given to Blog.get_post!/1, it raises an Ecto.NotFoundError. If your application raises any exception during a web request, Phoenix translates those requests into proper HTTP response codes. In this case, 404.We could, for example, have written this test as:assert_raise Ecto.NotFoundError, fn -&gt; get(conn, Routes.post_path(conn, :show, post)) endHowever, you may prefer the implementation Phoenix generates by default as it ignores the specific details of the failure, and instead verifies what the browser would actually receive.The tests for new, edit, and show actions are simpler variations of the tests we have seen so far. You can check the action implementation and their respective tests yourself. Now we are ready to move to JSON controller tests.","ref":"testing_controllers.html#html-controller-tests","title":"Testing Controllers - HTML controller tests","type":"extras"},{"doc":"So far we have been working with a generated HTML resource. However, let's take a look at how our tests look like when we generate a JSON resource.First of all, run this command:$ mix phx.gen.json News Article articles title bodyWe choose a very similar concept to the Blog context &lt;-&gt; Post schema, except we are using a different name so we can study these concepts in isolation.After you run the command above, do not forgot to follow the final steps output by the generator. Once all is done, we should run mix test and now have 33 passing tests:$ mix test ................ Finished in 0.6 seconds 33 tests, 0 failures Randomized with seed 618478You may have noticed that this time the scaffold controller has generated fewer tests. Previously it generated 16 (we went from 3 to 19) and now it generated 14 (we went from 19 to 33). That's because JSON APIs do not need to expose the new and edit actions. We can see this is the case in the resource we have added to the router at the end of the mix phx.gen.json command:resources &quot;/articles&quot;, ArticleController, except: [:new, :edit]new and edit are only necessary for HTML because they basically exist to assist users in creating and updating resources. Besides having less actions, we will the controller and view tests and implementations for JSON are drastically different from the HTML ones.The only thing that is pretty much the same between HTML and JSON is the contexts and the schema, which, once you think about it, it makes total sense. After all, your business logic should remain the same, regardless if you are exposing it as HTML or JSON.With the differences in hand, let's take a look at the controller tests.The index actionOpen up test/hello_web/controllers/article_controller_test.exs. The initial structure is quite similar to post_controller_test.exs. So let's take a look at the tests for the index action. The index action itself is implemented in lib/hello_web/controllers/article_controller.ex like this:def index(conn, _params) do articles = News.list_articles() render(conn, &quot;index.json&quot;, articles: articles) endThe action gets all articles and renders &quot;index.json&quot;. Since we are talking about JSON, we don't have a &quot;index.json.eex&quot; template. Instead, the code that converts &quot;articles&quot; into JSON can be found directly in the ArticleView module, defined at lib/hello_web/views/article_view.ex like this:defmodule HelloWeb.ArticleView do use HelloWeb, :view alias HelloWeb.ArticleView def render(&quot;index.json&quot;, %{articles: articles}) do %{data: render_many(articles, ArticleView, &quot;article.json&quot;)} end def render(&quot;show.json&quot;, %{article: article}) do %{data: render_one(article, ArticleView, &quot;article.json&quot;)} end def render(&quot;article.json&quot;, %{article: article}) do %{id: article.id, title: article.title, body: article.body} end endWe talked about render_many in the Views and Templates guide. All we need to know for now is that all JSON replies have a &quot;data&quot; key with either a list of posts (for index) or a single post inside of it.Let's take a look at the test for the index action then:describe &quot;index&quot; do test &quot;lists all articles&quot;, %{conn: conn} do conn = get(conn, Routes.article_path(conn, :index)) assert json_response(conn, 200)[&quot;data&quot;] == [] end endIt simply accesses the index path, asserts we got a JSON response with status 200 and that it contains a &quot;data&quot; key with an empty list, as we have no articles to return.That was quite boring. Let's look at something more interesting.The create actionThe create action is defined like this:def create(conn, %{&quot;article&quot; =&gt; article_params}) do with {:ok, %Article{} = article} &lt;- News.create_article(article_params) do conn |&gt; put_status(:created) |&gt; put_resp_header(&quot;location&quot;, Routes.article_path(conn, :show, article)) |&gt; render(&quot;show.json&quot;, article: article) end endAs we can see, it checks if an article could be created. If so, it sets the status code to :created (which translates to 201), it sets a &quot;location&quot; header with the location of the article, and then renders &quot;show.json&quot; with the article.This is precisely what the first test for the create action verifies:describe &quot;create&quot; do test &quot;renders article when data is valid&quot;, %{conn: conn} do conn = post(conn, Routes.article_path(conn, :create), article: @create_attrs) assert %{&quot;id&quot; =&gt; id} = json_response(conn, 201)[&quot;data&quot;] conn = get(conn, Routes.article_path(conn, :show, id)) assert %{ &quot;id&quot; =&gt; id, &quot;body&quot; =&gt; &quot;some body&quot;, &quot;title&quot; =&gt; &quot;some title&quot; } = json_response(conn, 200)[&quot;data&quot;] endThe test uses post/2 to create a new article and then we verify that the article returned a JSON response, with status 201, and that it had a &quot;data&quot; key in it. We pattern match the &quot;data&quot; on %{&quot;id&quot; =&gt; id}, which allows us to extract the ID of the new article. Then we perform a get/2 request on the show route and verify that the article was successfully created.Inside describe &quot;create&quot;, we will find another test, which handles the failure scenario. Can you spot the failure scenario in the create action? Let's recap it:def create(conn, %{&quot;article&quot; =&gt; article_params}) do with {:ok, %Article{} = article} &lt;- News.create_article(article_params) doThe with special form that ships as part of Elixir allows us to check explicitly for the happy paths. In this case, we are interested only in the scenarios where News.create_article(article_params) returns {:ok, article}, if it returns anything else, the other value will simply be returned directly and none of the contents inside the do/end block will be executed. In other words, if News.create_article/1 returns {:error, changeset}, we will simply return {:error, changeset} from the action.However, this introduces an issue. Our actions do not know how to handle the {:error, changeset} result by default. Luckily, we can teach Phoenix Controllers to handle it with the Action Fallback controller. At the top of the ArticleController, you will find: action_fallback HelloWeb.FallbackControllerThis line says: if any action does not return a %Plug.Conn{}, we want to invoke the FallbackController with the result. You will find HelloWeb.FallbackController at lib/hello_web/controllers/fallback_controller.ex and it looks like this:defmodule HelloWeb.FallbackController do use HelloWeb, :controller def call(conn, {:error, %Ecto.Changeset{} = changeset}) do conn |&gt; put_status(:unprocessable_entity) |&gt; put_view(HelloWeb.ChangesetView) |&gt; render(&quot;error.json&quot;, changeset: changeset) end def call(conn, {:error, :not_found}) do conn |&gt; put_status(:not_found) |&gt; put_view(HelloWeb.ErrorView) |&gt; render(:&quot;404&quot;) end endYou can see how the first clause of the call/2 function handles the {:error, changeset} case, setting the status code to unprocessable entity (422), and then rendering &quot;error.json&quot; from the changeset view with the failed changeset.With this in mind, let's look at our second test for create:test &quot;renders errors when data is invalid&quot;, %{conn: conn} do conn = post(conn, Routes.article_path(conn, :create), article: @invalid_attrs) assert json_response(conn, 422)[&quot;errors&quot;] != %{} endIt simply posts to the create path with invalid parameters. This makes it return a JSON response, with status code 422, and a response with a non-empty &quot;errors&quot; key.The action_fallback can be extremely useful to reduce boilerplate when designing APIs. You can learn more about the &quot;Action Fallback&quot; in the Controllers guide.The delete actionFinally, the last action we will stidy is the delete action for JSON. Its implementation looks like this:def delete(conn, %{&quot;id&quot; =&gt; id}) do article = News.get_article!(id) with {:ok, %Article{}} &lt;- News.delete_article(article) do send_resp(conn, :no_content, &quot;&quot;) end endThe new action simply attempts to delete the article and, if it succeeds, it returns an empty response with status code :no_content (204).The test looks like this:describe &quot;delete article&quot; do setup [:create_article] test &quot;deletes chosen article&quot;, %{conn: conn, article: article} do conn = delete(conn, Routes.article_path(conn, :delete, article)) assert response(conn, 204) assert_error_sent 404, fn -&gt; get(conn, Routes.article_path(conn, :show, article)) end end end defp create_article(_) do article = fixture(:article) %{article: article} endIt setups a new article, then in the test it invokes the delete path to delete it, asserting on a 204 response, which is neither JSON nor HTML. Then it verifies that we can no longer access said article.That's all!Now that we understand how the scaffolded code and their tests work for both HTML and JSON APIs, we are prepared to move forward in building and maintaining our web applications!","ref":"testing_controllers.html#json-controller-tests","title":"Testing Controllers - JSON controller tests","type":"extras"},{"doc":"Testing ChannelsRequirement: This guide expects that you have gone through the introductory guides and got a Phoenix application up and running.Requirement: This guide expects that you have gone through the Introduction to Testing guide.Requirement: This guide expects that you have gone through the Channels guide.In the Channels guide, we saw that a &quot;Channel&quot; is a layered system with different components. Given this, there would be cases when writing unit tests for our Channel functions may not be enough. We may want to verify that its different moving parts are working together as we expect. This integration testing would assure us that we correctly defined our channel route, the channel module, and its callbacks; and that the lower-level layers such as the PubSub and Transport are configured correctly and are working as intended.","ref":"testing_channels.html","title":"Testing Channels","type":"extras"},{"doc":"As we progress through this guide, it would help to have a concrete example we could work off of. Phoenix comes with a Mix task for generating a basic channel and tests. These generated files serve as a good reference for writing channels and their corresponding tests. Let's go ahead and generate our Channel:$ mix phx.gen.channel Room * creating lib/hello_web/channels/room_channel.ex * creating test/hello_web/channels/room_channel_test.exs Add the channel to your `lib/hello_web/channels/user_socket.ex` handler, for example: channel &quot;room:lobby&quot;, HelloWeb.RoomChannelThis creates a channel, its test and instructs us to add a channel route in lib/hello_web/channels/user_socket.ex. It is important to add the channel route or our channel won't function at all!","ref":"testing_channels.html#generating-channels","title":"Testing Channels - Generating channels","type":"extras"},{"doc":"Open up test/hello_web/channels/room_channel_test.exs and you will find this:defmodule HelloWeb.RoomChannelTest do use HelloWeb.ChannelCaseSimilar to ConnCase and DataCase, we now have a ChannelCase. All three of them have been generated for us when we started our Phoenix application. Let's take a look at it. Open up test/support/channel_case.ex:defmodule HelloWeb.ChannelCase do use ExUnit.CaseTemplate using do quote do # Import conveniences for testing with channels import Phoenix.ChannelTest # The default endpoint for testing @endpoint HelloWeb.Endpoint end end setup tags do :ok = Ecto.Adapters.SQL.Sandbox.checkout(Demo.Repo) unless tags[:async] do Ecto.Adapters.SQL.Sandbox.mode(Demo.Repo, {:shared, self()}) end :ok end endIt is very straight-forward. It sets up a case template that imports all of Phoenix.ChannelTest on use. In the setup block, it starts the SQL Sandbox, which we discussed in the Testing Contexts guide.","ref":"testing_channels.html#the-channelcase","title":"Testing Channels - The ChannelCase","type":"extras"},{"doc":"Now that we know that Phoenix provides with a custom Test Case just for channels and what it provides, we can move on to understanding the rest of test/hello_web/channels/room_channel_test.exs.First off, is the setup block:setup do {:ok, _, socket} = UserSocket |&gt; socket(&quot;user_id&quot;, %{some: :assign}) |&gt; subscribe_and_join(RoomChannel, &quot;room:lobby&quot;) %{socket: socket} endThe setup block sets up a Phoenix.Socket based on the UserSocket module, which you can find at &quot;lib/hello_web/channels/user_socket.ex&quot;. Then it says we want to subscribe and join the RoomChannel, accessible as &quot;room:lobby&quot; in the UserSocket. At the end of the test, we return the %{socket: socket} as metadata, so we can re-use it on every test.In a nutshell, subscribe_and_join/3 emulates the client joining a channel and subscribes the test process to the given topic. This is a necessary step since clients need to join a channel before they can send and receive events on that channel.","ref":"testing_channels.html#subscribe-and-joining","title":"Testing Channels - Subscribe and joining","type":"extras"},{"doc":"The first test block in our generated channel test looks like:test &quot;ping replies with status ok&quot;, %{socket: socket} do ref = push(socket, &quot;ping&quot;, %{&quot;hello&quot; =&gt; &quot;there&quot;}) assert_reply ref, :ok, %{&quot;hello&quot; =&gt; &quot;there&quot;} endThis tests the following code in our MyAppWeb.RoomChannel:# Channels can be used in a request/response fashion # by sending replies to requests from the client def handle_in(&quot;ping&quot;, payload, socket) do {:reply, {:ok, payload}, socket} endAs is stated in the comment above, we see that a reply is synchronous since it mimics the request/response pattern we are familiar with in HTTP. This synchronous reply is best used when we only want to send an event back to the client when we are done processing the message on the server. For example, when we save something to the database and then send a message to the client only once that's done.In the test &quot;ping replies with status ok&quot;, %{socket: socket} do line, we see that we have the map %{socket: socket}. This gives us access to the socket in the setup block.We emulate the client pushing a message to the channel with push/3. In the line ref = push(socket, &quot;ping&quot;, %{&quot;hello&quot; =&gt; &quot;there&quot;}), we push the event &quot;ping&quot; with the payload %{&quot;hello&quot; =&gt; &quot;there&quot;} to the channel. This triggers the handle_in/3 callback we have for the &quot;ping&quot; event in our channel. Note that we store the ref since we need that on the next line for asserting the reply. With assert_reply ref, :ok, %{&quot;hello&quot; =&gt; &quot;there&quot;}, we assert that the server sends a synchronous reply :ok, %{&quot;hello&quot; =&gt; &quot;there&quot;}. This is how we check that the handle_in/3 callback for the &quot;ping&quot; was triggered.Testing a BroadcastIt is common to receive messages from the client and broadcast to everyone subscribed to a current topic. This common pattern is simple to express in Phoenix and is one of the generated handle_in/3 callbacks in our MyAppWeb.RoomChannel.def handle_in(&quot;shout&quot;, payload, socket) do broadcast(socket, &quot;shout&quot;, payload) {:noreply, socket} endIts corresponding test looks like:test &quot;shout broadcasts to room:lobby&quot;, %{socket: socket} do push(socket, &quot;shout&quot;, %{&quot;hello&quot; =&gt; &quot;all&quot;}) assert_broadcast &quot;shout&quot;, %{&quot;hello&quot; =&gt; &quot;all&quot;} endWe notice that we access the same socket that is from the setup block. How handy! We also do the same push/3 as we did in the synchronous reply test. So we push the &quot;shout&quot; event with the payload %{&quot;hello&quot; =&gt; &quot;all&quot;}.Since the handle_in/3 callback for the &quot;shout&quot; event just broadcasts the same event and payload, all subscribers in the &quot;room:lobby&quot; should receive the message. To check that, we do assert_broadcast &quot;shout&quot;, %{&quot;hello&quot; =&gt; &quot;all&quot;}.NOTE: assert_broadcast/3 tests that the message was broadcast in the PubSub system. For testing if a client receives a message, use assert_push/3.Testing an asynchronous push from the serverThe last test in our MyAppWeb.RoomChannelTest verifies that broadcasts from the server are pushed to the client. Unlike the previous tests discussed, we are indirectly testing that our channel's handle_out/3 callback is triggered. This handle_out/3 is defined in our MyApp.RoomChannel as:def handle_out(event, payload, socket) do push(socket, event, payload) {:noreply, socket} endSince the handle_out/3 event is only triggered when we call broadcast/3 from our channel, we will need to emulate that in our test. We do that by calling broadcast_from or broadcast_from!. Both serve the same purpose with the only difference of broadcast_from! raising an error when broadcast fails.The line broadcast_from!(socket, &quot;broadcast&quot;, %{&quot;some&quot; =&gt; &quot;data&quot;}) will trigger our handle_out/3 callback above which pushes the same event and payload back to the client. To test this, we do assert_push &quot;broadcast&quot;, %{&quot;some&quot; =&gt; &quot;data&quot;}.That's it. Now you are ready to develop and fully test realtime applications. To learn more about other functionality provided when testing channels, check out the documentation for Phoenix.ChannelTest.","ref":"testing_channels.html#testing-a-synchronous-reply","title":"Testing Channels - Testing a synchronous reply","type":"extras"},{"doc":"Introduction to DeploymentOnce we have a working application, we're ready to deploy it. If you're not quite finished with your own application, don't worry. Just follow the Up and Running Guide to create a basic application to work with.When preparing an application for deployment, there are three main steps:Handling of your application secretsCompiling your application assetsStarting your server in productionIn this guide, we will learn how to get the production environment running locally. You can use the same techniques in this guide to run your application in production, but depending on your deployment infrastructure, extra steps will be necessary.As an example of deploying to other infrastructures, we also discuss three different approaches in our guides: using Elixir's releases with mix release, using Gigalixir, and using Heroku. The release guide also has a sample Docker file you can use if you prefer to deploy with container technologies.Let's explore those steps above one by one.","ref":"deployment.html","title":"Introduction to Deployment","type":"extras"},{"doc":"All Phoenix applications have data that must be kept secure, for example, the username and password for your production database, and the secret Phoenix uses to sign and encrypt important information. The general recommendation is to keep those in environment variables and load them into your application. This is done in config/prod.secret.exs, which is responsible for loading secrets and configuration from environment variables.Therefore, you need to make sure the proper relevant variables are set in production:$ mix phx.gen.secret REALLY_LONG_SECRET $ export SECRET_KEY_BASE=REALLY_LONG_SECRET $ export DATABASE_URL=ecto://USER:PASS@HOST/databaseDo not copy those values directly, set SECRET_KEY_BASE according to the result of mix phx.gen.secret and DATABASE_URL according to your database address.If for some reason you do not want to rely on environment variables, you can hard code the secrets in your config/prod.secret.exs, but make sure not to check the file into your version control system.With your secret information properly secured, it is time to configure assets!Before taking this step, we need to do one bit of preparation. Since we will be readying everything for production, we need to do some setup in that environment by getting our dependencies and compiling.$ mix deps.get --only prod $ MIX_ENV=prod mix compile","ref":"deployment.html#handling-of-your-application-secrets","title":"Introduction to Deployment - Handling of your application secrets","type":"extras"},{"doc":"This step is required only if you have static assets like images, JavaScript, stylesheets and more in your Phoenix applications. By default, Phoenix uses webpack, and that's what we are going to explore.Compilation of static assets happens in two steps:$ npm run deploy --prefix ./assets $ mix phx.digest Check your digested files at &quot;priv/static&quot;.Note: the --prefix flag on npm may not work on Windows. If so, replace the first command by cd assets &amp;&amp; npm run deploy &amp;&amp; cd ...And that is it! The first command builds the assets and the second generates digests as well as a cache manifest file so Phoenix can quickly serve assets in production.Keep in mind that, if you by any chance forget to run the steps above, Phoenix will show an error message:$ PORT=4001 MIX_ENV=prod mix phx.server 10:50:18.732 [info] Running MyApp.Endpoint with Cowboy on http://example.com 10:50:18.735 [error] Could not find static manifest at &quot;my_app/_build/prod/lib/foo/priv/static/cache_manifest.json&quot;. Run &quot;mix phx.digest&quot; after building your static files or remove the configuration from &quot;config/prod.exs&quot;.The error message is quite clear: it says Phoenix could not find a static manifest. Just run the commands above to fix it or, if you are not serving or don't care about assets at all, you can just remove the cache_static_manifest configuration from config/prod.exs.","ref":"deployment.html#compiling-your-application-assets","title":"Introduction to Deployment - Compiling your application assets","type":"extras"},{"doc":"To run Phoenix in production, we need to set the PORT and MIX_ENV environment variables when invoking mix phx.server:$ PORT=4001 MIX_ENV=prod mix phx.server 10:59:19.136 [info] Running MyApp.Endpoint with Cowboy on http://example.comTo run in detached mode so that the Phoenix server does not stop and continues to run even if you close the terminal:$ PORT=4001 MIX_ENV=prod elixir --erl &quot;-detached&quot; -S mix phx.serverIn case you get an error message, please read it carefully, and open up a bug report if it is still not clear how to address it.You can also run your application inside an interactive shell:$ PORT=4001 MIX_ENV=prod iex -S mix phx.server 10:59:19.136 [info] Running MyApp.Endpoint with Cowboy on http://example.com","ref":"deployment.html#starting-your-server-in-production","title":"Introduction to Deployment - Starting your server in production","type":"extras"},{"doc":"The previous sections give an overview about the main steps required to deploy your Phoenix application. In practice, you will end-up adding steps of your own as well. For example, if you are using a database, you will also want to run mix ecto.migrate before starting the server to ensure your database is up to date.Overall, here is a script you can use as a starting point:# Initial setup $ mix deps.get --only prod $ MIX_ENV=prod mix compile # Compile assets $ npm run deploy --prefix ./assets $ mix phx.digest # Custom tasks (like DB migrations) $ MIX_ENV=prod mix ecto.migrate # Finally run the server $ PORT=4001 MIX_ENV=prod mix phx.serverAnd that's it. Next you can use one of our official guides to deploy:with Elixir's releasesto Gigalixir, an Elixir-centric Platform as a Service (PaaS)and to Heroku, one of the most popular PaaS","ref":"deployment.html#putting-it-all-together","title":"Introduction to Deployment - Putting it all together","type":"extras"},{"doc":"Deploying with Releases","ref":"releases.html","title":"Deploying with Releases","type":"extras"},{"doc":"The only thing we'll need for this guide is a working Phoenix application. For those of us who need a simple application to deploy, please follow the Up and Running guide.","ref":"releases.html#what-we-ll-need","title":"Deploying with Releases - What we'll need","type":"extras"},{"doc":"Our main goal for this guide is to package your Phoenix application into a self-contained directory that includes the Erlang VM, Elixir, all of your code and dependencies. This package can then be dropped into a production machine.","ref":"releases.html#goals","title":"Deploying with Releases - Goals","type":"extras"},{"doc":"To assemble a release, you will need Elixir v1.9 or later:$ elixir -v 1.9.0If you are not familiar with Elixir releases yet, we recommend you to read Elixir's excellent docs before continuing.Once that is done, you can assemble a release by going through all of the steps in our general deployment guide with mix release at the end. Let's recap.First set the environment variables:$ mix phx.gen.secret REALLY_LONG_SECRET $ export SECRET_KEY_BASE=REALLY_LONG_SECRET $ export DATABASE_URL=ecto://USER:PASS@HOST/databaseThen load dependencies to compile code and assets:# Initial setup $ mix deps.get --only prod $ MIX_ENV=prod mix compile # Install / update JavaScript dependencies $ npm install --prefix ./assets # Compile assets $ npm run deploy --prefix ./assets $ mix phx.digestNote: the --prefix flag on npm may not work on Windows. If so, replace the first command by cd assets &amp;&amp; npm run deploy &amp;&amp; cd ...And now run mix release:$ MIX_ENV=prod mix release Generated my_app app * assembling my_app-0.1.0 on MIX_ENV=prod * skipping runtime configuration (config/releases.exs not found) Release created at _build/prod/rel/my_app! # To start your system _build/prod/rel/my_app/bin/my_app start ...You can start the release by calling _build/prod/rel/my_app/bin/my_app start, where you have to replace my_app by your current application name. If you do so, your application should start but you will notice your web server does not actually run! That's because we need to tell Phoenix to start the web servers. When using mix phx.server, the phx.server command does that for us, but in a release we don't have Mix (which is a build tool), so we have to do it ourselves.Open up config/prod.secret.exs and you should find a section about &quot;Using releases&quot; with a configuration to set. Go ahead and uncomment that line or manually add the line below, adapted to your application names:config :my_app, MyApp.Endpoint, server: trueNow assemble the release once again:$ MIX_ENV=prod mix release Generated my_app app * assembling my_app-0.1.0 on MIX_ENV=prod * skipping runtime configuration (config/releases.exs not found) Release created at _build/prod/rel/my_app! # To start your system _build/prod/rel/my_app/bin/my_app startAnd starting the release now should also successfully start the web server! Now you can get all of the files under the _build/prod/rel/my_app directory, package it, and run it in any production machine with the same OS and architecture as the one that assembled the release. For more details, check the docs for mix release.But before we finish this guide, there are two features from releases most Phoenix applications will use, so let's talk about those.","ref":"releases.html#releases-assemble","title":"Deploying with Releases - Releases, assemble!","type":"extras"},{"doc":"You may have noticed that, in order to assemble our release, we had to set both SECRET_KEY_BASE and DATABASE_URL. That's because config/config.exs, config/prod.exs, and friends are executed when the release is assembled (or more generally speaking, whenever you run a mix command).However, in many cases, we don't want to set the values for SECRET_KEY_BASE and DATABASE_URL when assembling the release but only when starting the system in production. In particular, you may not even have those values easily accessible, and you may have to reach out to another system to retrieve those. Luckily, for such use cases, mix release provides runtime configuration, which we can enable in three steps:Rename config/prod.secret.exs to config/releases.exsChange use Mix.Config inside the new config/releases.exs file to import Config (if you want, you can replace all uses of use Mix.Config by import Config, as the latter replaces the former)Change config/prod.exs to no longer call import_config &quot;prod.secret.exs&quot; at the bottomNow if you assemble another release, you should see this:$ MIX_ENV=prod mix release Generated my_app app * assembling my_app-0.1.0 on MIX_ENV=prod * using config/releases.exs to configure the release at runtimeNotice how it says you are using runtime configuration. Now you no longer need to set those environment variables when assembling the release, only when you run _build/prod/rel/my_app/bin/my_app start and friends.","ref":"releases.html#runtime-configuration","title":"Deploying with Releases - Runtime configuration","type":"extras"},{"doc":"Another common need in production systems is to execute custom commands required to set up the production environment. One of such commands is precisely migrating the database. Since we don't have Mix, a build tool, inside releases, which are a production artifact, we need to bring said commands directly into the release.Our recommendation is to create a new file in your application, such as lib/my_app/release.ex, with the following:defmodule MyApp.Release do @app :my_app def migrate do load_app() for repo &lt;- repos() do {:ok, _, _} = Ecto.Migrator.with_repo(repo, &amp;Ecto.Migrator.run(&amp;1, :up, all: true)) end end def rollback(repo, version) do load_app() {:ok, _, _} = Ecto.Migrator.with_repo(repo, &amp;Ecto.Migrator.run(&amp;1, :down, to: version)) end defp repos do Application.fetch_env!(@app, :ecto_repos) end defp load_app do Application.load(@app) end endWhere you replace the first two lines by your application names.Now you can assemble a new release with MIX_ENV=prod mix release and you can invoke any code, including the functions in the module above, by calling the eval command:$ _build/prod/rel/my_app/bin/my_app eval &quot;MyApp.Release.migrate&quot;And that's it!You can use this approach to create any custom command to run in production. In this case, we used load_app, which calls Application.load/1 to load the current application without starting it. However, you may want to write a custom command that starts the whole application. In such cases, Application.ensure_all_started/1 must be used. Keep in mind starting the application will start all processes for the current application, including the Phoenix endpoint. This can be circumvented by changing your supervision tree to not start certain children under certain conditions. For example, in the release commands file you could do:defp start_app do load_app() Application.put_env(@app, :minimal, true) Application.ensure_all_started(@app) endAnd then in your application you check Application.get_env(@app, :minimal) and start only part of the children when it is set.","ref":"releases.html#ecto-migrations-and-custom-commands","title":"Deploying with Releases - Ecto migrations and custom commands","type":"extras"},{"doc":"Elixir releases work well with container technologies, such as Docker. The idea is that you assemble the release inside the Docker container and then build an image based on the release artifacts.Here is an example Docker file to run at the root of your application covering all of the steps above:FROM elixir:1.9.0-alpine AS build # install build dependencies RUN apk add --no-cache build-base npm git python # prepare build dir WORKDIR /app # install hex + rebar RUN mix local.hex --force &amp;&amp; \\ mix local.rebar --force # set build ENV ENV MIX_ENV=prod # install mix dependencies COPY mix.exs mix.lock ./ COPY config config RUN mix do deps.get, deps.compile # build assets COPY assets/package.json assets/package-lock.json ./assets/ RUN npm --prefix ./assets ci --progress=false --no-audit --loglevel=error COPY priv priv COPY assets assets RUN npm run --prefix ./assets deploy RUN mix phx.digest # compile and build release COPY lib lib # uncomment COPY if rel/ exists # COPY rel rel RUN mix do compile, release # prepare release image FROM alpine:3.9 AS app RUN apk add --no-cache openssl ncurses-libs WORKDIR /app RUN chown nobody:nobody /app USER nobody:nobody COPY --from=build --chown=nobody:nobody /app/_build/prod/rel/my_app ./ ENV HOME=/app CMD [&quot;bin/my_app&quot;, &quot;start&quot;]At the end, you will have an application in /app ready to run as bin/my_app start.","ref":"releases.html#containers","title":"Deploying with Releases - Containers","type":"extras"},{"doc":"Deploying on Gigalixir","ref":"gigalixir.html","title":"Deploying on Gigalixir","type":"extras"},{"doc":"The only thing we'll need for this guide is a working Phoenix application. For those of us who need a simple application to deploy, please follow the Up and Running guide.","ref":"gigalixir.html#what-we-ll-need","title":"Deploying on Gigalixir - What we'll need","type":"extras"},{"doc":"Our main goal for this guide is to get a Phoenix application running on Gigalixir.","ref":"gigalixir.html#goals","title":"Deploying on Gigalixir - Goals","type":"extras"},{"doc":"Let's separate this process into a few steps so we can keep track of where we are.Initialize Git repositoryInstall the Gigalixir CLISign up for GigalixirCreate and set up Gigalixir applicationProvision a databaseMake our project ready for GigalixirDeploy time!Useful Gigalixir commands","ref":"gigalixir.html#steps","title":"Deploying on Gigalixir - Steps","type":"extras"},{"doc":"If you haven't already, we'll need to commit our files git. We can do so by running the following commands in our project directory:$ git init $ git add . $ git commit -m &quot;Initial commit&quot;","ref":"gigalixir.html#initializing-git-repository","title":"Deploying on Gigalixir - Initializing Git repository","type":"extras"},{"doc":"Follow the instructions here to install the command-line interface for your platform.","ref":"gigalixir.html#installing-the-gigalixir-cli","title":"Deploying on Gigalixir - Installing the Gigalixir CLI","type":"extras"},{"doc":"We can sign up for an account at gigalixir.com or with the CLI. Let's use the CLI.$ gigalixir signupGigalixir’s free tier does not require a credit card and comes with 1 app instance and 1 postgresql database for free, but please consider upgrading to a paid plan if you are running a production application.Next, let's login$ gigalixir loginAnd verify$ gigalixir account","ref":"gigalixir.html#signing-up-for-gigalixir","title":"Deploying on Gigalixir - Signing up for Gigalixir","type":"extras"},{"doc":"There are three different ways to deploy a Phoenix app on Gigalixir: with mix, with Elixir's releases, or with Distillery. In this guide, we'll be using Mix because it is the easiest to get up and running, but you won't be able to connect a remote observer or hot upgrade. For more information, see Mix vs Distillery vs Elixir Releases. If you want to deploy with another method, follow the Getting Started Guide.Creating a Gigalixir applicationLet's create a Gigalixir application$ gigalixir createVerify it was created$ gigalixir appsVerify that a git remote was created $ git remote -vSpecifying versionsThe buildpacks we use default to Elixir, Erlang, and Nodejs versions that are quite old and it's generally a good idea to run the same version in production as you do in development, so let's do that.$ echo &quot;elixir_version=1.10.3&quot; &gt; elixir_buildpack.config $ echo &quot;erlang_version=22.3&quot; &gt;&gt; elixir_buildpack.config $ echo &quot;node_version=12.16.3&quot; &gt; phoenix_static_buildpack.configDon't forget to commit$ git add elixir_buildpack.config phoenix_static_buildpack.config $ git commit -m &quot;set elixir, erlang, and node version&quot;","ref":"gigalixir.html#creating-and-setting-up-our-gigalixir-application","title":"Deploying on Gigalixir - Creating and setting up our Gigalixir application","type":"extras"},{"doc":"There's nothing we need to do to get our app running on Giglaixir, but for a production app, you probably want to enforce SSL. To do that, see Force SSLYou may also want to use SSL for your database connection. For that, uncomment the line ssl: true in your Repo config.","ref":"gigalixir.html#making-our-project-ready-for-gigalixir","title":"Deploying on Gigalixir - Making our Project ready for Gigalixir","type":"extras"},{"doc":"Let's provision a database for our app$ gigalixir pg:create --freeVerify the database was created$ gigalixir pgVerify that a DATABASE_URL and POOL_SIZE were created$ gigalixir config","ref":"gigalixir.html#provisioning-a-database","title":"Deploying on Gigalixir - Provisioning a database","type":"extras"},{"doc":"Our project is now ready to be deployed on Gigalixir.$ git push gigalixir masterCheck the status of your deploy and wait until the app is Healthy$ gigalixir psRun migrations$ gigalixir run mix ecto.migrateCheck your app logs$ gigalixir logsIf everything looks good, let's take a look at your app running on Gigalixir$ gigalixir open","ref":"gigalixir.html#deploy-time","title":"Deploying on Gigalixir - Deploy Time!","type":"extras"},{"doc":"Open a remote console$ gigalixir account:ssh_keys:add &quot;$(cat ~/.ssh/id_rsa.pub)&quot; $ gigalixir ps:remote_consoleTo open a remote observer, see Remote ObserverTo set up clustering, see Clustering NodesTo hot upgrade, see Hot UpgradesFor custom domains, scaling, jobs and other features, see the Gigalixir Documentation","ref":"gigalixir.html#useful-gigalixir-commands","title":"Deploying on Gigalixir - Useful Gigalixir Commands","type":"extras"},{"doc":"See TroubleshootingAlso, don't hesitate to email help@gigalixir.com or request an invitation and join the #gigalixir channel on Slack.","ref":"gigalixir.html#troubleshooting","title":"Deploying on Gigalixir - Troubleshooting","type":"extras"},{"doc":"Deploying on Heroku","ref":"heroku.html","title":"Deploying on Heroku","type":"extras"},{"doc":"The only thing we'll need for this guide is a working Phoenix application. For those of us who need a simple application to deploy, please follow the Up and Running guide.","ref":"heroku.html#what-we-ll-need","title":"Deploying on Heroku - What we'll need","type":"extras"},{"doc":"Our main goal for this guide is to get a Phoenix application running on Heroku.","ref":"heroku.html#goals","title":"Deploying on Heroku - Goals","type":"extras"},{"doc":"Heroku is a great platform and Elixir performs well on it. However, you may run into limitations if you plan to leverage advanced features provided by Elixir and Phoenix, such as:Connections are limited.Heroku limits the number of simultaneous connections as well as the duration of each connection. It is common to use Elixir for real-time apps which need lots of concurrent, persistent connections, and Phoenix is capable of handling over 2 million connections on a single server.Distributed clustering is not possible.Heroku firewalls dynos off from one another. This means things like distributed Phoenix channels and distributed tasks will need to rely on something like Redis instead of Elixir's built-in distribution.In-memory state such as those in Agents, GenServers, and ETS will be lost every 24 hours.Heroku restarts dynos every 24 hours regardless of whether the node is healthy.The built-in Observer can't be used with Heroku.Heroku does allow for connection into your dyno, but you won't be able to use the observer to watch the state of your dyno.If you are just getting started or you don't expect to use the features above, Heroku should be enough for your needs. For instance, if you are migrating an existing application running on Heroku to Phoenix, keeping a similar set of features, Elixir will perform just as well or even better than your current stack.If you want a platform-as-a-service without these limitations, try Gigalixir. If you would rather deploy to a cloud platform, such as EC2, Google Cloud, etc, consider using mix release.","ref":"heroku.html#limitations","title":"Deploying on Heroku - Limitations","type":"extras"},{"doc":"Let's separate this process into a few steps so we can keep track of where we are.Initialize Git repositorySign up for HerokuInstall the Heroku ToolbeltCreate and set up Heroku applicationMake our project ready for HerokuDeploy time!Useful Heroku commands","ref":"heroku.html#steps","title":"Deploying on Heroku - Steps","type":"extras"},{"doc":"Git is a popular decentralized revision control system and is also used to deploy apps to Heroku.Before we can push to Heroku we'll need to initialize a local Git repository and commit our files to it. We can do so by running the following commands in our project directory:$ git init $ git add . $ git commit -m &quot;Initial commit&quot;Heroku offers some great information on how it is using Git here.","ref":"heroku.html#initializing-git-repository","title":"Deploying on Heroku - Initializing Git repository","type":"extras"},{"doc":"Signing up to Heroku is very simple, just head over to https://signup.heroku.com/ and fill in the form.The Free plan will give us one web dyno and one worker dyno, as well as a PostgreSQL and Redis instance for free.These are meant to be used for testing and development, and come with some limitations. In order to run a production application, please consider upgrading to a paid plan.","ref":"heroku.html#signing-up-for-heroku","title":"Deploying on Heroku - Signing up for Heroku","type":"extras"},{"doc":"Once we have signed up, we can download the correct version of the Heroku Toolbelt for our system here.The Heroku CLI, part of the Toolbelt, is useful to create Heroku applications, list currently running dynos for an existing application, tail logs or run one-off commands (mix tasks for instance).","ref":"heroku.html#installing-the-heroku-toolbelt","title":"Deploying on Heroku - Installing the Heroku Toolbelt","type":"extras"},{"doc":"There are two different ways to deploy a Phoenix app on Heroku. We could use Heroku buildpacks or their container stack. The difference between these two approaches is in how we tell Heroku to treat our build. In buildpack case, we need to update our apps configuration on Heroku to use Phoenix/Elixir specific buildpacks. On container approach, we have more control on how we want to set up our app and we can define our container image using Dockerfile and heroku.yml. This section will explore the buildpack approach. In order to use Dockerfile, it is often recommended to convert our app to use releases, which we will describe later on.Create ApplicationA buildpack is a convenient way of packaging framework and/or runtime support. Phoenix requires 2 buildpacks to run on Heroku, the first adds basic Elixir support and the second adds Phoenix specific commands.With the Toolbelt installed, let's create the Heroku application. We will do so using the latest available version of the Elixir buildpack:$ heroku create --buildpack hashnuke/elixir Creating app... done, ⬢ mysterious-meadow-6277 Setting buildpack to hashnuke/elixir... done https://mysterious-meadow-6277.herokuapp.com/ | https://git.heroku.com/mysterious-meadow-6277.gitNote: the first time we use a Heroku command, it may prompt us to log in. If this happens, just enter the email and password you specified during signup.Note: the name of the Heroku application is the random string after &quot;Creating&quot; in the output above (mysterious-meadow-6277). This will be unique, so expect to see a different name from &quot;mysterious-meadow-6277&quot;.Note: the URL in the output is the URL to our application. If we open it in our browser now, we will get the default Heroku welcome page.Note: if we hadn't initialized our Git repository before we ran the heroku create command, we wouldn't have our Heroku remote repository properly set up at this point. We can set that up manually by running: heroku git:remote -a [our-app-name].The buildpack uses a predefined Elixir and Erlang version but to avoid surprises when deploying, it is best to explicitly list the Elixir and Erlang version we want in production to be the same we are using during development or in your continuous integration servers. This is done by creating a config file named elixir_buildpack.config in the root directory of your project with your target version of Elixir and Erlang:# Elixir version elixir_version=1.8.1 # Erlang version # available versions https://github.com/HashNuke/heroku-buildpack-elixir-otp-builds/blob/master/otp-versions erlang_version=21.2.5Adding the Phoenix Server and Assets BuildpackTo successfully run Phoenix in production, we need to compile assets and start the Phoenix server. The Phoenix Static buildpack can take care of that for us, so let's add it now.$ heroku buildpacks:add https://github.com/gjaldon/heroku-buildpack-phoenix-static.git Buildpack added. Next release on mysterious-meadow-6277 will use: 1. https://github.com/HashNuke/heroku-buildpack-elixir.git 2. https://github.com/gjaldon/heroku-buildpack-phoenix-static.gitThe Phoenix Static buildpack uses a predefined Node version but to avoid surprises when deploying, it is best to explicitly list the Node version we want in production to be the same we are using during development or in your continuous integration servers. This is done by creating a config file named phoenix_static_buildpack.config in the root directory of your project with your target version of Node:# Node version node_version=10.20.1Please refer to the configuration section for full details. You can make your own custom build script, but for now we will use the default one provided.The Phoenix Static buildpack also configures Heroku to use the proper command to start your application. The Elixir Buildpack runs by default mix run --no-halt, which will not start your Phoenix server. The Phoenix Static buildpack changes it to the proper mix phx.server. If you don't want to use the Phoenix Static buildpack, then you must manually define a Procfile at the root of your application with the proper command:web: mix phx.serverHeroku will recognize this file and use the command to start your application, ensuring that it also starts the Phoenix server.Finally, note that since we are using multiple buildpacks, you might run into an issue where the sequence is out of order (the Elixir buildpack needs to run before the Phoenix Static buildpack). Heroku's docs explain this better, but you will need to make sure the Phoenix Static buildpack comes last.","ref":"heroku.html#create-and-set-up-heroku-application","title":"Deploying on Heroku - Create and Set Up Heroku Application","type":"extras"},{"doc":"Every new Phoenix project ships with a config file config/prod.secret.exs which loads configuration and secrets from environment variables. This aligns well with Heroku best practices, so the only work left for us to do is to configure URLs and SSL.First let's tell Phoenix to use our Heroku URL and enforce we only use the SSL version of the website. Also, bind to the port requested by Heroku in the $PORT environment variable. Find the url line in your config/prod.exs:url: [host: &quot;example.com&quot;, port: 80],... and replace it with this (don't forget to replace mysterious-meadow-6277 with your application name):http: [port: {:system, &quot;PORT&quot;}], url: [scheme: &quot;https&quot;, host: &quot;mysterious-meadow-6277.herokuapp.com&quot;, port: 443], force_ssl: [rewrite_on: [:x_forwarded_proto]],Then open up your config/prod.secret.exs and uncomment the # ssl: true, line in your repository configuration. It will look like this:config :hello, Hello.Repo, ssl: true, url: database_url, pool_size: String.to_integer(System.get_env(&quot;POOL_SIZE&quot;) || &quot;10&quot;)Finally, if you plan on using websockets, then we will need to decrease the timeout for the websocket transport in lib/hello_web/endpoint.ex. If you do not plan on using websockets, then leaving it set to false is fine. You can find further explanation of the options available at the documentation.defmodule HelloWeb.Endpoint do use Phoenix.Endpoint, otp_app: :hello socket &quot;/socket&quot;, HelloWeb.UserSocket, websocket: [timeout: 45_000], longpoll: false ... endThis ensures that any idle connections are closed by Phoenix before they reach Heroku's 55-second timeout window.","ref":"heroku.html#making-our-project-ready-for-heroku","title":"Deploying on Heroku - Making our Project ready for Heroku","type":"extras"},{"doc":"The DATABASE_URL config var is automatically created by Heroku when we add the Heroku Postgres add-on. We can create the database via the heroku toolbelt:$ heroku addons:create heroku-postgresql:hobby-devNow we set the POOL_SIZE config var:$ heroku config:set POOL_SIZE=18This value should be just under the number of available connections, leaving a couple open for migrations and mix tasks. The hobby-dev database allows 20 connections, so we set this number to 18. If additional dynos will share the database, reduce the POOL_SIZE to give each dyno an equal share.When running a mix task later (after we have pushed the project to Heroku) you will also want to limit its pool size like so:$ heroku run &quot;POOL_SIZE=2 mix hello.task&quot;So that Ecto does not attempt to open more than the available connections.We still have to create the SECRET_KEY_BASE config based on a random string. First, use mix phx.gen.secret to get a new secret:$ mix phx.gen.secret xvafzY4y01jYuzLm3ecJqo008dVnU3CN4f+MamNd1Zue4pXvfvUjbiXT8akaIF53Your random string will be different; don't use this example value.Now set it in Heroku:$ heroku config:set SECRET_KEY_BASE=&quot;xvafzY4y01jYuzLm3ecJqo008dVnU3CN4f+MamNd1Zue4pXvfvUjbiXT8akaIF53&quot; Setting config vars and restarting mysterious-meadow-6277... done, v3 SECRET_KEY_BASE: xvafzY4y01jYuzLm3ecJqo008dVnU3CN4f+MamNd1Zue4pXvfvUjbiXT8akaIF53","ref":"heroku.html#creating-environment-variables-in-heroku","title":"Deploying on Heroku - Creating Environment Variables in Heroku","type":"extras"},{"doc":"Our project is now ready to be deployed on Heroku.Let's commit all our changes:$ git add elixir_buildpack.config $ git add phoenix_static_buildpack.config $ git commit -a -m &quot;Use production config from Heroku ENV variables and decrease socket timeout&quot;And deploy:$ git push heroku master Counting objects: 55, done. Delta compression using up to 8 threads. Compressing objects: 100% (49/49), done. Writing objects: 100% (55/55), 48.48 KiB | 0 bytes/s, done. Total 55 (delta 1), reused 0 (delta 0) remote: Compressing source files... done. remote: Building source: remote: remote: -----&gt; Multipack app detected remote: -----&gt; Fetching custom git buildpack... done remote: -----&gt; elixir app detected remote: -----&gt; Checking Erlang and Elixir versions remote: WARNING: elixir_buildpack.config wasn't found in the app remote: Using default config from Elixir buildpack remote: Will use the following versions: remote: * Stack cedar-14 remote: * Erlang 17.5 remote: * Elixir 1.0.4 remote: Will export the following config vars: remote: * Config vars DATABASE_URL remote: * MIX_ENV=prod remote: -----&gt; Stack changed, will rebuild remote: -----&gt; Fetching Erlang 17.5 remote: -----&gt; Installing Erlang 17.5 (changed) remote: remote: -----&gt; Fetching Elixir v1.0.4 remote: -----&gt; Installing Elixir v1.0.4 (changed) remote: -----&gt; Installing Hex remote: 2015-07-07 00:04:00 URL:https://s3.amazonaws.com/s3.hex.pm/installs/1.0.0/hex.ez [262010/262010] -&gt; &quot;/app/.mix/archives/hex.ez&quot; [1] remote: * creating /app/.mix/archives/hex.ez remote: -----&gt; Installing rebar remote: * creating /app/.mix/rebar remote: -----&gt; Fetching app dependencies with mix remote: Running dependency resolution remote: Dependency resolution completed successfully remote: [...] remote: -----&gt; Compiling remote: [...] remote: Generated phoenix_heroku app remote: [...] remote: Consolidated protocols written to _build/prod/consolidated remote: -----&gt; Creating .profile.d with env vars remote: -----&gt; Fetching custom git buildpack... done remote: -----&gt; Phoenix app detected remote: remote: -----&gt; Loading configuration and environment remote: Loading config... remote: [...] remote: Will export the following config vars: remote: * Config vars DATABASE_URL remote: * MIX_ENV=prod remote: remote: -----&gt; Installing binaries remote: Downloading node 0.12.4... remote: Installing node 0.12.4... remote: Using default npm version remote: remote: -----&gt; Building dependencies remote: [...] remote: Building Phoenix static assets remote: 07 Jul 00:06:22 - info: compiled 3 files into 2 files, copied 3 in 3616ms remote: Check your digested files at 'priv/static'. remote: remote: -----&gt; Finalizing build remote: Creating runtime environment remote: remote: -----&gt; Discovering process types remote: Procfile declares types -&gt; (web) remote: Default types for Multipack -&gt; web remote: remote: -----&gt; Compressing... done, 82.1MB remote: -----&gt; Launching... done, v5 remote: https://mysterious-meadow-6277.herokuapp.com/ deployed to Heroku remote: remote: Verifying deploy... done. To https://git.heroku.com/mysterious-meadow-6277.git * [new branch] master -&gt; masterTyping heroku open in the terminal should launch a browser with the Phoenix welcome page opened. In the event that you are using Ecto to access a database, you will also need to run migrations after the first deploy:$ heroku run &quot;POOL_SIZE=2 mix ecto.migrate&quot;And that's it!","ref":"heroku.html#deploy-time","title":"Deploying on Heroku - Deploy Time!","type":"extras"},{"doc":"Create Heroku applicationSet the stack of your app to container, this allows us to use Dockerfile to define our app setup.$ heroku create Creating app... done, ⬢ mysterious-meadow-6277 $ heroku stack:set containerAdd a new heroku.yml file to your root folder. In this file you can define addons used by your app, how to build the image and what configs are passed to the image. You can learn more about Heroku's heroku.yml options here. Here is a sample:setup: addons: - plan: heroku-postgresql as: DATABASE build: docker: web: Dockerfile config: MIX_ENV: prod SECRET_KEY_BASE: $SECRET_KEY_BASE DATABASE_URL: $DATABASE_URLSet up releases and DockerfileNow we need to define a Dockerfile at the root folder of your project that contains your application. We recommend to use releases when doing so, as the release will allow us to build a container with only the parts of Erlang and Elixir we actually use. Follow the releases docs. At the end of the guide, there is a sample Dockerfile file you can use.Once you have the image definition set up, you can push your app to heroku and you can see it starts building the image and deploy it.","ref":"heroku.html#deploying-to-heroku-using-the-container-stack","title":"Deploying on Heroku - Deploying to Heroku using the container stack","type":"extras"},{"doc":"We can look at the logs of our application by running the following command in our project directory:$ heroku logs # use --tail if you want to tail themWe can also start an IEx session attached to our terminal for experimenting in our app's environment:$ heroku run &quot;POOL_SIZE=2 iex -S mix&quot;In fact, we can run anything using the heroku run command, like the Ecto migration task from above:$ heroku run &quot;POOL_SIZE=2 mix ecto.migrate&quot;","ref":"heroku.html#useful-heroku-commands","title":"Deploying on Heroku - Useful Heroku Commands","type":"extras"},{"doc":"Heroku gives you the ability to connect to your dyno with an IEx shell which allows running Elixir code such as database queries.Modify the web process in your Procfile to run a named node:web: elixir --sname server -S mix phx.serverRedeploy to HerokuConnect to the dyno with heroku ps:exec (if you have several applications on the same repository you will need to specify the app name or the remote name with --app APP_NAME or --remote REMOTE_NAME)Launch an iex session with iex --sname console --remsh serverYou have an iex session into your dyno!","ref":"heroku.html#connecting-to-your-dyno","title":"Deploying on Heroku - Connecting to your dyno","type":"extras"},{"doc":"Compilation ErrorOccasionally, an application will compile locally, but not on Heroku. The compilation error on Heroku will look something like this:remote: == Compilation error on file lib/postgrex/connection.ex == remote: could not compile dependency :postgrex, &quot;mix compile&quot; failed. You can recompile this dependency with &quot;mix deps.compile postgrex&quot;, update it with &quot;mix deps.update postgrex&quot; or clean it with &quot;mix deps.clean postgrex&quot; remote: ** (CompileError) lib/postgrex/connection.ex:207: Postgrex.Connection.__struct__/0 is undefined, cannot expand struct Postgrex.Connection remote: (elixir) src/elixir_map.erl:58: :elixir_map.translate_struct/4 remote: (stdlib) lists.erl:1353: :lists.mapfoldl/3 remote: (stdlib) lists.erl:1354: :lists.mapfoldl/3 remote: remote: remote: ! Push rejected, failed to compile elixir app remote: remote: Verifying deploy... remote: remote: ! Push rejected to mysterious-meadow-6277. remote: To https://git.heroku.com/mysterious-meadow-6277.gitThis has to do with stale dependencies which are not getting recompiled properly. It's possible to force Heroku to recompile all dependencies on each deploy, which should fix this problem. The way to do it is to add a new file called elixir_buildpack.config at the root of the application. The file should contain this line:always_rebuild=trueCommit this file to the repository and try to push again to Heroku.Connection Timeout ErrorIf you are constantly getting connection timeouts while running heroku run this could mean that your internet provider has blocked port number 5000:heroku run &quot;POOL_SIZE=2 mix myapp.task&quot; Running POOL_SIZE=2 mix myapp.task on mysterious-meadow-6277... ! ETIMEDOUT: connect ETIMEDOUT 50.19.103.36:5000You can overcome this by adding detached option to run command:heroku run:detached &quot;POOL_SIZE=2 mix ecto.migrate&quot; Running POOL_SIZE=2 mix ecto.migrate on mysterious-meadow-6277... done, run.8089 (Free)","ref":"heroku.html#troubleshooting","title":"Deploying on Heroku - Troubleshooting","type":"extras"},{"doc":"Custom Error PagesPhoenix has a view called the ErrorView which lives in lib/hello_web/views/error_view.ex. The purpose of the ErrorView is to handle errors in a general way, from one centralized location.","ref":"custom_error_pages.html","title":"Custom Error Pages","type":"extras"},{"doc":"For new applications, the ErrorView looks like this:defmodule HelloWeb.ErrorView do use HelloWeb, :view # If you want to customize a particular status code # for a certain format, you may uncomment below. # def render(&quot;500.html&quot;, _assigns) do # &quot;Internal Server Error&quot; # end # By default, Phoenix returns the status message from # the template name. For example, &quot;404.html&quot; becomes # &quot;Not Found&quot;. def template_not_found(template, _assigns) do Phoenix.Controller.status_message_from_template(template) end endBefore we dive into this, let's see what the rendered 404 not found message looks like in a browser. In the development environment, Phoenix will debug errors by default, showing us a very informative debugging page. What we want here, however, is to see what page the application would serve in production. In order to do that we need to set debug_errors: false in config/dev.exs.use Mix.Config config :hello, HelloWeb.Endpoint, http: [port: 4000], debug_errors: false, code_reloader: true, . . .After modifying our config file, we need to restart our server in order for this change to take effect. After restarting the server, let's go to http://localhost:4000/such/a/wrong/path for a running local application and see what we get.Ok, that's not very exciting. We get the bare string &quot;Not Found&quot;, displayed without any markup or styling.The first question is, where does that error string come from? The answer is right in the ErrorView.def template_not_found(template, _assigns) do Phoenix.Controller.status_message_from_template(template) endGreat, so we have this template_not_found/2 function that takes a template and an assigns map, which we ignore. The template_not_found/2 is invoked whenever a Phoenix.View attempts to render a template but no template is found.In order words, to provide custom error pages, we could simply define a the proper render/2 function clause in HelloWeb.ErrorView.def render(&quot;404.html&quot;, _assigns) do &quot;Page Not Found&quot; endBut we can do even better.Phoenix generates an ErrorView for us, but it doesn't give us a lib/hello_web/templates/error directory. Let's create one now. Inside our new directory, let's add a template, 404.html.eex and give it some markup - a mixture of our application layout and a new div with our message to the user.&lt;!DOCTYPE html&gt; &lt;html lang=&quot;en&quot;&gt; &lt;head&gt; &lt;meta charset=&quot;utf-8&quot;&gt; &lt;meta http-equiv=&quot;X-UA-Compatible&quot; content=&quot;IE=edge&quot;&gt; &lt;meta name=&quot;viewport&quot; content=&quot;width=device-width, initial-scale=1&quot;&gt; &lt;meta name=&quot;description&quot; content=&quot;&quot;&gt; &lt;meta name=&quot;author&quot; content=&quot;&quot;&gt; &lt;title&gt;Welcome to Phoenix!&lt;/title&gt; &lt;link rel=&quot;stylesheet&quot; href=&quot;/css/app.css&quot;&gt; &lt;/head&gt; &lt;body&gt; &lt;div class=&quot;container&quot;&gt; &lt;div class=&quot;header&quot;&gt; &lt;ul class=&quot;nav nav-pills pull-right&quot;&gt; &lt;li&gt;&lt;a href=&quot;https://hexdocs.pm/phoenix/overview.html&quot;&gt;Get Started&lt;/a&gt;&lt;/li&gt; &lt;/ul&gt; &lt;span class=&quot;logo&quot;&gt;&lt;/span&gt; &lt;/div&gt; &lt;div class=&quot;phx-hero&quot;&gt; &lt;p&gt;Sorry, the page you are looking for does not exist.&lt;/p&gt; &lt;/div&gt; &lt;div class=&quot;footer&quot;&gt; &lt;p&gt;&lt;a href=&quot;https://phoenixframework.org&quot;&gt;phoenixframework.org&lt;/a&gt;&lt;/p&gt; &lt;/div&gt; &lt;/div&gt; &lt;!-- /container --&gt; &lt;script src=&quot;/js/app.js&quot;&gt;&lt;/script&gt; &lt;/body&gt; &lt;/html&gt;Now when we go back to http://localhost:4000/such/a/wrong/path, we should see a much nicer error page. It is worth noting that we did not render our 404.html.eex template through our application layout, even though we want our error page to have the look and feel of the rest of our site. This is to avoid circular errors. For example, what happens if our application failed due to an error in the layout? Attempting to render the layout again will just trigger another error. So ideally we want to minimize the amount of dependencies and logic in our error templates, sharing only what is necessary.","ref":"custom_error_pages.html#the-errorview","title":"Custom Error Pages - The ErrorView","type":"extras"},{"doc":"Elixir provides a macro called defexception for defining custom exceptions. Exceptions are represented as structs, and structs need to be defined inside of modules.In order to create a custom exception, we need to define a new module. Conventionally this will have &quot;Error&quot; in the name. Inside of that module, we need to define a new exception with defexception.defmodule MyApp.SomethingNotFoundError do defexception [:message] endYou can raise your new exception like this:raise MyApp.SomethingNotFoundError, &quot;oops&quot;By default, Plug and Phoenix will treat all exceptions as 500 errors. However, Plug provides a protocol called Plug.Exception where we are able to customize the status and add actions that exception structs can returns on the debug error page.If we wanted to supply a status of 404 for an MyApp.SomethingNotFoundError, we could do it by defining an implementation for the Plug.Exception protocol like this:defimpl Plug.Exception, for: MyApp.SomethingNotFoundError do def status(_exception), do: 404 def actions(_exception), do: [] endAlternatively, you could define a plug_status field directly in the exception struct:defmodule MyApp.SomethingNotFoundError do defexception [:message, plug_status: 404] endHowever, implementing the Plug.Exception protocol by hand can be convenient in certain occasions, such as when providing Actionable ERrors.","ref":"custom_error_pages.html#custom-exceptions","title":"Custom Error Pages - Custom Exceptions","type":"extras"},{"doc":"Exception actions are functions that can be triggered by the error page, it is basically a list of maps defining a label and a handler to be executed.It is rendered in the error page as a collection of buttons and follows the format of: [%{label: String.t(), handler: {module(), function :: atom(), args :: []}}].If we wanted to return some actions for an MyApp.SomethingNotFoundError we would implement Plug.Exception like this:defimpl Plug.Exception, for: MyApp.SomethingNotFoundError do def status(_exception), do: 404 def actions(_exception), do: [%{ label: &quot;Run seeds&quot;, handler: {Code, :eval_file, &quot;priv/repo/seeds.exs&quot;} }] end","ref":"custom_error_pages.html#actionable-errors","title":"Custom Error Pages - Actionable Errors","type":"extras"},{"doc":"Using SSLTo prepare an application to serve requests over SSL, we need to add a little bit of configuration and two environment variables. In order for SSL to actually work, we'll need a key file and certificate file from a certificate authority. The environment variables that we'll need are paths to those two files.The configuration consists of a new https: key for our endpoint whose value is a keyword list of port, path to the key file, and path to the cert (pem) file. If we add the otp_app: key whose value is the name of our application, Plug will begin to look for them at the root of our application. We can then put those files in our priv directory and set the paths to priv/our_keyfile.key and priv/our_cert.crt.Here's an example configuration from config/prod.exs.use Mix.Config config :hello, HelloWeb.Endpoint, http: [port: {:system, &quot;PORT&quot;}], url: [host: &quot;example.com&quot;], cache_static_manifest: &quot;priv/static/cache_manifest.json&quot;, https: [ port: 443, cipher_suite: :strong, otp_app: :hello, keyfile: System.get_env(&quot;SOME_APP_SSL_KEY_PATH&quot;), certfile: System.get_env(&quot;SOME_APP_SSL_CERT_PATH&quot;), # OPTIONAL Key for intermediate certificates: cacertfile: System.get_env(&quot;INTERMEDIATE_CERTFILE_PATH&quot;) ] Without the otp_app: key, we need to provide absolute paths to the files wherever they are on the filesystem in order for Plug to find them.Path.expand(&quot;../../../some/path/to/ssl/key.pem&quot;, __DIR__)The options under the https: key are passed to the Plug adapter, typically Plug.Cowboy, which in turn uses Plug.SSL to select the TLS socket options. Please refer to the documentation for Plug.SSL.configure/1 for more information on the available options and their defaults. The Plug HTTPS Guide and the Erlang/OTP ssl documentation also provide valuable information.","ref":"using_ssl.html","title":"Using SSL","type":"extras"},{"doc":"If you would like to use HTTPS in development, a self-signed certificate can be generated by running: mix phx.gen.cert. This requires Erlang/OTP 20 or later.With your self-signed certificate, your development configuration in config/dev.exs can be updated to run an HTTPS endpoint:config :my_app, MyApp.Endpoint, ... https: [ port: 4001, cipher_suite: :strong, keyfile: &quot;priv/cert/selfsigned_key.pem&quot;, certfile: &quot;priv/cert/selfsigned.pem&quot; ]This can replace your http configuration, or you can run HTTP and HTTPS servers on different ports.","ref":"using_ssl.html#ssl-in-development","title":"Using SSL - SSL in Development","type":"extras"},{"doc":"In many cases, you'll want to force all incoming requests to use SSL by redirecting HTTP to HTTPS. This can be accomplished by setting the :force_ssl option in your endpoint configuration. It expects a list of options which are forwarded to Plug.SSL. By default it sets the &quot;strict-transport-security&quot; header in HTTPS requests, forcing browsers to always use HTTPS. If an unsafe (HTTP) request is sent, it redirects to the HTTPS version using the :host specified in the :url configuration. For example:config :my_app, MyApp.Endpoint, force_ssl: [rewrite_on: [:x_forwarded_proto]]To dynamically redirect to the host of the current request, set :host in the :force_ssl configuration to nil.config :my_app, MyApp.Endpoint, force_ssl: [rewrite_on: [:x_forwarded_proto], host: nil]In these examples, the rewrite_on: key specifies the HTTP header used by a reverse proxy or load balancer in front of the application to indicate whether the request was received over HTTP or HTTPS. For more information on the implications of offloading TLS to an external element, in particular relating to secure cookies, refer to the Plug HTTPS Guide. Keep in mind that the options passed to Plug.SSL in that document should be set using the force_ssl: endpoint option in a Phoenix application.","ref":"using_ssl.html#force-ssl","title":"Using SSL - Force SSL","type":"extras"},{"doc":"HSTS or &quot;strict-transport-security&quot; is a mechanism that allows a website to declare itself as only accessible via a secure connection (HTTPS). It was introduced to prevent man-in-the-middle attacks that strip SSL/TLS. It causes web browsers to redirect from HTTP to HTTPS and refuse to connect unless the connection uses SSL/TLS.With force_ssl: [hsts: true] set, the Strict-Transport-Security header is set with a max age that defines the length of time the policy is valid for. Modern web browsers will respond to this by redirecting from HTTP to HTTPS for the standard case but it does have other consequenses. RFC6797 which defines HSTS also specifies that the browser should keep track of the policy of a host and apply it until it expires. It also specifies that traffic on any port other than 80 is assumed to be encrypted as per the policy.This can result in unexpected behaviour if you access your application on localhost, for example https://localhost:4000, as from that point forward and traffic coming from localhost will be expected to be encrypted, except port 80 which will be redirected to port 443. This has the potential to disrupt traffic to any other local servers or proxies that you may be running on your computer. Other applications or proxies on localhost will refuse to work unless the traffic is encrypted.If you do inadvertently turn on HSTS for localhost you may need to reset the cache on your browser before it will accept any HTTP traffic from localhost. For Chrome you need to Empty Cache and Hard Reload which is available from the reload menu that appears when you click and hold the reload icon from the Developer Tools Panel. For Safari you will need to clear your cache, remove the entry from ~/Library/Cookies/HSTS.plist (or delete that file entirely) and restart Safari. Alternately you can set the :expires option on force_ssl to 0 which should expired the entry to turn off HSTS. More information on the options for HSTS are available at Plug.SSL.","ref":"using_ssl.html#hsts","title":"Using SSL - HSTS","type":"extras"}]